<?php
/***********************************************************************************************************************************
***********************************************************************************************************************************/
require_once(URL_CLASSES.'000-vue/class.formulaire.modadddel.php');
require_once(URL_CLASSES.'000-vue/class.formatage.php');
require_once(URL_CLASSES.'000-vue/class.liste-default.php');

require_once(URL_CLASSES.'000-modele/class.mysql.select.php');
require_once(URL_CLASSES.'000-modele/class.mysql.modadddel.php');
require_once(URL_CLASSES.'000-modele/class.mysql.delete.php');

require_once("0-mvc-pdf-adds.php");


/***********************************************************************************************************************************
STRUCTURE DE LA TABLE

************************************************************************************************************************************

***********************************************************************************************************************************/
	



/******************************************************************************************************
CLASS VUE_FORMULAIRE POUR LE TYPE "PARAGRAPHE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_formulaire extends formulaire_modadd
{					
	/******************************************************************************************************
	METHODE D'ATTRIBUTION DES PARAMETRES
	
	******************************************************************************************************/
	private $id_formation = 0;
	private $facturation_liste = 0;
	private $produit_id_client = 0;
	
	public function set_params($a_param=array())
	{			
		
		//RECUPERATION DES VALEURS	//////////////////////////////////////////////////////////////////
		if($this->mod_id!=0)
		{
			//PARAMETRAGE DE LA SELECTION	//////////////////////////////////////////////////////////////////
			$a_p["table"]=PRE_MYSQL."facturation";
			$a_p["where"]="WHERE id=".$this->mod_id;
			$a_p["fichier_source"] = __METHOD__;
			$this->recuperation_valeurs($a_p);
			$this->id_formation = $this->a_values["id_formation"];
		}
		
		//RECUPERATION DE LA FORMATION
		$a_formation = pdf_add::formation($this->id_formation);
		$this->produit_id_client = stripslashes($a_formation["produit_id_client"]);
		$type = stripslashes($a_formation["produit_type"]);
		if($type == "intra")
		{
			$title = stripslashes($a_formation["intitule"]);
			$dates = pdf_add::dates($a_formation);
		}
		else
		{
			$a_form_inter = pdf_add::formation($a_formation["id_inter"]);
			$title = stripslashes($a_form_inter["intitule"]);
			$dates = pdf_add::dates($a_form_inter);
		}
		
		
		if($this->mod_id==0)
		{
			$this->a_values["date"] = date("Y-m-d");
			$this->a_values["intention"] = "A l'intention du service comptable";
			$a_nums = pdf_add::num_facture();
			$this->a_values["numero"] = intval($a_nums["n"])+1;
			$this->a_values["puht1"] = $a_formation["prix_unitaire"];
			$this->a_values["qte1"] = $a_formation["quantite"];
			$des = "<p>Module de formation : <br/><strong>".$title."</strong></p>";
			$des.= "<p>Selon la convention du ".formatage::formatage_date($a_formation["devis_date"],array("jour","nom_mois","annee"))."</p>";
			$des.= "<p>Dates  : ".$dates."<br />";
			//$des.= "<p>Lieu  : ".formatage::formatage_date($a_formation["devis_date"],array("jour","nom_mois","annee"))."<br />";
			$des.= "Stagiaires  : ".str_replace(";",", ",$a_formation["nom_stagiaires"])."<br /></p>";
			$this->a_values["designation1"] = $des;
		}
		
		
		//PAYEURS DE LA FORMATION
		$a_payeurs = array();
		$a_client = pdf_add::client($this->produit_id_client);
		$a_payeurs[$this->produit_id_client] = stripslashes($a_client["nom"]);
		$a_payeurs = $a_payeurs + pdf_add::payeurs();
		
		
		//TEXTE DU BOUTON DE FORMULAIRE	//////////////////////////////////////////////////////////////////
		$this->mod_txt_submit.=" la facture";
		$this->add_txt_submit.=" la facture";
			
						
		//CAPTION	/////////////////////////////////////////////////////////
		$this->add_champ("caption",array("type"=>"caption"));
		if($a_param["modadd"]=="mod")
			$this->add_champ("caption",array("texte"=>"Formation <strong>\"".$title."\" - ".$dates."</strong><br />Facture N°".$this->a_values["numero"]));
		else
			$this->add_champ("caption",array("texte"=>"Formation <strong>\"".$title."\" - ".$dates."</strong><br />Nouvelle facture"));
			
		$this->add_champ("leg_titre",array("type"=>"legende","texte"=>$this->get_legende("facture")));
		$this->add_champ("id_payeur",array("intitule"=>"Payeur","type"=>"select","tab_ext"=>$a_payeurs));
		$a_produits_pub = pdf_add::get_types_produits_publics();
		$this->add_champ("produits_publics",array("intitule"=>"Produit public ?","type"=>"select","tab_ext"=>$a_produits_pub));
		$this->add_champ("date",array("intitule"=>"Date","type"=>"text","options"=>"style='width:75px;'"));	
		$this->add_champ("acompte",array("intitule"=>"Acompte perçu","type"=>"text","options"=>"style='width:75px;'"));	
		$this->add_champ("numero",array("intitule"=>"Numéro","type"=>"text","options"=>"style='width:100px;'"));	
		$this->add_champ("intention",array("intitule"=>"Intention","type"=>"text","options"=>"style='width:300px;'"));	
		$this->add_champ("designation1",array("intitule"=>"Désignation","type"=>"textarea_ck"));	
		$this->add_champ("qte1",array("intitule"=>"Quantité","type"=>"text","options"=>"style='width:20px;'"));	
		$this->add_champ("puht1",array("intitule"=>"Prix unitaire HT","type"=>"text","options"=>"style='width:50px;'"));	
		
		if($this->facturation_liste==0)
			$this->add_champ("id_formation",array("type"=>"fixe","value"=>$this->id_formation));
						
		$this->add_champ("leg_types_stagiaires",array("type"=>"legende","texte"=>$this->get_legende("types-stagiaires")));
		$a_ext = pdf_add::get_types_stagiaires();
		$a_ext["-"] = " - ";
		ksort($a_ext);
		$this->add_champ("type_stagiaires",array("intitule"=>"Type de stagiaire","type"=>"select","tab_ext"=>$a_ext));
		$this->add_champ("nb_stagiaires",array("intitule"=>"Nombre","type"=>"text","options"=>"style='width:30px;'"));
			
		
		
		//FORMULAIRE DE RETOUR
		$this->post_form = 	"<form action='index.php?quoi=facturation' method='post'>";
		if($this->facturation_liste==0)
			$this->post_form.= 		"<input type='hidden' value='".$this->id_formation."' name='id_formation' />";
		$this->post_form.= 		"<input type='submit' value='Annuler et retourner aux factures' class='post-form-button back-to-liste' />";
		$this->post_form.= 	"</form>";
	}
	
	
	/******************************************************************************************************
	METHODE CREATION DE LEGENDE
	
	******************************************************************************************************/
	public function get_legende($type,$a_param=array())
	{
		$button="<input type='button' class='leg-help-button' id='".$type."' title=\"Cliquez pour afficher l'aide\" >";
		switch($type)
		{
			case "facture":
				$titre="<h3>Données de facturation</h3>";
				$texte="Remplissez les champs ci-dessous.<br/>";
			break;
			case "types-stagiaires":
				$titre="<h3>Données péda. stagiaires</h3>";
				$texte="Remplissez les champs ci-dessous.<br/>";
			break;
		}
			
			return $titre.$button."<div id='div-help-".$type."' style='display:none;'>".$texte."</div>";
	}
	/*****************************************************************************************************/







	//****************************************************************************************************************
	//PAS TOUCHE	----------------------------------------------------
	/******************************************************************************************************
	CONSTRUCTEUR
	__construct($a_param)
	*******************************************************************************************************
	RECOIT	ARRAY	$a_param
	******************************************************************************************************/
	public function __construct($a_params=array())
	{
		$this->id_formation = $_POST["id_formation"];
		
		if(isset($_POST["facturation-liste"]))
			$this->facturation_liste = $_POST["facturation-liste"];
		parent::__construct($a_params);
		//On attribue les attributs
		$this->set_params($a_params);
	}
	/*****************************************************************************************************/
	
	
	/******************************************************************************************************
	METHODE CREATION DU FORMULAIRE
	
	*******************************************************************************************************

	******************************************************************************************************/
	public function get_formulaire()
	{	
		if($this->facturation_liste==0)
			$a_client = pdf_add::client_entete($this->produit_id_client);
		else
		$a_client["affichage"] = "";
		return $a_client["affichage"]."<div class='formulaire'>".$this->create_formulaire()."</div>";
	}
	/*****************************************************************************************************/
	

	//FIN PAS TOUCHE----------------------------------------------------
	//****************************************************************************************************************
}
	




















/******************************************************************************************************
CLASS VUE_FORMULAIRE_DEL POUR LE TYPE "PARAGRAPHE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_formulaire_del extends formulaire_modadd
{					
	/******************************************************************************************************
	METHODE D'ATTRIBUTION DES PARAMETRES
	
	******************************************************************************************************/
	private function get_caption($a_param=array())
	{			
		$o_select=new mysql_select();
		//RECUPERATION DU TITRE DU PARAGRAPHE	//////////////////////////////////////////////////////////////
		$o_select->table = PRE_MYSQL."facturation";
		$o_select->where = "WHERE id=".$a_param["id"];
		$o_select->fichier_source = __METHOD__;
		$a_result=$o_select->select();
		$s_parag = stripslashes($a_result[0]["stagiaire"]);	
	
			
		$titre="Suppression de la facture de <strong>\"".$s_parag."\"</strong>";
		$elements="Etes-vous sur de vouloir supprimer cette facture ?"; 
			
		return array("titre"=>$titre,"elements"=>$elements);
	}
	
	

	//****************************************************************************************************************
	//PAS TOUCHE	----------------------------------------------------
	/******************************************************************************************************
	CONSTRUCTEUR
	__construct($a_param)
	*******************************************************************************************************
	RECOIT	ARRAY	$a_param
	******************************************************************************************************/
	public function __construct($a_param=array())
	{
		//On attribue l'ID de l'enregistrement à modifier 
		$this->mod_id=$a_param["id"];
		//On attribue le type d'action
		$this->set_type_action("del");
		$a_caption = $this->get_caption($a_param);
		
		$title=$a_caption["titre"]."<div class='form-del-attention'>".$a_caption["elements"]."</div>";
		$this->add_champ("caption",array("texte"=>$title));
		$this->add_champ("caption",array("type"=>"caption"));
	}
	/*****************************************************************************************************/
	
	
	/******************************************************************************************************
	METHODE CREATION DU FORMULAIRE
	
	*******************************************************************************************************

	******************************************************************************************************/
	public function get_formulaire()
	{
		return "<div class='formulaire'>".$this->create_formulaire()."</div>";
	}
	/*****************************************************************************************************/
	

	//FIN PAS TOUCHE----------------------------------------------------
	//****************************************************************************************************************
}
	






















/******************************************************************************************************
CLASS VUE_LISTE POUR LE TYPE "PARAGRAPHE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_liste extends liste_default
{		
	private $a_ids = array();
	private $form = "";
	private $id_formation = 0;
	private $produit_id_client = 0;
	private $annee_liste = 0;
	private $form_annee = "";
		
	//NOM DE LA PAGE	////////////////////////////////
	private function set_params()
	{		
		if($this->id_formation!=0)
		{
			//LA FORMATION
			$a_formation = pdf_add::formation($this->id_formation);
			$this->produit_id_client = $a_formation["produit_id_client"];
			if($a_formation["produit_type"] == "inter")
			{
				$a_f = pdf_add::formation($a_formation["id_inter"]);
				$title = stripslashes($a_f["intitule"]);
				$dates = pdf_add::dates($a_f);
				$a_nbh[$this->id_formation] = $a_f["duree"];
			}
			else
			{
				$title = stripslashes($a_formation["intitule"]);
				$dates = pdf_add::dates($a_formation);
				$a_nbh[$this->id_formation] = $a_formation["duree"];
			}
			
					
			$this->post_liste.= 	"<form action='index.php?quoi=produit' method='post'>";
			$this->post_liste.= 		"<input type='hidden' value='".$a_formation["produit_id_client"]."' name='produit_id_client' />";
			$this->post_liste.= 		"<input type='submit' value='Retourner à la fiche client' class='post-liste-button back-liste' />";
			$this->post_liste.= 	"</form>";
			
			$whereclose = "WHERE id_formation = ".$this->id_formation;
			$this->caption_att["pre"]="Factures de la formation <strong>".$title." - ".$dates."</strong>";
			//ATTRIBUTS DES TR A CREER AVANT LA LISTE DES ENREGISTREMENT
			$this->a_trs_post["mod"]["type"]="add";
			$this->a_trs_post["mod"]["contenu"]="Nouvelle facture";
			$this->a_trs_post["mod"]["hidden"] = array("id_formation"=>$this->id_formation);
		}
		else
		{
			if($this->annee_liste == 0)
				$options=	"<option selected = 'selected' value='0'>Toutes</option>";
			else
				$options=	"<option value='0'>Toutes</option>";
				
			
			for($i=2012;$i<=date("Y");$i++)
			{
				if($i==$this->annee_liste)
					$selected = "selected = 'selected' ";
				else
					$selected = "";
					
				$options.=	"<option ".$selected." value='".$i."'>".$i."</option>";
			}
			$this->form_annee = 	"<p><strong>Année de facturation : </strong></p><form method='post'>";
			$this->form_annee.= 		"<select onchange='form.submit();' name='annee-liste'>".$options."</select>";
			$this->form_annee.= 	"</form>";
			
			$a_nbh = array();
			$o_select = new mysql_select();
			$o_select->table = PRE_MYSQL."p_produits";
			foreach($o_select->select() as $array)
			{
				$a_nbh[$array["id"]] = $array["duree"];
				
				//GESTION DU BENEFICIAIRE DE LA FORMATION
				if($array["do_bool"]==1)
					$a_dest_formation[$array["id"]] = stripslashes($array["do_nom"]);
				else
				{
					$a_c = pdf_add::client($array["produit_id_client"]);
					$a_dest_formation[$array["id"]] = stripslashes($a_c["nom"]);
				}
			}
			
			if($this->annee_liste == 0)
				$whereclose = "";
			else
				$whereclose = "WHERE YEAR(date) = '".$this->annee_liste."'";
				
			
				
			
			$this->caption_att["pre"]="Factures";
		}
		
		//LES CLIENTS
		$a_payeurs = pdf_add::liste_client();
		
		//ATTRIBUTS DE SELECTION
		$this->table = PRE_MYSQL."facturation";
		$this->where = $whereclose;
		$this->fichier_source = __METHOD__;
		$this->order = array(array("numero",0));

		//ATTRIBUTS DE FORMATAGE DE LA LISTE
		$this->table_att=array("class"=>"table-liste");
		$this->caption_att["bottom"]="ok";
		$this->caption_att["class"]="caption";
		$this->caption_att["menu_off"]="ok";
	
		$this->colgroup=array(array("class"=>"col-action","span"=>2),array("class"=>"col-basic","span"=>2));
		$this->th_att=array("class"=>"th");
	
		//ATTRIBUTS DES TD ET TH A CREER POUR CHAQUE ENREGISTREMENT
		//TD et TH de modification
		if($this->id_formation!=0)
		{
			$this->a_tds[0]["type_td"]="mod";
			$this->a_tds[0]["champ_mod"]="id";
			$this->a_tds[0]["class_td"]="td-action";
		}
		else
		{
			$this->a_tds[0]["type_td"]="ext";
			$this->a_tds[0]["champ"]="id";
			$this->a_tds[0]["name"]="formulaire-mod";
			$this->a_tds[0]["url"]="index.php?quoi=facturation";
			$this->a_tds[0]["class_td"]="td-action";
			$this->a_tds[0]["autres-champs"] = array("facturation-liste"=>1);
			$this->a_tds[0]["sauf"] = array("type_stagiaires",array("B"));
		}
			
		if($this->id_formation!=0)
		{
			$this->a_tds[2]["type_td"]="ext";
			$this->a_tds[2]["champ"]="id";
			$this->a_tds[2]["name"]="id_facture";
			$this->a_tds[2]["url"]="0-mvc-pdf-facture.php";
			$this->a_tds[2]["form-more"]="target = '_blank'";
			$this->a_tds[2]["class_td"]="td-action pdf";
			
			$this->a_tds[4]["type_td"]="del";
			$this->a_tds[4]["champ_del"]="id";
			$this->a_tds[4]["class_td"]="td-action";
		}
	
		$this->a_tds[10]["type_td"]="basic";
		$this->a_tds[10]["champs"][]=array("nom"=>"id_payeur","tab_ext"=>$a_payeurs);
		$this->a_tds[10]["formatage"]["texte"]=array("ss");
		$this->a_tds[10]["th"]=array("type_th"=>"basic","intitule"=>"Payeur");
	
			
		if($this->id_formation==0)
		{
			$this->a_tds[12]["type_td"]="basic";
			$this->a_tds[12]["champs"][]=array("nom"=>"id_formation","tab_ext"=>$a_dest_formation);
			//$this->a_tds[12]["champs"][]=array("nom"=>"id_payeur","tab_ext"=>$a_payeurs);
			$this->a_tds[12]["formatage"]["texte"]=array("ss");
			$this->a_tds[12]["th"]=array("type_th"=>"basic","intitule"=>"Entreprise concernée");
		}
	
		$this->a_tds[15]["type_td"]="basic";
		$this->a_tds[15]["champs"][]=array("nom"=>"numero");
		$this->a_tds[15]["formatage"]["texte"]=array("ss");
		$this->a_tds[15]["th"]=array("type_th"=>"basic","intitule"=>"Numéro");
	
		$this->a_tds[20]["type_td"]="basic";
		$this->a_tds[20]["champs"][]=array("nom"=>"date");
		$this->a_tds[20]["formatage"]["date"]=array("jour","nom_mois","annee");
		$this->a_tds[20]["th"]=array("type_th"=>"basic","intitule"=>"Date");
				
		if($this->id_formation==0)
		{
			$this->a_tds[21]["type_td"]="basic";
			$this->a_tds[21]["champs"][]=array("nom"=>"nb_stagiaires");
			$this->a_tds[21]["formatage"]["texte"]=array("ss");
			$this->a_tds[21]["th"]=array("type_th"=>"basic","intitule"=>"Nb St.");
			
			$this->a_tds[22]["type_td"]="basic";
			$this->a_tds[22]["champs"][]=array("nom"=>"type_stagiaires");
			$this->a_tds[22]["formatage"]["texte"]=array("ss");
			$this->a_tds[22]["th"]=array("type_th"=>"basic","intitule"=>"Type St.");
			
			$this->a_tds[23]["type_td"]="basic";
			$this->a_tds[23]["champs"][]=array("nom"=>"nb_stagiaires");
			$this->a_tds[23]["formatage"]["multiplier_champs_ext"] = array("champ-int"=>"nb_stagiaires","table_ext"=>$a_nbh,"champ_id"=>"id_formation");
			$this->a_tds[23]["th"]=array("type_th"=>"basic","intitule"=>"Heures St.");
		}
				
		
		$a_addmul = array();
		for($i=1;$i<6;$i++)
			$a_addmul[] = array("puht".$i,"qte".$i);
		$this->a_tds[30]["type_td"]="basic";
		$this->a_tds[30]["champs"][]=array("nom"=>"id");
		$this->a_tds[30]["formatage"]["addition-multiplication"] = $a_addmul;
		$this->a_tds[30]["formatage"]["texte"]=array("euros");
		$this->a_tds[30]["th"]=array("type_th"=>"basic","intitule"=>"Prix HT total");
		$this->a_tds[30]["class_td"]="td-last";
	}


	
	public function __construct($a_params=array())
	{
		//ID FORMATION
		if(isset($_POST["id_formation"]))
		{
			unset($_SESSION["annee-liste"]);
			$this->id_formation = $_POST["id_formation"];
		}
		
		//ANNEE A AFFICHER
		if(!isset($_SESSION["annee-liste"]))
			$_SESSION["annee-liste"] = date("Y");
		if(isset($_POST["annee-liste"]))
			$_SESSION["annee-liste"] = $_POST["annee-liste"];
		$this->annee_liste = $_SESSION["annee-liste"];
		
		parent::__construct($a_params);
		//ON ATTRIBUE LES CARACTERISTIQUES DE CHAQUE "PAGE"
		$this->set_params($a_params);
		
	}

	
	public function get_liste()
	{		
		if($this->id_formation!=0)
			$a_client = pdf_add::client_entete($this->produit_id_client);
		else
			$a_client["affichage"] = "";
			
		return $a_client["affichage"].$this->form_annee."<div class='liste'>".$this->create_liste()."</div>";
	}
	//FIN PAS TOUCHE----------------------------------------------------
	//****************************************************************************************************************
}

















/******************************************************************************************************
CLASS MODELE_MODADD POUR LE TYPE "PARAGRAPHE" 

*******************************************************************************************************

******************************************************************************************************/
class modele_modadd
{	
	private function get_params($modadd)
	{					
		$a_params = array();
		
		//VARIABLE DE LA REQUETTE	///////////////////////////////////////////////////////////////////
		$a_params["table"] = PRE_MYSQL."facturation";
		$a_params["champ_id"] = "id";
		
		//CHAMPS A PRENDRE EN COMPTE	///////////////////////////////////////////////////////////////
		$a_params["a_champs"]=array("id_payeur","id_formation","date","numero","intention","acompte","designation1","qte1","puht1","type_stagiaires","nb_stagiaires","produits_publics");	
			
			
		//CHAMPS A VERIFIER	///////////////////////////////////////////////////////////////////////////
		$a_params["a_verif"]["id_payeur"] = array("notnull_select");
		$a_params["a_verif"]["date"] = array("notnull_text","date");
		$a_params["a_verif"]["acompte"] = array("numeric");
		$a_params["a_verif"]["puht1"] = array("notnull_text","numeric");
		$a_params["a_verif"]["qte1"] = array("notnull_text","numeric");
		
		return $a_params;
	}
	


//********************************************************************************************************
//PAS TOUCHE -------------

	/******************************************************************************************
	METHODE CONSTRUCTEUR 
	
	*******************************************************************************************

	******************************************************************************************/
	public function __construct($modadd,$id,$a_post_values=array(),$a_file_values=array())
	{
		$a_tt = explode("----",$a_post_values["nom-et-client"]);
		$a_post_values["stagiaire"] = $a_tt[0];
		$a_post_values["id_client"] = $a_tt[1];
		//CHOIX DE L'OBJET	INSERT/MOD	///////////////////////////////////////////////
		if($modadd=="add")
			$this->o_mysql=new mysql_insert_default();
		else
			$this->o_mysql=new mysql_update_default();
		
		//RECUPERATION DES VALEURS
		$this->o_mysql->set_form_values($a_post_values,$a_file_values,array($id));
				
		//On attribue les attributs
		$a_params=$this->get_params($modadd);
		
		//PARAMETRAGE	//////////////////////////////////////////////////////////////
		$this->o_mysql->set_params($a_params);
	}



	
	



	
	
	
	/******************************************************************************************
	METHODE D'AJOUT DE L'ENREGISTREMENT
	
	*******************************************************************************************
	
	RETOURNE	ARRAY  des codes d'erreurs de l'insertion
	******************************************************************************************/
	public function add()
	{
		$a_return = $this->o_mysql->add(); 
		return $a_return;
	}



	
	
	
	/******************************************************************************************
	METHODE DE MODIFICATION DE L'ENREGISTREMENT
	
	*******************************************************************************************
	
	RETOURNE	ARRAY  des codes d'erreurs de la modification
	******************************************************************************************/
	public function mod()
	{
		return $this->o_mysql->mod();
	}
	
	
	
	
	

//FIN PAS TOUCHE -------------
//********************************************************************************************************
}

	






















/******************************************************************************************************
CLASS MODELE_DEL POUR LE TYPE "PARAGRAPHE" 

*******************************************************************************************************

******************************************************************************************************/
class modele_del extends mysql_delete
{
	
	private $message_del="La suppression a bien été effectuée";
	private $message_cancel="La suppression a bien été annulée";
	
	/******************************************************************************************************
	---	METHODE DE SUPPRESSION DES PARAGRAPHES ---
	
	******************************************************************************************************/
	public function del()
	{
		$o_select=new mysql_select();
		if(count($this->a_del_id)>0)
		{	
			$this->table = PRE_MYSQL."facturation";
			$this->where = "WHERE id=".implode(" OR id=",$this->a_del_id);
			$this->delete();
			
			
		}
	}
	
	
	
	
	//********************************************************************************************************
	//ZONE PAS TOUCHE	----------------------------
	
	private $a_del_id;
	
	/*****************************************************************************************************
	
	*****************************************************************************************************/
	public function __construct($id)
	{
		$this->a_del_id=array($id);
	}
	
	
	/******************************************************************************************************
	---	METHODE DE RECUPERATION DU MESSAGE DEL	---
	
	******************************************************************************************************/
	
	public function get_message_del()
	{
		return $this->message_del;
	}
	
	
	/******************************************************************************************************
	---	METHODE DE RECUPERATION DU MESSAGE CANCEL ---
	
	******************************************************************************************************/
	
	public function get_message_cancel()
	{
		return $this->message_cancel;
	}
	
	
	//FIN ZONE PAS TOUCHE---------------------------
	//********************************************************************************************************
}
?>