<?php
/***********************************************************************************************************************************
***********************************************************************************************************************************/
require_once(URL_CLASSES.'000-vue/class.formulaire.modadddel.php');
require_once(URL_CLASSES.'000-vue/class.formatage.php');

require_once(URL_CLASSES.'000-modele/class.mysql.select.php');
require_once(URL_CLASSES.'000-modele/class.mysql.modadddel.php');
require_once(URL_CLASSES.'000-modele/class.mysql.delete.php');






/***********************************************************************************************************************************
STRUCTURE DE LA TABLE TEXTE

************************************************************************************************************************************
-- Structure de la table `  _textes`
--
CREATE TABLE IF NOT EXISTS `     _textes` (
  `id` int(11) NOT NULL auto_increment,
  `id_texte` int(11) NOT NULL default '0',
  `id_site` int(11) NOT NULL default '0',
  `id_menu` int(11) NOT NULL,
  `ordre` int(11) NOT NULL default '999',
  `type` varchar(255) NOT NULL,
  `titre` varchar(255) NOT NULL,
  `titre_menu` varchar(255) NOT NULL,
  `sous_titre_menu` text NOT NULL,
  `chapeau` text NOT NULL,
  `url` varchar(255) NOT NULL,
  `desc_tag` text NOT NULL,
  `value1` text NOT NULL,
  `value2` text NOT NULL,
  `value3` text NOT NULL,
  `value4` text NOT NULL
  `visuel_file` varchar(255) NOT NULL,
  `couleur` varchar(255) NOT NULL,
  `accueil` varchar(255) NOT NULL,
  `actif` tinyint(1) NOT NULL,
  `enunclic` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Structure de la table `    _menus`
--

CREATE TABLE IF NOT EXISTS `   _menus` (
  `id` int(11) NOT NULL auto_increment,
  `ordre` int(11) NOT NULL,
  `titre` varchar(255) NOT NULL,
  `titre_menu` varchar(255) NOT NULL,
  `url` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
***********************************************************************************************************************************/

class texte_add
{
	public static function type_publication()
	{	
		$a_type = array();
		$a_type[0] = "En attente";
		$a_type[2] = "Suspendue";
		$a_type[1] = "Publiée";
		
		return $a_type;
	}
}


/******************************************************************************************************
CLASS VUE_FORMULAIRE POUR LE TYPE "TEXTE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_formulaire extends formulaire_modadd
{					
	private $a_params_vf = array();
	private $a_menu_non = array(167,169);
			
	private function champ_titre()
	{
		$switch = "";
		switch($switch) 
		{
			default:
				$this->add_champ("leg_param",array("type"=>"legende","texte"=>$this->get_legende("param")));
				$this->add_champ("titre",array("intitule"=>"Titre*","type"=>"text","options"=>"style='width:350px;'"));
			break;	
		}
		
	}
	private function champ_titre_menu()
	{
		$switch = "";
		switch($switch) 
		{
			default:
				$this->add_champ("titre_menu",array("intitule"=>"Titre dans le menu*","type"=>"text","options"=>"style='width:150px;'"));
			break;	
		}
		
	}
	private function champ_ordre()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "ordre";
		if($this->a_params_vf["type"]=="menu")
			$switch = "";
		switch($switch) 
		{
			case "ordre" :
				//CHAMPS POUR LES PAGES DU MENU 5
				$this->add_champ("ordre",array("intitule"=>"Ordre*","type"=>"text","options"=>"style='width:30px;'"));
			break;
			default:
			break;	
		}
	}
	
	
	private function champ_actif()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "actif";
			
		if($this->a_params_vf["type"]=="menu" || $this->a_params_vf["type"]=="localisation" || $this->a_params_vf["type"]=="geolocalisation")
			$switch = "";
		
		switch($switch) 
		{
			case "actif" :
				//CHAMPS RADIO_MULT POUR LES PAGES DU MENU 5, DISABLED POUR LES REDACTEURS
				$a_options = array();
				if($this->a_params_vf["type_admin"]!=1 && $this->a_params_vf["type_admin"]!=2)
					$a_options = array("disable"=>1);
				$a_type_pub = texte_add::type_publication();
				$this->add_champ("actif",array("intitule"=>"Publication","type"=>"radio_mult","tab_ext"=>$a_type_pub,"a_options"=>$a_options));
			break;
			default:
				//AUTOMATIQUEMENT ACTIF POUR LES AUTRES PAGES
				$this->add_champ("actif",array("type"=>"fixe","value"=>1));
			break;	
		}
	}
	
	
	
	private function champ_accueil()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "accueil";
		if($this->a_params_vf["type"]=="menu" || $this->a_params_vf["type"]=="localisation" || $this->a_params_vf["type"]=="geolocalisation")
			$switch = "";
		switch($switch) 
		{
			case "accueil":
				$a_options = array();
				$this->add_champ("accueil",array("intitule"=>"En accueil","type"=>"cb_bool","a_options"=>$a_options));
			break;	
			default:
			//PAS DE CHAMP ACCUEIL POUR TOUTE LES PAGES
				$this->add_champ("accueil",array("type"=>"fixe","value"=>0));
			break;	
		}
	}
	private function champ_enunclic()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "euc";
		if($this->a_params_vf["type"]=="menu")
			$switch = "";
		switch($switch) 
		{
			case "euc" :
				$a_options = array();
				$this->add_champ("enunclic",array("intitule"=>"Menu \"En un clic\"","type"=>"cb_bool","a_options"=>$a_options));
			break;
			
			default:
				//PAS DE CHOIX "EN UN CLIC"
				$this->add_champ("enunclic",array("type"=>"fixe","value"=>0));
			break;	
		}
	}
	private function champ_administrateurs()
	{
		//SELON LES TYPES DE PAGE
		$switch = $this->a_params_vf["type"];
		//POUR LE MENU 5
		if($this->a_params_vf["id_menu"]==5)
			$switch = "menu_5";
		switch($switch) 
		{
			//TYPES DE PAGES
			case "" :
		//	case "actualite":
		//	case "partenaire":
		//	case "accueil":
		//	case "bandeau":
		//	case "qsn":
		//	case "menu_5":
				if($this->a_params_vf["type_admin"]<3)
				{	
					//ADMINISTRATEURS
					$o_select = new mysql_select();
					$a_values_p = array();
					$o_select->table=PRE_MYSQL."administrateurs";
					$o_select->fichier_source = __METHOD__;
					$o_select->champs=array("id","nom");
					$o_select->where="WHERE type>2";
					$a_values=$o_select->select();
					$a_values_p[0] = "Aucun";
					if(count($a_values)>0)
					{
						foreach($a_values AS $values)
							$a_values_p[$values["id"]]=$values["nom"];
						
						$a_values_ext = array();
						$o_select->table=PRE_MYSQL."texte_administrateur";
						$o_select->champs=array("id_administrateur");
						$o_select->where="WHERE id_texte=".$this->mod_id;
						$o_select->fichier_source = __METHOD__;
						$a_values=$o_select->select();
						foreach($a_values AS $values)
							$a_values_ext[]=$values["id_administrateur"];
						
						$this->add_champ("sel_ad",array("type"=>"select_ext","valeurs_ext"=>$a_values_ext,"valeurs_choix"=>$a_values_p,"post_nom"=>"t-a","intitule"=>"Rédacteurs(s)"));
					}
				}
			break;
			default:
				//$a_options = array();
				//$this->add_champ("enunclic",array("intitule"=>"En un clic ?","type"=>"cb_bool","a_options"=>$a_options));
			break;	
		}
	}
	private function champ_chapeau()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "chapeau";
		if($this->a_params_vf["type"]=="localisation" || $this->a_params_vf["type"]=="geolocalisation")
			$switch = "";
		if($this->a_params_vf["type"]=="menu")
			$switch = "couleur";
		switch($switch) 
		{
			case "chapeau":
				$int = "Texte de présentation";
				$this->add_champ("pres_desc",array("type"=>"legende","texte"=>$this->get_legende("pres_accueil")));
				$this->add_champ("chapeau",array("intitule"=>$int,"type"=>"textarea_ck","a_options"=>array("height"=>"100px;")));
			break;	
			case "couleur":
				$int = "Couleur";
				$this->add_champ("chapeau",array("intitule"=>"Couleur (hexa)","type"=>"text","options"=>"style='width:50px;'"));
			break;	
			default:
			break;	
		}
	}
	private function champ_visuel()
	{
		$switch = "";
		if(!in_array($this->a_params_vf["id_menu"],$this->a_menu_non))
			$switch = "visuel";
		if($this->a_params_vf["type"]=="menu" || $this->a_params_vf["type"]=="localisation" || $this->a_params_vf["type"]=="geolocalisation")
			$switch = "";
		switch($switch) 
		{
			case "visuel":
				$this->add_champ("visuel_file",array("intitule"=>"Visuel","type"=>"file_verif","path"=>"../visuels/uploaded/"));
			break;	
			default:
			break;	
		}
	}
	private function champ_desc_tag()
	{
		$switch = "";
		switch($switch) 
		{	
			default:
				$this->add_champ("leg_desc",array("type"=>"legende","texte"=>$this->get_legende("desc_tag")));
				$this->add_champ("desc_tag",array("intitule"=>"Tag de description","type"=>"textarea","options"=>"style='width:250px;height:50px;'"));
			break;	
		}
	}
	/******************************************************************************************************
	METHODE D'ATTRIBUTION DES PARAMETRES
	
	******************************************************************************************************/
	public function set_params()
	{					
		//SI MODIFICATION => RECUPERATION DES VALEURS DE LA PAGE	///////////////////////////////////////
		if($this->a_params_vf["id"]!=0)
		{
			$a_params_recup = array();
			$a_params_recup["table"]=PRE_MYSQL."textes";
			$a_params_recup["where"]="WHERE id=".$this->a_params_vf["id"];
			$a_params_recup["fichier_source"]= __METHOD__;
			$this->recuperation_valeurs($a_params_recup);
			unset($a_params_recup);
			
			$this->a_params_vf["id_texte"] = $this->a_values["id_texte"];
			$this->a_params_vf["id_site"] = $this->a_values["id_site"];
			$this->a_params_vf["id_menu"] = $this->a_values["id_menu"];
			$this->a_params_vf["type"] = $this->a_values["type"];
		}
		
		//TEXTE DU BOUTON DE FORMULAIRE	//////////////////////////////////////////////////////////////////
		if($this->a_values["type"] == "menu")
		{
			$this->mod_txt_submit.=" le menu";
			$this->add_txt_submit.=" le menu";
			$s_nom = stripslashes("Paramétrage du menu <strong>\"".$this->a_values["titre_menu"]."\"</strong>");
		}
		else
		{
			$this->mod_txt_submit.=" la page";
			$this->add_txt_submit.=" la page";
			$s_nom = stripslashes("Paramétrage de la page <strong>\"".$this->a_values["titre_menu"]."\"</strong>");
		}
		//CAPTION	//////////////////////////////////////////////////////////////////////////////////////
		$this->add_champ("caption",array("type"=>"caption"));
		if($this->a_params_vf["modadd"]=="mod")
			$this->add_champ("caption",array("texte"=>$s_nom));
		else
			$this->add_champ("caption",array("texte"=>"Nouvelle page"));
		
		
	
	
		//PARAMETRAGE DES CHAMPS	**********************************************************************
		$this->champ_titre();
		$this->champ_titre_menu();
		$this->champ_ordre();
		$this->champ_actif();
		$this->champ_accueil();
		$this->champ_enunclic();
		$this->champ_administrateurs();
		$this->champ_chapeau();
		$this->champ_visuel();
		$this->champ_desc_tag();
		
		//CHAMPS EN PLUS LORS DE L'AJOUT => HIDDENS
		if($this->a_params_vf["modadd"]=="add")
		{
			$this->add_champ("id_menu",array("type"=>"fixe","value"=>$this->a_params_vf["id_menu"]));
			$this->add_champ("id_texte",array("type"=>"fixe","value"=>$this->a_params_vf["id_texte"]));
			$this->add_champ("id_site",array("type"=>"fixe","value"=>$this->a_params_vf["id_site"]));
			$this->add_champ("type",array("type"=>"fixe","value"=>"base"));
			$this->add_champ("date_ajout",array("type"=>"fixe","value"=>date("Y-m-d")));
			$this->add_champ("id_redacteur",array("type"=>"fixe","value"=>$this->a_params_vf["id_administrateur"]));
		}
	}
	
	
	/******************************************************************************************************
	METHODE CREATION DE LEGENDE
	
	******************************************************************************************************/
	public function get_legende($type,$a_params=array())
	{
		$button="<input type='button' class='leg-help-button' id='".$type."' title=\"Cliquez pour afficher l'aide\" >";
		switch($type)
		{
			case "param":
				$titre="<h3>Paramètres généraux</h3>";
				$texte="Remplissez les champs ci-dessous.<br/>
						<strong>Attention : les champs suivis d'un astérisque (*) sont obligatoires</strong>";
			break;
			
			case "pres_desc":
				$titre="<h3>Présentation</h3>";
				$texte="Remplissez les champs ci-dessous. Leur contenu sera affiché dans le sommaire des menus ou des pages<br/>
						<strong>Attention : les champs suivis d'un astérisque (*) sont obligatoires</strong>";
			break;
			
			case "pres_accueil":
				$titre="<h3>Texte de présentation</h3>";
				$texte="Remplissez les champs ci-dessous. Leur contenu sera affiché au dessus du sommaire du menu concerné.<br/>";
			break;
			
			case "accueil":
				$titre="<h3>Affichage d'accueil</h3>";
				$texte="Remplissez les champs ci-dessous et ajoutez éventuellement un visuel. <br/>
				<strong>Attention : </strong>ces champs correspondent aux textes et aux visuels apparaissant en page d'accueil du site ou en page d'accueil du menu.";
			break;
			
			case "desc_tag":
				$titre="<h3>Tag de description</h3>";
				$texte="Le tag de description de votre page sert au référencement (ce sont les lignes présentes sous le titre dans google par exemples)";
			break;
		}
			
			return $titre.$button."<div id='div-help-".$type."' style='display:none;'>".$texte."</div>";
	}
	/*****************************************************************************************************/





	//****************************************************************************************************************
	//PAS TOUCHE	----------------------------------------------------
	/******************************************************************************************************
	CONSTRUCTEUR
	__construct($a_param)
	*******************************************************************************************************
	RECOIT	ARRAY	$a_param
	******************************************************************************************************/
	public function __construct($a_params=array())
	{
		$this->a_params_vf = $a_params;
		parent::__construct($a_params);
		$this->set_params();
	}
	/*****************************************************************************************************/
	
	
	/******************************************************************************************************
	METHODE CREATION DU FORMULAIRE
	
	*******************************************************************************************************

	******************************************************************************************************/
	public function get_formulaire()
	{
		return "<div class='formulaire'>".$this->create_formulaire()."</div>";
	}
	/*****************************************************************************************************/
	

	//FIN PAS TOUCHE----------------------------------------------------
	//****************************************************************************************************************
}
	




















/******************************************************************************************************
CLASS VUE_FORMULAIRE_DEL POUR LE TYPE "TEXTE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_formulaire_del extends formulaire_modadd
{					
	/******************************************************************************************************
	METHODE D'ATTRIBUTION DES PARAMETRES
	
	******************************************************************************************************/
	private function get_caption($a_param=array())
	{			
		$o_select=new mysql_select();
		//RECUPERATION DU NOMBRE PARAGRAPHE	//////////////////////////////////////////////////////////////
		$o_select->table=PRE_MYSQL."paragraphes";
		$o_select->where="WHERE id_texte=".$a_param["id"];
		$a_result=$o_select->select();
		$nb_parag=count($a_result);	
		
		//RECUPERATION DU NOM DE LA PAGE	/////////////////////////////////////////////////////////////////
		$o_select->table=PRE_MYSQL."textes";
		$o_select->where="WHERE id=".$a_param["id"];
		$a_result=$o_select->select();
		$s_page=stripslashes($a_result[0]["titre_menu"]);	
			
		$titre="Suppression de la page <strong>\"".$s_page."\"</strong>";
		$elements="Etes-vous sur de vouloir supprimer cette page avec le(s) <strong>".$nb_parag." paragraphe(s)</strong> qu'elle contient ?"; 
			
		return array("titre"=>$titre,"elements"=>$elements);
	}
	
	

	//****************************************************************************************************************
	//PAS TOUCHE	----------------------------------------------------
	/******************************************************************************************************
	CONSTRUCTEUR
	__construct($a_param)
	*******************************************************************************************************
	RECOIT	ARRAY	$a_param
	******************************************************************************************************/
	public function __construct($a_param=array())
	{
		//On attribue l'ID de l'enregistrement à modifier 
		$this->mod_id=$a_param["id"];
		//On attribue le type d'action
		$this->set_type_action("del");
		$a_caption = $this->get_caption($a_param);
		
		$title=$a_caption["titre"]."<div class='form-del-attention'>".$a_caption["elements"]."</div>";
		$this->add_champ("caption",array("texte"=>$title));
		$this->add_champ("caption",array("type"=>"caption"));
	}
	/*****************************************************************************************************/
	
	
	/******************************************************************************************************
	METHODE CREATION DU FORMULAIRE
	
	*******************************************************************************************************

	******************************************************************************************************/
	public function get_formulaire()
	{
		return "<div class='formulaire'>".$this->create_formulaire()."</div>";
	}
	/*****************************************************************************************************/
	

	//FIN PAS TOUCHE----------------------------------------------------
	//****************************************************************************************************************
}
	

















/******************************************************************************************************
CLASS VUE_LISTE POUR LE TYPE "TEXTE" 

*******************************************************************************************************

******************************************************************************************************/
class vue_liste
{
	
	public function __construct($a_param=array())
	{
		header("Location:index.php?quoi=paragraphe");
	}
}








	
/******************************************************************************************************
CLASS MODELE_MODADD POUR LE TYPE "TEXTE" 

*******************************************************************************************************

******************************************************************************************************/
class modele_modadd
{	
	private function get_params($modadd)
	{				
		$a_param=array();
		//VARIABLE DE LA REQUETTE	///////////////////////////////////////////////////////////////////
		$a_param["table"]=PRE_MYSQL."textes";
		$a_param["champ_id"]="id";
		
		//CHAMPS A PRENDRE EN COMPTE	///////////////////////////////////////////////////////////////
		$a_param["a_champs"]=array("ordre","titre","titre_menu","sous_titre_menu","chapeau","url","desc_tag","value1","value2","couleur","accueil");
		$a_param["a_cb_bool"]=array("actif","enunclic");
		if($modadd=="add")
		{
			$a_param["a_champs"][]="type";
			$a_param["a_champs"][]="id_menu";
			$a_param["a_champs"][]="id_texte";
		}
		$a_param["a_files"]["visuel_file"]["visuel"][]=array("resize_type"=>"min","new_dim"=>"250","post"=>"");
		$a_param["a_files"]["visuel_file"]["visuel"][]=array("resize_type"=>"min","new_dim"=>"490","post"=>"-g");
		$a_param["a_files"]["visuel_file"]["nom"][1]=array("type"=>"val_form","champ"=>"titre");
		$a_param["a_files"]["visuel_file"]["nom"][2]=array("type"=>"fixe","texte"=>"-t");
		$a_param["a_files"]["visuel_file"]["nom"][3]=array("type"=>"id");
		$a_param["a_files"]["visuel_file"]["path"]="../visuels/uploaded/";
		
		//PARAMETRAGE DES EXT			///////////////////////////////////////////////////////////////
		$a_param["a_ext"]["sel_ad"]["type"] = "select_ext";
		$a_param["a_ext"]["sel_ad"]["table_ext"] = PRE_MYSQL."texte_administrateur";
		$a_param["a_ext"]["sel_ad"]["champ_id"] = "id_texte";
		$a_param["a_ext"]["sel_ad"]["champ_valeur"] = "id_administrateur";
		$a_param["a_ext"]["sel_ad"]["post_nom"] = "t-a";	
		
		//CHAMPS A VERIFIER	///////////////////////////////////////////////////////////////////////////
		$a_param["a_verif"]["titre"]=array("notnull_text");
		$a_param["a_verif"]["titre_menu"]=array("notnull_text");
		$a_param["a_verif"]["ordre"]=array("positif");
		
		//ACTIONS			///////////////////////////////////////////////////////////////////////////
		$a_param["a_actions"][]=array("type"=>"formatage_url","champ"=>"url","value"=>"titre");
	
		
		return $a_param;
	}
	


	//********************************************************************************************************
	//PAS TOUCHE -------------

	/******************************************************************************************
	METHODE CONSTRUCTEUR 
	
	*******************************************************************************************
	
	RECOIT		STRING	$quoi de ce qui est concerné par l'ajout
				ARRAY 	$a_post des valeurs reçues par $_POST	
				STRING	$modadd (mod ou add)
	
	PROVOQUE	le choix des paramètres en fonction du quoi
	******************************************************************************************/
	public function __construct($modadd,$id,$a_post_values=array(),$a_file_values=array())
	{
		//CHOIX DE L'OBJET	INSERT/MOD	///////////////////////////////////////////////
		if($modadd=="add")
			$this->o_mysql=new mysql_insert_default();
		else
			$this->o_mysql=new mysql_update_default();
		
		//RECUPERATION DES VALEURS
		$this->o_mysql->set_form_values($a_post_values,$a_file_values,array($id));
				
		//On attribue les attributs
		$a_params=$this->get_params($modadd,$language);
		
		//PARAMETRAGE	//////////////////////////////////////////////////////////////
		$this->o_mysql->set_params($a_params);
	}



	/******************************************************************************************
	METHODE D'AJOUT DE L'ENREGISTREMENT
	
	*******************************************************************************************
	
	RETOURNE	ARRAY  des codes d'erreurs de l'insertion
	******************************************************************************************/
	public function add()
	{
		return $this->o_mysql->add();
	}



	
	
	
	/******************************************************************************************
	METHODE DE MODIFICATION DE L'ENREGISTREMENT
	
	*******************************************************************************************
	
	RETOURNE	ARRAY  des codes d'erreurs de la modification
	******************************************************************************************/
	public function mod()
	{
		return $this->o_mysql->mod();
	}
	
	
	
	
	

	//********************************************************************************************************
	//FIN PAS TOUCHE -------------
	//********************************************************************************************************
}









	














/******************************************************************************************************
CLASS MODELE_DEL POUR LE TYPE "TEXTE" 

*******************************************************************************************************

******************************************************************************************************/
class modele_del extends mysql_delete
{
	
	private $message_del="La suppression a bien été effectuée";
	private $message_cancel="La suppression a bien été annulée";
	
	/******************************************************************************************************
	---	METHODE DE SUPPRESSION DES PARAGRAPHES ---
	
	******************************************************************************************************/
	public function del_paragraphes($a_id)
	{
		$o_select=new mysql_select();
		if(count($a_id)>0)
		{	
			$o_select->table=PRE_MYSQL."paragraphes";
			$o_select->where="WHERE id=".implode(" OR id=",$a_id);
			$a_files = $o_select->select();
			
			foreach($a_files AS $file)
			{
				$this->delete_file(str_replace(".","-g.",$file["visuel_file"]),"../visuels/uploaded/");
				$this->delete_file($file["visuel_file"],"../visuels/uploaded/");
				
				$this->delete_file($file["down_file"],"../files/");
			}
			$this->table=PRE_MYSQL."paragraphes";
			$this->where="WHERE id=".implode(" OR id=",$a_id);
			$this->delete();
		}
	}

	/******************************************************************************************************
	---	METHODE DE SUPPRESSION ---
	
	******************************************************************************************************/
	public function del($id)
	{
		$a_id_parag=array();
		$o_select=new mysql_select();
		//SUPPRESION DES PARAGRAPHES	///////////////////////////////////////////////
		$o_select->table=PRE_MYSQL."paragraphes";
		$o_select->where="WHERE id_texte=".$id;
		$a_paragraphes = $o_select->select();
		foreach($a_paragraphes AS $parag)
			$a_id_parag[]=$parag["id"];
		
		$this->del_paragraphes($a_id_parag);
		
		
		//SUPPRESION DE LA PAGE			///////////////////////////////////////////////		
		$this->table=PRE_MYSQL."textes";
		$this->where="WHERE id=".$id;
		$this->delete();
	}
	

	
	
	
	//********************************************************************************************************
	//ZONE PAS TOUCHE	----------------------------
	
	private $a_del_id;
	
	/*****************************************************************************************************
	
	*****************************************************************************************************/
	public function __construct($id)
	{
		$this->a_del_id=array($id);
	}
	
	
	/******************************************************************************************************
	---	METHODE DE RECUPERATION DU MESSAGE DEL	---
	
	******************************************************************************************************/
	
	public function get_message_del()
	{
		return $this->message_del;
	}
	
	
	/******************************************************************************************************
	---	METHODE DE RECUPERATION DU MESSAGE CANCEL ---
	
	******************************************************************************************************/
	
	public function get_message_cancel()
	{
		return $this->message_cancel;
	}
	
	
	//FIN ZONE PAS TOUCHE---------------------------
	//********************************************************************************************************
}
?>