<?php
require_once("class.mysql.update.php");
require_once("class.mysql.select.php");
require_once(URL_CLASSES."000-vue/class.formatage.php");

class upload_file
{
	public $table;
	public $champ_id;
	public $a_files;
	public $a_file_values=array();
	public $a_post_values=array();
	public $a_id=array();
	
	protected $a_erreurs=array("erreur"=>0);
	
	
	
	/******************************************************************************************************
	METHODE DE RECUPERATION DE L'EXTENSION D'UN FICHIER
	private type_mime_ext($file)
	
	*******************************************************************************************************
	RECOIT		$file	le fichier
	RETOURNE	$ext l'extension
	******************************************************************************************************/
	private function type_mime_ext($file)
	{
		//VALEUR PAR DEFAULT
		$a_ext=explode(".",$file["name"]);
		$ext=end($a_ext);
		
		$a_type=explode("/",$file["type"]);
		switch($a_type[0])
		{
			//APPLICATIONS	///////////////////////////////////////////////////////////////////////////////
			case "application" :
				//$ext="app";
			/*
			case "application/EDI-X12" :données EDI ANSI ASC X12 ; Défini dans la RFC 1767
			case "application/EDIFACT" :données EDI EDIFACT ; Défini dans la RFC 1767
			case "application/javascript" :JavaScript ; Défini dans la RFC 4329
			case "application/octet-stream" :flux de données arbitraire. Considéré comme le format par "défaut" dans plusieurs OS, souvent utilisé pour identifier des fichiers exécutables, ou de type inconnu, ou des fichiers qui doivent être téléchargés grâce à des protocoles qui ne fournissent pas de champ "content disposition" dans leur en-tête. La RFC 2046 le décrit comme un recours pour les sous-types et les types non reconnus.
			case "application/ogg" :Ogg, un flux de données multimedia, conteneur ; Défini dans la RFC 3534
			case "application/xhtml+xml" :XHTML ; Défini dans la RFC 3236
			case "application/x-shockwave-flash" :fichier Adobe Flash ; Documenté par Adobe TechNote tn_4151 et Adobe TechNote tn_16509
			case "application/json" :JavaScript Object Notation ; Défini dans la RFC 4627
			*/
			break;
			
			//AUDIO	///////////////////////////////////////////////////////////////////////////////
			case "audio" :
				switch($type)
				{
					case "audio/mpeg" :
						$ext="mp3";
					break;
					case "audio/x-ms-wma" :
						$ext="wma";
					break;
					case "audio/vnd.rn-realaudio" :
						$ext="rm";
					break;
					case "audio/x-wav" :
						$ext="wav";
					break;
				}
			break;
			
			//IMAGE	///////////////////////////////////////////////////////////////////////////////	
			case "image" :
				switch($type)
				{		
					case "image/gif" :
						$ext="gif";
					break;
					case "image/jpeg" :
						$ext="jpg";
					break;
					case "image/png" :
						$ext="png";
					break;
					case "image/tiff" :
						$ext="tiff";
					break;
					case "image/vnd.microsoft.icon" :
						$ext="ico";
					break;
				}
			break;
			
			//MULTIPART	///////////////////////////////////////////////////////////////////////////////	
			case "multipart" :
				$ext="multipart";
				/*case "multipart/mixed" :MIME E-mail ; Défini dans la RFC 2045 et la RFC 2046
				case "multipart/alternative" :MIME E-mail ; Défini dans la RFC 2045 et la RFC 2046
				case "multipart/related" :MIME E-mail ; Défini dans la RFC 2387 et utilisé par MHTML (HTML mail)*/
			break;
				
			
			
			//TEXTES	///////////////////////////////////////////////////////////////////////////////	
			case "text" :
				switch($type)
				{	
					case "text/css" :
						$ext="css";
					break;
					case "text/html" :
						$ext="html";
					break;
					case "text/plain" :
						$ext="txt";
					break;
					case "text/xml" :
						$ext="xml";
					break;
				}
			break;
				
			
			
			//VIDEOS	///////////////////////////////////////////////////////////////////////////////	
			case "video" :
				switch($type)
				{	
					case "video/mpeg" :
						$ext="mpeg";
					break;
					case "video/mp4" :
						$ext="avi";
					break;
					case "video/quicktime" :
						$ext="mov";
					break;
					case "video/x-ms-wmv" :
						$ext="wmv";
					break;
					case "video/x-flv" :
						$ext="flv";
					break;
				}
			break;
		}
		return $ext;
	}
	
	
	
	
	/******************************************************************************************************
	METHODE D'UPLOAD D'UN FICHIER AVEC MODIFICATION D'UNE TABLE MYSQL
	public  up_mysql_http($file,$a_attributs)
	
	*******************************************************************************************************
	RECOIT 		FILE	$file (fichier) correspondant
				ARRAY	$a_attributs des attributs de l'élément
	
	******************************************************************************************************/
	public function up_mysql_http($file,$a_attributs,$champ)
	{
		$s_path="";
		$s_nom="";
		$s_ext="";
		$s_id="";
				
		//PATH DU FICHIER	/////////////////////////////////////////////////////////////////
		if(isset($a_attributs["path"]))
			$s_path=$a_attributs["path"];
		
		//NOM DU FICHIER	/////////////////////////////////////////////////////////////////
		if(isset($a_attributs["nom"]))
		{
			ksort($a_attributs["nom"]);
			$s_nom="";
			foreach($a_attributs["nom"] AS $a_param)
			{
				switch($a_param["type"])
				{
					case "val_form" :
						$s_nom.=$this->a_post_values[$a_param["champ"]];
					break;
					case "fixe" :
						$s_nom.=$a_param["texte"];
					break;
					case "id" :
						$s_nom.=$this->a_id[0];
					break;
				}		
			}	
			$s_nom=formatage::formatage_url($s_nom);
		}
				
		//EXTENSION DU FICHIER	/////////////////////////////////////////////////////////////
		$s_ext=$this->type_mime_ext($file); 
		
		
		$s_nom_fichier=$s_nom.".".$s_ext;
		$s_fichier=$s_path.$s_nom.".".$s_ext;
		
		//SUPPRESSION D'UN ANCIEN FICHIER EVENTUEL	//////////////////////////////////////////////////////
		$o_select = new mysql_select();
		$o_select->table=$this->table;
		$o_select->champs=array($champ);
		$o_select->where="WHERE ".$this->champ_id."=".$this->a_id[0];
		$a_select=$o_select->select();
		$old_nom = $a_select[0][$champ];
		
		if(is_file($a_attributs["path"].$a_select[0][$champ]))
		{
			if(!unlink($a_attributs["path"].$a_select[0][$champ]))
				$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de la suppression physique du fichier <em>".$a_attributs["path"].$a_select[0][$champ]."</em>");
		}
		
		
		
		//UPLOAD DU NOUVEAU FICHIER	/////////////////////////////////////////////////////////////
		if(!move_uploaded_file($file['tmp_name'],$s_fichier))
			$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de l'ajout physique du fichier <em>".$a_attributs["path"].$a_select[0][$champ]."</em>");
		
		//UPDATE DE LA TABLE	/////////////////////////////////////////////////////////////////
		$o_up = new mysql_update();
		$o_up->table=$this->table;
		$o_up->champ_id=$this->champ_id;
		$o_up->a_id=$this->a_id;
		$o_up->add_values(array($champ=>$s_nom_fichier));
		$a_err=$o_up->update();
		if($a_err["erreur"]!=0)
			$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de l'ajout dans la base du fichier <em>".$a_attributs["path"].$a_select[0][$champ]."</em> : <br/>".$a_err["message"]);
			
		
		if(isset($a_attributs["visuel"]))
		{
			$o_resize_photo = new resize_photo($s_fichier);
						
			foreach($a_attributs["visuel"] AS $a_voila)
			{
				//SUPPRESSION EVENTUELLE D'UN VIEUX FICHIER
				$nom_a_sup = str_replace(".",$a_voila["post"].".",$old_nom);
				//echo $nom_a_sup."<br/>";
				if(is_file($a_attributs["path"].$nom_a_sup))
				{
					if(!unlink($a_attributs["path"].$nom_a_sup))
						$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de la suppression physique du fichier <em>".$a_attributs["path"].$nom_a_sup."</em>");
				}

				
				$o_resize_photo->create_visuel($a_voila["resize_type"],$a_voila["new_dim"],$a_voila["post"],$a_voila["folder_pre"],$a_voila["params"]);
			}
		}
	}
	
	
	
	
	/******************************************************************************************************
	METHODE DE SUPPRESSION D'UN FICHIER AVEC MODIFICATION D'UNE TABLE MYSQL
	public : del_mysql($champ,$a_attributs)
	
	*******************************************************************************************************
	RECOIT 		STRING	$id	de l'enregistrement
				ARRAY	$a_attributs des attributs de l'élément
	
	******************************************************************************************************/
	public function del_mysql($champ,$a_attributs)
	{
		//ON RECUPERE LE NOM DU FICHIER		//////////////////////////////////////////////////////////////
		$o_select = new mysql_select();
		$o_select->table=$this->table;
		$o_select->champs=array($champ);
		$o_select->where="WHERE ".$this->champ_id."=".$this->a_id[0];
		$a_select=$o_select->select();
		
		$old_nom = $a_select[0][$champ];
		
		//ON SUPPRIME LE FICHIER	//////////////////////////////////////////////////////////////////////
		if(is_file($a_attributs["path"].$old_nom))
		{
			//PHYSIQUEMENT
			if(!unlink($a_attributs["path"].$old_nom))
				$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de la suppression physique du fichier <em>".$a_attributs["path"].$old_nom."</em>");
			//DE LA BASE
			$o_up = new mysql_update();
			$o_up->table=$this->table;
			$o_up->champ_id=$this->champ_id;
			$o_up->a_id=$this->a_id;
			$o_up->add_values(array($champ=>""));
			$a_err=$o_up->update();
			if($a_err["erreur"]!=0)
				$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de la suppression de la base du fichier <em>".$a_attributs["path"].$old_nom."</em> : <br/>".$a_err["message"]);
		}
			
		
		
		//ON SUPPRIME LES FICHIERS MULTIPLES	//////////////////////////////////////////////////////////////////////
		if(isset($a_attributs["visuel"]))
		{						
			foreach($a_attributs["visuel"] AS $a_voila)
			{
				//SUPPRESSION EVENTUELLE D'UN VIEUX FICHIER
				$nom_a_sup = str_replace(".",$a_voila["post"].".",$old_nom);
				//echo $nom_a_sup."<br/>";
				if(is_file($a_attributs["path"].$nom_a_sup))
				{
					if(!unlink($a_attributs["path"].$nom_a_sup))
						$this->a_erreurs=array("erreur"=>4,"message"=>"<strong>ATTENTION : </strong>Echec de la suppression physique du fichier <em>".$a_attributs["path"].$nom_a_sup."</em>");
				}
			}
		}
	}
}



class upload_file_gestion extends upload_file
{	
	/******************************************************************************************************
	METHODE DE GESTION DES FICHIERS DEPUIS UNE PARTIE DE GESTION
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	public function up_mysql_http_gestion()
	{
		//ON BOUCLE SUR LES CHAMPS DE FILE A MODIFIER
		foreach($this->a_files AS $champ=>$a_attributs)
		{
			//echo $this->a_file_values[$champ]['tmp_name'];
			
			//ON VERIFIE SI LE CHAMPS FILE CORRESPONDANT EST REMPLI POUR L'UPLOAD
			if($this->a_file_values[$champ]['tmp_name']!="")
				$a_erreurs=$this->up_mysql_http($this->a_file_values[$champ],$a_attributs,$champ);
			
			//ON VERIFIE SI LE CHAMPS DEL EST PRESENT POUR LA SUPPRESSION
			if(isset($this->a_post_values[$champ."-del"]))
				$a_erreurs=$this->del_mysql($champ,$a_attributs);
		}
	}
}


class resize_photo
{	
	private $extension;
	private $mime;
	
	private $orig_w;
	private $orig_h;
	
	private $ref_tmp_file;
	private $ref_w;
	private $ref_h;
	private $ref_x=0;
	private $ref_y=0;
	
	private $new_tmp_file;
	private $new_file_name;
	private $new_w;
	private $new_h;
	private $new_x=0;
	private $new_y=0;
	
	
	public function __construct($ref_file)
	{
		//DETERMINATION DE L'EXTENSIONS ET DU NOM 	////////////////////////////////////////////////////
		$a_ref_file=explode(".",$ref_file);
		$this->extension=end($a_ref_file); //Extension 
		$this->new_file_name=str_replace(".".$this->extension,"",$ref_file); 	//Nom du fichier avant le point
		
		//CREATION DE L'IMAGE REF TEMPORAIRE	////////////////////////////////////////////////////////
		$a_dim=getimagesize($ref_file);
		$this->orig_w=$a_dim[0];	//W ref
		$this->orig_h=$a_dim[1];	//H ref
		$this->mime=$a_dim[2];	//MIME DE L'image
		switch($this->mime)
		{
			case 1 :	//GIF
				$this->ref_tmp_file = imagecreatefromgif($ref_file);
			break;
			case 2 :	//JPG
				$this->ref_tmp_file = imagecreatefromjpeg($ref_file);
			break;
			case 3 :	//PNG
				$this->ref_tmp_file = imagecreatefrompng($ref_file);
			break;
		}
	}
	
	
	public function __destruct()
	{
		imagedestroy($this->ref_tmp_file);
	}
	
	
	
	/******************************************************************************************************
	METHODE D'APPLICATION DES DIMMENSIONS 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function create_new_tmp_file()
	{
		switch($this->mime)
		{
			case 1:
				$this->new_tmp_file = imagecreate($this->new_w,$this->new_h);
				imagecolorallocate($this->new_tmp_file, 255, 255, 255);
			break;
			case 2:
				$this->new_tmp_file = imagecreatetruecolor($this->new_w,$this->new_h);
				imagecolorallocate($this->new_tmp_file, 255, 255, 255);
			break;
			case 3:
				$this->new_tmp_file = imagecreatetruecolor($this->new_w,$this->new_h);
				imagealphablending($this->new_tmp_file,false);
				imagesavealpha($this->new_tmp_file,true);
			break;
		}
	}
	
	/******************************************************************************************************
	METHODE DE REDIMENSIONNEMENT SUR LA LARGEUR 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function resize_width($new_dim)
	{
		$this->new_w=$new_dim;
		
		if($this->new_w<$this->orig_w)
			$this->new_h=ceil($this->orig_h*$this->new_w/$this->orig_w);
		else
		//Pas de changement	///////////////////
		{
			$this->new_w=$this->orig_w;
			$this->new_h=$this->orig_h;
		}
	}
	
	
	/******************************************************************************************************
	METHODE DE REDIMENSIONNEMENT SUR LA HAUTEUR 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function resize_height($new_dim)
	{
		$this->new_h=$new_dim;
		
		if($this->new_h<$this->orig_h)
			$this->new_w=ceil($this->orig_w*$this->new_h/$this->orig_h);
		else
		{
			$this->new_w=$this->orig_w;
			$this->new_h=$this->orig_h;
		}
	}
	
	
	/******************************************************************************************************
	METHODE DE REDIMENSIONNEMENT FORMAT MAXIMAL 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function resize_max($new_dim)
	{
		if($this->orig_w<$this->orig_h)
			$this->resize_width($new_dim);
		else
			$this->resize_height($new_dim);
	}
	
	
	/******************************************************************************************************
	METHODE DE REDIMENSIONNEMENT FORMAT MINIMAL 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function resize_min($new_dim)
	{
		if($this->orig_w>$this->orig_h)
			$this->resize_width($new_dim);
		else
			$this->resize_height($new_dim);
	}
	
	
	/******************************************************************************************************
	METHODE DE RECADRAGE CARRE 
	
	*******************************************************************************************************
	
	******************************************************************************************************/
	private function recadrage($new_dim)
	{
		if($this->orig_w>$new_dim AND $this->orig_h>$new_dim)
		{
			//Nouvelle h et w	//////////////////////////////////////////////////////
			$this->new_h=$new_dim;
			$this->new_w=$new_dim;
		}
		elseif($this->orig_w>$new_dim)
		{
			$this->new_h=$this->orig_h;
			$this->new_w=$this->orig_h;
		}
		elseif($this->orig_h>$new_dim)
		{
			$this->new_h=$this->orig_w;
			$this->new_w=$this->orig_w;
		}
		//Détermination de W et H de référence
		//Détermination des coordonnées de ref pour la copie
		if($this->orig_w>$this->orig_h)
		{
			$this->ref_h=$this->orig_h;
			$this->ref_w=$this->orig_h;
			$this->ref_x=($this->orig_w/2)-($this->ref_w/2);
		}
		else
		{
			$this->ref_w=$this->orig_w;
			$this->ref_h=$this->orig_w;
			$this->ref_y=($this->orig_h/2)-$this->ref_h/2;
		}
	}
	
	//RECADRAGE AVEC DES DIMENSION W FIXES
	private function fixe_w_max_h($new_dim)
	{
		//Nouvelle h et w	//////////////////////////////////////////////////////
		//LARGEUR
		$this->new_w=$new_dim[0];
		$this->ref_w=$this->orig_w;
		$this->ref_x=0;
		
		//RAPPORT
		$rapport=$this->new_w/$this->ref_w;
		
		if(($new_dim[1]/$this->orig_h)>$rapport)
		{
			$this->new_h=ceil($this->orig_h/$rapport);
			$this->ref_h=$this->orig_h;
			$this->ref_y=0;
		}
		else
		//La nouvelle hauteur est inférieure à celle du rapport : on recadre 
		{
			$this->new_h=$new_dim[1];
			$this->ref_h=floor($this->new_h/$rapport);
			$this->ref_y=floor(($this->orig_h/2) - ($this->ref_h/2));
		}
	}
	
	//RECADRAGE AVEC DES DIMENSION H FIXES
	private function fixe_h_max_w($new_dim)
	{
		//Nouvelle h et w	//////////////////////////////////////////////////////
		//LARGEUR
		$this->new_h=$new_dim[1];
		$this->ref_h=$this->orig_h;
		$this->ref_y=0;
		
		//RAPPORT
		$rapport=$this->new_h/$this->ref_h;
		
		if(($new_dim[0]/$this->orig_w)>$rapport)
		{
			$this->new_w=ceil($this->orig_w/$rapport);
			$this->ref_w=$this->orig_w;
			$this->ref_x=0;
		}
		else
		//La nouvelle largeur est inférieure à celle du rapport : on recadre 
		{
			$this->new_w=$new_dim[0];
			$this->ref_w=floor($this->new_w/$rapport);
			$this->ref_x=floor($this->orig_w - $this->ref_w)/2;
		}
	}
	
	//RECADRAGE AVEC DES DIMENSION H ET WFIXES
	private function fixe_w_fixe_h($new_dim)
	{
		$rap_w = $this->orig_w/$new_dim[0];
		$rap_h = $this->orig_h/$new_dim[1];
		
		if($rap_w>$rap_h)
			$this->fixe_h_max_w($new_dim);
		else
			$this->fixe_w_max_h($new_dim);
	}
	
	
	
	private function init_ref_xy()
	{
		$this->ref_x=0;
		$this->ref_y=0;
		$this->new_x=0;
		$this->new_y=0;
		$this->new_w=0;
		$this->new_h=0;
		$this->ref_w=$this->orig_w;
		$this->ref_h=$this->orig_h;
	}
	
	
	
	
	public function create_visuel($type,$new_dim,$post="",$folder_pre="",$a_params=array())
	{
		//INITIALISATION DES X ET Y DE REF	////////////////////////////////////////////////////
		$this->init_ref_xy();
		//DETERMINATION DES NOUVELLES DIMENSIONS	////////////////////////////////////////////////////
		switch($type)
		{
			case "max":
				$this->resize_max($new_dim);
			break;
			case "min":
				$this->resize_min($new_dim);
			break;
			case "max_width":
				$this->resize_width($new_dim);
			break;
			case "max_height":
				$this->resize_height($new_dim);
			break;
			case "recad":
				$this->recadrage($new_dim);
			break;
			case "fixe_w_max_h":
				$this->fixe_w_max_h($new_dim);
			break;
			case "fixe_h_max_w":
				$this->fixe_h_max_w($new_dim);
			break;
			case "fixe_w_fixe_h":
				$this->fixe_w_fixe_h($new_dim);
			break;
		}		
				
		//CREATION DE L'IMAGE TEMPORAIRE		/////////////////////////////////////////////////////////
		$this->create_new_tmp_file();
		
		//COPIE DE L'IMAGE REF_TMP VERS L'IMAGE NEW_TMP	/////////////////////////////////////////////////
		imagecopyresampled(	$this->new_tmp_file,	//img dest
							$this->ref_tmp_file,	//img src
							$this->new_x,	//x dest
							$this->new_y,	//y dest
							$this->ref_x,	//x src
							$this->ref_y,	//y src
							$this->new_w,	//w dest
							$this->new_h,	//h dest
							$this->ref_w,	//w src
							$this->ref_h	//h src
							);
	
		//TRAITEMENTS SPECIAUX...	////////////////////////////////////////////////////////////////////
		if(isset($a_params["mirror"]))
		{
			$this->create_mirror($a_params["mirror"]);
		}
		
	
	
	
		//CREATION DU CHEMIN DE L'IMAGE DEPUIS NEW_TMP	/////////////////////////////////////////////////
		$new_fichier=$this->new_file_name.$post.".".$this->extension;
		if($folder_pre!="")
		{
			$a_nf=explode("/",$new_fichier);
			$new_fichier=str_replace(end($a_nf),$folder_pre.end($a_nf),$new_fichier);
		}
		
		//ENREGISTREMENT DE L'IMAGE	/////////////////////////////////////////////////////////////////////
		switch($this->mime)
		{
			case 1 :
				imagegif($this->new_tmp_file,$new_fichier);
			break;
			case 2 :
				imagejpeg($this->new_tmp_file,$new_fichier,100);
			break;
			case 3 :
				imagepng($this->new_tmp_file,$new_fichier);
			break;
		}
		//DESTRUCTION DE NEW_TMP	////////////////////////////////////////////////////////////////
		imagedestroy($this->new_tmp_file); 
	}



	private function create_mirror($a_params=array())
	{	
		$tmp = $this->new_tmp_file;
		$largeur = $this->new_w;
		$hauteur = $this->new_h; 
		
		if(isset($a_params["taux_h"]))
		{
			$h_mirror = $hauteur * $taux_h;
		}
		if(isset($a_params["px_h"]))
		{
			$h_mirror = $a_params["px_h"];
		}
		
		$this->new_h = $this->new_h + $h_mirror;
		$temporaireUn = imagecreatetruecolor($largeur, $h_mirror);
		$temporaireDeux = imagecreatetruecolor($largeur, $h_mirror);
		$this->create_new_tmp_file();
		imagefill($this->new_tmp_file, 1, 1, $blancUn);
		$blancDeux = imagecolorallocate($temporaireDeux, 255, 255, 255);
		imagefill($temporaireDeux, 1, 1, $blancDeux); 
		imagecopy ($this->new_tmp_file, $tmp, 0, 0, 0, 0, $largeur, $hauteur);
		imagecopy ($temporaireUn, $tmp, 0, 0, 0, $hauteur - $h_mirror, $largeur, $h_mirror);
		$this->imageflip($temporaireDeux, $temporaireUn);
		imagecopy ($this->new_tmp_file, $temporaireDeux, 0, $hauteur, 0, 0, $largeur, $h_mirror); 
	}
	
	
	private function imageflip($dest, $src) 
	{
		$w = imagesx($src);	
		$h = imagesy($src);	
		$alpha = $a_params["alpha"];
		$alpha = 127;
		for($y=0; $y<$h; $y++) 
		{
			for ($x=0; $x<$w; $x++) 
		   {
				$couleur = imagecolorsforindex($src, imagecolorat($src, $x, $y));	
				$couleurAlpha = imagecolorallocatealpha($dest, $couleur['red'], $couleur['green'], $couleur['blue'], $alpha);
				imagesetpixel($dest, $x, ($h-$y), $couleurAlpha);	
			}		
			if($alpha > 1) 
				$alpha--;	
		}
	}
}
?>
