<?php 
class formatage 
{
	/******************************************************************************************
	METHODE Ko, Mo, Go	transforemation depis bytes
	octets($float)
	******************************************************************************************/
	public static function octets($float)
	{
		//Kilo
		if($float<1000)
			$string = "1 Ko";
		if($float<1000000)
			$string = ceil($float/1048.576)." Ko";
		else
			$string = number_format(($float/1048576),2)." Mo";
		return $string;
	}



	/******************************************************************************************
	METHODE PHRASE LIMITE	
	phrase_limite($string,$limit,$final)
	******************************************************************************************/
	public static function phrase_limite($string,$limit,$final)
	{
		//GESTION DES IMAGES
		$a_string_tmp=explode("<img",strtolower($string));
		$a_string_tmp2=explode(">",strtolower($a_string_tmp[1]));
		$string2=$a_string_tmp2[1];
		for($i=2;$i<count($a_string_tmp2);$i++)
			$string2.=">".$a_string_tmp2[$i];
		
		$string=$a_string_tmp[0].$string2;
		
		//GESTION DE FIN DE TAG
		$tag_add="";
		$a_tags=array("strong","b","font","i","u","p","li","ul","ol","th","td","tr","table","div");
	
		
		$a_mots=explode(" ",$string);
		$nbCar=$limit-strlen($final);
		
		$s_mots="";
		$i=0;
		foreach($a_mots AS $mot)
		{
			if((strlen($mot) + strlen($s_mots))<$nbCar)
			{
				if(strlen($s_mots)==0)
					$s_mots.=$mot." ";
				else
					$s_mots.=" ".$mot;
			}
			else
			{
				foreach($a_tags AS $tag)
				{
					$tag_debut=substr_count($s_mots,"<".$tag);
					$tag_fin=substr_count($s_mots,"</".$tag.">");
					if($tag_debut>$tag_fin)
						$tag_add.="</".$tag.">";
				}
				
				$s_mots.=$final.$tag_add;
				break;
			}
		}
		return $s_mots;
	}



	/******************************************************************************************
	METHODE D'ENUMERATION 
	enumeration($int,$a_params=array("mf"=>"m","style"=>""))
	*******************************************************************************************
	RECOIT		INT $int de la position à formater
	RETOURNE	STRING $string_format de la chaine formatée
	******************************************************************************************/
	public static function enumeration($int,$a_params=array("mf"=>"m","style"=>""))
	{
		if($int == 1)
		{
			if($a_params["mf"]=="m")
			 	$ext = "er";
			else
				$ext = "ère";	
		}
		else
			$ext = "ème";
		
		$string = $int."<sup ".$a_params["style"].">".$ext."</sup>";
		return $string;
	}
	
	/******************************************************************************************
	METHODE DE SUPPRESSION DES CARACTERES INVISIBLES 
	strip_invisible(chaine)
	*******************************************************************************************
	RECOIT		STRING $string de la chaine à formater
	RETOURNE	STRING $string_format de la chaine formatée
	******************************************************************************************/
	
	public static function strip_invisible($string) 
	{
		$string = trim($string);
		$string = ereg_replace("\n", "", $string); 
		$string = ereg_replace("\r", "", $string); 
		$string = ereg_replace("\t", "", $string);
		return $string;
	}
	
	
	
	
	
	
	
	
	/******************************************************************************************
	METHODE DE SUPPRESSION DES ACCENTS 
	strip_accent(chaine)
	*******************************************************************************************
	RECOIT		STRING $string de la chaine à formater
	RETOURNE	STRING $string_format de la chaine formatée
	******************************************************************************************/
	
	public static function strip_accents($string) 
	{
		$string = str_replace(
			array('à', 'â', 'ä', 'á', 'ã', 'å','î', 'ï', 'ì', 'í','ô', 'ö', 'ò', 'ó', 'õ', 'ø','ù', 'û', 'ü', 'ú','é', 'è', 'ê', 'ë','ç', 'ÿ', 'ñ',
				'À', 'Â', 'Ä', 'Á', 'Ã', 'Å','Î', 'Ï', 'Ì', 'Í','Ô', 'Ö', 'Ò', 'Ó', 'Õ', 'Ø','Ù', 'Û', 'Ü', 'Ú','É', 'È', 'Ê', 'Ë','Ç', 'Ÿ', 'Ñ',),
			array('a', 'a', 'a', 'a', 'a', 'a','i', 'i', 'i', 'i','o', 'o', 'o', 'o', 'o', 'o','u', 'u', 'u', 'u','e', 'e', 'e', 'e','c', 'y', 'n', 
				'A', 'A', 'A', 'A', 'A', 'A','I', 'I', 'I', 'I','O', 'O', 'O', 'O', 'O', 'O','U', 'U', 'U', 'U','E', 'E', 'E', 'E','C', 'Y', 'N',),
				$string);
		return $string;
	}


	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE VALEUR EN URL "voici-une-url"
	formatage_url($string)
	*******************************************************************************************
	RECOIT		STRING $string de la chaine à formater
	RETOURNE	STRING $string_format de la chaine formatée
	******************************************************************************************/
	public static function formatage_url($string)
	{
		//SUPPRESSION DES ACCENTS
		$string = formatage::strip_accents($string);
		//REMPLACEMENT DES CARACTERES AUTRES QUE CHIFFRES ET LETTRES PAR "-"		 
		$string = preg_replace('/([^a-z0-9]+)/i', '-', $string);
		//SUPPRESSION DES MULTIPLES "-"
		$string=ereg_replace("-{2,}","-",$string);
		//SUPPRESSION DES "-" EN DEBUT ET FIN DE CHAINE
		if(substr($string,0,1)=="-")
			$string=substr_replace($string,"",0,1);
		if(substr($string,-1,1)=="-")
			$string=substr_replace($string,"",-1,1);
		//ON RETOURNE EN MINUSCULE
		return strtolower($string);
	}
		
	
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE VALEUR EN URL "voici-une-url.html"
	formatage_url_html($string)
	*******************************************************************************************
	RECOIT		STRING $string de la chaine à formate
	RETOURNE	STRING $string_format de la chaine formatée
	******************************************************************************************/
	public static function formatage_url_html($string)
	{
		//TRANSFORMATION EN URL ET AJOUT DU .HTML
		$string = formatage::formatage_url($string).".html";
		return $string;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE VALEUR EN CHIFFRES TELEPHONIQUES 02 40 44 52 32 => 240445232
	format_tel($num)
	
	*******************************************************************************************
	RECOIT		STRING $num de la chaine à formater
	RETOURNE	STRING $num de la chaine formatée
	******************************************************************************************/
	private function format_tel($num)
	{
		//SUPPRESSION DES ESPACES
		$a_search=array(" ","-","/");
		$num=str_replace($a_search,"",$num);
		
		//SUPPRESSION DU PREMIER 0
		if(substr($num,0,1)==0)
			$num=substr_replace($num,"",0,1);
			
		return $num;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE VALEUR EN VISUEL
	formatage_visuel($valeur,$attributs)
	*******************************************************************************************
	RECOIT		STRING $num de la chaine à formater
				ARRAY des attributs
					path=>chemin relatif ou absolu
					width=>taille max
					height=>hauteur max
					alt=>texte alternatif
	RETOURNE	STRING $num de la chaine formatée
	******************************************************************************************/
	public static function formatage_visuel($valeur,$attributs)
	{
		$style="";
		$alt="";
		//chemin
		$src=$attributs["path"].$valeur;
		
		if(isset($attributs["width"]))
			$style.="width:".$attributs["width"].";";
		if(isset($attributs["height"]))
			$style.="height:".$attributs["height"].";";
		if(isset($attributs["alt"]))
			$alt=$attributs["alt"];
		
		$img="<img src='".$src."' style='".$style."' alt='".$alt."' />";
			
		return $img;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UN VISUEL
	visuels($a_attributs)
	*******************************************************************************************
	RECOIT		STRING $num de la chaine à formater
				ARRAY des attributs
					path=>chemin relatif ou absolu
					width=>taille max
					height=>hauteur max
					alt=>texte alternatif
	RETOURNE	STRING $num de la chaine formatée
	******************************************************************************************/
	public static function visuels($a_attributs)
	{
		//Initialisation
		$style_div = "";
		$style_img = "";
		$type = "";
		$alt = "visuel";
		$path = "";
		$left = 0;
		$top = 0;
		$surface_fixe = 100000;
		$a_link = array("","");
		
		$src = $a_attributs["src"];
		$w_new = $a_attributs["w_new"];
		$h_new = $a_attributs["h_new"];
		$class = $a_attributs["class"];
		
		if(isset($a_attributs["path"]))
			$path = $a_attributs["path"];
		if(isset($a_attributs["type"]))
			$type = $a_attributs["type"];
		if(isset($a_attributs["alt"]))
			$alt = $a_attributs["alt"];
		if(isset($a_attributs["surface_fixe"]))
			$surface_fixe = $a_attributs["surface_fixe"];
		
		//Visuel
		if(isset($a_attributs["url"]))
		{
			$a_link[0] = "<a href=".$a_attributs["url"]." title=\"".$alt."\" class='".$a_attributs["class_a"]."' >";
			$a_link[1] = "</a>";
		}
		
		if(substr($src,0,1)=="/")
			$src_ok = substr($src,1);
		else
			$src_ok = $src;

		//ON VERIFIE SI L'IMAGE EXISTE
		if(@getimagesize($src_ok))
		{
			$a_lh = getimagesize($src_ok);
				
			$orig_w = $a_lh[0]; 
			$orig_h = $a_lh[1]; 
			$rapport_h_sur_l = $orig_h/$orig_w;
			
			if($type == "")
			{
				$new_h_tmp = $h_new;
				$new_w_tmp = floor($new_h_tmp / $rapport_h_sur_l);
				if($new_w_tmp>=$w_new)
				{
					$new_h = $new_h_tmp;
					$new_w = $new_w_tmp;
				}
				else
				{
					$new_w = $w_new;
					$new_h = floor($new_w * $rapport_h_sur_l);
				}
				
				$top = floor(($h_new-$new_h)/2);
				$left =  floor(($w_new-$new_w)/2);
				
				$style_div = "style='width:".$w_new."px; height:".$h_new."px; overflow:hidden; position:relative;'"; 
				$style_img = "style='left:".$left."px; top:".$top."px; width:".$new_w."px; height:".$new_h."px; position:absolute;'" ;
			}
			//IMAGE AVEC UNE W OU UNE H MAX DEVANT ETRE AFFICHE COMPLETEMENT
			elseif($type=="complete")
			{
				if($orig_w>$orig_h)
				{
					//image horizontale -> la ref est la largeur	//////////////////////////////////////////////////////
					$new_w = $w_new;
					$new_h = $new_w * $rapport_h_sur_l;
				}
				else
				{
					//image vertical -> la ref est la hauteur	//////////////////////////////////////////////////////
					$new_h = $h_new;
					$new_w = $new_h / $rapport_h_sur_l;
				}
				
				$top = floor(($h_new-$new_h)/2);
				$left =  floor(($w_new-$new_w)/2);
				
				$style_img = "style='left:".$left."px; top:".$top."px; width:".$new_w."px; height:".$new_h."px;'" ;
			}
			//IMAGE AVEC UNE W OU UNE H MAX DEVANT ETRE AFFICHE COMPLETEMENT
			elseif($type=="surface_fixe")
			{
				$orig_surface = $orig_h * $orig_w;
				$rap_surface = $orig_surface / $surface_fixe;
				
				$racine = sqrt($rap_surface);
				
				$new_h = $h_new = ceil($orig_h/$racine);
				$new_w = $w_new = ceil($orig_w/$racine);
				
				$style_img = "style='left:".$left."px; top:".$top."px; width:".$new_w."px; height:".$new_h."px;'" ;

			}
			
			
			
			$img =	"<div class='".$a_attributs["class"]."' ".$style_div.">";
			$img.=		$a_link[0]."<img ".$style_img." src = '".$path.$src_ok."' />".$a_link[1];
			$img.=	"</div>";
		}
		return $img;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE STRING 
	formatage_texte($string,$a_format,$a_attributs=array())
	*******************************************************************************************
	RECOIT		STRING $string de la chaine à formater
				ARRAY $a_format des criteres de formatage à appliquer
					"ss"			=> stripslashe la chaine	
					"bold"			=> encapsule ds la balise <strong>
					"utf8"			=> encode en utf8
					"tel_france"	=> transforme la chaine au format "00 00 00 00 00"	
					"tel_inter"		=> transforme la chaine au format "+33 0 00 00 00 00"	
					"euros"			=> transforme la chaine au format "000 000,00 €"	
					"mailto"		=> encapsule la chaine dans <a mailto:$string>$string</a>
									   après avoir vérifié qu'elle est bien un mail
					"url"			=> encapsule la chaine dans <a href="$a_attributs['path'].$string">$a_attributs['texte_lien']</a>
									   après avoir vérifié qu'elle est bien un mail
					ARRAY $a_attributs des attribut de formatage (optionnel
	
	
	RETOURNE	STRING	$string_format de la chaine formatée
	******************************************************************************************/
	public static function formatage_texte($string,$a_format,$a_attributs=array())
	{
		$string_format=$string;
		foreach($a_format AS $format)
		{
			switch($format)
			{
				case "parag":
					if(substr($string_format,0,2)!="<p")
						$string_format = "<p>".stripslashes($string_format)."</p>";
				break;
				case "ss":
					$string_format=stripslashes($string_format);
				break;
				case "explode":
					$a_tmp = explode($a_attributs["delimiter"],$string_format);
					if(isset($a_attributs["each"]) && $a_attributs["each"]["type"]=="date")
					{
						foreach($a_tmp as $off=>$value_)
							$a_tmp[$off] = formatage::formatage_date($value_,$a_attributs["each"]["attributs"]);
					}
					$string_format = implode($a_attributs["glue"],$a_tmp);
				break;
				case "bold":
					$string_format="<strong>".$string_format."</strong>";
				break;		
				case "utf8":
					$string_format=utf8_encode($string_format);
				break;		
				case "tel_france":
					if($string_format!="")
					{
						//formatage du num
						$string_format=formatage::format_tel($string_format);
						//On ajoute le zéro devant
						$string_format=substr_replace($string_format,"0",0,0);
						//On ajoute les espaces
						for($i=0;$i<5;$i++)
							$string_format=substr_replace($string_format, ' ', $i*2+$i, 0);
						//on supprime les espaces de début et de fin
						$string_format=trim($string_format);
					}
				break;		
				case "tel_inter":
					//formatage du num
					$string_format=formatage::format_tel($string_format);
					//On ajoute un zéro devant
					$string_format=substr_replace($string_format,"0",0,0);
					//On ajoute les espaces
					for($i=0;$i<5;$i++)
						$string_format=substr_replace($string_format, ' ', $i*2+$i, 0);
					//on supprime les espaces de début et de fin
					$string_format=trim($string_format);
					//on remplace le 0
					$string_format=substr_replace($string_format,"+33 ",0,1);
				break;
				
				case "euros":
					$string_format=number_format($string_format,2,","," ")." €";
				break;
				
				case "mailto":
					$Syntaxe='#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,5}$#';
					if(preg_match($Syntaxe,$string_format) AND !empty($string_format))
						$string_format="<a href=\"mailto:".$string_format."\">".$string_format."</a>";
				break;
				
				case "url":
					if(isset($a_attributs["class"]))
						$class="class='".$a_attributs["class"]."'";
					else
						$class="";
					$string_format="<a ".$class." href=\"".$a_attributs["path"].$string_format."\">".$a_attributs["texte_lien"]."</a>";
				break;
				
				case "couleur":
					$string_format="<span style='color:".$a_attributs["couleur"].";'>".$string_format."</span>";
				break;
				
				case "limite":
					$string_format=formatage::phrase_limite($string_format,$a_attributs["limite"],$a_attributs["final"]);
				break;
			}
		}
		return $string_format;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE STRING DATE EN AAAA-MM-DD
	formatage_date_r($string="")	
	*******************************************************************************************

	******************************************************************************************/
	public static function formatage_date_r($string="")
	{
		$a_mois=array(	"janvier"=>"01","fevrier"=>"02","mars"=>"03","avril"=>"04","mai"=>"05","juin"=>"06",
						"juillet"=>"07","aout"=>"08","septembre"=>"09","octobre"=>"10","novembre"=>"11","decembre"=>"12"
					);

		$string=html_entity_decode($string,ENT_QUOTES,"UTF-8");
		$string=formatage::formatage_url($string);
		
		$a_date=explode("-",$string);
		foreach($a_date as $sub_string)
		{
			if(array_key_exists($sub_string,$a_mois))
				$a_nd[1]=$a_mois[$sub_string];
			elseif($sub_string>999)
				$a_nd[0]=$sub_string;
			elseif($sub_string<32)
				$a_nd[2]=$sub_string;
		}
		$date=$a_nd[0]."-".$a_nd[1]."-".$a_nd[2];
		return $date;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE DATE EN mois
	date_mois($date="0000-00-00")
	*******************************************************************************************

	******************************************************************************************/
	private static function date_mois($date="0000-00-00")
	{
		$a_mois=array(	"01"=>"janvier","02"=>"février","03"=>"mars","04"=>"avril","05"=>"mai","06"=>"juin",
						"07"=>"juillet","08"=>"août","09"=>"septembre","10"=>"octobre","11"=>"novembre","12"=>"décembre","00"=>"Pas bon format de mois"
					);
		$a_date=explode("-",$date);
		return $a_mois[$a_date[1]];
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE DATE EN nom du jour
	date_jour($date="0000-00-00")
	*******************************************************************************************

	******************************************************************************************/
	private static function date_jour($date="0000-00-00")
	{
		$a_jours=array(0=>"dimanche",1=>"lundi",2=>"mardi",3=>"mercredi",4=>"jeudi",5=>"vendredi",6=>"samedi");
		list($annee,$mois,$jour)=explode("-",$date);
		$date_ts=mktime(0,0,0,$mois,$jour,$annee);
		$s_jour=$a_jours[date("w",$date_ts)];
		
		//FORMATAGE DU JOUR (chiffre)
		if($jour<10)
			$jour=str_replace("0","",$jour);
		if($jour==1)
			$jour=trim($jour)."er";
		
		return $s_jour." ".$jour;
	}
		
	
	/******************************************************************************************
	METHODE DE FORMATAGE D'UNE DATE EN nom du jour mois annee
	formatage_date($date_d="0000-00-00",$a_attribut,$date_f="0000-00-00")
	*******************************************************************************************

	******************************************************************************************/
	public static function formatage_date($date_d="0000-00-00",$a_attribut,$date_f="0000-00-00")
	{
		//DUREE
		if($date_f!="0000-00-00" AND $date_f!="" AND $date_f!=$date_d)
		{
			list($annee_d,$mois_d,$jour_d)=explode("-",$date_d);
			list($annee_f,$mois_f,$jour_f)=explode("-",$date_f);
		
			if(in_array("nom_jour",$a_attribut))
			{
				$s_jour_d=formatage::date_jour($date_d);
				$s_jour_f=formatage::date_jour($date_f);
			}
			elseif(in_array("jour",$a_attribut))
			{
				$s_jour_d=$jour_d;
				$s_jour_f=$jour_f;
			}
		
			if(in_array("nom_mois",$a_attribut))
			{
				$s_mois_f=formatage::date_mois($date_f);
				if($mois_d==$mois_f)
					$s_mois_d="";
				else
					$s_mois_d=formatage::date_mois($date_d);
			}
		
			elseif(in_array("mois",$a_attribut))
			{
				$s_mois_f=$mois_f;
				if($mois_d==$mois_f)
					$s_mois_d="";
				else
					$s_mois_d=$mois_d;
			}
			
			if(in_array("annee",$a_attribut))
			{
				$s_annee_f=$annee_f;
				if($annee_d==$annee_f)
					$s_annee_d="";
				else
					$s_annee_d=$annee_d;
			}
		
			$s_dates=$s_jour_d." ".$s_mois_d." ".$s_annee_d." au ".$s_jour_f." ".$s_mois_f." ".$s_annee_f;
		}
			
			
		else
		{
			list($annee_d,$mois_d,$jour_d)=explode("-",$date_d);
		
			if(in_array("nom_jour",$a_attribut))
				$s_jour_d=formatage::date_jour($date_d);
			elseif(in_array("jour",$a_attribut))
				$s_jour_d=$jour_d;
		
			if(in_array("nom_mois",$a_attribut))
				$s_mois_d=formatage::date_mois($date_d);
			elseif(in_array("mois",$a_attribut))
				$s_mois_d=$mois_d;
			
			if(in_array("annee",$a_attribut))
				$s_annee_d=$annee_d;
		
			$s_dates=$s_jour_d." ".$s_mois_d." ".$s_annee_d;
		}
		return $s_dates;
	}
}
?>
