<?php
require_once("class.formulaire.format.php");


class formulaire_contact extends formulaire_format
{
	//ARRAY fichier/classe pour l'erreur
	private $s_fc="<em>class.formulaire.contact.php => formulaire_contact</em>";
	//STRING du formulaire HTML renvoyée
	private $s_form="";
	//STRING Class appliqué au formulaire 
	public $class_div="form";
	//STRING page de destination du formulaire
	public $form_action="";
	//STRING texte du submit
	public $txt_submit="Envoyer";
	//STRING path visuel verif
	protected $path_visuel_verif="/visuels/public/verif/";

	//ARRAY des erreurs
	private $a_erreurs=array();
	
	//BOOL no_spam
	public $no_spam=1;
	public $rand_nb=10;
	
	
	/******************************************************************************************
	FONCTION D'AJOUT D'UNE CLASS CSS AU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT	$class	STRING de la class à appliquer		
	
	Déclinée en 	class 		pour le div global encapsulant le formulaire
					class-ele 	pour les divs encapsulant les elements
					class-err	pour les divs encapsulant les elements avec erreur
					class-cha	pour les divs encapsulant les champs
					class-int	pour les labels encapsulant les intitulés
	******************************************************************************************/
	public function set_class_div($class)
	{
		$this->class_div=$class;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION D'UN CHAMP DU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT		STRING $nom 		nom du champs		
	RETOURNE	STRING $champ_form	affichage HTML du champ
	******************************************************************************************/
	private function create_champ($nom)
	{
		//PARAMETRES COMMUNS	////////////////////////////////////////////////////////
		$id = $nom.$this->a_values["id"];
		$nom=$nom;
		$type=$this->a_champs[$nom]["type"];
		
		//GESTION DES OPTIONS	////////////////////////////////////////////////////////
		$options="";
		if(isset($this->a_champs[$nom]["options"]))
			$options=$this->a_champs[$nom]["options"];
		
		//TYPE DE CHAMPS	///////////////////////////////////////////////////////////
		switch($type)
		{
			case "text":
				$champ_form=$this->form_InputText($nom,$id,$options);
			break;
			case "textarea":
				$champ_form=$this->form_Textarea($nom,$id,$options);
			break;
			case "fixe":
				$this->a_values[$nom]=$this->a_champs[$nom]["value"];
				$champ_form=$this->form_Input("hidden",$nom,$id,$options);
			break;
			case "select":
				$champ_form=$this->form_Select($nom,$this->a_champs[$nom]["tab_ext"],$id,$options);
			break;
			case "cb_bool":
				//CREATION DU CHAMPS "FILE_VERIF"
				$champ_form=$this->form_CheckBox_bool($nom,$id,$options);
			break;
			
			
			default:
				$champ_form="<strong>CHAMP ".$nom." => type=".$type."</strong> : type de champ non renseigné ou erroné 
							<br/>Il faut le renseigner avec la fonction add_champ().
							<br/>".$this->s_fc;
			break;
		}
		
		//RETOUR	///////////////////////////////////////////////////////////
		return $champ_form;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION D'UN ELEMENT DU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT		STRING 	$nom 	nom du champ		
	RETOURNE	STRING 	affichage HTML de l'élément
	******************************************************************************************/
	private function create_element($nom)
	{		
	
		//CHAMPS APPARENTS	/////////////////////////////////////////////////////////////////////////////////////////
		if(	$this->a_champs[$nom]["type"]!="fixe" AND $this->a_champs[$nom]["type"]!="hidden")
		{
			//CREATION DU LABEL	//////////////////////////////////////////////////////////
			$for=$nom."-".$this->a_values["id"];
			$options="class='".$this->class_div."-int'";
			//Gestion de l'intitulé -> si intitulé, on l'integre au label
			$value="";
			if(isset($this->a_champs[$nom]["intitule"]))
				$value=$this->a_champs[$nom]["intitule"];
			//string HTML
			$label=$this->form_Label($for,$value,$options);
			
			
			
			//CREATION DU CHAMP	//////////////////////////////////////////////////////////
			//Class
			$class=$this->class_div."-cha";
			//Gestion des erreurs -> Si erreur, on écrit le texte de l'erreur
			$erreur="";
			if(isset($this->a_erreurs[$nom]))
				$erreur="<p class='erreur'>".$this->a_erreurs[$nom]."</p>";
			//Création du champ
			$s_champ_form=$this->create_champ($nom);
			//string HTML
			$champ="<div class='".$class."'>".$erreur.$s_champ_form."</div>";
			
			
			
			//CREATION DE L'ELEMENT	//////////////////////////////////////////////////////////
			//Class
			$class=$this->class_div."-ele";
			//Gestion des erreurs -> si erreur, on attribut le suffixe -err
			if(isset($this->a_erreurs[$nom]))
				$class=$this->class_div."-err";
			//string HTML
			$element="<div class='".$class."'>".$label.$champ."<div class='".$this->class_div."-clear'></div></div>";
		}
	
		//CHAMPS INVISIBLES	/////////////////////////////////////////////////////////////////////////////////////////
		else
			$element=$this->create_champ($nom);
		
		
		//RETOUR	//////////////////////////////////////////////////////////////////
		return $element;
	}	
	
	
	
	
	
	/******************************************************************************************
	FONCTION D'ATTRIBUTION DU TABLEAU D'ERREUR
	
	
	*******************************************************************************************
	RECOIT	ARRAY $a_erreurs 	Tableau des erreur pour chaque champ
								$a_erreur["nom du champ"]="Message d'erreur" 		
	******************************************************************************************/
	public function set_erreurs($a_erreurs)
	{
		$this->a_erreurs=$a_erreurs;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION DU FORMULAIRE TOTAL
	
	*******************************************************************************************
	RETOURNE	STRING 		affichage HTML du formulaire :
							div-global
								form
									champ - label (X fois)
									hidden de l'action
									submit
								/form
							/div-global		
	******************************************************************************************/
	public function create_formulaire($no_spam=1)
	{
		//TITRE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		if(isset($this->a_champs["caption"]))
			$this->s_form.="<div class='caption'>".$this->a_champs["caption"]["texte"]."</div>";
			
		//OUVERTURE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		$this->s_form.="<div class='".$this->class_div."'>";
		
		
		$this->s_form.=$this->form_Head("post",$this->form_action,"form-".$this->a_values["id"],"form-".$this->a_values["id"]);
		
		
		//CREATION DES CHAMPS	//////////////////////////////////////////////////////////////////////////////////////////
		foreach($this->a_champs AS $champ=>$a_format)
		{
			switch($a_format["type"])
			{
				case "caption":
					$this->s_form.="";			
				break;
				case "legende":
					$this->s_form.="<p class='form-leg'>".$a_format["texte"]."</p>";
				break;
				case "libre":
					$this->s_form.=$a_format["html"];
				break;
				default:
					$this->s_form.=$this->create_element($champ);
				break;
			}		
		}	
		
		//CHAMP NO SPAM
		if($this->no_spam==1)
		{
			$verif=rand(1,$this->rand_nb);
			$this->a_values["no_spam"]=$verif;
			$options="autocomplete='off'";
			$this->a_values["no_spam_verif"]="";
			
			$this->s_form.=	"<div class='form-nospan'>";
			$this->s_form.=		"<p class='titre-nospan'>Vérification anti-spam</p>";
			$this->s_form.=		"<p class='text-nospan'>Recopiez le texte de l'image dans le champ en dessous :</p>";
			$this->s_form.=		"<div class='form-img-nospan'>";
			$this->s_form.=			$this->form_Input("hidden","no_spam");	
			$this->s_form.=			"<img class='form-verif-value' src='".$this->path_visuel_verif."verif_".$verif.".png' alt='verif_".$verif."' />";
			
			if(isset($this->a_erreurs["no_spam_verif"]))
				$erreur="<p class='erreur'>".$this->a_erreurs["no_spam_verif"]."</p>";
			$this->s_form.=$erreur.$this->form_Input("text","no_spam_verif","no_spam_verif",$options);	
			$this->s_form.=		"</div>";
			$this->s_form.=		"<div class='clear'></div>";
			$this->s_form.="</div>";
		}
		
		//CHAMP "SEND"
		$this->a_values["send"]=1;
		$this->s_form.=$this->form_Input("hidden","send");	
		
		//BOUTON SUBMIT	//////////////////////////////////////////////////////////////////////////////////////////
		$options="class='val-submit'";
		$this->s_form.="<div class='form-submit'>";
		$this->a_values["submit-bt"]=$this->txt_submit;
		$this->s_form.=$this->form_Input("submit","submit-bt","submit-bt".$this->a_values["id"],$options);	
		$this->s_form.="</div>";
		
		
		//FERMETURE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		$this->s_form.=$this->form_Close();
		$this->s_form.="</div>";
		
		return $this->s_form;
	}
}
?>
