<?php
require_once("class.formulaire.format.php");


class formulaire_modadd extends formulaire_format
{
	//ARRAY fichier/classe pour l'erreur
	private $s_fc="<em>class.formulaire.modadddel.php => formulaire_modadddel</em>";
	//STRING du formulaire HTML renvoyée
	private $s_form="";
	//STRING Class appliqué au formulaire 
	protected $class_div="form";
	//STRING page de destination du formulaire
	protected $form_action="";
	//STRING valeur de l'ID
	protected $mod_id="";
	//STRING Type de formulaire (mod ou add)
	protected $type_action="";
	//STRING texte du submit ADD
	protected $add_txt_submit="Ajouter";
	//STRING texte du submit MOD
	protected $mod_txt_submit="Modifier";
	//STRING texte du submit DEL
	protected $del_txt_submit="Valider";
	//STRING texte du submit DEL
	protected $post_form = "";
	//STRING texte du message si erreur
	protected $message="";
	//BOOL D'ERREUR
	private $erreurs = 0;
	//ARRAY des erreurs
	private $a_erreurs = array();
	//ARRAY des valeurs d'erreur
	private $a_erreurs_values = array(); 
	
	public function __construct($a_param=array())
	{
		//On attribue l'ID de l'enregistrement à modifier 
		$this->mod_id = $a_param["id"];
		//On attribue le message 
		$this->message = $a_param["message"];
		//On attribue le type d'action
		$this->set_type_action($a_param["modadd"]);
		
		//GESTION DES ERREURS
		if($a_param["erreur"]==1)
		{
			$this->erreurs = $a_param["erreur"];
			$this->a_erreurs = $a_param["erreurs"];
			$this->a_erreurs_values = $a_param["valeurs"];
		}
	}
	
	/******************************************************************************************
	FONCTION D'AJOUT D'UNE CLASS CSS AU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT	$class	STRING de la class à appliquer		
	
	Déclinée en 	class 		pour le div global encapsulant le formulaire
					class-ele 	pour les divs encapsulant les elements
					class-err	pour les divs encapsulant les elements avec erreur
					class-cha	pour les divs encapsulant les champs
					class-int	pour les labels encapsulant les intitulés
	******************************************************************************************/
	public function set_class_div($class)
	{
		$this->class_div=$class;
	}
	
	
	
	
	/******************************************************************************************************
	METHODE RECUPERATION DES VALEURS DE L'ENREGISTREMENT
	
	*******************************************************************************************************

	******************************************************************************************************/
	protected function recuperation_valeurs($a_param)
	{
		//RECUPERATION DES VALEURS
		$o_select=new mysql_select();
		if(isset($a_param["table"]))
			$o_select->table=$a_param["table"];
		if(isset($a_param["where"]))
			$o_select->where=$a_param["where"];
		if(isset($a_param["fichier_source"]))
			$o_select->fichier_source=$a_param["fichier_source"];
		
		
		if(isset($a_param["limite"]))
			$o_select->limite=$a_param["limite"];
		else
			$o_select->limite=1;
			
		$a_valeurs = $o_select->select();
		
		$this->set_values($a_valeurs[0]);
	}
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION D'UN CHAMP DU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT		STRING $nom 		nom du champs		
	RETOURNE	STRING $champ_form	affichage HTML du champ
	******************************************************************************************/
	private function create_champ($nom)
	{
		//PARAMETRES COMMUNS	////////////////////////////////////////////////////////
		$id=$nom;
		$nom=$nom;
		$type=$this->a_champs[$nom]["type"];
		
		//GESTION DES OPTIONS	////////////////////////////////////////////////////////
		if(isset($this->a_champs[$nom]["options"]))
			$options=$this->a_champs[$nom]["options"];
		
		//TYPE DE CHAMPS	///////////////////////////////////////////////////////////
		switch($type)
		{
			case "text":
				$champ_form=$this->form_InputText($nom,$id,$options);
			break;
			case "text_explode":
				$champ_form=$this->form_InputText($nom,$id,$options);
			break;
			case "textareafck":
				$path=$this->a_champs[$nom]["path"];
				$basepath=$this->a_champs[$nom]["basepath"];
				$a_options=$this->a_champs[$nom]["a_options"];
				$champ_form=$this->form_TextareaFCK ($nom,$id,$basepath,$path,$a_options);
			break;
			case "textarea_ck":
				$a_options = $this->a_champs[$nom]["a_options"];
				$champ_form = $this->form_Textarea_ck($nom,$id,$a_options);
			break;
			case "textarea":
				$champ_form=$this->form_Textarea($nom,$id,$options);
			break;
			case "fixe":
				$this->a_values[$nom]=$this->a_champs[$nom]["value"];
				$champ_form=$this->form_Input("hidden",$nom,$id,$options);
			break;
			case "select":
				$champ_form=$this->form_Select($nom,$this->a_champs[$nom]["tab_ext"],$id,$options);
			break;
			case "radio_mult":
				$a_options = $this->a_champs[$nom]["a_options"];	
				$champ_form=$this->form_Radio($nom,$this->a_champs[$nom]["tab_ext"],$id,$a_options);
			break;
			case "file_verif":
				//CREATION DU CHAMPS "FILE_VERIF"
				$champ_form=$this->form_InputFileVerif($nom,$id,$this->a_champs[$nom]["path"],$options);
			break;
			case "cb_bool":
				$a_options = $this->a_champs[$nom]["a_options"];
				$champ_form=$this->form_CheckBox_bool($nom,$id,$a_options);
			break;
			case "cb_ext":
				$champ_form="";
				$post_nom=$this->a_champs[$nom]["post_nom"];
				$a_valeurs_choix=$this->a_champs[$nom]["valeurs_choix"];
				$a_valeurs_ext=$this->a_champs[$nom]["valeurs_ext"];
				foreach($a_valeurs_choix AS $id=>$nom)
				{
					if(in_array($id,$a_valeurs_ext))
						$this->add_values($post_nom."[".$id."]",1);
				//CREATION DU CHAMPS "CB_MULTI" : multiple cb externes
					$champ_form.=$this->form_CheckBox_bool($post_nom."[".$id."]",$id,$options)." ".$nom."<br/>";
				}
			break;
			case "explode_":
				$champ_form="";
				$post_nom = $this->a_champs[$nom]["post_nom"];
				//$a_values = explode($this->a_champs[$nom]["separator"],$this->a_values[$this->a_champs[$nom]["post_values"]]);
				//$offset = $this->a_champs[$nom]["offset"];
				$id = $nom;
				//$this->add_values($post_nom,$a_values[$offset]);
				$champ_form.= $this->form_InputText($post_nom,$id,$options);
			break;
			case "select_ext":
				$champ_form="";
				$post_nom=$this->a_champs[$nom]["post_nom"];
				$a_valeurs_choix=$this->a_champs[$nom]["valeurs_choix"];
				$a_valeurs_ext=$this->a_champs[$nom]["valeurs_ext"];
				$champ_form=$this->form_Select_multi($post_nom,$a_valeurs_choix,$id,$options,$a_valeurs_ext);
			break;
			
			
			default:
				$champ_form="<strong>CHAMP ".$nom." => type=".$type."</strong> : type de champ non renseigné ou erroné 
							<br/>Il faut le renseigner avec la fonction add_champ().
							<br/>".$this->s_fc;
			break;
		}
		
		//RETOUR	///////////////////////////////////////////////////////////
		return $champ_form;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION D'UN ELEMENT DU FORMULAIRE
	
	
	*******************************************************************************************
	RECOIT		STRING 	$nom 	nom du champ		
	RETOURNE	STRING 	affichage HTML de l'élément
	******************************************************************************************/
	private function create_element($nom)
	{		
		//CHAMPS APPARENTS	/////////////////////////////////////////////////////////////////////////////////////////
		if(	$this->a_champs[$nom]["type"]!="fixe" AND $this->a_champs[$nom]["type"]!="hidden")
		{
			
			if(!isset($this->a_champs[$nom]["div_class1"]))
				$class = $this->class_div;
			else
				$class = $this->a_champs[$nom]["div_class1"];
			
			//CREATION DU LABEL	//////////////////////////////////////////////////////////
			$options = " class='".$class."-int' ";
			if(isset($this->a_champs[$nom]["label-option"]))
				$options.= $this->a_champs[$nom]["label-option"];
			//Gestion de l'intitulé -> si intitulé, on l'integre au label
			$value="";
			if(isset($this->a_champs[$nom]["intitule"]))
				$value = $this->a_champs[$nom]["intitule"];
			//string HTML
			$label = $this->form_Label($for,$value,$options);
			
			
			
			//CREATION DU CHAMP	//////////////////////////////////////////////////////////
			//Class
			$class_c = $class."-cha";
			//Gestion des erreurs -> Si erreur, on écrit le texte de l'erreur
			$erreur="";
			if(isset($this->a_erreurs[$nom]))
				$erreur = "<p class='erreur'>".$this->a_erreurs[$nom]."</p>";
			//Création du champ
			$s_champ_form = $this->create_champ($nom);
			if(isset($this->a_champs[$nom]["post_champ"]))
				$s_champ_form.=$this->a_champs[$nom]["post_champ"];
			//string HTML
			$champ="<div class='".$class_c."'>".$erreur.$s_champ_form."</div>";
			
			
			
			//CREATION DE L'ELEMENT	//////////////////////////////////////////////////////////
			//Class
			$class_e = $class."-ele";
			//Gestion des erreurs -> si erreur, on attribut le suffixe -err
			if(isset($this->a_erreurs[$nom]))
				$class_e = $class."-err";
			//string HTML
			$element="<div class='".$class_e."'>".$label.$champ."<div class='".$class."-clear'></div></div>";
			if(isset($this->a_champs[$nom]["pre_ele"]))
				$element = $this->a_champs[$nom]["pre_ele"].$element;
			if(isset($this->a_champs[$nom]["post_ele"]))
				$element = $element.$this->a_champs[$nom]["post_ele"];
				
		}
	
		//CHAMPS INVISIBLES	/////////////////////////////////////////////////////////////////////////////////////////
		else
			$element=$this->create_champ($nom);
		
		
		//RETOUR	//////////////////////////////////////////////////////////////////
		return $element;
	}
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION D'ATTRIBUTION DU TYPE DE FORMULAIRE ADD OU MOD
	
	
	*******************************************************************************************
	RECOIT	STRING $type 	type "mod" ou "add" du formulaire		
	******************************************************************************************/
	public function set_type_action($type)
	{
		$this->type_action=$type;
		if($type=="add")
			$this->a_values["id"]=0;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION D'ATTRIBUTION DU TABLEAU D'ERREUR
	
	
	*******************************************************************************************
	RECOIT	ARRAY $a_erreurs 	Tableau des erreur pour chaque champ
								$a_erreur["nom du champ"]="Message d'erreur" 		
	******************************************************************************************/
	public function set_erreurs($a_erreurs)
	{
		$this->a_erreurs = $a_erreurs;
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	FONCTION DE CREATION DU FORMULAIRE TOTAL
	
	*******************************************************************************************
	RETOURNE	STRING 		affichage HTML du formulaire :
							div-global
								form
									champ - label (X fois)
									hidden de l'action
									submit
								/form
							/div-global		
	******************************************************************************************/
	public function create_formulaire()
	{
		$message_erreur_class = "";
		if($this->erreurs == 1)
		{
			$this->set_values($this->a_erreurs_values);
			$message_erreur_class = "-erreur";
		}
		
		//TITRE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		if(isset($this->a_champs["caption"]))
			$this->s_form.="<div class='caption'>".$this->a_champs["caption"]["texte"]."</div>";
		
		//MESSAGE EVENTUEL		//////////////////////////////////////////////////////////////////////////////////////////
		if($this->message!="")
			$this->s_form.="<div class='message".$message_erreur_class."'>".$this->message."</div>";
		
			
		//OUVERTURE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		$this->s_form.="<div class='".$this->class_div."'>";
		
		
		$this->s_form.=$this->form_Head("post",$this->form_action,"form-".$this->a_values["id"],"form-".$this->a_values["id"]);
		
		
		//CREATION DES CHAMPS	//////////////////////////////////////////////////////////////////////////////////////////
		foreach($this->a_champs AS $champ=>$a_format)
		{
			switch($a_format["type"])
			{
				case "caption":
					$this->s_form.="";			
				break;
				case "legende":
					$this->s_form.="<div class='form-leg'>".$a_format["texte"]."</div>";
				break;
				case "libre":
					$this->s_form.=$a_format["html"];
				break;
				case "explode":
					$this->s_form.=$this->create_element($champ);
				break;
				default:
					$this->s_form.=$this->create_element($champ);
				break;
			}		
		}	
			
		//HIDDEN D'ACTION	//////////////////////////////////////////////////////////////////////////////////////////
		//Vérification de l'offset
		if(!isset($this->a_values[$this->type_action]))
		{
			switch($this->type_action)
			{
				case "mod":
					//On ajoute la valeur de l'id à l'offset "mod" du tableau des valeurs
					$this->a_values["mod"]=$this->mod_id;
					//Creation de l'input
					$this->s_form.=$this->form_Input("hidden","mod");
				break;
				case "add":
					//On ajoute la valeur 1 à l'offset "add" du tableau des valeurs
					$this->a_values["add"]=0;
					$this->s_form.=$this->form_Input("hidden","add");
				break;
				case "del":
					$this->s_form.="<div class='form-del-choix'>".$this->form_Radio("del",array(0=>"Non","1"=>"Oui"))."</div>";
					//On ajoute la valeur 1 à l'offset "id_del" du tableau des valeurs
					$this->a_values["id_del"]=$this->mod_id;
					$this->s_form.=$this->form_Input("hidden","id_del");
				break;
				
				default :
				break;
			}
		}
		else
			$this->s_form.="<strong>ATTENTION : Le type d'action correspond à un champ du formulaire</strong>
							<br/>Les champs 'add' ou 'mod' ne peuvent pas être utilisés dans une bdd.
							<br/>".$this->s_fc;
					
		
		//BOUTON SUBMIT	//////////////////////////////////////////////////////////////////////////////////////////
		$options="class='val-submit'";
		$this->s_form.="<div class='form-submit'>";
		switch($this->type_action)
		{
			case "mod":
				$this->a_values["submit-bt"]=$this->mod_txt_submit;
				$this->s_form.=$this->form_Input("submit","submit-bt","submit-bt-".$this->a_values["id"],$options);
			break;
			case "add":
				$this->a_values["submit-bt"]=$this->add_txt_submit;
				$this->s_form.=$this->form_Input("submit","submit-bt","submit-bt-".$this->a_values["id"],$options);
			break;
			case "del":
				$this->a_values["submit-bt"]=$this->del_txt_submit;
				$this->s_form.=$this->form_Input("submit","submit-bt","submit-bt-".$this->a_values["id"],$options);
			break;
			
			default :
				$this->s_form.="<strong>ATTENTION : Le type d'action n'est pas spécifiée</strong>
								<br>Il faut le spécifier avec la function <b>set_type_action()</b>
								<br>".$this->s_fc;
			break;
		}
		$this->s_form.="</div>";
		
		
		
		
		
		
		//FERMETURE DU FORMULAIRE	//////////////////////////////////////////////////////////////////////////////////////////
		$this->s_form.=$this->form_Close();
		$this->s_form.="</div>";
		$this->s_form.= "<div id='post-form'>".$this->post_form."</div>";
		
		return $this->s_form;
	}
}
?>
