<?php
class Formulaire {
/**
*************************************************************************
Cette class permet de generer des formulaire HTML 
*************************************************************************
Index des methodes
*************************************************************************
@see	set_values() 
		-> Donne des valeurs aux champs du formulaire.
@see	get_values() 
		-> Attribue une valeur au champ selon son nom.
@see	form_Head() 
		-> Genere l'ouverture du formulaire.
@see	form_OpenField() 
		-> Genere une ouveture de fieldset.
@see	form_CloseField() 
		-> genere une fermeture de fieldset
@see	form_InterField() 
		-> Genere une fermeture ET une ouverture de fieldset.
@see	form_Label() 
		-> Genere un label.
@see	form_Input() 
		-> Genere un input generic (tous type optionel).
@see	form_InputText() 
		-> Racourci pour generer des input de type texte (evite de passer le parametre 'type').
@see	form_Textarea() 
		-> Genrere des textarea.
@see	form_Select() 
		-> Genere un select.
@see	form_CheckBox() 
		-> Racourci pour generer ds chechbox.
@see	form_Submit() 
		-> Racourci pour generer un bouton de validation (submi).
@see	form_Close() 
		-> Ferme le formulaire. 
************************************************************************* **/
   
	protected $a_values=array();   
   
    public function __construct()
    {
	}
	
	
/**
*************************************************************************
@brief	 	Attribue des valeurs aux champs du formulaire
*****************************************************************************
@param		array		$a_values	valeur pour chaque champ [nom_champ]=>valeur_champ 

************************************************************************* **/
	public function set_values($a_values)
	{
		$this->a_values=$a_values;
	}
	
	
/**
*************************************************************************
@brief	 	Attribue des valeurs aux champs du formulaire
*****************************************************************************
@param		array		$a_values	valeur pour chaque champ [nom_champ]=>valeur_champ 

************************************************************************* **/
	public function add_values($offset,$value)
	{
		if(is_array($offset))
			$this->a_values[$offset[0]][$offset[1]]=$value;
		else
			$this->a_values[$offset]=$value;
	}

	
/**
*************************************************************************
@brief	 	Recupère la valeur d'un champ
*****************************************************************************
@param		string		$name		Specifie le nom du champ 

*****************************************************************************
@return		string		
************************************************************************* **/
	private function get_value($name)
	{
		if(isset($this->a_values[$name]))
			return stripslashes($this->a_values[$name]);
		else
			return "";
	}
	
/**
*************************************************************************
@brief	 	Genere l'ouverture du formulaire
*****************************************************************************
@param		string		$method		Specifie la methode du formulaire 
@param		string		$action		specifie l'action du formulaire
@param		string		$name		Specifie le nom du formulaire
@param		string		$id			Specifie l'id du formulaire
@param		int			$enctypeVal	Specifie l'enctype du formulaire
@param		string		$class		Specifie la class du formulaire
@param		string		$options	Specifie des options libres

*****************************************************************************
@return		string		
************************************************************************* **/
	public function form_Head($method='post', $action='', $name='', $id='', $enctypeVal=0, $class='', $options= NULL)
	{
		$enctype= array('multipart/form-data' ,  'application/x-www-form-urlencoded' , 'text/plain');
	
		if ( !in_array($enctypeVal , $enctype ) )
			$enctypeVal = 0; 
		if ( !empty($id) )
			 $idRender = 'id ="'.$id.'"';	
		if (!empty($name) ) 
			$name = 'name ="'.$name.'"';
		if (!empty($class) ) 
			$class = 'class ="'.$class.'"';
					
		return '<form action="'.$action.'" '.$name.' '.$idRender.' enctype="'.$enctype[$enctypeVal].'" method="'.$method.'" '.$class.' '.$options.'>';	
	}
	
/**
*************************************************************************
@brief 		Genere une ouveture de fieldset
*****************************************************************************
@param		string		$id			Specifie l'id du fielset
@param		string		$value		Specifie le texte a fficher dans <legend>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_OpenField($id='', $value, $options = NULL)
	{
		if ( !empty($id) )
			 $idRender = 'id ="'.$id.'"';	
		$return = '<fieldset '.$idRender.' '.$options.'>'."\n";
		$return .= "\t".'<legend>'.$value.'</legend>'."\n";
		return $return;
	}

/**
*************************************************************************
@brief 		genere une fermeture de fieldset
*****************************************************************************
@return string
************************************************************************* **/
	public function form_CloseField()
	{
		return '</fieldset>';
	}

/**
*************************************************************************
@brief 		Genere une fermeture ET une ouverture de fieldset
*****************************************************************************
@param		string		$id			Specifie l'id du fielset
@param		string		$value		Specifie le texte a afficher dans <legend>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_InterField($id='', $value, $options = NULL){
		return $this->form_CloseField().$this->form_OpenField($id, $value , $options);
	}

	
/**
*************************************************************************
@brief 		Genere un label
*****************************************************************************
@param		string		$id			Specifie l'id du fielset
@param		string		$value		Specifie le texte a fficher dans <legend>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return
************************************************************************* **/
	public function form_Label($id, $value, $options = NULL)
	{
		return '<label for="'.$id.'" '.$options.'>'.$value.'</label>';
	}

/**
*************************************************************************
@brief 		Genere un input generic (tous type optionel)
*****************************************************************************
@param		string		$type		Specifie le type de champs
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id du fielset
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Input($type , $name , $id ='',  $options = NULL)
	{
		$value=$this->get_value($name);
			
		if ( !empty($id) )
			 $idRender = 'id ="'.$id.'"';	
		
		if ( empty ( $name ) ) 
			return 'Le Type TEXTE necessite un parametre : name';
		elseif ( empty ( $type ) ) 
			return 'Le Type GENERIC necessite un parametre : type';
		else	
			return '<input type="'.$type.'" name="'.$name.'" '.$idRender.' value="'.$value.'" '.$options.' />';
	}

/**
*************************************************************************
@brief 		Racourci pour generer des input de type texte (evite de passer le parametre 'type')
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id du fielset
@param		string		$value		Specifie le value a afficher dans <input>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_InputText($name, $id,  $options = NULL )
	{
		return $this->form_input('text' , $name , $id,  $options);
	}

/**
*************************************************************************
@brief 		Genere un file avec verification
*****************************************************************************
@param		string		$type		Specifie le type de champs
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id du fielset
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_InputFileVerif($name,$id ='',$path,$options = NULL)
	{
		//VARIABLES
		$check_del="";
		
		//CREATION DES BIDULES
		if (!empty($id) )
			 $idRender = 'id ="'.$id.'"';
		if ( empty ( $name ) ) 
			return 'Le Type FILE necessite un parametre : name';
		
		
		$value=$this->get_value($name);
		if(is_file($path.$value))
		{
			//AFFICHAGE DE LA CHECKBOX : LE NOM DU CHAMP SUIVI DE "-del"
			$check_del="<br/>".$this->form_CheckBox_bool($name."-del",$id."-del",$options)." Supprimer";
			//AFFICHAGE DU FICHIER
			if(@getimagesize($path.$value))
				$fichier="<br/><img src='".$path.$value."'/>";
			else
				$fichier="<br/>Fichier existant : <a href='/".$path.$value."'>".$value."</a>";
		}
		$check_file='<input type="file" name="'.$name.'" '.$idRender.' '.$options.' />';
		return $check_file.$fichier.$check_del;
	}


/**
*************************************************************************
@brief 		Genere des textarea
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id de champs
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Textarea ($name , $id="", $options = NULL)
	{
		$value=$this->get_value($name);
		
		if ( !empty($id) )
			 $idRender = ' id ="'.$id.'" ';	
		if ( empty ( $name ) ) 
			return 'Le Type TEXTAREA necessite un parametre : name';
		else	
			return '<textarea name="'.$name.'" '.$idRender.$options.'>'.$value.'</textarea>';
	}
	
/**
*************************************************************************
@brief 		Genere des textarea_CK
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id de champs
@param		string		$path		Specifie le chemin vers fckeditor
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Textarea_ck($name, $id, $a_options = array())
	{
		$value=$this->get_value($name);
		
		
		if ( !empty($id) )
			 $idRender = ' id ="'.$id.'" ';	
		
		$a_config = array();
		//File par défaut de configuration
		$a_config["config_file"] = "customConfig : 'config_custom.js'";
		
		//toolbar
		if(isset($a_options["toolbar"]))
			$a_config["toolbar"] = "toolbar : '".$a_options["toolbar"]."'";
		//Config
		if(isset($a_options["config_file"]))
			$a_config["config_file"] = "customConfig : '".$a_options["config_file"]."'";
		//width
		if(isset($a_options["width"]))
			$a_config["width"] = "width : '".$a_options["width"]."'";
		//height
		if(isset($a_options["height"]))
			$a_config["height"] = "height : '".$a_options["height"]."'";

		$s_config = implode(",",$a_config);
		
		$textarea = '<textarea name="'.$name.'">'.$value.'</textarea>';
		$js = "<script type=\"text/javascript\">CKEDITOR.replace( '".$name."',{".$s_config."} );</script>";
		
		return $textarea.$js;
	}
	
/**
*************************************************************************
@brief 		Genere des textareaFCK
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id de champs
@param		string		$path		Specifie le chemin vers fckeditor
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_TextareaFCK ($name, $id, $basepath, $path, $a_options = array())
	{
		$value=$this->get_value($name);
		
		
		if ( !empty($id) )
			 $idRender = ' id ="'.$id.'" ';	
		
		require_once($basepath."fckeditor.php");
		$oFCKeditor = new FCKeditor($name);
		$oFCKeditor->BasePath = $basepath;
		$oFCKeditor->Path = $path;
		$oFCKeditor->Value = $value;
		
		//echo $basepath;
		if(isset($a_options["toolbar"]))
			$oFCKeditor->ToolbarSet = $a_options["toolbar"];
		
		if(isset($a_options["width"])) 
			$oFCKeditor->Width  = $a_options["width"]; 
		
		if(isset($a_options["height"]))
			$oFCKeditor->Height = $a_options["height"];

		return $oFCKeditor->CreateHtml();
	}
	
/**
*************************************************************************
@brief 		Genere un groupe radio 
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		array		$content	Specifie le contenu a afficher dans <option>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Radio($name , $content =array(), $id='', $a_options = NULL)
	{
		$value=$this->get_value($name);
		
		if (empty ( $id ) ) 
			$id=$name;	
			
		if ( empty ( $name ) ) 
			return 'Le Type SELECT necessite un parametre : name';
		else
		{
			if ( count($content) < 1 )
				return 'Le Type SELECT necessite une liste de valeurs'; 	
			
			$return ='';
			
			if(isset($a_options["disable"]) && $a_options["disable"]==1)
				$disable = 'disabled="disabled"';
			else
				$disable = "";
			
			if(isset($a_options["options"]))
				$options = $a_options["options"];
			else
				$options = "";
			
			if(isset($a_options["div-class"]))
				$dc = $a_options["div-class"];
			else
				$dc = "radio-div";
				
			foreach ($content as $key => $entry )
			{
				if ( $value == $key )
					$checked = 'checked="checked"';
					
				$return.='<div class="'.$dc.'"><input '.$disable.' type="radio" name="'.$name.'" value="'.$key.'" '.$checked.' '.$options.' id="'.$id.$key.'" class="form-radio" /> '.$entry.'</div>';
				$checked='';
			}
		return $return;
		}
	}
	
	
/**
*************************************************************************
@brief 		Genere un select 
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		array		$content	Specifie le contenu a afficher dans <option>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Select($name, $content =array(), $id='', $a_options = array())
	{
		$value=$this->get_value($name);
		
		if (empty ( $id ) ) 
			$id=$name;
			
		if ( empty ( $name ) ) 
			return 'Le Type SELECT necessite un parametre : name';
		else
		{
			if(isset($a_options["disable"]) && $a_options["disable"]==1)
				$disable = 'disabled="disabled"';
			else
				$disable = "";
				
			if ( count($content) < 1 )
				return 'Le Type SELECT necessite une liste de valeurs'; 	
			
			$return ='<select name="'.$name.'" id="'.$id.'" '.$a_options["options"].' '.$disable.'>';
			foreach ($content as $key => $entry )
			{
				if ( $value == $key )
					$select = 'selected="selected"';
					
				$return .='<option value="'.$key.'" '.$select.'>'.$entry.'</option>';
				$select ='';
			}
			
			$return .= '</select>';
		return $return;
		}
	}
	
	
/**
*************************************************************************
@brief 		Genere un select 
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		array		$content	Specifie le contenu a afficher dans <option>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Select_multi($name, $content =array(), $id='', $options = NULL,$a_valeurs=array(),$lignes=8)
	{
		if (empty ( $id ) ) 
			$id=$name;
			
		if ( empty ( $name ) ) 
			return 'Le Type SELECT necessite un parametre : name';
		else
		{
			if ( count($content) < 1 )
				return 'Le Type SELECT necessite une liste de valeurs'; 	
			
			$return ='<select multiple="multiple" size="'.$lignes.'" name="'.$name.'[]" id="'.$id.'" '.$options.'>';
			foreach ($content as $key => $entry )
			{
				if (in_array($key,$a_valeurs))
					$select = 'selected="selected"';
				else
					$select = '';
					
				$return.='<option value="'.$key.'" '.$select.'>'.$entry.'</option>';
			}
			
			$return.= '</select>';
		return $return;
		}
	}
	
/**
*************************************************************************
@brief 		Racourci pour generer des chechbox boolennes (0/1)
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return
************************************************************************* **/
	public function form_CheckBox_bool($name,$id ='',$a_options = array())
	{
		$value=$this->get_value($name);
		if($value==1)
			$checked='checked="checked"';
		else
			$checked='';
		
		if ( !empty($id) )
			 $idRender = 'id ="'.$id.'"';	
		
		if ( empty ( $name ) ) 
			return 'Le Type CHECKBOX necessite un parametre : name';
		else	
		{
			if(isset($a_options["disable"]) && $a_options["disable"]==1)
				$disable = 'disabled="disabled"';
			else
				$disable = "";
				
			return '<input type="checkbox" '.$disable.' name="'.$name.'" '.$idRender.' '.$checked.' '.$a_options["options"].' value="1" class="form-checkbox" />';
		}
	}

/**
*************************************************************************
@brief 		Racourci pour generer un bouton de  validation (submi)
*****************************************************************************
@param		string		$name		Specifie le nom de champs
@param		string		$id			Specifie l'id du fielset
@param		string		$value		Specifie le value a afficher dans <input>
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return
************************************************************************* **/
	public function form_Submit($name , $value = 'Envoyer', $id='',  $options = NULL)
	{
		return $this->form_Input('submit' , $name , $value ,$id,  $options);
	}
	
/**
*************************************************************************
@brief 		Ferme le formulaire
*****************************************************************************
@return		string
************************************************************************* **/
	public function form_Close()
	{
		return '</form>';
	}
	
/**
*************************************************************************
@brief 		Racourci pour generer un bouton (0/1)
*****************************************************************************
@param		string		$id			Specifie l'id du champ référent
@param		options		$options	Permet de passer du texte suplementaire (ex: class="test")
*****************************************************************************
@return
************************************************************************* **/
	public function form_button_ajax($id ='',$options = NULL)
	{
		
		if (empty($id) )
			return 'Le Type BUTTON necessite un ID';
		else	
			return '<input type="button" id="bajax_'.$id.'" '.$options.' class="form-button-ajax" />';
	}
}
?>
