<?php
require_once("class.table.php");
require_once("class.formatage.php");
require_once("class.formulaire.php");
require_once("class.menu-navigation.php");
require_once(URL_CLASSES."000-controleur/controleur-liste.php");
require_once(URL_CLASSES."000-modele/class.mysql.select.php");

class liste_default
{	
	/******************************************************************************************
	ATTRIBUTS
	
	******************************************************************************************/
	
	//ATTRIBUTS POUR LA SELECTION DES ENREGISTREMENTS	///////////////////////////////////
	//-> cf class.mysql.select.php pour la définition des attributs
	//-> implémentés par la class fille
	protected $table="";
	protected $where="";
	protected $offset="";
	protected $seek = 0;
	protected $limite = 0;
	protected $order=array();
	protected $message="";
	
	//ATTRIBUTS POUR LE CONTENU DE LA TABLE	////////////////////////////////////////////////
	//-> implémentés par la class fille
	protected $a_tds=array();
	protected $a_trs_pre=array();
	protected $a_trs_post=array();
	protected $post_liste = "";
	
	
	//ATTRIBUTS DES VALEURS		////////////////////////////////////////////////////////////
	private $a_select=array();
	
	//ATTRIBUTS POUR LA CONSTRUCTION DE LA TABLE		////////////////////////////////////
	private $a_th=array();
	private $a_td=array();
	private $a_tr_td=array();
	private $a_tr_pre=array();
	private $a_tr_post=array();
	private $s_tr_message="";
	private $s_caption="";
	private $fichier_source = "";
	
	//ATTRIBUTS DE FORMATAGE DE LA TABLE		////////////////////////////////////////////
	//-> implémentés par la class fille
	protected $table_att;
	protected $caption_att = array();
	protected $tr_att;
	protected $th_att;
	protected $td_att;
	protected $colgroup;	
	
	protected $html = "";
	
	protected $nb_resultats = 0;
	
	
	public function __construct($a_param=array())
	{
		//ATTRIBUTIONS
		if(isset($a_param["seek"]))
			$this->seek = $a_param['seek'];
		if(isset($a_param['limite']))
			$this->limite = $a_param['limite'];
		if(isset($a_param['menu_off']))
			$this->caption_att["menu_off"] = $a_param['menu_off'];
		else
			$this->caption_att["menu_off"] = 0;
		
		$this->table = $a_param['table'];
		$this->where = $a_param['where'];
				
		$this->message = $a_param['message'];
		$this->fichier_source = $a_param['fichier_source'];		
	}
	
	
	
	
	
	
	
	/******************************************************************************************
	METHODE D'ATTRIBUTION DE VALEURS
	
	*******************************************************************************************
	
	RECOIT		INT		$nb_total = nb total des enregistrements
				INT		$nb_par_page = nb d'enregistrements par page
				INT		$seek_encours = numéro du premier enregistrement de la page
							
	RENSEIGNE	$this->s_caption
	******************************************************************************************/
	protected function set_values($a_values)
	{	
		$this->a_select=$a_values;	
	}
	
	
	
	
	
	/******************************************************************************************
	METHODE DE SELECTION DES VALEURS
	
	*******************************************************************************************
	
	RECOIT		INT		$nb_total = nb total des enregistrements
				INT		$nb_par_page = nb d'enregistrements par page
				INT		$seek_encours = numéro du premier enregistrement de la page
							
	RENSEIGNE	$this->s_caption
	******************************************************************************************/
	protected function select_values()
	{	
		//SELECTION DES ENREGISTREMENTS	////////////////////////////////////////////////////////////////
		$o_select=new mysql_select();
		$o_select->table = $this->table;
		$o_select->where = $this->where;
		$o_select->offset = $this->id;
		$o_select->seek = $this->seek;
		$o_select->limite = $this->limite;
		
		if(count($_SESSION["liste_order"])>0)
			$this->order = $_SESSION["liste_order"];

		$o_select->order = $this->order;
		
		$o_select->fichier_source = $this->fichier_source;
		
		$this->a_select = $o_select->select();
		
		//echo $o_select->get_query()."<br/>";
		$this->nb_resultats = $o_select->get_nb_total();
		//CREATION DU MENU DE NAVIGATION	/////////////////////////////////////////////////////////////
		$this->create_caption($o_select->get_nb_total(),$o_select->limite,$o_select->seek);
	}
	
	
	
	
	
	/******************************************************************************************
	METHODE DE CREATION DU CONTENU DE LA CELLULE CAPTION
	
	*******************************************************************************************
	
	RECOIT		INT		$nb_total = nb total des enregistrements
				INT		$nb_par_page = nb d'enregistrements par page
				INT		$seek_encours = numéro du premier enregistrement de la page
							
	RENSEIGNE	$this->s_caption
	******************************************************************************************/
	protected function create_caption($nb_total,$nb_par_page,$seek_encours)
	{	
		$this->s_caption = "";
		$s_pre = "";
		$s_post = "";
		
		//SI NB>0 -> MENU NAVIGATION DANS LA CAPTION
		if($nb_total>0 AND $this->caption_att["menu_off"]==0 AND $nb_par_page>0)
		{
			$o_menu=new menu_navigation($nb_total,$nb_par_page,$seek_encours);
			$this->s_caption=$o_menu->get_menu_format();	
			$this->s_caption.=$o_menu->get_desc_format();	
		}
		
		//GESTION PRE
		if(isset($this->caption_att["pre"]))
			$s_pre=$this->caption_att["pre"];
			
		//GESTION POST
		if(isset($this->caption_att["post"]))
			$s_post=$this->caption_att["post"];
			
		$this->s_caption = $s_pre.$this->s_caption.$s_post;
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TH
	
	*******************************************************************************************
	
	RECOIT		STRING	$value = contenu HTML de l'entête
	RENSEIGNE	ARRAY	$this->a_th = tableau des entetes						
	******************************************************************************************/
	protected function th($value)
	{
		$a_th=table::th_create($this->th_att);
		$this->a_th[]=$a_th["open"].$value.$a_th["close"];
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TH ORDONNANTE
	
	*******************************************************************************************
	
	RECOIT		STRING	$champ		champ sur lequel sera effectué le tri
				ARRAY	$a_order	tableau de l'ordre actuel
				STRING	$value		intitulé du bouton
				
	RENSEIGNE	ARRAY	$this->a_th = tableau des entetes						
	******************************************************************************************/
	protected function th_order($champ,$a_order,$value)
	{
		//GESTION DESC OU NON
		$desc=0;
		$desc_aff=2;
		if($a_order[0][0]==$champ)
		{
			$desc=1-$a_order[0][1];
			$desc_aff=$desc;
		}
		
		//CREATION DU BOUTON DE TRI 
		$o_form=new formulaire();
		$o_form->set_values(array("order"=>"order","order-champ"=>$champ,"order-desc"=>$desc,$value=>$value));
		$form=$o_form->form_Head();
		$form.=$o_form->form_Input("hidden","order");
		$form.=$o_form->form_Input("hidden","order-champ");
		$form.=$o_form->form_Input("hidden","order-desc");
		$form.=$o_form->form_Input("submit",$value,""," class=\"order-input-".$desc_aff."\" ");
		$form.=$o_form->form_Close();
		
		//AJOUT DE LA TH
		$this->th($form,$this->th_att);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TD
	
	*******************************************************************************************
	
	RECOIT		STRING	$value = contenu HTML de la TD
	RENSEIGNE	ARRAY	$this->a_td = tableau des TD de la ligne						
	******************************************************************************************/
	protected function td($value)
	{
		$a_td=table::td_create($this->td_att);
		$this->a_td[]=$a_td["open"].$value.$a_td["close"];
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE BOUTON D'ACTION
	
	*******************************************************************************************
	
	RECOIT		DIVERS	$id		identifiant de l'enregistrement concerne par l'action
				STRING	$type	type d'action
				
	RETOURNE	STRING	formulaire HTML de l'action						
	******************************************************************************************/
	protected function post_action($id,$type,$a_hidden=array())
	{
		$o_form=new formulaire();
		$o_form->set_values(array("formulaire-".$type=>$id));
		$form=$o_form->form_Head();
		$form.=$o_form->form_Input("hidden","formulaire-".$type);
		$form.=$o_form->form_Input("submit",$type."-".$id,$type."-".$id,"class='".$type."-submit'");
		if(count($a_hidden)>0)
		{
			foreach($a_hidden AS $nom=>$value)
			{
				$o_form->set_values(array($nom=>$value));
				$form.=$o_form->form_Input("hidden",$nom);
			}	
		}
		$form.=$o_form->form_Close();
		return $form;
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TD AVEC BOUTON DE MODIFICATION
	
	*******************************************************************************************
	
	RECOIT		DIVERS	$id = identifiant de l'enregistrement concerné par la mod
	RENSEIGNE	ARRAY	$this->a_td = tableau des TD de la ligne						
	******************************************************************************************/
	protected function td_mod($id)
	{
		$form=$this->post_action($id,"mod");
		$this->td($form);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TD AVEC BOUTON EXTERNE
	
	*******************************************************************************************
	
	RECOIT		DIVERS	$id = identifiant
				STRING	$ext = url externe
	RENSEIGNE	ARRAY	$this->a_td = tableau des TD de la ligne						
	******************************************************************************************/
	protected function td_ext($id,$name,$ext,$more="",$a_autres=array())
	{
		$form = "";
		$o_form=new formulaire();
		$o_form->set_values(array($name=>$id));
		$form.=$o_form->form_Head("post",$ext,"","",0,"",$more);
		if(count($a_autres)>0)
		{
			$a_autres[$name] = $id;
			$o_form->set_values($a_autres);
			foreach($a_autres as $ca=>$va)
				$form.=$o_form->form_Input("hidden",$ca);
		}
		else
		{
			$o_form->set_values(array($name=>$id));
			$form.=$o_form->form_Input("hidden",$name);
		}
		$form.=$o_form->form_Input("submit",$name."-".$id,$name."-".$id,"class='".$name."-submit' ".$more);
		$form.=$o_form->form_Close();
		$this->td($form);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TD AVEC BOUTON DE SUPPRESSION
	
	*******************************************************************************************
	
	RECOIT		DIVERS	$id = identifiant de l'enregistrement concerné par la suppression
	RENSEIGNE	ARRAY	$this->a_td = tableau des TD de la ligne						
	******************************************************************************************/
	protected function td_del($id)
	{
		$form=$this->post_action($id,"del");
		$this->td($form);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TR
	
	*******************************************************************************************
	
	RECOIT		STRING	$value = contenu HTML de la TR
	RETOURNE	STRING	HTML de la TR						
	******************************************************************************************/
	protected function tr($value)
	{
		$a_tr=table::tr_create($this->tr_att);
		return $a_tr["open"].$value.$a_tr["close"];
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TR A PARTIR D'UN ARRAY DE TD
	
	*******************************************************************************************
	UTILISE		ARRAY 	$this->a_td = tableau des TD de la ligne
	RENSEIGNE	ARRAY	$this->a_tr_td = tableau des TR de la table créées depuis les arrays						
	******************************************************************************************/
	protected function tr_td()
	{
		$s_td=implode("",$this->a_td);
		$this->a_td=array();
		
		$this->a_tr_td[]=$this->tr($s_td);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION D'UNE TR A PARTIR D'UN ARRAY DE TH
	
	*******************************************************************************************
	UTILISE		ARRAY 	$this->a_th = tableau des TH
	RETOURNE	STRING	HTML de la ligne des entetes						
	******************************************************************************************/
	protected function tr_th()
	{
		$this->tr_att["class"]="tr-th";
		$s_th=implode("",$this->a_th);
		$this->a_th=array();
		
		return $this->tr($s_th);
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION DE LA TABLE
	
	*******************************************************************************************

	RETOURNE	STRING	HTML de la table					
	******************************************************************************************/
	protected function table()
	{
		//CREATION DE LA TABLE	//////////////////////////////////////////////////////////////
		$a_table=table::table_create($this->table_att);
		$a_caption=table::caption_create($this->caption_att);
		
		$s_table=$a_caption["open"].$this->s_caption.$a_caption["close"];
		
		$s_table.="<tbody class='content'>";
		$s_table.=$this->s_tr_message;
		$s_table.=$this->tr_th();
		$s_table.=implode($this->a_tr_pre);
		$s_table.=implode("",$this->a_tr_td);
		$s_table.=implode($this->a_tr_post);
		$s_table.="</tbody>";
		
		$s_table=$a_table["open"].table::colgroup_create($this->colgroup).$s_table.$a_table["close"];
		
		return $s_table;
	}
	
	
	
	/******************************************************************************************
	METHODE DE CREATION DE LA LISTE
	
	*******************************************************************************************
	
	RETOURNE	STRING	HTML de la table						
	******************************************************************************************/
	protected function create_liste()
	{		
		$this->a_tr_td = array();
		//On selectionne les valeurs
		$this->select_values();
		//CREATION DES LIGNES DES ENREGISTREMENTS DE LA LISTE	/////////////////////////////////////////
		$i=0;
		foreach($this->a_select AS $select)
		{
			//FORMAT DE LA LIGNE	///////////////////////////////////
			if($i%2==0)
				$this->tr_att["class"]="tr-0";
			else
				$this->tr_att["class"]="tr-1";
			$i++;
			
			
			//CREATION DES TD	///////////////////////////////////////
			foreach($this->a_tds AS $a_attributs)
			{
				if(isset($a_attributs["champs"]))
				{
					//VALEURS
					$s_valeur="";
					foreach($a_attributs["champs"] AS $a_champ)
					{
						$v_tmp = "";
						//Récupération de la valeur
						if(isset($select[$a_champ["nom"]]))
						{
							$valeur = $select[$a_champ["nom"]];
							//Enregistrement externe
							if(isset($a_champ["tab_ext"]))
								$v_tmp.=$a_champ["tab_ext"][$valeur];
							else
								$v_tmp.=$valeur;
								
							if(isset($a_champ["formatage"]))
							{
								$v_tmp = formatage::formatage_texte($v_tmp,$a_champ["formatage"]);
							}
							
							if(isset($a_champ["separator"]))
								$v_tmp.=$a_champ["separator"];
								
						}
						$s_valeur.=$v_tmp;
					}
							
					//Formatage de la valeur
					if(isset($a_attributs["formatage"]))
					{
						foreach($a_attributs["formatage"] AS $type_format=>$attributs)
						{
							//FORMATAGE TYPE VISUEL	/////////////////////////////////////////////////////////
							if($type_format=="visuel")
							{
								$s_valeur=formatage::formatage_visuel($s_valeur,$attributs);
							}
							//FORMATAGE TYPE TEXTE	/////////////////////////////////////////////////////////
							if($type_format=="texte")
								$s_valeur=formatage::formatage_texte($s_valeur,$attributs);
							//FORMATAGE TYPE LIMITE	/////////////////////////////////////////////////////////
							if($type_format=="limite")
								$s_valeur=formatage::formatage_texte($s_valeur,array("limite"),$attributs);
							//FORMATAGE TYPE EXPLODE	/////////////////////////////////////////////////////////
							if($type_format=="explode")
								$s_valeur = formatage::formatage_texte($s_valeur,array("explode"),$attributs);
							//FORMATAGE TYPE URL	/////////////////////////////////////////////////////////
							if($type_format=="url")
							{
								if(!empty($s_valeur))
									$s_valeur=formatage::formatage_texte($s_valeur,array("url"),$attributs);
							}
							//FORMATAGE TYPE URL	/////////////////////////////////////////////////////////
							if($type_format=="date")
							{
								if(!empty($s_valeur))
									$s_valeur=formatage::formatage_date($s_valeur,$attributs);
							}
							//FORMATAGE TYPE URL	/////////////////////////////////////////////////////////
							if($type_format=="multiplier_champs")
							{
								$s_valeur = 0;
								foreach($attributs["champs"] as $champ)
									$s_valeur+= $select[$champ[0]] * $select[$champ[1]];
							}
							//FORMATAGE TYPE URL	/////////////////////////////////////////////////////////
							if($type_format=="multiplier_champs_ext")
							{
								$s_valeur = 0;
								$s_valeur = $select[$attributs["champ-int"]] * $attributs["table_ext"][$select[$attributs["champ_id"]]];
							}
							//FORMATAGE TYPE URL	/////////////////////////////////////////////////////////
							if($type_format=="addition-multiplication")
							{
								$s_valeur = 0;
								foreach($attributs as $array)
									$s_valeur+= $select[$array[0]] * $select[$array[1]];
							}
							//FORMATAGE TYPE COMPARAISON	/////////////////////////////////////////////////
							if($type_format=="comparaison")
							{
								//On recupere la valeur de comparaison selon la table et le champ id
								$val_comp=$attributs["table_ext"][$select[$attributs["champ_id"]]];
								$new_val=$val_comp-$valeur;
								//Couleurs	
								if($new_val<0)
									$color=$attributs["coul-"];
								else
									$color=$attributs["coul+"];
								//Euros
								if(in_array("euros",$attributs))
									$new_val=formatage::formatage_texte($new_val,array("euros"));
								
								$a_couleur["couleur"]=$color;
								
								$s_valeur=formatage::formatage_texte($new_val,array("couleur"),$a_couleur);
								
								//$s_valeur=$new_val;
							}
							//FORMATAGE TYPE COMPARAISON	/////////////////////////////////////////////////
							if($type_format=="add_contenu")
							{
								if(!empty($s_valeur) && isset($attributs["pre"]))
									$s_valeur = $attributs["pre"].$s_valeur;
								if(!empty($s_valeur) && isset($attributs["post"]))
									$s_valeur = $s_valeur.$attributs["post"];
							}
						}
					}	
				}
					
				
				//Gestion de la classe de la td
				if(isset($a_attributs["class_td"]))
				{
					$old_c=0;
					//il y a-t-il une classe ?
					if(isset($this->td_att["class"]))
						$old_c=$this->td_att["class"];
					//On applique la nouvelle
					$this->td_att["class"]=$a_attributs["class_td"];
				}	
				
				//Création de la cellule
				switch($a_attributs["type_td"])
				{
					case "basic" : 
						$this->td($s_valeur);
					break;
					
					case "mod" : 
						$this->td_mod($select[$a_attributs["champ_mod"]]);
					break;
					
					case "del" : 
						$this->td_del($select[$a_attributs["champ_del"]]);
					break;
					
					case "ext" : 
						if(!isset($a_attributs["sauf"]))
							$this->td_ext($select[$a_attributs["champ"]],$a_attributs["name"],$a_attributs["url"],$a_attributs["form-more"],$a_attributs["autres-champs"]);
						else
						{
							if(!in_array($select[$a_attributs["sauf"][0]],$a_attributs["sauf"][1]))
								$this->td_ext($select[$a_attributs["champ"]],$a_attributs["name"],$a_attributs["url"],$a_attributs["form-more"],$a_attributs["autres-champs"]);
							else
								$this->td("");	
						}
					break;
				
					default :
						$this->td($s_valeur);
					break;				
				}
					
				//Gestion de la classe
				if(isset($a_attributs["class_td"]))
				{
					if($old_c!=0)
						$this->td_att["class"]=$old_c;
					else
						unset($this->td_att["class"]);
				}
			}
			
			//CREATION DE LA LIGNE	//////////////////////////////
			$this->tr_td();			
		}
		
		
		//CREATION DE LA LIGNE DES ENTETES	///////////////////////////////////////////////////////////
		foreach($this->a_tds as $num=>$a_attributs)
		{
			//Création des TH selon leur type
			if(isset($a_attributs["th"]))
			{
				switch($a_attributs["th"]["type_th"])
				{
					//Type "basic" -> On insert l'intitulé
					case "basic" :
						$this->th($a_attributs["th"]["intitule"]);
					break;
					//Type "order" -> On insert un bouton de tri
					case "order" :
						$this->th_order($a_attributs["th"]["champ_ordre"],$this->order,$a_attributs["th"]["intitule"]);
					break;
					
					default :
						$this->th("Erreur de type de TH");
					break;
				}
			}
			else
			//Création des TH non renseignées
				$this->th("");
		}
		
		
		//CREATION DES LIGNES AVANT CONTENU	///////////////////////////////////////////////////////////
		$this->tr_att["class"]="tr-pre";
		foreach($this->a_trs_pre AS $a_attributs)
		{
			//Création des TR selon leur type
			if(isset($a_attributs["type"]))
			{
				switch($a_attributs["type"])
				{
					//Type "basic" -> On insert le contenu
					case "basic" :
						$html_cont=$a_attributs["contenu"];
					break;
					//Type "add" -> On insert un bouton d'ajout
					case "add" :
						$button=$this->post_action(1,"add");
						$html_cont=$button.$a_attributs["contenu"];
					break;
				}
			}
			else
			//Création des TH non renseignées
				$html_cont="Pas de type attribué";
				
			$this->a_tr_pre[]=$this->tr("<td colspan='".count($this->a_tds)."'>".$html_cont."</td>");
		}
		
		
		
		//CREATION DES LIGNES APRES CONTENU	///////////////////////////////////////////////////////////
		$this->tr_att["class"]="tr-post";
		$this->a_tr_post = array();
		foreach($this->a_trs_post AS $a_attributs)
		{
			//Création des TR selon leur type
			if(isset($a_attributs["type"]))
			{
				switch($a_attributs["type"])
				{
					//Type "basic" -> On insert le contenu
					case "basic" :
						$html_cont=$a_attributs["contenu"];
					break;
					//Type "add" -> On insert un bouton d'ajout
					case "add" :
						$button=$this->post_action(1,"add",$a_attributs["hidden"]);
						$html_cont=$button.$a_attributs["contenu"];
					break;
				}
			}
			else
			//Création des TH non renseignées
				$html_cont="PAS DE TYPE ATTRIBUE";
			
			
			$this->a_tr_post[]=$this->tr("<td colspan='".count($this->a_tds)."'>".$html_cont."</td>");
		}
		
		//CREATION DE LA LIGNE DE MESSAGE 	///////////////////////////////////////////////////////////
		$this->tr_att["class"]="";
		if($this->message!="")
			$this->s_tr_message=$this->tr("<td colspan='".count($this->a_tds)."' class='message'>".$this->message."</td>");
		
		
			
		
		//RETOUR	//////////////////////////////////////////////////////////////////////
		return $this->table()."<div id='post-liste'>".$this->post_liste."</div>";
	}
}

?>
