<?php
class menu_navigation
{
	private $nb_par_page=0;
	private $nb_total=0;
	private $seek_encours=0;
	private $a_pages=array();
	private $a_encours=array();
	
	//DECLARATION VARIABLES DE FORMATAGE DU MENU
	private $pages_balises=array("<div>","</div>");		//STRINGS ENCAPSULANT LE MENU DE NAVIGATION (AVANT/APRES)
	private $pages_txt=array("Page ","");				//STRINGS ENCAPSULANT LES NUMEROS DE PAGES (AVANT/APRES)
	private $pages_url=array("index.php?page=","");	//STRINGS DES URLS ENCAPSULANT LE SEEK DE L'ENREGISTREMENT (AVANT/APRES)
	private $pages_separator=" - ";						//STRING SEPARANT LES ENTITES DU MENU
	private $pages_nb=3;								//INT DU NB DE PAGE AVANT ET APRES LA PAGE COURANTE DANS LE MENU
	private $go_to=array("<<",">>");					//STRING D'AFFICHAGE DES SYMBOLES DEBUT/FIN DE LISTE
	private $pages_active_balise=array("<strong>","</strong>");	//STRINGS ENCAPSULANT L'ENTITE ACTIVE DU MENU (AVANT/APRES)
	
	
	//DECLARATION VARIABLES DE FORMATAGE DE LA DESCRIPTION
	private $desc_balises=array("<div>","</div>");						//STRINGS ENCAPSULANT LA DESCRIPTION (AVANT/APRES)
	private $desc_before=array("Enregistrement","Enregistrements");		//STRINGS AVANT LES NOMBRES D'ENREGISTREMENTS
	private $desc_betwen=array("à","à");								//STRINGS ENTRE LES NOMBRES D'ENREGISTREMENTS
	private $desc_after=array("sur","sur les");							//STRINGS APRES LES NOMBRES D'ENREGISTREMENTS
	private $desc_total=array("au total","au total");					//STRINGS APRES LE TOTAL
	
	
	
	//CONSTRUCTEUR
	
	public function __construct($nb_total,$nb_par_page,$seek_encours)
	{	
		$this->nb_total=$nb_total;
		$this->nb_par_page=$nb_par_page;
		$this->seek_encours=$seek_encours;
		
		$nb_pages=ceil($nb_total/$nb_par_page);
		
		for($i=0;$i<$nb_pages;$i++)
		{
			$seek=$i*$nb_par_page;
			$num_page=$i+1;
			$num_first=$i*$nb_par_page+1;
			$num_last=$i*$nb_par_page+$nb_par_page;
			if($num_last>$nb_total)
				$num_last=$nb_total;
			
			$this->a_pages[]=array("seek"=>$seek,"num_page"=>$num_page,"num_first_enr"=>$num_first,"num_last_enr"=>$num_last);
			
			if($this->seek_encours==$seek)
				$this->a_encours=array("seek"=>$seek,"num_page"=>$num_page,"num_first_enr"=>$num_first,"num_last_enr"=>$num_last);
		}		
	}
	
	//FONCTION DE MODIFICATION DES VARIABLES
	public function set_pages_balises($array)
	{
		$this->pages_balises=$array;
	}
	
	public function set_pages_txt($array)
	{
		$this->pages_txt=$array;
	}
	
	public function set_pages_url($array)
	{
		$this->pages_url=$array;
	}
	
	public function set_pages_separator($string)
	{
		$this->pages_separator=$string;
	}
	
	public function set_pages_nb($int)
	{
		$this->pages_nb=$int;
	}
	
	public function set_go_to($array)
	{
		$this->go_to=$array;
	}
	
	public function set_pages_active_balise($array)
	{
		$this->pages_active_balise=$array;
	}
	
	public function set_desc_balises($array)
	{
		$this->desc_balises=$array;
	}
	
	public function set_desc_before($array)
	{
		$this->desc_before=$array;
	}
	
	public function set_desc_betwen($array)
	{
		$this->desc_betwen=$array;
	}
	
	public function set_desc_after($array)
	{
		$this->desc_after=$array;
	}
	
	public function set_desc_total($array)
	{
		$this->desc_total=$array;
	}
	
	
	
	
	
	
	
	public function get_menu_format()
	{	
		$go_end="";
		$go_begin="";
		
		
		//NOMBRE DE PAGE D'AFFICHAGE LIMITEES DANS LE MENU
		if(count($this->a_pages)>($this->pages_nb*2+1) AND $this->pages_nb>0)
		{
			//DETERMINATION DE L'OFFSET EN COURS
			$offset_encours=0;
			foreach($this->a_pages AS $offset=>$a_page)
			{
				if($a_page["seek"]==$this->seek_encours)
					$offset_encours=$offset;
			}
			
			//DETERMINATION DE L'OFFSET DE DEBUT
			$off_begin=$offset_encours-$this->pages_nb;
			if($off_begin>=0)
				$off_end=$off_begin+($this->pages_nb*2);
			else
			{
				$diff=0-$off_begin;
				$off_end=$off_begin+($this->pages_nb*2)+$diff;
				$off_begin=0;
			}
			//echo $off_end." - ".(count($this->a_pages)-1);
			
			//DETERMINATION DE L'OFFSET DE FIN
			if($off_end>count($this->a_pages)-1)
			{
				$diff=$off_end-(count($this->a_pages)-1);
				$off_begin=$off_end-($this->pages_nb*2)-$diff;
				$off_end=(count($this->a_pages)-1);
			}
			
			//CREATION DU MENU A AFFICHER
			foreach($this->a_pages AS $offset=>$a_page)
			{
				if($offset>=$off_begin AND $offset<=$off_end)
					$a_pages_aff[$offset]=$a_page;
			}
			
			if($off_begin>0)
				$go_begin="<a class='to-begin' href='".$this->pages_url[0]."0".$this->pages_url[1]."'>".$this->go_to[0]."</a>";
			if($off_end<(count($this->a_pages)-1))
				$go_end="<a class='to-end'  href='".$this->pages_url[0].$this->a_pages[(count($this->a_pages)-1)]["seek"].$this->pages_url[1]."'>".$this->go_to[1]."</a>";
			
		}
		else
			$a_pages_aff=$this->a_pages;
		
		
		
		//AFFICHAGE DU MENU
		foreach($a_pages_aff AS $a_page)
		{
			if($a_page["seek"]==$this->seek_encours)
				$txt=$this->pages_active_balise[0].$this->pages_txt[0].$a_page["num_page"].$this->pages_txt[1].$this->pages_active_balise[1];
			else
				$txt=$this->pages_txt[0].$a_page["num_page"].$this->pages_txt[1];
				
			$a_menu[]="<a href='".$this->pages_url[0].$a_page["seek"].$this->pages_url[1]."'>".$txt."</a>";
		}
		$menu_pages=$this->pages_balises[0].$go_begin.implode($this->pages_separator,$a_menu).$go_end.$this->pages_balises[1];
		
		return $menu_pages;
	}
	
	
	
	public function get_desc_format()
	{	
		if(($this->a_encours["num_last_enr"]-$this->a_encours["num_first_enr"])>1)
			$off_bb=1;
		else
			$off_bb=0;
		
		if(($this->nb_total)>1)
			$off_at=1;
		else
			$off_at=0;
			
		$desc=$this->desc_balises[0].$this->desc_before[$off_bb]." ".$this->a_encours["num_first_enr"]." ".$this->desc_betwen[$off_bb]." ".$this->a_encours["num_last_enr"]." ".$this->desc_after[$off_at]." ".$this->nb_total." ".$this->desc_total[$off_at].$this->desc_balises[1];
		
		
	
		return $desc;
	}
}
?>
