<?php
class table 
{
	/**********************************************************************************************
	//CLASSE DE CONSTRUCTION DES ELEMENTS D'UNE TABLE
	
	**********************************************************************************************/
	
	
	
	/*********************************************************************
	//FONCTION DE FORMATAGE DES ATTRIBUTS
	
	RECOIT		$a_att			$a_att["id"]=string
								$a_att["class"]=string
								$a_att["options"]=string
							
	RETOURNE	STRING DES ATTRIBUTS
	**********************************************************************/	
	private function attributs($a_att)
	{
		$s_att="";
		
		if(isset($a_att["id"]))
			$s_att.=" id='".$a_att["id"]."' ";
			
		if(isset($a_att["name"]))
			$s_att.=" name='".$a_att["name"]."' ";
			
		if(isset($a_att["class"]))
			$s_att.=" class='".$a_att["class"]."' ";
			
		if(isset($a_att["options"]))
			$s_att.=" ".$a_att["options"]." ";
			
		if(isset($a_att["span"]))
			$s_att.=" span='".$a_att["span"]."' ";
			
		return $s_att;
	}
	
	
	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE TABLE
	
	RECOIT		$a_att			$a_att["id"]=string
								$a_att["class"]=string
								$a_att["options"]=string
							
	RETOURNE	Array["open"]=>balise d'ouverture
				Array["close"]=>balise d'ouverture
	**********************************************************************/	
	static function table_create($a_att=array())
	{
		$open="<table ".self::attributs($a_att).">";
		$close="</table>";
		
		return array("open"=>$open,"close"=>$close);
	}
	

	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE CAPTION
	
	RECOIT		$att		$att["id"]=string
							$att["class"]=string
							$att["options"]=string
							
	RETOURNE	Array["open"]=>balise d'ouverture
				Array["close"]=>balise d'ouverture
	**********************************************************************/	
	static function caption_create($a_att=array())
	{
		$open="<caption ".self::attributs($a_att).">";
		$close="</caption>";
		
		return array("open"=>$open,"close"=>$close);
	}
	
	
	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE COLGROUP
	
	RECOIT		$att=array des diffrentes colones
				$att[]=	array	["span"]=int
								["class"]=string
								["options"]=string
							
	RETOURNE	STRING DU COLGROUP
	**********************************************************************/	
	static function colgroup_create($a_att=array())
	{
		if(count($a_att)>0)
		{
			$s_colgroup="";
			$i_span=0;
			
			foreach($a_att AS $a_attributs)
				$s_colgroup.="<col ".self::attributs($a_attributs)." />";
			
			return "<colgroup>".$s_colgroup."</colgroup>";
		}		
		else
			return "";
	}
	
	
	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE TR
	
	RECOIT		$att		$att["id"]=string
							$att["class"]=string
							$att["options"]=string
							
	RETOURNE	Array["open"]=>balise d'ouverture
				Array["close"]=>balise d'ouverture
	**********************************************************************/	
	static function tr_create ($a_att=array())
	{		
		$open="<tr ".self::attributs($a_att).">";
		$close="</tr>";
		
		return array("open"=>$open,"close"=>$close);
	}
	

	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE TH
	
	RECOIT		$att		$att["id"]=string
							$att["class"]=string
							$att["options"]=string
							
	RETOURNE	Array["open"]=>balise d'ouverture
				Array["close"]=>balise d'ouverture
	**********************************************************************/	
	static function th_create ($th_att=array())
	{
		$open="<th ".self::attributs($a_att).">";
		$close="</th>";
		
		return array("open"=>$open,"close"=>$close);
	}
	

	/*********************************************************************
	//FONCTION DE CONSTRUCTION DE LA BALISE TD
	
	RECOIT		$att		$att["id"]=string
							$att["class"]=string
							$att["options"]=string
							
	RETOURNE	Array["open"]=>balise d'ouverture
				Array["close"]=>balise d'ouverture
	**********************************************************************/	
	static function td_create ($a_att=array())
	{
		$open="<td ".self::attributs($a_att).">";
		$close="</td>";
		
		return array("open"=>$open,"close"=>$close);
	}
	
	
}
?>
