package com.airtight.simpleviewer 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import flash.events.*;
    import flash.external.*;
    
    public class API extends flash.events.EventDispatcher
    {
        public function API()
        {
            super();
            return;
        }

        public function getImageInfo(arg1:int):com.airtight.simpleviewer.data.ImageData
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return null;
            }
            return com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[arg1];
        }

        public function setSize(arg1:Number, arg2:Number):void
        {
            com.airtight.simpleviewer.Shell.instance.stageWidth = arg1;
            com.airtight.simpleviewer.Shell.instance.stageHeight = arg2;
            com.airtight.simpleviewer.Shell.instance.stageManager.setSize(arg1, arg2);
            return;
        }

        internal function onImageSelected(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(SV_IMAGE_CHANGE, com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex));
            callJS(SV_IMAGE_CHANGE, com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex);
            return;
        }

        public function showThumbPage(arg1:int):void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.thumbArea.pageIndex = arg1;
            return;
        }

        public function getThumbPageIndex():int
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return 0;
            }
            return com.airtight.simpleviewer.Shell.instance.thumbArea.pageIndex;
        }

        public function initListeners():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onThumbPageChange, false, 0, true);
            return;
        }

        public function showImage(arg1:int):void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            if (com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex == arg1) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, arg1));
            return;
        }

        public function dispose():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            if (com.airtight.simpleviewer.Shell.instance.stageManager != null) 
            {
                com.airtight.simpleviewer.Shell.instance.imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected);
            }
            if (com.airtight.simpleviewer.Shell.instance.stageManager != null) 
            {
                com.airtight.simpleviewer.Shell.instance.thumbArea.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onThumbPageChange);
            }
            com.airtight.simpleviewer.Shell.instance.dispose();
            return;
        }

        public function clearOption(arg1:String):void
        {
            com.airtight.simpleviewer.config.Config.instance.clearOption(arg1);
            com.airtight.simpleviewer.Shell.instance.doUpdate();
            return;
        }

        public function openImageLinkURL():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.onOpenClick(null);
            return;
        }

        internal function callJS(arg1:String, arg2:*=null):void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            if (!flash.external.ExternalInterface.available) 
            {
                return;
            }
            if (!JSAPIEnabled) 
            {
                return;
            }
            flash.external.ExternalInterface.call(arg1, arg2);
            return;
        }

        public function toggleAudio():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.SoundManager.instance.toggleMusic();
            return;
        }

        public function getGalleryInfo():Object
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return null;
            }
            var loc1:*=new Object();
            loc1.imageCount = com.airtight.simpleviewer.Shell.instance.imageArea.imageCount;
            loc1.thumbPageCount = com.airtight.simpleviewer.Shell.instance.thumbArea.pageCount;
            loc1.thumbPageSize = com.airtight.simpleviewer.Shell.instance.thumbArea.pageSize;
            return loc1;
        }

        public function getOption(arg1:String):com.airtight.simpleviewer.config.Option
        {
            return com.airtight.simpleviewer.config.Config.instance.getOption(arg1);
        }

        public function getImageIndex():int
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return 0;
            }
            return com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex;
        }

        public function showPreviousImage():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, (com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex - 1)));
            return;
        }

        public function toggleFullscreen():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.onFullscreenClick(null);
            return;
        }

        public function showNextImage():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex + 1));
            return;
        }

        internal function onThumbPageChange(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(SV_PAGE_CHANGE, com.airtight.simpleviewer.Shell.instance.thumbArea.pageIndex));
            callJS(SV_PAGE_CHANGE, com.airtight.simpleviewer.Shell.instance.thumbArea.pageIndex);
            return;
        }

        public function toggleAutoPlay():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.imageArea.autoPlayManager.toggleAutoPlay();
            return;
        }

        public function onComplete():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            JSAPIEnabled = com.airtight.simpleviewer.config.Config.instance.enableAPI;
            if (!flash.external.ExternalInterface.available) 
            {
                return;
            }
            if (!JSAPIEnabled) 
            {
                return;
            }
            flash.external.ExternalInterface.addCallback("setSize", setSize);
            flash.external.ExternalInterface.addCallback("show", show);
            flash.external.ExternalInterface.addCallback("dispose", dispose);
            flash.external.ExternalInterface.addCallback("showNextImage", showNextImage);
            flash.external.ExternalInterface.addCallback("showPreviousImage", showPreviousImage);
            flash.external.ExternalInterface.addCallback("showImage", showImage);
            flash.external.ExternalInterface.addCallback("getImageIndex", getImageIndex);
            flash.external.ExternalInterface.addCallback("getThumbPageIndex", getThumbPageIndex);
            flash.external.ExternalInterface.addCallback("getImageInfo", getImageInfo);
            flash.external.ExternalInterface.addCallback("toggleAutoPlay", toggleAutoPlay);
            flash.external.ExternalInterface.addCallback("downloadImage", downloadImage);
            flash.external.ExternalInterface.addCallback("openImageLinkURL", openImageLinkURL);
            flash.external.ExternalInterface.addCallback("toggleAudio", toggleAudio);
            flash.external.ExternalInterface.addCallback("toggleFullscreen", toggleFullscreen);
            flash.external.ExternalInterface.addCallback("showThumbPage", showThumbPage);
            flash.external.ExternalInterface.addCallback("getGalleryInfo", getGalleryInfo);
            flash.external.ExternalInterface.addCallback("setOption", setOption);
            callJS(SV_COMPLETE);
            return;
        }

        public function downloadImage():void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.DownloadManager.instance.downloadImage();
            return;
        }

        public function show(arg1:Boolean):void
        {
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                return;
            }
            com.airtight.simpleviewer.Shell.instance.visible = arg1;
            return;
        }

        public function setOption(arg1:String, arg2:String):void
        {
            com.airtight.simpleviewer.config.Config.instance.setOption(arg1, arg2);
            com.airtight.simpleviewer.Shell.instance.doUpdate();
            return;
        }

        public static const SV_IMAGE_CHANGE:String="svImageChange";

        public static const SV_PAGE_CHANGE:String="svPageChange";

        public static const SV_COMPLETE:String="svComplete";

        internal var JSAPIEnabled:Boolean=true;
    }
}
