package com.airtight.simpleviewer 
{
    import assets.*;
    import com.airtight.simpleviewer.config.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.utils.*;
    
    public class Preloader extends flash.display.MovieClip
    {
        public function Preloader()
        {
            super();
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, init, false, 0, true);
            return;
        }

        public function get api():Object
        {
            return _app != null ? _app.api : null;
        }

        internal function onLoadComplete(arg1:flash.events.Event):void
        {
            addEventListener(flash.events.Event.ENTER_FRAME, doFadeOut, false, 0, true);
            dispatchEvent(new flash.events.Event(com.airtight.simpleviewer.API.SV_COMPLETE, true, false));
            api.onComplete();
            return;
        }

        internal function doFadeOut(arg1:flash.events.Event):void
        {
            _clip.visible = true;
            if (_clip.alpha > 0) 
            {
                _clip.alpha = _clip.alpha - 0.1;
            }
            else 
            {
                onFadeOutDone();
            }
            return;
        }

        internal function onError(arg1:flash.events.Event):void
        {
            removeMe(null);
            return;
        }

        public function set embedOptions(arg1:Object):void
        {
            _embedOptions = arg1;
            return;
        }

        public function get loadBar():flash.display.Sprite
        {
            return _clip.mcLoadbar;
        }

        internal function init(arg1:flash.events.Event):void
        {
            _embedOptions = new Object();
            removeEventListener(flash.events.Event.ADDED_TO_STAGE, init);
            _fadingOut = false;
            stop();
            stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
            stage.align = flash.display.StageAlign.TOP_LEFT;
            addEventListener(flash.events.Event.ENTER_FRAME, onEnterFrame, false, 0, true);
            _clip = new assets.PreloaderAsset();
            addChild(_clip);
            _clip.alpha = 0;
            _clip.visible = false;
            if (com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                _clip.mcLogo.visible = false;
            }
            var loc1:*=flash.display.LoaderInfo(this.loaderInfo).parameters["preloaderColor"];
            setBarColor(loc1);
            stage.addEventListener(flash.events.Event.RESIZE, onResize, false, 0, true);
            onResize(null);
            return;
        }

        internal function setBarColor(arg1:String):void
        {
            var loc1:*=null;
            if (arg1 != null) 
            {
                loc1 = new flash.geom.ColorTransform();
                loc1.color = stringToColor(arg1);
                _clip.mcLoadbar.transform.colorTransform = loc1;
            }
            return;
        }

        internal function onEnterFrame(arg1:flash.events.Event):void
        {
            var loc1:*=NaN;
            _clip.visible = true;
            if (_fadingOut) 
            {
                if (_clip.alpha > 0) 
                {
                    _clip.alpha = _clip.alpha - 0.1;
                }
                else 
                {
                    removeEventListener(flash.events.Event.ENTER_FRAME, onEnterFrame);
                    removeChild(_clip);
                }
                return;
            }
            if (framesLoaded == totalFrames && _clip.alpha >= 1) 
            {
                removeEventListener(flash.events.Event.ENTER_FRAME, onEnterFrame);
                initMainApp();
                _clip.mcLoadbar.mcProgress.width = 103;
            }
            else 
            {
                if (_clip.alpha < 1) 
                {
                    _clip.alpha = _clip.alpha + 0.1;
                }
                loc1 = root.loaderInfo.bytesLoaded / root.loaderInfo.bytesTotal;
                if (loc1 < 0 || isNaN(loc1) || loc1 > 1) 
                {
                    loc1 = 0;
                }
                _clip.mcLoadbar.mcProgress.width = loc1 * 103;
            }
            return;
        }

        internal function onFadeOutDone():void
        {
            removeMe(null);
            _app.shell.showGallery();
            return;
        }

        internal function stringToColor(arg1:String):int
        {
            var loc1:*=new RegExp("#");
            arg1 = arg1.replace(loc1, "0x");
            if (arg1.substr(0, 2) != "0x") 
            {
                arg1 = "0x" + arg1;
            }
            var loc2:*=int(arg1);
            return int(Math.min(Math.max(loc2, 0), 16777215));
        }

        internal function initMainApp():void
        {
            nextFrame();
            var loc1:*=Class(flash.utils.getDefinitionByName("Main"));
            if (loc1) 
            {
                _app = new loc1();
                addChild(_app as flash.display.DisplayObject);
                _app.addEventListener(flash.events.Event.COMPLETE, onLoadComplete, false, 0, true);
                _app.addEventListener(flash.events.ErrorEvent.ERROR, onError, false, 0, true);
                _app.init();
            }
            return;
        }

        internal function onResize(arg1:flash.events.Event):void
        {
            var loc1:*=stage.stageWidth;
            var loc2:*=stage.stageHeight;
            if (this.parent != this.stage) 
            {
                loc1 = this.parent.parent.width;
                loc2 = this.parent.parent.height;
            }
            _clip.x = Math.floor(loc1 / 2);
            _clip.y = Math.floor(loc2 / 2);
            return;
        }

        internal function removeMe(arg1:flash.events.Event):void
        {
            stage.removeEventListener(flash.events.Event.RESIZE, onResize);
            removeEventListener(flash.events.Event.ENTER_FRAME, doFadeOut);
            removeChild(_clip);
            return;
        }

        public function get embedOptions():Object
        {
            return _embedOptions;
        }

        internal static const BAR_WIDTH:Number=120;

        internal static const BAR_HEIGHT:Number=14;

        internal var _app:Object;

        internal var _embedOptions:Object;

        internal var _clip:assets.PreloaderAsset;

        internal var _fadingOut:Boolean;
    }
}
