package com.airtight.simpleviewer 
{
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import com.airtight.utils.*;
    import com.greensock.plugins.*;
    import flash.display.*;
    import flash.events.*;
    import flash.ui.*;
    import org.casalib.util.*;
    
    public class Shell extends flash.display.Sprite
    {
        public function Shell(arg1:SingletonEnforcer)
        {
            super();
            return;
        }

        internal function doAfterUpdate(arg1:flash.events.Event):void
        {
            var loc1:*;
            _waitFrames++;
            if (_waitFrames == 4) 
            {
                removeEventListener(flash.events.Event.ENTER_FRAME, doAfterUpdate);
                _stageManager.visible = true;
            }
            return;
        }

        public function onKeyDown(arg1:flash.events.KeyboardEvent):void
        {
            if (!com.airtight.simpleviewer.config.Config.instance.enableKeyboardControls) 
            {
                return;
            }
            if (arg1.keyCode == flash.ui.Keyboard.SPACE && com.airtight.simpleviewer.config.Config.instance.showAutoPlayButton) 
            {
                _stageManager.imageArea.autoPlayManager.toggleAutoPlay();
            }
            if (arg1.keyCode == 70) 
            {
                onFullscreenClick(arg1);
            }
            return;
        }

        public function doUpdate():void
        {
            updateContextMenu();
            _stageManager.visible = false;
            dispatchEvent(new flash.events.Event(com.airtight.simpleviewer.Shell.UPDATE));
            addEventListener(flash.events.Event.ENTER_FRAME, doAfterUpdate, false, 0, true);
            _waitFrames = 0;
            return;
        }

        public function get stageHeight():int
        {
            if (isLoadee) 
            {
                return parent.parent.parent.parent.height;
            }
            return stage.stageHeight;
        }

        public function get stageManager():com.airtight.simpleviewer.display.StageManager
        {
            return _stageManager;
        }

        public function onFullscreenClick(arg1:flash.events.Event):void
        {
            if (stage.displayState != "fullScreen") 
            {
                stage.displayState = "fullScreen";
            }
            else 
            {
                stage.displayState = "normal";
            }
            return;
        }

        internal function onEnter(arg1:flash.events.Event):void
        {
            return;
        }

        public function onAboutClick(arg1:flash.events.Event):void
        {
            org.casalib.util.NavigateUtil.openUrl(com.airtight.simpleviewer.config.Constants.ABOUT_URL, org.casalib.util.NavigateUtil.WINDOW_BLANK);
            return;
        }

        internal function onFullscreenChange(arg1:flash.events.Event):void
        {
            updateContextMenu();
            return;
        }

        public function get stageX():int
        {
            if (isLoadee) 
            {
                return this.parent.parent.parent.parent.x;
            }
            return 0;
        }

        public function init(arg1:Main):void
        {
            _initialized = false;
            arg1.addChild(this);
            _api = arg1.api;
            if (stage == null) 
            {
                return;
            }
            stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
            stage.align = flash.display.StageAlign.TOP_LEFT;
            org.casalib.util.StageReference.setStage(this.stage);
            if (!doSecurityCheck()) 
            {
                return;
            }
            com.airtight.simpleviewer.Logger.log("SimpleViewer " + (com.airtight.simpleviewer.config.Constants.IS_PRO ? "PRO" : "STANDARD") + " V" + com.airtight.simpleviewer.config.Version.VERSION, com.airtight.simpleviewer.Logger.WARN);
            com.airtight.simpleviewer.config.Config.instance.addEventListener(flash.events.Event.INIT, onConfigLoaded, false, 0, true);
            com.airtight.simpleviewer.config.Config.instance.addEventListener(flash.events.ErrorEvent.ERROR, onError, false, 0, true);
            com.airtight.simpleviewer.config.Config.instance.init(this);
            com.airtight.simpleviewer.config.Config.instance.load();
            return;
        }

        public function set stageHeight(arg1:int):void
        {
            _stageHeight = arg1;
            return;
        }

        public function get thumbArea():com.airtight.simpleviewer.display.thumbs.ThumbArea
        {
            return _stageManager.thumbArea;
        }

        public function set stageWidth(arg1:int):void
        {
            _stageWidth = arg1;
            return;
        }

        public function get imageArea():com.airtight.simpleviewer.display.image.ImageArea
        {
            return _stageManager.imageArea;
        }

        public function onDownloadClick(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.DownloadManager.instance.downloadImage();
            return;
        }

        public function onOpenClick(arg1:flash.events.Event):void
        {
            var loc1:*=com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[imageArea.imageIndex];
            org.casalib.util.NavigateUtil.openUrl(loc1.linkURL, loc1.linkTarget);
            return;
        }

        public static function get instance():com.airtight.simpleviewer.Shell
        {
            if (com.airtight.simpleviewer.Shell._instance == null) 
            {
                com.airtight.simpleviewer.Shell._instance = new Shell(new SingletonEnforcer());
            }
            return com.airtight.simpleviewer.Shell._instance;
        }

        public function onDataLoaded(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.Logger.log("Shell.onDataLoaded : Image Count: " + com.airtight.simpleviewer.data.DataManager.instance.galleryData.imageCount, com.airtight.simpleviewer.Logger.DEBUG);
            _stageManager = new com.airtight.simpleviewer.display.StageManager(this, 0, 0);
            _stageManager.visible = false;
            _stageManager.initListeners();
            _api.initListeners();
            imageArea.createImages();
            thumbArea.createThumbs();
            if (com.airtight.simpleviewer.config.Config.instance.enableKeyboardControls) 
            {
                stage.addEventListener(flash.events.KeyboardEvent.KEY_UP, onKeyDown, false, 0, true);
                stage.addEventListener(flash.events.KeyboardEvent.KEY_DOWN, thumbArea.onKeyDown, false, 0, true);
            }
            if (com.airtight.simpleviewer.config.Config.instance.enableMouseWheel) 
            {
                stage.addEventListener(flash.events.MouseEvent.MOUSE_WHEEL, thumbArea.onMouseWheel, false, 0, true);
            }
            com.airtight.simpleviewer.ToolTipManager.instance.initListeners();
            _initialized = true;
            if (com.airtight.simpleviewer.config.Constants.DEBUG_MODE) 
            {
                _stats = new com.airtight.utils.Stats();
                addChild(_stats);
            }
            com.airtight.simpleviewer.SoundManager.instance.init();
            stage.addEventListener(flash.events.Event.FULLSCREEN, onFullscreenChange, false, 0, true);
            dispatchEvent(new flash.events.Event(flash.events.Event.COMPLETE, true));
            return;
        }

        public function dispose():void
        {
            var loc1:*;
            try 
            {
                if (_stats != null) 
                {
                    _stats.dispose();
                    removeChild(_stats);
                }
                if (_errorMsg != null) 
                {
                    removeChild(_errorMsg);
                }
                if (_stageManager != null) 
                {
                    _stageManager.dispose();
                }
                com.airtight.simpleviewer.config.Config.instance.removeEventListener(flash.events.Event.INIT, onConfigLoaded);
                com.airtight.simpleviewer.config.Config.instance.removeEventListener(flash.events.ErrorEvent.ERROR, onError);
                com.airtight.simpleviewer.data.DataManager.instance.removeEventListener(flash.events.Event.INIT, onDataLoaded);
                com.airtight.simpleviewer.data.DataManager.instance.removeEventListener(flash.events.ErrorEvent.ERROR, onError);
                com.airtight.simpleviewer.ToolTipManager.instance.dispose();
                stage.removeEventListener(flash.events.KeyboardEvent.KEY_UP, onKeyDown);
                stage.removeEventListener(flash.events.KeyboardEvent.KEY_DOWN, thumbArea.onKeyDown);
                stage.removeEventListener(flash.events.MouseEvent.MOUSE_WHEEL, thumbArea.onMouseWheel);
                stage.removeEventListener(flash.events.Event.FULLSCREEN, onFullscreenChange);
                org.casalib.util.StageReference.removeStage();
            }
            catch (e:Error)
            {
            };
            return;
        }

        internal function onConfigLoaded(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.Logger.log("Shell.onConfigLoaded", com.airtight.simpleviewer.Logger.DEBUG);
            com.airtight.simpleviewer.Logger.log("imagePath: " + com.airtight.simpleviewer.config.Config.instance.imagePath, com.airtight.simpleviewer.Logger.DEBUG);
            if (_initialized) 
            {
                dispatchEvent(new flash.events.Event(com.airtight.simpleviewer.Shell.UPDATE));
                return;
            }
            com.airtight.simpleviewer.config.Localization.instance.load();
            updateContextMenu();
            com.airtight.simpleviewer.data.DataManager.instance.addEventListener(flash.events.Event.INIT, onDataLoaded, false, 0, true);
            com.airtight.simpleviewer.data.DataManager.instance.addEventListener(flash.events.ErrorEvent.ERROR, onError, false, 0, true);
            com.airtight.simpleviewer.data.DataManager.instance.loadGallery();
            com.greensock.plugins.TweenPlugin.activate([com.greensock.plugins.ColorTransformPlugin, com.greensock.plugins.TintPlugin]);
            return;
        }

        public function get api():com.airtight.simpleviewer.API
        {
            return _api;
        }

        public function get stageY():int
        {
            if (isLoadee) 
            {
                return this.parent.parent.parent.parent.y;
            }
            return 0;
        }

        public function showGallery():void
        {
            _stageManager.visible = true;
            imageArea.startTheShow();
            return;
        }

        internal function updateContextMenu():void
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc4:*=null;
            var loc5:*=null;
            var loc6:*=null;
            var loc1:*=new flash.ui.ContextMenu();
            this.contextMenu = loc1;
            loc1.hideBuiltInItems();
            if (com.airtight.simpleviewer.config.Config.instance.showFullscreenButton) 
            {
                if (org.casalib.util.StageReference.getStage().displayState != "normal") 
                {
                    loc3 = new flash.ui.ContextMenuItem(com.airtight.simpleviewer.config.Localization.instance.exitFullscreen);
                    loc3.addEventListener(flash.events.ContextMenuEvent.MENU_ITEM_SELECT, onFullscreenClick, false, 0, true);
                    loc1.customItems.push(loc3);
                }
                else 
                {
                    loc2 = new flash.ui.ContextMenuItem(com.airtight.simpleviewer.config.Localization.instance.goFullscreen);
                    loc2.addEventListener(flash.events.ContextMenuEvent.MENU_ITEM_SELECT, onFullscreenClick, false, 0, true);
                    loc1.customItems.push(loc2);
                }
            }
            if (com.airtight.simpleviewer.config.Config.instance.showDownloadButton) 
            {
                (loc4 = new flash.ui.ContextMenuItem(com.airtight.simpleviewer.config.Localization.instance.downloadImage + "...")).addEventListener(flash.events.ContextMenuEvent.MENU_ITEM_SELECT, onDownloadClick, false, 0, true);
                loc4.enabled = org.casalib.util.StageReference.getStage().displayState == "normal";
                loc1.customItems.push(loc4);
            }
            if (com.airtight.simpleviewer.config.Config.instance.showOpenButton) 
            {
                (loc5 = new flash.ui.ContextMenuItem(com.airtight.simpleviewer.config.Localization.instance.openImage + "...")).addEventListener(flash.events.ContextMenuEvent.MENU_ITEM_SELECT, onOpenClick, false, 0, true);
                loc5.enabled = org.casalib.util.StageReference.getStage().displayState == "normal";
                loc1.customItems.push(loc5);
            }
            if (!com.airtight.simpleviewer.config.Constants.IS_PRO || com.airtight.simpleviewer.config.Constants.DEBUG_MODE) 
            {
                (loc6 = new flash.ui.ContextMenuItem(com.airtight.simpleviewer.config.Localization.instance.about + " SimpleViewer " + com.airtight.simpleviewer.config.Version.VERSION + "...")).addEventListener(flash.events.ContextMenuEvent.MENU_ITEM_SELECT, onAboutClick, false, 0, true);
                loc1.customItems.push(loc6);
            }
            return;
        }

        public function get isLoadee():Boolean
        {
            return !(parent.parent.parent == stage);
        }

        internal function onError(arg1:flash.events.ErrorEvent):void
        {
            _errorMsg = new com.airtight.simpleviewer.display.components.TextMessage(this, 0, 0, arg1.text, 12);
            dispatchEvent(new flash.events.Event(flash.events.ErrorEvent.ERROR, true));
            return;
        }

        internal function doSecurityCheck():Boolean
        {
            var loc1:*=null;
            if (com.airtight.simpleviewer.config.Constants.IS_BETA) 
            {
                loc1 = new Date();
                if (loc1.getFullYear() > 2010) 
                {
                    onError(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, true, false, "This Beta software has expired. Please get the latest release version."));
                    return false;
                }
            }
            if (com.airtight.simpleviewer.config.Constants.IS_DEMO) 
            {
                if (!org.casalib.util.LocationUtil.isDomain(this, "simpleviewer.net")) 
                {
                    onError(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, true, false, "This is a Demo Version. Please use a release version."));
                    return false;
                }
            }
            return true;
        }

        public function get stageWidth():int
        {
            if (isLoadee) 
            {
                return parent.parent.parent.parent.width;
            }
            return stage.stageWidth;
        }

        public static const UPDATE:String="update";

        internal var _stageWidth:int=-1;

        internal var _stageX:int=-1;

        internal var _stageHeight:int=-1;

        internal var _initialized:Boolean;

        internal var _waitFrames:int=0;

        internal var _api:com.airtight.simpleviewer.API;

        internal var _stageManager:com.airtight.simpleviewer.display.StageManager;

        internal var _errorMsg:com.airtight.simpleviewer.display.components.TextMessage;

        internal var _stats:com.airtight.utils.Stats;

        internal static var _instance:com.airtight.simpleviewer.Shell;

        internal var _stageY:int=-1;
    }
}


class SingletonEnforcer extends Object
{
    public function SingletonEnforcer()
    {
        super();
        return;
    }
}