package com.airtight.simpleviewer 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.config.*;
    import com.greensock.*;
    import flash.events.*;
    import flash.media.*;
    import flash.net.*;
    
    public class SoundManager extends flash.events.EventDispatcher
    {
        public function SoundManager(arg1:SingletonEnforcer)
        {
            super();
            return;
        }

        internal function errorHandler(arg1:flash.events.IOErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("Sound file cannot be found at URL: " + com.airtight.simpleviewer.config.Config.instance.resolveURL(com.airtight.simpleviewer.config.Config.instance.audioURL), com.airtight.simpleviewer.Logger.WARN);
            _initialized = false;
            return;
        }

        public function init():void
        {
            if (!com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.audioURL)) 
            {
                return;
            }
            var loc1:*=new flash.net.URLRequest(com.airtight.simpleviewer.config.Config.instance.resolveURL(com.airtight.simpleviewer.config.Config.instance.audioURL));
            _music = new flash.media.Sound();
            _music.addEventListener(flash.events.IOErrorEvent.IO_ERROR, errorHandler, false, 0, true);
            _music.load(loc1);
            _isPlaying = false;
            _musicDefaultVolume = com.airtight.simpleviewer.config.Config.instance.audioVolume;
            _pausePoint = 0;
            _initialized = true;
            if (com.airtight.simpleviewer.config.Config.instance.playAudioOnLoad) 
            {
                toggleMusic();
            }
            return;
        }

        public function toggleMusic():void
        {
            if (!_initialized) 
            {
                return;
            }
            if (_isPlaying) 
            {
                _channel.soundTransform = new flash.media.SoundTransform(_musicDefaultVolume);
                com.greensock.TweenLite.to(_channel, 1, {"volume":0, "onComplete":onFadeOutComplete});
                _pausePoint = _channel.position;
            }
            else 
            {
                if (_channel != null) 
                {
                    com.greensock.TweenLite.killTweensOf(_channel);
                    _channel.stop();
                }
                _channel = _music.play(_pausePoint);
                _channel.addEventListener(flash.events.Event.SOUND_COMPLETE, onMusicComplete, false, 0, true);
                _channel.soundTransform = new flash.media.SoundTransform(_musicDefaultVolume);
                if (_pausePoint != 0) 
                {
                    _channel.soundTransform = new flash.media.SoundTransform(0);
                    com.greensock.TweenLite.to(_channel, 1, {"volume":_musicDefaultVolume});
                }
            }
            _isPlaying = !_isPlaying;
            dispatchEvent(new com.airtight.events.CustomEvent(flash.events.Event.CHANGE, _isPlaying));
            return;
        }

        internal function onFadeOutComplete():void
        {
            _pausePoint = _channel.position;
            _channel.stop();
            return;
        }

        internal function onMusicComplete(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.loopAudio) 
            {
                _channel = _music.play(0);
                _channel.soundTransform = new flash.media.SoundTransform(_musicDefaultVolume);
                _channel.addEventListener(flash.events.Event.SOUND_COMPLETE, onMusicComplete, false, 0, true);
            }
            else 
            {
                _isPlaying = false;
                dispatchEvent(new com.airtight.events.CustomEvent(flash.events.Event.CHANGE, _isPlaying));
            }
            _pausePoint = 0;
            return;
        }

        public static function get instance():com.airtight.simpleviewer.SoundManager
        {
            if (com.airtight.simpleviewer.SoundManager._instance == null) 
            {
                com.airtight.simpleviewer.SoundManager._instance = new SoundManager(new SingletonEnforcer());
            }
            return com.airtight.simpleviewer.SoundManager._instance;
        }

        internal var _channel:flash.media.SoundChannel;

        internal var _isPlaying:Boolean;

        internal var _music:flash.media.Sound;

        internal var _musicDefaultVolume:Number;

        internal var _pausePoint:Number;

        internal var _initialized:Boolean=false;

        internal static var _instance:com.airtight.simpleviewer.SoundManager;
    }
}


class SingletonEnforcer extends Object
{
    public function SingletonEnforcer()
    {
        super();
        return;
    }
}