package com.airtight.simpleviewer 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.*;
    import com.airtight.simpleviewer.display.components.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.utils.*;
    
    public class ToolTipManager extends flash.events.EventDispatcher
    {
        public function ToolTipManager(arg1:SingletonEnforcer)
        {
            super();
            return;
        }

        internal function onDelayDone(arg1:flash.events.TimerEvent):void
        {
            showTip(true);
            return;
        }

        public function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.addEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate, false, 0, true);
            _stageManager = com.airtight.simpleviewer.Shell.instance.stageManager;
            _timer = new flash.utils.Timer(DELAY, 1);
            _timer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, onDelayDone, false, 0, true);
            _tip = new com.airtight.simpleviewer.display.components.ToolTip(com.airtight.simpleviewer.Shell.instance.stageManager, 0, 0);
            _tip.visible = false;
            doUpdate(null);
            return;
        }

        public function addTarget(arg1:com.airtight.simpleviewer.display.components.BaseButton):void
        {
            arg1.addEventListener(com.airtight.events.UIEvent.OVER, onOver, false, 0, true);
            arg1.addEventListener(com.airtight.events.UIEvent.OUT, onOut, false, 0, true);
            arg1.addEventListener(com.airtight.events.UIEvent.ACTIVATE, onActivate, false, 0, true);
            return;
        }

        internal function doUpdate(arg1:flash.events.Event):void
        {
            _enabled = com.airtight.simpleviewer.config.Config.instance.showToolTips;
            return;
        }

        internal function onOut(arg1:com.airtight.events.UIEvent):void
        {
            _timer.stop();
            showTip(false);
            return;
        }

        internal function onActivate(arg1:com.airtight.events.UIEvent):void
        {
            if (!arg1.data) 
            {
                onOut(arg1);
            }
            return;
        }

        internal function onOver(arg1:com.airtight.events.UIEvent):void
        {
            _timer.stop();
            _timer.start();
            _target = com.airtight.simpleviewer.display.components.BaseButton(arg1.target);
            return;
        }

        internal function showTip(arg1:Boolean):void
        {
            if (_tip == null || !_enabled) 
            {
                return;
            }
            _tip.show(arg1, _target.tooltipText);
            var loc1:*=_target.localToGlobal(new flash.geom.Point(0, 0));
            var loc2:*=_stageManager.globalToLocal(loc1);
            var loc3:*=loc2.clone();
            loc3.x = loc3.x + _target.width * _target.parent.scaleY / 2;
            loc3.y = loc3.y + (_target.height + com.airtight.simpleviewer.display.ButtonBar.V_PADDING) * _target.parent.scaleY + 11;
            if (loc3.y + _tip.height > com.airtight.simpleviewer.Shell.instance.stageHeight) 
            {
                loc3.y = loc2.y - com.airtight.simpleviewer.display.ButtonBar.V_PADDING * _target.parent.scaleY - 11;
            }
            if (loc3.x + _tip.width / 2 > com.airtight.simpleviewer.Shell.instance.stageWidth) 
            {
                loc3.x = com.airtight.simpleviewer.Shell.instance.stageWidth - _tip.width / 2 - 3;
            }
            if (loc3.x - _tip.width / 2 < 0) 
            {
                loc3.x = _tip.width / 2 + 3;
            }
            _tip.move(loc3.x, loc3.y);
            return;
        }

        public function dispose():void
        {
            com.airtight.simpleviewer.Shell.instance.removeEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate);
            if (_timer == null) 
            {
                return;
            }
            _timer.removeEventListener(flash.events.TimerEvent.TIMER_COMPLETE, onDelayDone);
            _timer.stop();
            _timer = null;
            return;
        }

        public static function get instance():com.airtight.simpleviewer.ToolTipManager
        {
            if (com.airtight.simpleviewer.ToolTipManager._instance == null) 
            {
                com.airtight.simpleviewer.ToolTipManager._instance = new ToolTipManager(new SingletonEnforcer());
            }
            return com.airtight.simpleviewer.ToolTipManager._instance;
        }

        internal static const DELAY:int=500;

        internal var _enabled:Boolean=true;

        internal var _timer:flash.utils.Timer;

        internal var _stageManager:com.airtight.simpleviewer.display.StageManager;

        internal var _target:com.airtight.simpleviewer.display.components.BaseButton;

        internal var _tip:com.airtight.simpleviewer.display.components.TextMessage;

        internal static var _instance:com.airtight.simpleviewer.ToolTipManager;
    }
}


class SingletonEnforcer extends Object
{
    public function SingletonEnforcer()
    {
        super();
        return;
    }
}