package com.airtight.simpleviewer.data 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.utils.*;
    import flash.events.*;
    import flash.net.*;
    
    public class DataManager extends flash.events.EventDispatcher
    {
        public function DataManager(arg1:SingletonEnforcer)
        {
            super();
            _loaded = false;
            return;
        }

        internal function onGotPhotoList(arg1:flash.events.Event):void
        {
            var loc1:*=XML(flash.net.URLLoader(arg1.target).data);
            parseFlickrGallery(loc1);
            return;
        }

        internal function onFlickrSetError(arg1:flash.events.ErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("DataManager: Flickr Photoset Error for Set id: " + com.airtight.simpleviewer.config.Config.instance.flickrSetId, com.airtight.simpleviewer.Logger.WARN);
            dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Flickr PhotoSet Not Found"));
            return;
        }

        internal function onFlickrError(arg1:flash.events.ErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("DataManager: Flickr Error: " + arg1.text, com.airtight.simpleviewer.Logger.WARN);
            dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Cannot load from Flickr"));
            return;
        }

        public function loadGallery():void
        {
            var loc1:*=null;
            if (com.airtight.simpleviewer.config.Config.instance.useFlickr) 
            {
                if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrSetId)) 
                {
                    doFlickrSetQuery();
                }
                else if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrGroupId)) 
                {
                    doFlickrGroupQuery();
                }
                else if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrUserId)) 
                {
                    doFlickrSearch(com.airtight.simpleviewer.config.Config.instance.flickrUserId);
                }
                else if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrUserName)) 
                {
                    loc1 = getflickrQueryURL(FLICKR_FIND_USER) + "&username=" + com.airtight.simpleviewer.config.Config.instance.flickrUserName;
                    com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotUserID, onFlickrUsernameError);
                }
                else if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrTags)) 
                {
                    doFlickrSearch();
                }
                else 
                {
                    doInterestingnessSearch();
                }
            }
            else 
            {
                parseXMLGallery(com.airtight.simpleviewer.config.Config.instance.galleryXML);
            }
            return;
        }

        internal function doInterestingnessSearch():void
        {
            var loc1:*=getflickrQueryURL(FLICKR_INTERESTINGNESS);
            loc1 = loc1 + "&per_page=" + com.airtight.simpleviewer.config.Config.instance.flickrImageCount;
            loc1 = loc1 + "&extras=url_sq, url_m, url_l,url_o";
            com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotPhotoList, onFlickrError);
            return;
        }

        internal function onFlickrGroupError(arg1:flash.events.ErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("DataManager: Flickr Photoset Error for Group id: " + com.airtight.simpleviewer.config.Config.instance.flickrGroupId, com.airtight.simpleviewer.Logger.WARN);
            dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Flickr Group Not Found"));
            return;
        }

        internal function onGotUserID(arg1:flash.events.Event):void
        {
            var loc1:*=XML(flash.net.URLLoader(arg1.target).data);
            var loc2:*=loc1.@nsid;
            if (loc2 == null || loc2 == "") 
            {
                onFlickrUsernameError(null);
            }
            else 
            {
                doFlickrSearch(loc2);
            }
            return;
        }

        internal function parseXMLGallery(arg1:XML):void
        {
            var img:com.airtight.simpleviewer.data.ImageData;
            var galleryXML:XML;
            var imgTag:XML;
            var i:int;

            var loc1:*;
            i = 0;
            img = null;
            imgTag = null;
            galleryXML = arg1;
            try 
            {
                _galleryData = new com.airtight.simpleviewer.data.GalleryData();
                _galleryData.imageCount = galleryXML.length();
                if (!com.airtight.simpleviewer.config.Constants.IS_PRO) 
                {
                    _galleryData.imageCount = Math.min(_galleryData.imageCount, 50);
                }
                _galleryData.images = [];
                if (_galleryData.imageCount == 0) 
                {
                    com.airtight.simpleviewer.Logger.log("DataManager: No Images Specified in Gallery XML: " + com.airtight.simpleviewer.config.Config.instance.galleryURL, com.airtight.simpleviewer.Logger.WARN);
                    dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "No Images Specified in Gallery XML"));
                    return;
                }
                i = 0;
                while (i < _galleryData.imageCount) 
                {
                    img = new com.airtight.simpleviewer.data.ImageData();
                    imgTag = galleryXML[i];
                    if (imgTag.@imageURL.toString() == "") 
                    {
                        img.imageURL = com.airtight.simpleviewer.config.Config.instance.imagePath + imgTag.filename.toString();
                    }
                    else 
                    {
                        img.imageURL = imgTag.@imageURL;
                    }
                    if (imgTag.@thumbURL.toString() == "") 
                    {
                        img.thumbURL = com.airtight.simpleviewer.config.Config.instance.thumbPath + imgTag.filename.toString();
                    }
                    else 
                    {
                        img.thumbURL = imgTag.@thumbURL;
                    }
                    img.linkURL = img.imageURL;
                    if (com.airtight.simpleviewer.config.Config.isValidString(imgTag.@linkURL)) 
                    {
                        img.linkURL = imgTag.@linkURL;
                    }
                    img.linkTarget = "_blank";
                    if (com.airtight.simpleviewer.config.Config.isValidString(imgTag.@linkTarget)) 
                    {
                        img.linkTarget = imgTag.@linkTarget;
                    }
                    img.caption = imgTag.caption.toString();
                    img.index = i;
                    _galleryData.images.push(img);
                    ++i;
                }
                if (com.airtight.simpleviewer.config.Config.instance.randomizeImages) 
                {
                    _galleryData.randomizeImageOrder();
                }
                dispatchEvent(new flash.events.Event(flash.events.Event.INIT));
            }
            catch (e:Error)
            {
                com.airtight.simpleviewer.Logger.log("DataManager: Cannot Parse Gallery XML: " + com.airtight.simpleviewer.config.Config.instance.galleryURL, com.airtight.simpleviewer.Logger.WARN);
                dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Cannot Parse Gallery XML"));
            }
            return;
        }

        internal function doFlickrSetQuery():void
        {
            var loc1:*=null;
            loc1 = getflickrQueryURL(FLICKR_SET) + "&photoset_id=" + com.airtight.simpleviewer.config.Config.instance.flickrSetId;
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrTags)) 
            {
                loc1 = loc1 + "&tags=" + com.airtight.simpleviewer.config.Config.instance.flickrTags;
            }
            loc1 = loc1 + "&tag_mode=" + String(com.airtight.simpleviewer.config.Config.instance.flickrTagMode).toLowerCase();
            loc1 = loc1 + "&per_page=" + com.airtight.simpleviewer.config.Config.instance.flickrImageCount;
            loc1 = loc1 + "&media=photos";
            loc1 = loc1 + "&extras=url_sq,url_m,url_l,url_o";
            com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotPhotoList, onFlickrSetError);
            return;
        }

        internal function onFlickrUsernameError(arg1:flash.events.ErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("DataManager: Flickr Username Error: " + com.airtight.simpleviewer.config.Config.instance.flickrUserName, com.airtight.simpleviewer.Logger.WARN);
            dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Flickr User Not Found"));
            return;
        }

        internal function doFlickrSearch(arg1:String=null):void
        {
            var loc2:*=null;
            var loc3:*=null;
            var loc1:*=getflickrQueryURL(FLICKR_SEARCH);
            if (arg1 != null) 
            {
                loc1 = loc1 + "&user_id=" + arg1;
            }
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrTags)) 
            {
                loc1 = loc1 + "&tags=" + com.airtight.simpleviewer.config.Config.instance.flickrTags;
            }
            loc1 = loc1 + "&sort=" + String(com.airtight.simpleviewer.config.Config.instance.flickrSort).toLowerCase();
            loc1 = loc1 + "&tag_mode=" + String(com.airtight.simpleviewer.config.Config.instance.flickrTagMode).toLowerCase();
            loc1 = loc1 + "&per_page=" + com.airtight.simpleviewer.config.Config.instance.flickrImageCount;
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrExtraParams)) 
            {
                loc2 = new RegExp(",", "g");
                loc3 = "&" + com.airtight.simpleviewer.config.Config.instance.flickrExtraParams.replace(loc2, "&");
                loc1 = loc1 + loc3;
            }
            loc1 = loc1 + "&media=photos";
            loc1 = loc1 + "&extras=url_sq,url_m,url_l,url_o";
            com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotPhotoList, onFlickrError);
            return;
        }

        internal function doFlickrGroupQuery():void
        {
            var loc1:*=null;
            loc1 = getflickrQueryURL(FLICKR_GROUP) + "&group_id=" + com.airtight.simpleviewer.config.Config.instance.flickrGroupId;
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.flickrTags)) 
            {
                loc1 = loc1 + "&tags=" + com.airtight.simpleviewer.config.Config.instance.flickrTags;
            }
            loc1 = loc1 + "&tag_mode=" + String(com.airtight.simpleviewer.config.Config.instance.flickrTagMode).toLowerCase();
            loc1 = loc1 + "&per_page=" + com.airtight.simpleviewer.config.Config.instance.flickrImageCount;
            loc1 = loc1 + "&extras=url_sq,url_m,url_l,url_o";
            com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotPhotoList, onFlickrGroupError);
            return;
        }

        public function get galleryData():com.airtight.simpleviewer.data.GalleryData
        {
            return _galleryData;
        }

        internal function parseFlickrGallery(arg1:XML):void
        {
            var img:com.airtight.simpleviewer.data.ImageData;
            var galleryXML:XML;
            var i:int;
            var owner:String;
            var thisOwner:String;
            var imgTag:XML;
            var fetchSize:String;

            var loc1:*;
            fetchSize = null;
            owner = null;
            i = 0;
            img = null;
            imgTag = null;
            thisOwner = null;
            galleryXML = arg1;
            try 
            {
                _galleryData = new com.airtight.simpleviewer.data.GalleryData();
                _galleryData.imageCount = galleryXML.length();
                _galleryData.images = [];
                if (_galleryData.imageCount == 0) 
                {
                    com.airtight.simpleviewer.Logger.log("DataManager: 0 photos returned from Flickr.", com.airtight.simpleviewer.Logger.WARN);
                    dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Flickr Images Not Found"));
                    return;
                }
                fetchSize = com.airtight.simpleviewer.config.Config.instance.flickrImageSize;
                owner = galleryXML.@owner;
                i = 0;
                while (i < _galleryData.imageCount) 
                {
                    img = new com.airtight.simpleviewer.data.ImageData();
                    imgTag = galleryXML[i];
                    img.flickrId = imgTag.@id;
                    img.isFlickrImage = true;
                    img.index = i;
                    img.thumbURL = imgTag.@url_sq;
                    img.imageURL = imgTag.@url_m;
                    if ((fetchSize == "ORIGINAL" || fetchSize == "LARGE") && !(imgTag.@url_l.toString() == "")) 
                    {
                        img.imageURL = imgTag.@url_l;
                    }
                    if (fetchSize == "ORIGINAL" && !(imgTag.@url_o.toString() == "")) 
                    {
                        img.imageURL = imgTag.@url_o;
                    }
                    thisOwner = owner != "" ? owner : imgTag.@owner;
                    img.linkURL = "http://www.flickr.com/photos/" + thisOwner + "/" + imgTag.@id;
                    img.linkTarget = "_blank";
                    _galleryData.images.push(img);
                    ++i;
                }
                if (com.airtight.simpleviewer.config.Config.instance.randomizeImages) 
                {
                    _galleryData.randomizeImageOrder();
                }
                dispatchEvent(new flash.events.Event(flash.events.Event.INIT));
            }
            catch (e:Error)
            {
                com.airtight.simpleviewer.Logger.log("DataManager: Cannot Parse Flickr Gallery", com.airtight.simpleviewer.Logger.WARN);
                dispatchEvent(new flash.events.ErrorEvent(flash.events.ErrorEvent.ERROR, false, false, "Cannot Parse Flickr Gallery"));
            }
            return;
        }

        public static function getflickrQueryURL(arg1:String):String
        {
            return FLICKR_BASE + arg1 + FLICKR_KEY;
        }

        public static function get instance():com.airtight.simpleviewer.data.DataManager
        {
            if (com.airtight.simpleviewer.data.DataManager._instance == null) 
            {
                com.airtight.simpleviewer.data.DataManager._instance = new DataManager(new SingletonEnforcer());
            }
            return com.airtight.simpleviewer.data.DataManager._instance;
        }

        public static const FLICKR_SEARCH:String="flickr.photos.search";

        public static const FLICKR_INTEREST:String="flickr.interestingness.getList";

        public static const FLICKR_KEY:String="&api_key=b40dc56c795c0103c6170731e6271e04";

        public static const FLICKR_SET:String="flickr.photosets.getPhotos";

        public static const FLICKR_BASE:String="http://api.flickr.com/services/rest/?method=";

        public static const FLICKR_PHOTO_INFO:String="flickr.photos.getInfo";

        public static const FLICKR_GROUP:String="flickr.groups.pools.getPhotos";

        public static const FLICKR_INTERESTINGNESS:String="flickr.interestingness.getList";

        public static const FLICKR_FIND_USER:String="flickr.people.findByUsername";

        internal var _loaded:Boolean;

        internal var _galleryData:com.airtight.simpleviewer.data.GalleryData;

        internal static var _instance:com.airtight.simpleviewer.data.DataManager;
    }
}


class SingletonEnforcer extends Object
{
    public function SingletonEnforcer()
    {
        super();
        return;
    }
}