package com.airtight.simpleviewer.data 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.utils.*;
    import flash.events.*;
    import flash.net.*;
    
    public class ImageData extends flash.events.EventDispatcher
    {
        public function ImageData()
        {
            super();
            return;
        }

        public function get thumbURL():String
        {
            return _thumbURL;
        }

        internal function onCaptionError(arg1:flash.events.ErrorEvent):void
        {
            com.airtight.simpleviewer.Logger.log("ImageData: Flickr Error: " + com.airtight.simpleviewer.data.DataManager.FLICKR_PHOTO_INFO, com.airtight.simpleviewer.Logger.WARN);
            return;
        }

        public function set flickrId(arg1:String):void
        {
            _flickrId = arg1;
            return;
        }

        internal function setDownloadURL(arg1:String):void
        {
            if (!(com.airtight.simpleviewer.config.Config.instance.embedURL == null) && arg1.indexOf("http://") == -1) 
            {
                _downloadURL = com.airtight.simpleviewer.config.Config.instance.embedURL.substring(0, com.airtight.simpleviewer.config.Config.instance.embedURL.lastIndexOf("/") + 1);
                _downloadURL = _downloadURL + arg1;
            }
            else 
            {
                _downloadURL = arg1;
            }
            return;
        }

        public function get downloadURL():String
        {
            return _downloadURL;
        }

        public function get flickrId():String
        {
            return _flickrId;
        }

        public function set caption(arg1:String):void
        {
            _caption = arg1;
            return;
        }

        public function get isFlickrImage():Boolean
        {
            return _isFlickrImage;
        }

        public function get index():Number
        {
            return _index;
        }

        public function get linkURL():String
        {
            return _linkURL;
        }

        public function loadFlickrCaption():void
        {
            if (!_isFlickrImage) 
            {
                return;
            }
            var loc1:*=com.airtight.simpleviewer.data.DataManager.getflickrQueryURL(com.airtight.simpleviewer.data.DataManager.FLICKR_PHOTO_INFO);
            loc1 = loc1 + "&photo_id=" + _flickrId;
            com.airtight.utils.NetUtils.getDataFromURL(loc1, null, onGotCaption, onCaptionError);
            return;
        }

        public function get imageURL():String
        {
            return _imageURL;
        }

        public function set isFlickrImage(arg1:Boolean):void
        {
            _isFlickrImage = arg1;
            return;
        }

        public function set index(arg1:Number):void
        {
            _index = arg1;
            return;
        }

        public function set linkTarget(arg1:String):void
        {
            _linkTarget = arg1;
            return;
        }

        public function set imageURL(arg1:String):void
        {
            _imageURL = com.airtight.simpleviewer.config.Config.instance.resolveURL(arg1);
            setDownloadURL(_imageURL);
            return;
        }

        public function set linkURL(arg1:String):void
        {
            _linkURL = arg1;
            return;
        }

        public function get linkTarget():String
        {
            return _linkTarget;
        }

        public function set thumbURL(arg1:String):void
        {
            _thumbURL = com.airtight.simpleviewer.config.Config.instance.resolveURL(arg1);
            return;
        }

        public function get caption():String
        {
            return _caption;
        }

        internal function onGotCaption(arg1:flash.events.Event):void
        {
            var loc1:*=XML(flash.net.URLLoader(arg1.target).data);
            _caption = "";
            if (!(loc1 == "") && com.airtight.simpleviewer.config.Config.instance.flickrShowTitle) 
            {
                _caption = _caption + "<font face=\'" + com.airtight.simpleviewer.config.Config.instance.flickrTitleFontName + "\' size=\'" + com.airtight.simpleviewer.config.Config.instance.flickrTitleFontSize + "\' color=\'#" + com.airtight.simpleviewer.config.Config.colorToString(com.airtight.simpleviewer.config.Config.instance.flickrTitleFontColor) + "\'>" + loc1 + "</font>";
            }
            if (!(loc1 == "") && com.airtight.simpleviewer.config.Config.instance.flickrShowTitle && !(loc1 == "") && com.airtight.simpleviewer.config.Config.instance.flickrShowDescription) 
            {
                _caption = _caption + "<font face=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontName + "\' size=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontSize + "\' color=\'#" + com.airtight.simpleviewer.config.Config.colorToString(com.airtight.simpleviewer.config.Config.instance.captionFontColor) + "\'><br><br></font>";
            }
            if (!(loc1 == "") && com.airtight.simpleviewer.config.Config.instance.flickrShowDescription) 
            {
                _caption = _caption + "<font face=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontName + "\' size=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontSize + "\' color=\'#" + com.airtight.simpleviewer.config.Config.colorToString(com.airtight.simpleviewer.config.Config.instance.captionFontColor) + "\'>" + loc1 + "</font>";
            }
            if (com.airtight.simpleviewer.config.Config.instance.flickrShowPageLink) 
            {
                _caption = _caption + "<br><br><font face=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontName + "\' size=\'" + com.airtight.simpleviewer.config.Config.instance.captionFontSize + "\' color=\'#" + com.airtight.simpleviewer.config.Config.colorToString(com.airtight.simpleviewer.config.Config.instance.captionFontColor) + "\'><u><a href=\'" + linkURL + "\' target=\'_blank\'>" + com.airtight.simpleviewer.config.Config.instance.flickrPageLinkText + "</a></u></font>";
            }
            dispatchEvent(new flash.events.Event(flash.events.Event.INIT));
            return;
        }

        internal var _downloadURL:String;

        internal var _linkTarget:String;

        internal var _isFlickrImage:Boolean=false;

        internal var _index:Number;

        internal var _linkURL:String;

        internal var _thumbURL:String;

        internal var _flickrId:String;

        internal var _caption:String;

        internal var _imageURL:String;
    }
}
