package com.airtight.simpleviewer.display 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.utils.*;
    import com.greensock.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class BackgroundImage extends com.airtight.simpleviewer.display.components.Base
    {
        public function BackgroundImage(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _imageHolder = new flash.display.Sprite();
            addChild(_imageHolder);
            return;
        }

        internal function onImageLoaded(arg1:flash.events.Event):void
        {
            _loaded = true;
            if (com.airtight.simpleviewer.config.Config.instance.imageSmoothing) 
            {
                _imageBMP = new flash.display.Bitmap();
                _imageHolder.addChild(_imageBMP);
                _imageBMP.bitmapData = flash.display.Bitmap(_imageLoader.content).bitmapData;
                _imageBMP.smoothing = true;
            }
            invalidate();
            alpha = 0;
            com.greensock.TweenLite.to(this, 1, {"alpha":1});
            return;
        }

        public override function draw():void
        {
            var loc1:*=null;
            if (!_enabled || !_loaded) 
            {
                _imageHolder.graphics.clear();
                _imageHolder.graphics.beginFill(0, 0);
                _imageHolder.graphics.drawRect(0, 0, width, height);
                _imageHolder.graphics.endFill();
            }
            else 
            {
                _imageHolder.graphics.clear();
                var loc2:*=_scaleMode;
                switch (loc2) 
                {
                    case "NONE":
                    {
                        break;
                    }
                    case "FILL":
                    {
                        loc1 = org.casalib.util.RatioUtil.scaleToFill(new flash.geom.Rectangle(0, 0, _imageLoader.contentLoaderInfo.width, _imageLoader.contentLoaderInfo.width), new flash.geom.Rectangle(0, 0, width, height));
                        _imageHolder.width = loc1.width;
                        _imageHolder.height = loc1.height;
                        break;
                    }
                    case "STRETCH":
                    {
                        _imageHolder.width = width;
                        _imageHolder.height = height;
                        break;
                    }
                }
            }
            return;
        }

        internal function onImageError(arg1:flash.events.Event):void
        {
            _loaded = false;
            com.airtight.simpleviewer.Logger.log("Background Image Load Error for URL: " + com.airtight.simpleviewer.config.Config.instance.backgroundURL, com.airtight.simpleviewer.Logger.WARN);
            return;
        }

        public override function update():void
        {
            _enabled = com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.backgroundURL);
            if (!_enabled) 
            {
                return;
            }
            _scaleMode = com.airtight.simpleviewer.config.Config.instance.backgroundScale;
            _imageLoader = new flash.display.Loader();
            _imageHolder.addChild(_imageLoader);
            if (com.airtight.simpleviewer.config.Config.instance.imageSmoothing) 
            {
                _imageLoader.visible = false;
            }
            _loaded = false;
            com.airtight.utils.NetUtils.loadImage(_imageLoader, com.airtight.simpleviewer.config.Config.instance.resolveURL(com.airtight.simpleviewer.config.Config.instance.backgroundURL), onImageLoaded, onImageError);
            invalidate();
            return;
        }

        internal var _enabled:Boolean;

        internal var _imageBMP:flash.display.Bitmap;

        internal var _loaded:Boolean;

        internal var _scaleMode:String;

        internal var _imageHolder:flash.display.Sprite;

        internal var _imageLoader:flash.display.Loader;
    }
}
