package com.airtight.simpleviewer.display 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class ButtonBar extends com.airtight.simpleviewer.display.components.Base
    {
        public function ButtonBar(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _bkgndRect = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, true, 0, 0.5, false);
            _buttons = [];
            _downloadBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.DownloadButton");
            _downloadBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onDownloadClick, false, 0, true);
            _buttons.push(_downloadBtn);
            _downloadBtn.name = "DOWNLOAD_BTN";
            _openBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.OpenButton");
            _openBtn.addEventListener(com.airtight.events.UIEvent.CLICK, com.airtight.simpleviewer.Shell.instance.onOpenClick, false, 0, true);
            _buttons.push(_openBtn);
            _spacer1 = new com.airtight.simpleviewer.display.components.Icon(this, 0, 0, "assets.Spacer");
            _nextBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.NextButton");
            _nextBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onNextClick, false, 0, true);
            _buttons.push(_nextBtn);
            _playBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.AutoPlayButton");
            _playBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onAutoPlayClick, false, 0, true);
            _buttons.push(_playBtn);
            _backBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.NextButton");
            _backBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onBackClick, false, 0, true);
            _backBtn.flipped = true;
            _buttons.push(_backBtn);
            _spacer2 = new com.airtight.simpleviewer.display.components.Icon(this, 0, 0, "assets.Spacer");
            _soundBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.SoundButton");
            _soundBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onSoundClick, false, 0, true);
            _buttons.push(_soundBtn);
            _fullScreenBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.FullScreenButton");
            _fullScreenBtn.addEventListener(com.airtight.events.UIEvent.CLICK, com.airtight.simpleviewer.Shell.instance.onFullscreenClick, false, 0, true);
            _buttons.push(_fullScreenBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_fullScreenBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_soundBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_playBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_downloadBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_nextBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_backBtn);
            com.airtight.simpleviewer.ToolTipManager.instance.addTarget(_openBtn);
            _fullScreenBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.goFullscreen;
            _soundBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.playAudio;
            _playBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.playAutoPlay;
            _downloadBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.downloadImage;
            _nextBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.nextImage;
            _backBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.previousImage;
            _openBtn.tooltipText = com.airtight.simpleviewer.config.Localization.instance.openImage;
            return;
        }

        internal function onDownloadClick(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.DownloadManager.instance.downloadImage();
            return;
        }

        internal function onFullscreenChange(arg1:flash.events.Event):void
        {
            var loc1:*=org.casalib.util.StageReference.getStage().displayState == "fullScreen";
            _downloadBtn.active = !loc1;
            _openBtn.active = !loc1;
            _fullScreenBtn.tooltipText = loc1 ? com.airtight.simpleviewer.config.Localization.instance.exitFullscreen : com.airtight.simpleviewer.config.Localization.instance.goFullscreen;
            return;
        }

        public override function get width():Number
        {
            return _width * scaleX;
        }

        public override function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.imageArea.autoPlayManager.addEventListener(flash.events.Event.CHANGE, onAutoPlayChange, false, 0, true);
            com.airtight.simpleviewer.SoundManager.instance.addEventListener(flash.events.Event.CHANGE, onSoundChange, false, 0, true);
            stage.addEventListener(flash.events.Event.FULLSCREEN, onFullscreenChange, false, 0, true);
            _imageArea = com.airtight.simpleviewer.Shell.instance.imageArea;
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected, false, 0, true);
            return;
        }

        public override function draw():void
        {
            _bkgndRect.setSize(_width, _height);
            return;
        }

        internal function onBackClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, (_imageArea.imageIndex - 1)));
            return;
        }

        public override function update():void
        {
            var loc4:*=null;
            var loc5:*=0;
            var loc1:*=com.airtight.simpleviewer.config.Config.instance.showDownloadButton || com.airtight.simpleviewer.config.Config.instance.showOpenButton;
            var loc2:*=com.airtight.simpleviewer.config.Config.instance.showAutoPlayButton || com.airtight.simpleviewer.config.Config.instance.showNavButtons;
            var loc3:*=com.airtight.simpleviewer.config.Config.instance.showAudioButton || com.airtight.simpleviewer.config.Config.instance.showFullscreenButton;
            if (com.airtight.simpleviewer.config.Config.instance.buttonBarPosition == "NONE" || !loc3 && !loc2 && !loc1) 
            {
                visible = false;
                return;
            }
            visible = true;
            _bkgndRect.color = com.airtight.simpleviewer.config.Config.instance.buttonBarBackColor;
            _bkgndRect.opacity = com.airtight.simpleviewer.config.Config.instance.buttonBarBackOpacity;
            var loc7:*=0;
            var loc8:*=_buttons;
            for each (loc4 in loc8) 
            {
                loc4.colorUp = com.airtight.simpleviewer.config.Config.instance.buttonBarColor;
                loc4.colorOver = com.airtight.simpleviewer.config.Config.instance.buttonBarHoverColor;
                loc4.update();
            }
            loc5 = H_PADDING * 2;
            _downloadBtn.visible = com.airtight.simpleviewer.config.Config.instance.showDownloadButton;
            if (com.airtight.simpleviewer.config.Config.instance.showDownloadButton) 
            {
                _downloadBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _downloadBtn.width + H_PADDING;
            }
            _openBtn.visible = com.airtight.simpleviewer.config.Config.instance.showOpenButton;
            if (com.airtight.simpleviewer.config.Config.instance.showOpenButton) 
            {
                _openBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _openBtn.width + H_PADDING;
            }
            if (loc1 && (loc2 || loc3)) 
            {
                _spacer1.visible = true;
                _spacer1.move(loc5, V_PADDING);
                loc5 = loc5 + _spacer1.width + H_PADDING;
            }
            else 
            {
                _spacer1.visible = false;
            }
            _backBtn.visible = com.airtight.simpleviewer.config.Config.instance.showNavButtons;
            if (com.airtight.simpleviewer.config.Config.instance.showNavButtons) 
            {
                _backBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _backBtn.width + H_PADDING;
            }
            _playBtn.visible = com.airtight.simpleviewer.config.Config.instance.showAutoPlayButton;
            if (com.airtight.simpleviewer.config.Config.instance.showAutoPlayButton) 
            {
                _playBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _playBtn.width + H_PADDING;
            }
            _nextBtn.visible = com.airtight.simpleviewer.config.Config.instance.showNavButtons;
            if (com.airtight.simpleviewer.config.Config.instance.showNavButtons) 
            {
                _nextBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _nextBtn.width + H_PADDING;
            }
            if (loc2 && loc3) 
            {
                _spacer2.visible = true;
                _spacer2.move(loc5, V_PADDING);
                loc5 = loc5 + _spacer2.width + H_PADDING;
            }
            else 
            {
                _spacer2.visible = false;
            }
            _soundBtn.visible = com.airtight.simpleviewer.config.Config.instance.showAudioButton;
            if (com.airtight.simpleviewer.config.Config.instance.showAudioButton) 
            {
                _soundBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _soundBtn.width + H_PADDING;
            }
            _fullScreenBtn.visible = com.airtight.simpleviewer.config.Config.instance.showFullscreenButton;
            if (com.airtight.simpleviewer.config.Config.instance.showFullscreenButton) 
            {
                _fullScreenBtn.move(loc5, V_PADDING);
                loc5 = loc5 + _fullScreenBtn.width + H_PADDING;
            }
            loc5 = loc5 + H_PADDING;
            setSize(loc5, _fullScreenBtn.height + V_PADDING * 2);
            scaleX = com.airtight.simpleviewer.config.Config.instance.buttonBarScale;
            scaleY = com.airtight.simpleviewer.config.Config.instance.buttonBarScale;
            var loc6:*;
            (loc6 = new flash.geom.ColorTransform()).color = com.airtight.simpleviewer.config.Config.instance.buttonBarColor;
            _spacer1.face.transform.colorTransform = loc6;
            _spacer2.face.transform.colorTransform = loc6;
            return;
        }

        internal function onSoundChange(arg1:com.airtight.events.CustomEvent):void
        {
            _soundBtn.showFrame(arg1.data ? 2 : 1);
            _soundBtn.tooltipText = arg1.data ? com.airtight.simpleviewer.config.Localization.instance.pauseAudio : com.airtight.simpleviewer.config.Localization.instance.playAudio;
            return;
        }

        public override function get height():Number
        {
            if (com.airtight.simpleviewer.config.Config.instance.floatButtonBar) 
            {
                return 0;
            }
            return _height * scaleY;
        }

        public function onAutoPlayClick(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.Shell.instance.imageArea.autoPlayManager.toggleAutoPlay();
            return;
        }

        internal function onAutoPlayChange(arg1:com.airtight.events.CustomEvent):void
        {
            _playBtn.showFrame(arg1.data ? 2 : 1);
            _playBtn.tooltipText = arg1.data ? com.airtight.simpleviewer.config.Localization.instance.pauseAutoPlay : com.airtight.simpleviewer.config.Localization.instance.playAutoPlay;
            return;
        }

        internal function onImageSelected(arg1:com.airtight.events.CustomEvent):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.enableLooping) 
            {
                return;
            }
            _nextBtn.active = !(arg1.data == (_imageArea.imageCount - 1));
            _backBtn.active = !(arg1.data == 0);
            return;
        }

        internal function onSoundClick(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.SoundManager.instance.toggleMusic();
            return;
        }

        internal function onNextClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, _imageArea.imageIndex + 1));
            return;
        }

        public static const V_PADDING:Number=2;

        internal static const H_PADDING:Number=4;

        internal var _fullScreenBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _spacer1:com.airtight.simpleviewer.display.components.Icon;

        internal var _spacer2:com.airtight.simpleviewer.display.components.Icon;

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _playBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _buttons:Array;

        internal var _openBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _soundBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _nextBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _downloadBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _backBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _bkgndRect:com.airtight.simpleviewer.display.components.BkgndRect;
    }
}
