package com.airtight.simpleviewer.display 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import flash.display.*;
    import flash.events.*;
    import flash.external.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class StageManager extends com.airtight.simpleviewer.display.components.Base
    {
        public function StageManager(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        public function get captionIsOverlay():Boolean
        {
            return _captionIsOverlay;
        }

        public function get buttonBar():com.airtight.simpleviewer.display.ButtonBar
        {
            return _buttonBar;
        }

        internal function onBackButtonClick(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.backButtonURL)) 
            {
                org.casalib.util.NavigateUtil.openUrl(com.airtight.simpleviewer.config.Config.instance.backButtonURL, org.casalib.util.NavigateUtil.WINDOW_SELF);
            }
            else if (flash.external.ExternalInterface.available) 
            {
                flash.external.ExternalInterface.call("history.back");
            }
            return;
        }

        internal function doFixedLayout():void
        {
            _imageArea.move(com.airtight.simpleviewer.config.Config.instance.imageAreaX, com.airtight.simpleviewer.config.Config.instance.imageAreaY);
            _imageArea.setSize(com.airtight.simpleviewer.config.Config.instance.imageAreaWidth, com.airtight.simpleviewer.config.Config.instance.imageAreaHeight);
            _thumbArea.move(com.airtight.simpleviewer.config.Config.instance.thumbAreaX, com.airtight.simpleviewer.config.Config.instance.thumbAreaY);
            _caption.move(com.airtight.simpleviewer.config.Config.instance.captionX, com.airtight.simpleviewer.config.Config.instance.captionY);
            _title.move(com.airtight.simpleviewer.config.Config.instance.titleX, com.airtight.simpleviewer.config.Config.instance.titleY);
            _buttonBar.move(com.airtight.simpleviewer.config.Config.instance.buttonBarX, com.airtight.simpleviewer.config.Config.instance.buttonBarY);
            return;
        }

        internal function onImageResize(arg1:flash.events.Event):void
        {
            if (_useFixedLayout) 
            {
                return;
            }
            if (_lockTopStackToImage) 
            {
                _topStack.x = _imageArea.x + _imageArea.imageRect.x - _frameWidth;
                _topStack.y = _imageArea.y + _imageArea.imageRect.top - _stageVPadding - _topStack.height - _frameWidth;
            }
            if (_lockBottomStackToImage) 
            {
                _bottomStack.x = _imageArea.x + _imageArea.imageRect.x - _frameWidth;
                _bottomStack.y = _imageArea.y + _imageArea.imageRect.bottom + _stageVPadding + _frameWidth;
            }
            if (_lockCaptionToImage) 
            {
                _caption.width = _imageArea.imageRect.width + _frameWidth * 2;
            }
            if (_lockTitleToImage) 
            {
                _title.width = _imageArea.imageRect.width + _frameWidth * 2;
            }
            if (_lockButtonBarToImage) 
            {
                _buttonBar.alignInRect(new flash.geom.Rectangle(0, _buttonBar.y, _imageArea.imageRect.width + _frameWidth * 2, _buttonBar.height));
            }
            if (_lockThumbsToImage) 
            {
                _thumbArea.alignInRect(new flash.geom.Rectangle(0, _thumbArea.y, _imageArea.imageRect.width + _frameWidth * 2, _thumbArea.height));
            }
            _topStack.visible = true;
            _bottomStack.visible = true;
            return;
        }

        public function get lockTitleToImage():Boolean
        {
            return _lockTitleToImage;
        }

        public function get thumbArea():com.airtight.simpleviewer.display.thumbs.ThumbArea
        {
            return _thumbArea;
        }

        public function get titlePosition():String
        {
            return _titlePosition;
        }

        protected override function addChildren():void
        {
            var loc1:*=null;
            _backgroundImage = new com.airtight.simpleviewer.display.BackgroundImage(this, 0, 0);
            _galleryHolder = new com.airtight.simpleviewer.display.components.Base(this, 0, 0);
            _thumbArea = new com.airtight.simpleviewer.display.thumbs.ThumbArea(_galleryHolder, 0, 0);
            _imageArea = new com.airtight.simpleviewer.display.image.ImageArea(_galleryHolder, 0, 0);
            _title = new com.airtight.simpleviewer.display.components.Title(_galleryHolder, 0, 0);
            _caption = new com.airtight.simpleviewer.display.components.Caption(_galleryHolder, 0, 0);
            _buttonBar = new com.airtight.simpleviewer.display.ButtonBar(this, 0, 0);
            _leftStack = new com.airtight.simpleviewer.display.components.VBox(_galleryHolder, 0, 0);
            _rightStack = new com.airtight.simpleviewer.display.components.VBox(_galleryHolder, 0, 0);
            _topStack = new com.airtight.simpleviewer.display.components.VBox(_galleryHolder, 0, 0);
            _bottomStack = new com.airtight.simpleviewer.display.components.VBox(_galleryHolder, 0, 0);
            _backButton = new com.airtight.simpleviewer.display.components.TextButton(this, 0, 0, null);
            _backButton.addEventListener(com.airtight.events.UIEvent.CLICK, onBackButtonClick, false, 0, true);
            _svLogo = new com.airtight.simpleviewer.display.components.SVLogo(this, 0, 0);
            if (com.airtight.simpleviewer.config.Constants.DEBUG_MODE) 
            {
                loc1 = new com.airtight.simpleviewer.display.components.DummyButton(this, 0, 100, onUpdateClick, 65535, 1);
                loc1.setSize(60, 30);
            }
            if (!com.airtight.simpleviewer.Shell.instance.isLoadee) 
            {
                stage.addEventListener(flash.events.Event.RESIZE, onResize, false, 0, true);
            }
            onResize(null);
            return;
        }

        public override function update():void
        {
            super.update();
            _stageBorder = com.airtight.simpleviewer.config.Config.instance.stageBorder;
            _stageHPadding = com.airtight.simpleviewer.config.Config.instance.stageHPadding;
            _stageVPadding = com.airtight.simpleviewer.config.Config.instance.stageVPadding;
            _thumbPosition = com.airtight.simpleviewer.config.Config.instance.thumbPosition;
            _captionPosition = com.airtight.simpleviewer.config.Config.instance.captionPosition;
            _titlePosition = com.airtight.simpleviewer.config.Config.instance.titlePosition;
            _buttonBarPosition = com.airtight.simpleviewer.config.Config.instance.buttonBarPosition;
            if (com.airtight.simpleviewer.config.Config.instance.thumbColumns == 0 || com.airtight.simpleviewer.config.Config.instance.thumbRows == 0) 
            {
                _thumbPosition = "NONE";
            }
            _frameWidth = com.airtight.simpleviewer.config.Config.instance.frameWidth;
            if (com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "NONE") 
            {
                _frameWidth = 0;
            }
            _lockTopStackToImage = !com.airtight.simpleviewer.config.Config.instance.lockTopStack;
            _lockBottomStackToImage = !com.airtight.simpleviewer.config.Config.instance.lockBottomStack;
            _lockTitleToImage = _titlePosition == "TOP" && _lockTopStackToImage || _titlePosition == "BOTTOM" && _lockBottomStackToImage;
            _lockCaptionToImage = _captionPosition == "TOP" && _lockTopStackToImage || _captionPosition == "BOTTOM" && _lockBottomStackToImage;
            _lockButtonBarToImage = _buttonBarPosition == "TOP" && _lockTopStackToImage || _buttonBarPosition == "BOTTOM" && _lockBottomStackToImage;
            _lockThumbsToImage = _thumbPosition == "TOP" && _lockTopStackToImage || _thumbPosition == "BOTTOM" && _lockBottomStackToImage;
            _captionIsOverlay = !(_captionPosition.indexOf("OVERLAY") == -1);
            _titleIsOverlay = !(_titlePosition.indexOf("OVERLAY") == -1);
            _buttonBarIsOverlay = _buttonBarPosition == "OVERLAY";
            _buttonBar.hAlign = com.airtight.simpleviewer.config.Config.instance.buttonBarHAlign;
            _buttonBar.vAlign = com.airtight.simpleviewer.config.Config.instance.buttonBarVAlign;
            _galleryHolder.hAlign = com.airtight.simpleviewer.config.Config.instance.stageHAlign;
            _galleryHolder.vAlign = com.airtight.simpleviewer.config.Config.instance.stageVAlign;
            _thumbArea.hAlign = com.airtight.simpleviewer.config.Config.instance.thumbHAlign;
            _thumbArea.vAlign = com.airtight.simpleviewer.config.Config.instance.thumbVAlign;
            _leftStack.spacing = _stageVPadding;
            _rightStack.spacing = _stageVPadding;
            _topStack.spacing = _stageVPadding;
            _bottomStack.spacing = _stageVPadding;
            _leftStack.setSize(0, 0);
            _rightStack.setSize(0, 0);
            _topStack.setSize(0, 0);
            _bottomStack.setSize(0, 0);
            _caption.setSize(com.airtight.simpleviewer.config.Config.instance.captionWidth, com.airtight.simpleviewer.config.Config.instance.captionHeight);
            _title.setSize(com.airtight.simpleviewer.config.Config.instance.titleWidth, com.airtight.simpleviewer.config.Config.instance.titleHeight);
            _backButton.visible = com.airtight.simpleviewer.config.Config.instance.showBackButton;
            _backButton.htmlText = com.airtight.simpleviewer.config.Config.instance.backButtonText;
            _backButton.move(com.airtight.simpleviewer.config.Config.instance.backButtonX, com.airtight.simpleviewer.config.Config.instance.backButtonY);
            _backButton.fontSize = com.airtight.simpleviewer.config.Config.instance.backButtonFontSize;
            _backButton.msg.fontColor = com.airtight.simpleviewer.config.Config.instance.backButtonFontColor;
            _backButton.msg.fontFace = com.airtight.simpleviewer.config.Config.instance.backButtonFontName;
            _backButton.msg.backColor = com.airtight.simpleviewer.config.Config.instance.backButtonBackColor;
            _backButton.msg.backOpacity = com.airtight.simpleviewer.config.Config.instance.backButtonBackOpacity;
            _title.visible = !(_titlePosition == "NONE");
            _thumbArea.visible = !(_thumbPosition == "NONE");
            _caption.visible = !(_captionPosition == "NONE");
            _svLogo.visible = !com.airtight.simpleviewer.config.Constants.IS_PRO || com.airtight.simpleviewer.config.Constants.DEBUG_MODE;
            addChild(_title);
            addChild(_caption);
            addChild(_buttonBar);
            addChild(_thumbArea);
            _useFixedLayout = com.airtight.simpleviewer.config.Config.instance.useFixedLayout;
            if (_useFixedLayout) 
            {
                doFixedLayout();
                return;
            }
            if (_titlePosition == "LEFT") 
            {
                _leftStack.addChild(_title);
            }
            if (_buttonBarPosition == "LEFT") 
            {
                _leftStack.addChild(_buttonBar);
            }
            if (_thumbPosition == "LEFT") 
            {
                _leftStack.addChild(_thumbArea);
            }
            if (_captionPosition == "LEFT") 
            {
                _leftStack.addChild(_caption);
            }
            if (_titlePosition == "RIGHT") 
            {
                _rightStack.addChild(_title);
            }
            if (_buttonBarPosition == "RIGHT") 
            {
                _rightStack.addChild(_buttonBar);
            }
            if (_thumbPosition == "RIGHT") 
            {
                _rightStack.addChild(_thumbArea);
            }
            if (_captionPosition == "RIGHT") 
            {
                _rightStack.addChild(_caption);
            }
            if (_titlePosition == "TOP") 
            {
                _topStack.addChild(_title);
            }
            if (_buttonBarPosition == "TOP") 
            {
                _topStack.addChild(_buttonBar);
            }
            if (_thumbPosition == "TOP") 
            {
                _topStack.addChild(_thumbArea);
            }
            if (_captionPosition == "TOP") 
            {
                _topStack.addChild(_caption);
            }
            if (_titlePosition == "BOTTOM") 
            {
                _bottomStack.addChild(_title);
            }
            if (_buttonBarPosition == "BOTTOM") 
            {
                _bottomStack.addChild(_buttonBar);
            }
            if (_thumbPosition == "BOTTOM") 
            {
                _bottomStack.addChild(_thumbArea);
            }
            if (_captionPosition == "BOTTOM") 
            {
                _bottomStack.addChild(_caption);
            }
            if (_captionIsOverlay) 
            {
                _imageArea.overlay.overlayHolder.addChild(_caption);
            }
            if (_titleIsOverlay) 
            {
                _imageArea.overlay.overlayHolder.addChild(_title);
            }
            if (_buttonBarIsOverlay) 
            {
                _imageArea.overlay.overlayHolder.addChild(_buttonBar);
            }
            if (_lockTopStackToImage) 
            {
                _topStack.visible = false;
            }
            if (_lockBottomStackToImage) 
            {
                _bottomStack.visible = false;
            }
            return;
        }

        protected override function init():void
        {
            super.init();
            return;
        }

        public function get buttonBarPosition():String
        {
            return _buttonBarPosition;
        }

        public override function initListeners():void
        {
            _caption.initListeners();
            _title.initListeners();
            _buttonBar.initListeners();
            _imageArea.transitionManager.initListeners();
            _imageArea.overlay.initListeners();
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize, false, 0, true);
            return;
        }

        public function get buttonBarIsOverlay():Boolean
        {
            return _buttonBarIsOverlay;
        }

        public override function draw():void
        {
            super.draw();
            _backgroundImage.setSize(width, height);
            if (_useFixedLayout) 
            {
                return;
            }
            if ((_titlePosition == "LEFT" || _titlePosition == "RIGHT") && _titlePosition == _thumbPosition) 
            {
                _title.width = _thumbArea.width;
            }
            if ((_captionPosition == "LEFT" || _captionPosition == "RIGHT") && _captionPosition == _thumbPosition) 
            {
                _caption.width = _thumbArea.width;
            }
            if (_thumbPosition == "LEFT") 
            {
                _leftStack.width = _thumbArea.width;
            }
            if (_thumbPosition == "RIGHT") 
            {
                _rightStack.width = _thumbArea.width;
            }
            var loc1:*=_stageBorder * 2;
            if (_leftStack.width > 0) 
            {
                loc1 = loc1 + _leftStack.width + _stageHPadding;
            }
            if (_rightStack.width > 0) 
            {
                loc1 = loc1 + _rightStack.width + _stageHPadding;
            }
            var loc2:*=_stageBorder * 2;
            if (_buttonBarPosition == "STAGE_TOP") 
            {
                loc2 = loc2 + _buttonBar.height + _stageVPadding;
            }
            if (_topStack.height > 0) 
            {
                loc2 = loc2 + _topStack.height + _stageVPadding;
            }
            if (_bottomStack.height > 0) 
            {
                loc2 = loc2 + _bottomStack.height + _stageVPadding;
            }
            if (_svLogo.visible) 
            {
                loc2 = loc2 + _stageVPadding + _svLogo.height;
                if (com.airtight.simpleviewer.config.Config.instance.thumbNavStyle == "NUMERIC" && _thumbPosition == "BOTTOM" && !(_captionPosition == "BOTTOM")) 
                {
                    loc2 = loc2 - (_stageVPadding + _svLogo.height);
                }
            }
            if (loc1 + _imageArea.maxWidth > width) 
            {
                _imageArea.width = Math.max(width - loc1, 0);
            }
            else 
            {
                _imageArea.width = _imageArea.maxWidth;
            }
            if (loc2 + _imageArea.maxHeight > height) 
            {
                _imageArea.height = Math.max(height - loc2, 0);
            }
            else 
            {
                _imageArea.height = _imageArea.maxHeight;
            }
            _galleryHolder.width = loc1 + _imageArea.width;
            _galleryHolder.height = loc2 + _imageArea.height;
            _galleryHolder.alignInRect(new flash.geom.Rectangle(0, 0, width, height));
            var loc3:*=_stageBorder;
            if (_buttonBarPosition == "STAGE_TOP") 
            {
                _buttonBar.y = loc3;
                loc3 = loc3 + _buttonBar.height + _stageVPadding;
            }
            if (!_lockTopStackToImage) 
            {
                _topStack.y = loc3;
            }
            if (_topStack.height > 0) 
            {
                loc3 = loc3 + _topStack.height + _stageVPadding;
            }
            _imageArea.y = loc3;
            loc3 = loc3 + _imageArea.height;
            if (!_lockBottomStackToImage) 
            {
                _bottomStack.y = loc3 + _stageVPadding;
            }
            _leftStack.y = _imageArea.y;
            _leftStack.vAlign = "TOP";
            if (_thumbPosition == "LEFT") 
            {
                _leftStack.vAlign = com.airtight.simpleviewer.config.Config.instance.thumbVAlign;
            }
            _leftStack.alignInRect(new flash.geom.Rectangle(0, _imageArea.y, _leftStack.width, _imageArea.height));
            _rightStack.y = _imageArea.y;
            _rightStack.vAlign = "TOP";
            if (_thumbPosition == "RIGHT") 
            {
                _rightStack.vAlign = com.airtight.simpleviewer.config.Config.instance.thumbVAlign;
            }
            _rightStack.alignInRect(new flash.geom.Rectangle(0, _imageArea.y, _rightStack.width, _imageArea.height));
            var loc4:*=_stageBorder;
            _leftStack.x = loc4;
            if (_leftStack.width > 0) 
            {
                loc4 = loc4 + _leftStack.width + _stageHPadding;
            }
            _imageArea.x = loc4;
            loc4 = loc4 + _imageArea.width;
            _rightStack.x = loc4 + _stageHPadding;
            if (!_lockTopStackToImage) 
            {
                _topStack.x = _imageArea.x;
            }
            if (!_lockBottomStackToImage) 
            {
                _bottomStack.x = _imageArea.x;
            }
            if ((_titlePosition == "TOP" || _titlePosition == "BOTTOM") && !_lockTitleToImage) 
            {
                _title.width = _imageArea.width;
            }
            if ((_captionPosition == "TOP" || _captionPosition == "BOTTOM") && !_lockCaptionToImage) 
            {
                _caption.width = _imageArea.width;
            }
            if (_svLogo.visible) 
            {
                _svLogo.x = width - _svLogo.width - _stageBorder;
                _svLogo.y = height - _svLogo.height - _stageBorder;
            }
            if ((_thumbPosition == "TOP" || _thumbPosition == "BOTTOM") && !_lockThumbsToImage) 
            {
                _thumbArea.alignInRect(new flash.geom.Rectangle(0, _thumbArea.y, _imageArea.width, _thumbArea.height));
            }
            else if (_thumbPosition != "LEFT") 
            {
                if (_thumbPosition == "RIGHT") 
                {
                    _thumbArea.alignInRect(new flash.geom.Rectangle(0, _thumbArea.y, _rightStack.width, _thumbArea.height));
                }
            }
            else 
            {
                _thumbArea.alignInRect(new flash.geom.Rectangle(0, _thumbArea.y, _leftStack.width, _thumbArea.height));
            }
            if (_buttonBarPosition != "STAGE_TOP") 
            {
                if ((_buttonBarPosition == "TOP" || _buttonBarPosition == "BOTTOM") && !_lockButtonBarToImage) 
                {
                    _buttonBar.alignInRect(new flash.geom.Rectangle(0, _buttonBar.y, _imageArea.width, _buttonBar.height));
                }
                else if (_buttonBarPosition != "LEFT") 
                {
                    if (_buttonBarPosition == "RIGHT") 
                    {
                        _buttonBar.alignInRect(new flash.geom.Rectangle(0, _buttonBar.y, _rightStack.width, _buttonBar.height));
                    }
                }
                else 
                {
                    _buttonBar.alignInRect(new flash.geom.Rectangle(0, _buttonBar.y, _leftStack.width, _buttonBar.height));
                }
            }
            else 
            {
                _buttonBar.alignInRect(new flash.geom.Rectangle(_stageBorder, _buttonBar.y, width - _stageBorder * 2, _buttonBar.height));
            }
            return;
        }

        public function get titleIsOverlay():Boolean
        {
            return _titleIsOverlay;
        }

        public function get title():com.airtight.simpleviewer.display.components.Title
        {
            return _title;
        }

        internal function onUpdateClick(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.config.Config.instance.load();
            return;
        }

        public function get lockCaptionToImage():Boolean
        {
            return _lockCaptionToImage;
        }

        public function get caption():com.airtight.simpleviewer.display.components.Caption
        {
            return _caption;
        }

        public function get imageArea():com.airtight.simpleviewer.display.image.ImageArea
        {
            return _imageArea;
        }

        public override function dispose():void
        {
            super.dispose();
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize);
            _backButton.removeEventListener(com.airtight.events.UIEvent.CLICK, onBackButtonClick);
            if (!com.airtight.simpleviewer.Shell.instance.isLoadee) 
            {
                stage.removeEventListener(flash.events.Event.RESIZE, onResize);
            }
            thumbArea.dispose();
            imageArea.dispose();
            addChild(_caption);
            addChild(_title);
            addChild(_buttonBar);
            _backgroundImage.dispose();
            removeChild(_backgroundImage);
            removeChild(_thumbArea);
            removeChild(_imageArea);
            _title.dispose();
            removeChild(_title);
            _caption.dispose();
            removeChild(_caption);
            _buttonBar.dispose();
            removeChild(_buttonBar);
            _backButton.dispose();
            removeChild(_backButton);
            _svLogo.dispose();
            removeChild(_svLogo);
            return;
        }

        public function get captionPosition():String
        {
            return _captionPosition;
        }

        internal function onResize(arg1:flash.events.Event):void
        {
            setSize(com.airtight.simpleviewer.Shell.instance.stageWidth, com.airtight.simpleviewer.Shell.instance.stageHeight);
            return;
        }

        internal var _buttonBar:com.airtight.simpleviewer.display.ButtonBar;

        internal var _lockTopStackToImage:Boolean;

        internal var _thumbArea:com.airtight.simpleviewer.display.thumbs.ThumbArea;

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _backgroundImage:com.airtight.simpleviewer.display.BackgroundImage;

        internal var _lockButtonBarToImage:Boolean;

        internal var _topStack:com.airtight.simpleviewer.display.components.VBox;

        internal var _backButton:com.airtight.simpleviewer.display.components.TextButton;

        internal var _galleryHolder:com.airtight.simpleviewer.display.components.Base;

        internal var _thumbPosition:String;

        internal var _titlePosition:String;

        internal var _stageBorder:Number;

        internal var _lockCaptionToImage:Boolean;

        internal var _caption:com.airtight.simpleviewer.display.components.Caption;

        internal var _stageHPadding:Number;

        internal var _lockThumbsToImage:Boolean;

        internal var _buttonBarPosition:String;

        internal var _useFixedLayout:Boolean;

        internal var _bottomStack:com.airtight.simpleviewer.display.components.VBox;

        internal var _captionIsOverlay:Boolean;

        internal var _buttonBarIsOverlay:Boolean;

        internal var _svLogo:com.airtight.simpleviewer.display.components.SVLogo;

        internal var _lockTitleToImage:Boolean;

        internal var _leftStack:com.airtight.simpleviewer.display.components.VBox;

        internal var _rightStack:com.airtight.simpleviewer.display.components.VBox;

        internal var _titleIsOverlay:Boolean;

        internal var _title:com.airtight.simpleviewer.display.components.Title;

        internal var _lockBottomStackToImage:Boolean;

        internal var _captionPosition:String;

        internal var _frameWidth:Number;

        internal var _stageVPadding:Number;
    }
}
