package com.airtight.simpleviewer.display.components 
{
    import com.airtight.simpleviewer.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    
    public class Base extends flash.display.Sprite
    {
        public function Base(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super();
            move(arg2, arg3);
            if (arg1 != null) 
            {
                arg1.addChild(this);
            }
            init();
            return;
        }

        protected function addChildren():void
        {
            return;
        }

        public function set hAlign(arg1:String):void
        {
            _hAlign = arg1;
            return;
        }

        public function setSize(arg1:Number, arg2:Number):void
        {
            _width = arg1;
            _height = arg2;
            invalidate();
            return;
        }

        public function draw():void
        {
            return;
        }

        public function update():void
        {
            return;
        }

        public override function get width():Number
        {
            return _width;
        }

        public override function set height(arg1:Number):void
        {
            _height = arg1;
            invalidate();
            return;
        }

        public function initListeners():void
        {
            return;
        }

        protected function init():void
        {
            addChildren();
            com.airtight.simpleviewer.Shell.instance.addEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate, false, 0, true);
            _needsUpdate = true;
            invalidate();
            return;
        }

        public function move(arg1:Number, arg2:Number):void
        {
            x = Math.round(arg1);
            y = Math.round(arg2);
            return;
        }

        public override function set width(arg1:Number):void
        {
            _width = arg1;
            invalidate();
            return;
        }

        public function alignInRect(arg1:flash.geom.Rectangle):void
        {
            var loc1:*=_hAlign;
            switch (loc1) 
            {
                case "LEFT":
                {
                    x = arg1.left;
                    break;
                }
                case "CENTER":
                {
                    x = arg1.left + (arg1.width - width) / 2;
                    break;
                }
                case "RIGHT":
                {
                    x = arg1.right - width;
                    break;
                }
            }
            loc1 = _vAlign;
            switch (loc1) 
            {
                case "TOP":
                {
                    y = arg1.top;
                    break;
                }
                case "CENTER":
                {
                    y = arg1.top + (arg1.height - height) / 2;
                    break;
                }
                case "BOTTOM":
                {
                    y = arg1.bottom - height;
                    break;
                }
            }
            return;
        }

        public function set vAlign(arg1:String):void
        {
            _vAlign = arg1;
            return;
        }

        public function dispose():void
        {
            com.airtight.simpleviewer.Shell.instance.removeEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate);
            return;
        }

        public override function get height():Number
        {
            return _height;
        }

        public function get vAlign():String
        {
            return _vAlign;
        }

        public override function set x(arg1:Number):void
        {
            super.x = Math.round(arg1);
            return;
        }

        public override function set y(arg1:Number):void
        {
            super.y = Math.round(arg1);
            return;
        }

        internal function doUpdate(arg1:flash.events.Event):void
        {
            _needsUpdate = true;
            invalidate();
            return;
        }

        internal function onInvalidate(arg1:flash.events.Event):void
        {
            removeEventListener(flash.events.Event.ENTER_FRAME, onInvalidate);
            if (_needsUpdate) 
            {
                update();
                _needsUpdate = false;
            }
            draw();
            return;
        }

        protected function invalidate():void
        {
            addEventListener(flash.events.Event.ENTER_FRAME, onInvalidate);
            return;
        }

        public function get hAlign():String
        {
            return _hAlign;
        }

        protected var _height:Number=0;

        protected var _needsUpdate:Boolean;

        protected var _width:Number=0;

        protected var _vAlign:String;

        protected var _hAlign:String;
    }
}
