package com.airtight.simpleviewer.display.components 
{
    import com.airtight.events.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.ui.*;
    
    public class BaseButton extends com.airtight.simpleviewer.display.components.Base
    {
        public function BaseButton(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:Object=null, arg5:Number=0)
        {
            super(arg1, arg2, arg3);
            _data = arg4;
            _active = true;
            _selected = false;
            _debugColor = arg5;
            _hit.addEventListener(flash.events.MouseEvent.ROLL_OVER, onOver, false, 0, true);
            _hit.addEventListener(flash.events.MouseEvent.ROLL_OUT, onOut, false, 0, true);
            _hit.addEventListener(flash.events.MouseEvent.MOUSE_DOWN, onDown, false, 0, true);
            _hit.addEventListener(flash.events.MouseEvent.CLICK, onClick, false, 0, true);
            return;
        }

        protected override function addChildren():void
        {
            _hit = new flash.display.Sprite();
            addChild(_hit);
            return;
        }

        public function get mouseInside():Boolean
        {
            return _mouseInside;
        }

        public function get active():Boolean
        {
            return _active;
        }

        public override function draw():void
        {
            super.draw();
            _hit.graphics.clear();
            if (_debugColor != 0) 
            {
                _hit.graphics.beginFill(_debugColor, 0.5);
            }
            else 
            {
                _hit.graphics.beginFill(65280, 0);
            }
            _hit.graphics.drawRect(0, 0, _width, _height);
            _hit.graphics.endFill();
            return;
        }

        public function set active(arg1:Boolean):void
        {
            _active = arg1;
            _hit.useHandCursor = _active;
            _hit.buttonMode = _active;
            if (mouseInside) 
            {
                flash.ui.Mouse.hide();
                flash.ui.Mouse.show();
                dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.ACTIVATE, _active));
            }
            return;
        }

        public function get tooltipText():String
        {
            return _tooltipText;
        }

        protected function onOver(arg1:flash.events.Event):void
        {
            _mouseInside = true;
            if (!_active) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.OVER, _data));
            return;
        }

        protected override function init():void
        {
            super.init();
            _hit.buttonMode = true;
            _hit.useHandCursor = true;
            tabEnabled = false;
            tabChildren = false;
            _mouseInside = isMouseInside();
            return;
        }

        protected function onUp(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.UP, _data));
            stage.removeEventListener(flash.events.MouseEvent.MOUSE_UP, onUp);
            return;
        }

        public function get selected():Boolean
        {
            return _selected;
        }

        public function set tooltipText(arg1:String):void
        {
            _tooltipText = arg1;
            if (mouseInside) 
            {
                dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.OVER, _data));
            }
            return;
        }

        protected function onDown(arg1:flash.events.Event):void
        {
            if (!_active) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.DOWN, _data));
            stage.addEventListener(flash.events.MouseEvent.MOUSE_UP, onUp, false, 0, true);
            return;
        }

        public function set data(arg1:Object):void
        {
            _data = arg1;
            return;
        }

        protected function onClick(arg1:flash.events.Event):void
        {
            if (!_active) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.CLICK, _data));
            return;
        }

        public function get data():Object
        {
            return _data;
        }

        protected function onOut(arg1:flash.events.Event):void
        {
            _mouseInside = false;
            if (!_active) 
            {
                return;
            }
            dispatchEvent(new com.airtight.events.UIEvent(com.airtight.events.UIEvent.OUT, _data));
            return;
        }

        protected function isMouseInside():Boolean
        {
            var loc1:*=_hit.localToGlobal(new flash.geom.Point(mouseX, mouseY));
            return _hit.hitTestPoint(loc1.x, loc1.y);
        }

        public function set selected(arg1:Boolean):void
        {
            _selected = arg1;
            active = !_selected;
            return;
        }

        internal var _mouseInside:Boolean;

        protected var _data:Object;

        internal var _tooltipText:String;

        protected var _hit:flash.display.Sprite;

        protected var _active:Boolean;

        internal var _debugColor:Number;

        internal var _selected:Boolean;
    }
}
