package com.airtight.simpleviewer.display.components 
{
    import flash.display.*;
    
    public class BkgndRect extends com.airtight.simpleviewer.display.components.Base
    {
        public function BkgndRect(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:Boolean=false, arg5:int=0, arg6:Number=0.5, arg7:Boolean=false, arg8:Boolean=false)
        {
            _rounded = arg4;
            _color = arg5;
            _opacity = arg6;
            _hollow = arg8;
            super(arg1, arg2, arg3);
            mouseEnabled = false;
            mouseChildren = false;
            return;
        }

        protected override function addChildren():void
        {
            _background = new flash.display.Shape();
            addChild(_background);
            return;
        }

        public override function draw():void
        {
            super.draw();
            _background.graphics.clear();
            _background.graphics.beginFill(_color, _opacity);
            if (width <= 0 || isNaN(width)) 
            {
                return;
            }
            if (height <= 0 || isNaN(height)) 
            {
                return;
            }
            if (_rounded) 
            {
                _background.graphics.drawRoundRect(0, 0, width, height, _cornerRadius, _cornerRadius);
                if (_hollow) 
                {
                    _background.graphics.drawRoundRect(_thickness, _thickness, width - _thickness * 2, height - _thickness * 2, _cornerRadius, _cornerRadius);
                }
            }
            else 
            {
                _background.graphics.drawRect(0, 0, width, height);
                if (_hollow) 
                {
                    _background.graphics.drawRect(_thickness, _thickness, width - _thickness * 2, height - _thickness * 2);
                }
            }
            _background.graphics.endFill();
            return;
        }

        public function set color(arg1:int):void
        {
            _color = arg1;
            return;
        }

        public function get cornerRadius():Number
        {
            return _cornerRadius;
        }

        public function get opacity():Number
        {
            return _opacity;
        }

        public function set cornerRadius(arg1:Number):void
        {
            _cornerRadius = arg1;
            return;
        }

        public function set opacity(arg1:Number):void
        {
            _opacity = arg1;
            return;
        }

        public function set rounded(arg1:Boolean):void
        {
            _rounded = arg1;
            return;
        }

        public function set hollow(arg1:Boolean):void
        {
            _hollow = arg1;
            return;
        }

        public function set thickness(arg1:Number):void
        {
            _thickness = arg1;
            draw();
            return;
        }

        public function get rounded():Boolean
        {
            return _rounded;
        }

        public function get hollow():Boolean
        {
            return _hollow;
        }

        public function get color():int
        {
            return _color;
        }

        public function get thickness():Number
        {
            return _thickness;
        }

        internal var _opacity:Number;

        internal var _background:flash.display.Shape;

        internal var _hollow:Boolean;

        internal var _color:int;

        internal var _cornerRadius:Number=10;

        internal var _rounded:Boolean;

        internal var _thickness:Number=20;
    }
}
