package com.airtight.simpleviewer.display.components 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import com.greensock.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    
    public class Caption extends com.airtight.simpleviewer.display.components.Base
    {
        public function Caption(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _bkgnd = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, false, com.airtight.simpleviewer.config.Config.instance.captionBackColor, com.airtight.simpleviewer.config.Config.instance.captionBackOpacity);
            _bkgnd.mouseEnabled = false;
            _bkgnd.mouseChildren = false;
            _numberTF = new flash.text.TextField();
            _numberTF.embedFonts = false;
            _numberTF.multiline = false;
            _numberTF.wordWrap = false;
            _numberTF.selectable = false;
            addChild(_numberTF);
            _captionTF = new flash.text.TextField();
            _captionTF.embedFonts = false;
            _captionTF.multiline = true;
            _captionTF.wordWrap = true;
            _captionTF.selectable = false;
            addChild(_captionTF);
            return;
        }

        public override function draw():void
        {
            var loc1:*=NaN;
            _bkgnd.setSize(_width, _height);
            if (com.airtight.simpleviewer.config.Config.instance.showImageNumber) 
            {
                _captionTF.width = width - _captionPadding * 3 - _numberTF.textWidth - 5;
                _numberTF.visible = true;
            }
            else 
            {
                _captionTF.width = width - _captionPadding * 2;
                _numberTF.visible = false;
            }
            _numberTF.width = width - _captionPadding * 2;
            if (com.airtight.simpleviewer.config.Config.instance.captionPosition == "OVERLAY_BOTTOM" || com.airtight.simpleviewer.config.Config.instance.captionPosition == "OVERLAY_TOP") 
            {
                loc1 = Math.max(_captionTF.textHeight, _numberTF.textHeight);
                if (!com.airtight.simpleviewer.config.Config.instance.showImageNumber) 
                {
                    loc1 = _captionTF.textHeight;
                }
                _captionTextAreaHeight = Math.min(loc1 + _captionPadding * 2, _height);
                _captionTF.height = _captionTextAreaHeight - _captionPadding;
                _numberTF.height = _captionTextAreaHeight - _captionPadding;
                _bkgnd.setSize(width, _captionTextAreaHeight);
                if (com.airtight.simpleviewer.config.Config.instance.captionPosition == "OVERLAY_BOTTOM") 
                {
                    _bkgnd.move(0, _height - _captionTextAreaHeight);
                    _captionTF.x = _captionPadding;
                    _captionTF.y = _height - _captionTextAreaHeight + _captionPadding;
                    _numberTF.x = _captionPadding;
                    _numberTF.y = _height - _captionTextAreaHeight + _captionPadding;
                }
            }
            else 
            {
                _captionTF.height = _height - _captionPadding;
                _numberTF.height = _height - _captionPadding;
            }
            return;
        }

        public override function update():void
        {
            _captionPadding = com.airtight.simpleviewer.config.Config.instance.captionPadding;
            _bkgnd.color = com.airtight.simpleviewer.config.Config.instance.captionBackColor;
            _bkgnd.opacity = com.airtight.simpleviewer.config.Config.instance.captionBackOpacity;
            var loc1:*=new flash.text.TextFormat();
            loc1.align = String(com.airtight.simpleviewer.config.Config.instance.captionTextAlignment).toLowerCase();
            loc1.font = com.airtight.simpleviewer.config.Config.instance.captionFontName;
            loc1.size = com.airtight.simpleviewer.config.Config.instance.captionFontSize;
            loc1.color = com.airtight.simpleviewer.config.Config.instance.captionFontColor;
            loc1.leading = 3;
            _captionTF.defaultTextFormat = loc1;
            _captionTF.setTextFormat(loc1);
            _captionTF.x = _captionPadding;
            _captionTF.y = _captionPadding;
            var loc2:*=new flash.text.TextFormat();
            loc2.align = flash.text.TextFormatAlign.RIGHT;
            loc2.font = com.airtight.simpleviewer.config.Config.instance.captionFontName;
            loc2.size = com.airtight.simpleviewer.config.Config.instance.imageNumberFontSize;
            loc2.color = com.airtight.simpleviewer.config.Config.instance.captionFontColor;
            loc2.leading = 3;
            _numberTF.defaultTextFormat = loc2;
            _numberTF.setTextFormat(loc2);
            _numberTF.x = _captionPadding;
            _numberTF.y = _captionPadding;
            if (com.airtight.simpleviewer.config.Config.instance.captionDropShadow) 
            {
                _captionTF.filters = com.airtight.simpleviewer.display.components.IconButton.getFilters();
                _numberTF.filters = com.airtight.simpleviewer.display.components.IconButton.getFilters();
            }
            else 
            {
                _captionTF.filters = [];
                _numberTF.filters = [];
            }
            this.mouseEnabled = com.airtight.simpleviewer.config.Config.instance.enableCaptionLinks;
            this.mouseChildren = com.airtight.simpleviewer.config.Config.instance.enableCaptionLinks;
            var loc3:*=com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex];
            if (loc3.caption != null) 
            {
                captionText = loc3.caption;
            }
            return;
        }

        public override function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_OVER, onImageSelected, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart);
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete);
            com.airtight.simpleviewer.Shell.instance.imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected);
            com.airtight.simpleviewer.Shell.instance.thumbArea.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_OVER, onImageSelected);
            return;
        }

        internal function onFadeEnd():void
        {
            this.blendMode = flash.display.BlendMode.NORMAL;
            if (this.alpha == 0) 
            {
                this.visible = false;
            }
            return;
        }

        public function set captionText(arg1:String):void
        {
            _captionTF.htmlText = arg1;
            invalidate();
            return;
        }

        internal function onFadeStart():void
        {
            this.blendMode = flash.display.BlendMode.LAYER;
            return;
        }

        public function set numberText(arg1:String):void
        {
            _numberTF.text = arg1;
            invalidate();
            return;
        }

        internal function onTransitionComplete(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.Shell.instance.stageManager.lockCaptionToImage) 
            {
                show(true);
            }
            return;
        }

        internal function onTransitionStart(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.Shell.instance.stageManager.lockCaptionToImage) 
            {
                show(false);
            }
            return;
        }

        internal function onCaptionLoaded(arg1:flash.events.Event):void
        {
            if (arg1.target.index == com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex) 
            {
                captionText = arg1.target.caption;
                arg1.target.removeEventListener(flash.events.Event.INIT, onCaptionLoaded);
            }
            return;
        }

        public override function get height():Number
        {
            if (com.airtight.simpleviewer.config.Config.instance.floatCaption && !(com.airtight.simpleviewer.config.Config.instance.captionPosition == "OVERLAY_BOTTOM")) 
            {
                return 0;
            }
            return _height;
        }

        internal function onImageSelected(arg1:com.airtight.events.CustomEvent):void
        {
            var loc1:*=com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[arg1.data];
            if (loc1.caption == null) 
            {
                loc1.addEventListener(flash.events.Event.INIT, onCaptionLoaded, false, 0, true);
            }
            else 
            {
                captionText = loc1.caption;
            }
            numberText = arg1.data + 1 + " / " + com.airtight.simpleviewer.data.DataManager.instance.galleryData.imageCount;
            return;
        }

        internal function show(arg1:Boolean):void
        {
            if (arg1 == visible) 
            {
                return;
            }
            visible = arg1;
            if (arg1) 
            {
                this.alpha = 0;
                onFadeStart();
                com.greensock.TweenLite.to(this, 10, {"alpha":1, "useFrames":true, "onComplete":onFadeEnd});
            }
            return;
        }

        public function get captionTextAreaHeight():Number
        {
            return _captionTextAreaHeight;
        }

        internal var _captionTF:flash.text.TextField;

        internal var _numberTF:flash.text.TextField;

        internal var _captionTextAreaHeight:Number;

        internal var _captionPadding:Number;

        internal var _bkgnd:com.airtight.simpleviewer.display.components.BkgndRect;
    }
}
