package com.airtight.simpleviewer.display.components 
{
    import assets.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.utils.*;
    
    public class Icon extends com.airtight.simpleviewer.display.components.Base
    {
        public function Icon(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:String="", arg5:Boolean=false)
        {
            _clipPath = arg4;
            _loadExternal = arg5;
            _showDropShadow = true;
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            super.addChildren();
            useHandCursor = false;
            buttonMode = false;
            mouseEnabled = false;
            mouseChildren = false;
            clipPath = _clipPath;
            return;
        }

        public function set clipPath(arg1:String):void
        {
            var loc1:*=null;
            var loc2:*=null;
            _clipPath = arg1;
            if (_clip != null) 
            {
                removeChild(_clip);
            }
            _clip = new flash.display.MovieClip();
            addChild(_clip);
            if (_clipPath == null) 
            {
                return;
            }
            if (_loadExternal) 
            {
                _clipLoader = new flash.display.Loader();
                _clip.addChild(_clipLoader);
                com.airtight.utils.NetUtils.loadImage(_clipLoader, com.airtight.simpleviewer.config.Config.instance.resolveURL(_clipPath), onIconLoaded, onIconError);
                _face = _clip;
            }
            else 
            {
                loc1 = Class(flash.utils.getDefinitionByName(_clipPath));
                loc2 = new loc1();
                _clip.addChild(loc2);
                if (loc2.mcFace == null) 
                {
                    _face = _clip;
                }
                else 
                {
                    _face = loc2.mcFace;
                }
                if (loc2.mcBack == null) 
                {
                    _back = null;
                }
                else 
                {
                    _back = loc2.mcBack;
                }
                setSize(_clip.width, _clip.height);
                flipped = _flipped;
            }
            _face.stop();
            if (_showDropShadow) 
            {
                this.filters = com.airtight.simpleviewer.display.components.IconButton.getFilters();
            }
            else 
            {
                this.filters = [];
            }
            return;
        }

        internal function onIconLoaded(arg1:flash.events.Event):void
        {
            setSize(_clip.width, _clip.height);
            flipped = _flipped;
            return;
        }

        public function set backOpacity(arg1:Number):void
        {
            if (_back == null) 
            {
                return;
            }
            _back.alpha = arg1;
            return;
        }

        public function set flipped(arg1:Boolean):void
        {
            _flipped = arg1;
            _clip.scaleX = _flipped ? -1 : 1;
            return;
        }

        public function get clip():flash.display.MovieClip
        {
            return _clip;
        }

        public function get showDropShadow():Boolean
        {
            return _showDropShadow;
        }

        protected override function init():void
        {
            super.init();
            setSize(_clip.width, _clip.height);
            return;
        }

        public function set showDropShadow(arg1:Boolean):void
        {
            _showDropShadow = arg1;
            return;
        }

        public override function draw():void
        {
            super.draw();
            return;
        }

        public function get face():flash.display.MovieClip
        {
            return _face;
        }

        internal function onIconError(arg1:flash.events.Event):void
        {
            com.airtight.simpleviewer.Logger.log("IconButton Image Load Error for URL: " + _clipPath, com.airtight.simpleviewer.Logger.WARN);
            return;
        }

        public function set backColor(arg1:Number):void
        {
            if (_back == null) 
            {
                return;
            }
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = arg1;
            _back.transform.colorTransform = loc1;
            return;
        }

        internal static const TWEEN_LENGTH:Number=10;

        internal var _showDropShadow:Boolean;

        internal var _clip:flash.display.MovieClip;

        internal var _loadExternal:Boolean;

        internal var _clipPath:String;

        internal var _flipped:Boolean=false;

        internal var _back:flash.display.MovieClip;

        internal var _face:flash.display.MovieClip;

        internal static var ref3:assets.InvertedArrow;

        internal static var ref4:assets.BigArrow;

        internal static var ref6:assets.ClassicArrow;

        internal static var ref8:assets.AutoPlayButton;

        internal static var ref5:assets.ArrowSquare;

        internal static var ref7:assets.DownloadButton;

        internal static var ref9:assets.FullScreenButton;

        internal var _clipLoader:flash.display.Loader;

        internal static var ref10:assets.SoundButton;

        internal static var ref11:assets.Spacer;

        internal static var ref13:assets.NextButton;

        internal static var ref14:assets.OpenButton;

        internal static var ref15:assets.TriangleArrow;

        internal static var ref12:assets.BigPlayButtonAsset;

        internal static var ref1:assets.CircleArrow;
    }
}
