package com.airtight.simpleviewer.display.components 
{
    import com.airtight.simpleviewer.config.*;
    import com.greensock.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.geom.*;
    
    public class IconButton extends com.airtight.simpleviewer.display.components.BaseButton
    {
        public function IconButton(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:Object=null, arg5:String="", arg6:Boolean=false)
        {
            _iconPath = arg5;
            _loadExternal = arg6;
            super(arg1, arg2, arg3, arg4);
            return;
        }

        protected override function addChildren():void
        {
            super.addChildren();
            _icon = new com.airtight.simpleviewer.display.components.Icon(this, 0, 0, _iconPath, _loadExternal);
            iconPath = _iconPath;
            return;
        }

        public function get icon():com.airtight.simpleviewer.display.components.Icon
        {
            return _icon;
        }

        public function set flipped(arg1:Boolean):void
        {
            _flipped = arg1;
            _icon.flipped = _flipped;
            _icon.x = _flipped ? _icon.width : 0;
            return;
        }

        public function showFrame(arg1:int):void
        {
            _icon.face.gotoAndStop(arg1);
            return;
        }

        public override function update():void
        {
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = _colorUp;
            _face.transform.colorTransform = loc1;
            _dropShadowStrength = com.airtight.simpleviewer.config.Config.instance.dropShadowStrength;
            super.update();
            return;
        }

        public function set iconPath(arg1:String):void
        {
            _icon.clipPath = arg1;
            setSize(_icon.width, _icon.height);
            flipped = _flipped;
            if (_loadExternal) 
            {
                addEventListener(flash.events.Event.INIT, onIconLoaded, false, 0, true);
            }
            else if (_icon.face == null) 
            {
                _face = _icon;
            }
            else 
            {
                _face = _icon.face;
            }
            update();
            return;
        }

        public override function set active(arg1:Boolean):void
        {
            super.active = arg1;
            _icon.alpha = arg1 ? 1 : 0.3;
            if (!arg1) 
            {
                onOut(null);
            }
            return;
        }

        public override function get width():Number
        {
            return _icon.width;
        }

        protected override function init():void
        {
            super.init();
            setSize(_icon.width, _icon.height);
            return;
        }

        public override function draw():void
        {
            super.draw();
            return;
        }

        public function set colorUp(arg1:Number):void
        {
            _colorUp = arg1;
            return;
        }

        public function get colorOver():Number
        {
            return _colorOver;
        }

        public static function getFilters():Array
        {
            if (_dropShadowStrength == 0) 
            {
                return new Array();
            }
            return new Array(new flash.filters.GlowFilter(0, 0.7, 4, 4, _dropShadowStrength, 1), new flash.filters.DropShadowFilter(2.5, 90, 0, 0.3, 3, 3, _dropShadowStrength, 1));
        }

        protected override function onOver(arg1:flash.events.Event):void
        {
            super.onOver(arg1);
            if (!_active) 
            {
                return;
            }
            com.greensock.TweenLite.to(_face, 1, {"tint":_colorOver, "useFrames":true});
            if (_dropShadowStrength != 0) 
            {
                com.greensock.TweenMax.to(_face, 1, {"glowFilter":{"color":16777215, "alpha":0.8, "blurX":4, "blurY":4, "strength":_dropShadowStrength}, "useFrames":true});
            }
            return;
        }

        public function get face():flash.display.Sprite
        {
            return _face;
        }

        public function get colorUp():Number
        {
            return _colorUp;
        }

        
        {
            _dropShadowStrength = 1;
        }

        protected override function onUp(arg1:flash.events.Event):void
        {
            super.onUp(arg1);
            _icon.x = _flipped ? _icon.width : 0;
            _icon.y = 0;
            return;
        }

        public override function get height():Number
        {
            return _icon.height;
        }

        protected override function onDown(arg1:flash.events.Event):void
        {
            super.onDown(arg1);
            if (!_active) 
            {
                return;
            }
            _icon.x = _flipped ? _icon.width + 1 : 1;
            _icon.y = 1;
            return;
        }

        protected override function onClick(arg1:flash.events.Event):void
        {
            super.onClick(arg1);
            return;
        }

        internal function onIconLoaded(arg1:flash.events.Event):void
        {
            setSize(_icon.width, _icon.height);
            return;
        }

        public function set colorOver(arg1:Number):void
        {
            _colorOver = arg1;
            return;
        }

        protected override function onOut(arg1:flash.events.Event):void
        {
            super.onOut(arg1);
            com.greensock.TweenLite.to(_face, 1, {"tint":_colorUp, "useFrames":true});
            if (_dropShadowStrength != 0) 
            {
                com.greensock.TweenMax.to(_face, 1, {"glowFilter":{"color":16777215, "alpha":0, "blurX":3, "blurY":3, "remove":true, "strength":_dropShadowStrength}, "useFrames":true});
            }
            return;
        }

        public override function set selected(arg1:Boolean):void
        {
            super.selected = arg1;
            if (arg1) 
            {
                onOver(null);
            }
            else 
            {
                onOut(null);
            }
            return;
        }

        internal static const TWEEN_LENGTH:Number=10;

        internal var _flipped:Boolean=false;

        internal var _face:flash.display.Sprite;

        internal var _icon:com.airtight.simpleviewer.display.components.Icon;

        internal var _colorUp:Number=9671571;

        internal var _loadExternal:Boolean;

        internal var _iconPath:String;

        internal static var _dropShadowStrength:Number=1;

        internal var _colorOver:Number=16777215;
    }
}
