package com.airtight.simpleviewer.display.components 
{
    import assets.*;
    import com.airtight.simpleviewer.config.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.geom.*;
    
    public class NumericNavButton extends com.airtight.simpleviewer.display.components.BaseButton
    {
        public function NumericNavButton(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:String="", arg5:Object=null)
        {
            super(arg1, arg2, arg3, arg5);
            text = arg4;
            return;
        }

        protected override function addChildren():void
        {
            super.addChildren();
            _clip = new assets.NumericNavAsset();
            addChild(_clip);
            _clip.useHandCursor = false;
            _clip.buttonMode = false;
            _clip.mouseEnabled = false;
            _clip.mouseChildren = false;
            _clip.txtLabel.filters = [new flash.filters.GlowFilter(0, 0.7, 4, 4, com.airtight.simpleviewer.config.Config.instance.dropShadowStrength, 2)];
            _frame = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, false, 16777215, 1, false, true);
            _frame.thickness = 1;
            return;
        }

        public override function draw():void
        {
            super.draw();
            _clip.txtLabel.x = (Math.floor((_width - _clip.txtLabel.textWidth) / 2) - 1);
            _clip.mcBkgnd.width = _width;
            _frame.width = _width;
            _frame.height = BUTTON_HEIGHT;
            draw2();
            return;
        }

        public override function update():void
        {
            super.update();
            _backColor = com.airtight.simpleviewer.config.Config.instance.thumbNavBackColor;
            _frontColor = com.airtight.simpleviewer.config.Config.instance.thumbNavColor;
            _hoverColor = com.airtight.simpleviewer.config.Config.instance.thumbNavHoverColor;
            _frame.color = _frontColor;
            _clip.txtLabel.textColor = _frontColor;
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = _backColor;
            _clip.mcBkgnd.transform.colorTransform = loc1;
            _backOpacity = com.airtight.simpleviewer.config.Config.instance.thumbNavBackOpacity;
            return;
        }

        protected override function onOver(arg1:flash.events.Event):void
        {
            super.onOver(arg1);
            draw2();
            return;
        }

        public function set text(arg1:String):void
        {
            _clip.txtLabel.text = arg1;
            draw();
            return;
        }

        public override function set active(arg1:Boolean):void
        {
            super.active = arg1;
            draw2();
            return;
        }

        protected override function onClick(arg1:flash.events.Event):void
        {
            super.onClick(arg1);
            return;
        }

        public function set index(arg1:int):void
        {
            text = String(arg1 + 1);
            data = arg1;
            return;
        }

        public function get text():String
        {
            return _text;
        }

        internal function draw2():void
        {
            var loc1:*=selected || mouseInside && active;
            _clip.mcBkgnd.alpha = loc1 ? 10 * _backOpacity : 1 * _backOpacity;
            if (!selected && !active) 
            {
                _clip.mcBkgnd.alpha = 0.5 * _backOpacity;
            }
            _frame.visible = selected;
            _clip.txtLabel.textColor = loc1 ? _hoverColor : _frontColor;
            return;
        }

        public override function set selected(arg1:Boolean):void
        {
            super.selected = arg1;
            draw2();
            return;
        }

        protected override function onOut(arg1:flash.events.Event):void
        {
            super.onOut(arg1);
            draw2();
            return;
        }

        public static const BUTTON_HEIGHT:int=15;

        internal var _text:String="";

        internal var _frontColor:Number;

        internal var _backOpacity:Number;

        internal var _hoverColor:Number;

        internal var _frame:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _clip:assets.NumericNavAsset;

        internal var _backColor:Number;
    }
}
