package com.airtight.simpleviewer.display.components 
{
    import flash.display.*;
    
    public class ProgressBar extends com.airtight.simpleviewer.display.components.Base
    {
        public function ProgressBar(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        public function set maximum(arg1:Number):void
        {
            _max = arg1;
            _value = Math.min(_value, _max);
            drawProgress();
            return;
        }

        public override function draw():void
        {
            super.draw();
            _back.graphics.clear();
            _back.graphics.beginFill(_backColor, _backAlpha);
            _back.graphics.drawRect(0, 0, _width, _height);
            _back.graphics.endFill();
            _bar.graphics.clear();
            _bar.graphics.beginFill(_barColor);
            _bar.graphics.drawRect(0, 0, _width - 2, _height - 2);
            _bar.scaleX = 0;
            _bar.graphics.endFill();
            return;
        }

        protected override function addChildren():void
        {
            _back = new flash.display.Sprite();
            addChild(_back);
            _bar = new flash.display.Sprite();
            _bar.x = 1;
            _bar.y = 1;
            addChild(_bar);
            _backColor = 0;
            _backAlpha = 0.5;
            return;
        }

        public override function update():void
        {
            return;
        }

        public function get barColor():Number
        {
            return _barColor;
        }

        internal function drawProgress():void
        {
            _bar.scaleX = _value / _max;
            return;
        }

        protected override function init():void
        {
            super.init();
            setSize(106, 120);
            return;
        }

        public function set barColor(arg1:Number):void
        {
            _barColor = arg1;
            invalidate();
            return;
        }

        public function set value(arg1:Number):void
        {
            _value = Math.min(arg1, _max);
            drawProgress();
            return;
        }

        public function get maximum():Number
        {
            return _max;
        }

        public function get value():Number
        {
            return _value;
        }

        internal var _back:flash.display.Sprite;

        internal var _bar:flash.display.Sprite;

        internal var _max:Number=1;

        internal var _barColor:Number;

        internal var _value:Number=0;

        internal var _backAlpha:Number;

        internal var _backColor:Number;
    }
}
