package com.airtight.simpleviewer.display.components 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.text.*;
    import flash.utils.*;
    
    public class TextMessage extends com.airtight.simpleviewer.display.components.Base
    {
        public function TextMessage(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:String="", arg5:Number=12, arg6:Number=0, arg7:Boolean=true, arg8:Boolean=true, arg9:Boolean=true)
        {
            _fontSize = arg5;
            _fadeTime = arg6;
            _rounded = arg8;
            _autoCenter = arg9;
            super(arg1, arg2, arg3);
            if (arg7) 
            {
                show(true, arg4);
            }
            return;
        }

        protected override function addChildren():void
        {
            _bkgnd = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, _rounded);
            mouseEnabled = false;
            mouseChildren = false;
            _tf = new flash.text.TextField();
            _tf.embedFonts = false;
            _tf.multiline = false;
            _tf.wordWrap = false;
            _tf.selectable = false;
            _tf.autoSize = flash.text.TextFieldAutoSize.LEFT;
            _tf.x = PADDING_H - 2;
            _tf.y = PADDING_V;
            _tf.filters = [new flash.filters.GlowFilter(0, 0.7, 5, 5, 1, 1)];
            var loc1:*=new flash.text.TextFormat();
            loc1.align = flash.text.TextFormatAlign.CENTER;
            loc1.font = com.airtight.simpleviewer.config.Constants.DEFAULT_FONTS;
            loc1.size = _fontSize;
            loc1.color = 16777215;
            loc1.bold = true;
            _tf.defaultTextFormat = loc1;
            addChild(_tf);
            _tf.text = _text;
            return;
        }

        public function set backOpacity(arg1:Number):void
        {
            _bkgnd.opacity = arg1;
            return;
        }

        public override function draw():void
        {
            _bkgnd.setSize(_tf.textWidth + PADDING_H * 2, _tf.textHeight + PADDING_V * 2);
            _width = _bkgnd.width;
            _height = _bkgnd.height;
            if (!_autoCenter) 
            {
                return;
            }
            if (parent != com.airtight.simpleviewer.Shell.instance) 
            {
                x = (parent.width - _width) / 2;
                y = (parent.height - _height) / 2;
            }
            else 
            {
                x = (com.airtight.simpleviewer.Shell.instance.stageWidth - _width) / 2;
                y = (com.airtight.simpleviewer.Shell.instance.stageHeight - _height) / 2;
            }
            return;
        }

        protected override function init():void
        {
            super.init();
            if (_autoCenter) 
            {
                stage.addEventListener(flash.events.Event.RESIZE, onStageResize, false, 0, true);
            }
            _msgTimer = new flash.utils.Timer(_fadeTime, 1);
            if (_fadeTime != 0) 
            {
                _msgTimer.addEventListener(flash.events.TimerEvent.TIMER_COMPLETE, onHideTimerDone, false, 0, true);
            }
            return;
        }

        public function set text(arg1:String):void
        {
            if (arg1 == null) 
            {
                arg1 = "";
            }
            _tf.text = arg1;
            draw();
            return;
        }

        internal function onFadeDone():void
        {
            if (alpha == 0) 
            {
                visible = false;
            }
            return;
        }

        public function set fontFace(arg1:String):void
        {
            var loc1:*=new flash.text.TextFormat();
            loc1.font = arg1;
            _tf.setTextFormat(loc1);
            invalidate();
            return;
        }

        public function set fontSize(arg1:Number):void
        {
            var loc1:*=new flash.text.TextFormat();
            loc1.size = arg1;
            _tf.setTextFormat(loc1);
            draw();
            return;
        }

        internal function onHideTimerDone(arg1:flash.events.Event):void
        {
            show(false);
            return;
        }

        public function set fontColor(arg1:Number):void
        {
            var loc1:*=new flash.text.TextFormat();
            loc1.color = arg1;
            _tf.setTextFormat(loc1);
            invalidate();
            return;
        }

        public function get text():String
        {
            return _text;
        }

        public function set htmlText(arg1:String):void
        {
            if (arg1 == null) 
            {
                arg1 = "";
            }
            _tf.htmlText = arg1;
            draw();
            return;
        }

        public function set backColor(arg1:Number):void
        {
            _bkgnd.color = arg1;
            return;
        }

        internal function onStageResize(arg1:flash.events.Event):void
        {
            invalidate();
            return;
        }

        public function show(arg1:Boolean=true, arg2:String=""):void
        {
            if (arg1) 
            {
                text = arg2;
                visible = true;
                alpha = 0;
                _msgTimer.stop();
                _msgTimer.start();
            }
            else 
            {
                alpha = 1;
            }
            com.greensock.TweenLite.to(this, 10, {"alpha":arg1 ? 1 : 0, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone, "onComplete":onFadeDone});
            return;
        }

        public static const PADDING_V:Number=10;

        public static const PADDING_H:Number=20;

        internal var _autoCenter:Boolean;

        internal var _fadeTime:Number;

        internal var _text:String="";

        internal var _fontSize:Number;

        protected var _tf:flash.text.TextField;

        internal var _msgTimer:flash.utils.Timer;

        internal var _rounded:Boolean;

        protected var _bkgnd:com.airtight.simpleviewer.display.components.BkgndRect;
    }
}
