package com.airtight.simpleviewer.display.components 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.greensock.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    
    public class Title extends com.airtight.simpleviewer.display.components.Base
    {
        public function Title(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _holder = new flash.display.Sprite();
            addChild(_holder);
            _bkgnd = new com.airtight.simpleviewer.display.components.BkgndRect(_holder, 0, 0, false, com.airtight.simpleviewer.config.Config.instance.titleBackColor, com.airtight.simpleviewer.config.Config.instance.titleBackOpacity);
            _tf = new flash.text.TextField();
            _tf.embedFonts = false;
            _tf.selectable = false;
            _tf.multiline = true;
            _tf.wordWrap = true;
            _holder.addChild(_tf);
            return;
        }

        public override function draw():void
        {
            if (_tf.text != "") 
            {
                _tf.width = width - _titlePadding * 2;
                if (com.airtight.simpleviewer.config.Config.instance.floatTitle) 
                {
                    _height = _tf.height + _titlePadding * 2;
                    if (!(com.airtight.simpleviewer.config.Config.instance.titlePosition == "OVERLAY_BOTTOM") && !(com.airtight.simpleviewer.config.Config.instance.titlePosition == "OVERLAY_TOP")) 
                    {
                        _holder.y = -_height - com.airtight.simpleviewer.config.Config.instance.stageVPadding;
                    }
                }
                else 
                {
                    _tf.height = _height - _titlePadding;
                    _holder.y = 0;
                }
                _bkgnd.setSize(_width, _height);
            }
            else 
            {
                _height = 0;
                _tf.height = 0;
            }
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart);
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete);
            return;
        }

        internal function onFadeStart():void
        {
            this.blendMode = flash.display.BlendMode.LAYER;
            return;
        }

        public override function update():void
        {
            _titlePadding = com.airtight.simpleviewer.config.Config.instance.titlePadding;
            _bkgnd.opacity = com.airtight.simpleviewer.config.Config.instance.titleBackOpacity;
            _bkgnd.color = com.airtight.simpleviewer.config.Config.instance.titleBackColor;
            var loc1:*=new flash.text.TextFormat();
            loc1.align = String(com.airtight.simpleviewer.config.Config.instance.titleTextAlignment).toLowerCase();
            loc1.font = com.airtight.simpleviewer.config.Config.instance.titleFontName;
            loc1.size = com.airtight.simpleviewer.config.Config.instance.titleFontSize;
            loc1.color = com.airtight.simpleviewer.config.Config.instance.titleFontColor;
            _tf.defaultTextFormat = loc1;
            _tf.setTextFormat(loc1);
            var loc2:*=com.airtight.simpleviewer.config.Config.instance.galleryXML.@title;
            if (!com.airtight.simpleviewer.config.Config.isValidString(loc2)) 
            {
                loc2 = com.airtight.simpleviewer.config.Config.instance.title;
            }
            _tf.htmlText = loc2;
            _tf.x = _titlePadding;
            _tf.y = _titlePadding;
            if (com.airtight.simpleviewer.config.Config.instance.titleDropShadow) 
            {
                _tf.filters = com.airtight.simpleviewer.display.components.IconButton.getFilters();
            }
            else 
            {
                _tf.filters = [];
            }
            if (com.airtight.simpleviewer.config.Config.instance.floatTitle) 
            {
                _tf.autoSize = flash.text.TextFieldAutoSize.LEFT;
            }
            else 
            {
                _tf.autoSize = flash.text.TextFieldAutoSize.NONE;
            }
            return;
        }

        internal function onTransitionComplete(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.Shell.instance.stageManager.lockTitleToImage) 
            {
                show(true);
            }
            return;
        }

        internal function onTransitionStart(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.Shell.instance.stageManager.lockTitleToImage) 
            {
                show(false);
            }
            return;
        }

        public override function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            return;
        }

        internal function onFadeEnd():void
        {
            this.blendMode = flash.display.BlendMode.NORMAL;
            if (this.alpha == 0) 
            {
                this.visible = false;
            }
            return;
        }

        internal function show(arg1:Boolean):void
        {
            if (arg1 == visible) 
            {
                return;
            }
            visible = arg1;
            if (arg1) 
            {
                this.alpha = 0;
                onFadeStart();
                com.greensock.TweenLite.to(this, 10, {"alpha":1, "useFrames":true, "onComplete":onFadeEnd});
            }
            return;
        }

        public override function get height():Number
        {
            if (com.airtight.simpleviewer.config.Config.instance.floatTitle && !(com.airtight.simpleviewer.config.Config.instance.titlePosition == "OVERLAY_BOTTOM") && !(com.airtight.simpleviewer.config.Config.instance.titlePosition == "OVERLAY_TOP")) 
            {
                return 0;
            }
            return _height;
        }

        internal var _holder:flash.display.Sprite;

        internal var _tf:flash.text.TextField;

        internal var _bkgnd:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _titlePadding:Number;
    }
}
