package com.airtight.simpleviewer.display.image 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import flash.events.*;
    import flash.utils.*;
    
    public class AutoPlayManager extends flash.events.EventDispatcher
    {
        public function AutoPlayManager()
        {
            super();
            return;
        }

        internal function onImageLoaded(arg1:com.airtight.events.CustomEvent):void
        {
            com.airtight.simpleviewer.Shell.instance.imageArea.images[arg1.data].removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded);
            com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex = int(arg1.data);
            _timer.stop();
            _timer.start();
            return;
        }

        public function get isPlaying():Boolean
        {
            return _isPlaying;
        }

        internal function onTick(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex != (com.airtight.simpleviewer.Shell.instance.imageArea.imageCount - 1)) 
            {
                showImage(com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex + 1);
            }
            else if (com.airtight.simpleviewer.config.Config.instance.enableLooping) 
            {
                showImage(0);
            }
            else 
            {
                play(false);
            }
            _isFirstTickAfterLoad = false;
            return;
        }

        internal function showImage(arg1:int):void
        {
            var loc1:*=com.airtight.simpleviewer.Shell.instance.imageArea.images[arg1];
            if (loc1.loaded) 
            {
                com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex = arg1;
                _timer.stop();
                _timer.start();
            }
            else 
            {
                _nextImageIndex = arg1;
                _timer.stop();
                loc1.addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded, false, 0, true);
                loc1.load();
            }
            return;
        }

        public function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.addEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.USER_NAVIGATION, onUserNav, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded, false, 0, true);
            _timer = new flash.utils.Timer(com.airtight.simpleviewer.config.Config.instance.displayTime * 1000, 0);
            _playMsg = new com.airtight.simpleviewer.display.components.TextMessage(com.airtight.simpleviewer.Shell.instance.imageArea, 0, 0, "", 14, MSG_DISPLAY_TIME, false);
            _playMsg.visible = false;
            doUpdate(null);
            return;
        }

        internal function showMessage(arg1:String):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.showAutoPlayStatus) 
            {
                _playMsg.show(true, arg1);
            }
            return;
        }

        public function doUpdate(arg1:flash.events.Event):void
        {
            _timer.delay = com.airtight.simpleviewer.config.Config.instance.displayTime * 1000;
            _isPlaying = false;
            _isFirstTickAfterLoad = false;
            return;
        }

        internal function onFirstImageLoaded(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.autoPlayOnLoad) 
            {
                _isFirstTickAfterLoad = true;
                play();
            }
            return;
        }

        public function toggleAutoPlay():void
        {
            play(!_isPlaying);
            return;
        }

        internal function onUserNav(arg1:flash.events.Event):void
        {
            _isFirstTickAfterLoad = false;
            play(false);
            return;
        }

        public function play(arg1:Boolean=true):void
        {
            if (arg1 == _isPlaying) 
            {
                return;
            }
            if (arg1) 
            {
                _timer.addEventListener(flash.events.TimerEvent.TIMER, onTick, false, 0, true);
                _timer.start();
                if (com.airtight.simpleviewer.config.Config.instance.goNextOnAutoPlay && !_isFirstTickAfterLoad) 
                {
                    onTick(null);
                }
                showMessage(com.airtight.simpleviewer.config.Localization.instance.autoPlayOn);
            }
            else 
            {
                _timer.removeEventListener(flash.events.TimerEvent.TIMER, onTick);
                _timer.stop();
                showMessage(com.airtight.simpleviewer.config.Localization.instance.autoPlayOff);
            }
            _isPlaying = arg1;
            dispatchEvent(new com.airtight.events.CustomEvent(flash.events.Event.CHANGE, _isPlaying));
            return;
        }

        public function dispose():void
        {
            play(false);
            com.airtight.simpleviewer.Shell.instance.removeEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate);
            com.airtight.simpleviewer.Shell.instance.imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.USER_NAVIGATION, onUserNav);
            com.airtight.simpleviewer.Shell.instance.imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded);
            if (_timer == null) 
            {
                return;
            }
            _timer.removeEventListener(flash.events.TimerEvent.TIMER, onTick);
            _timer.stop();
            _timer = null;
            return;
        }

        internal static const MSG_DISPLAY_TIME:Number=2000;

        internal var _isPlaying:Boolean;

        internal var _timer:flash.utils.Timer;

        internal var _nextImageIndex:int;

        internal var _playMsg:com.airtight.simpleviewer.display.components.TextMessage;

        internal var _isFirstTickAfterLoad:Boolean;
    }
}
