package com.airtight.simpleviewer.display.image 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.utils.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class Image extends com.airtight.simpleviewer.display.components.Base
    {
        public function Image(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:String="", arg5:int=0)
        {
            super(arg1, arg2, arg3);
            _imageURL = arg4;
            _index = arg5;
            _showing = false;
            _useSmoothing = com.airtight.simpleviewer.config.Config.instance.imageSmoothing;
            visible = false;
            _loading = false;
            _loaded = false;
            _loadError = false;
            return;
        }

        public override function update():void
        {
            _scaleMode = com.airtight.simpleviewer.config.Config.instance.imageScaleMode;
            var loc1:*=_scaleMode == "NONE" || _scaleMode == "FILL" || com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "ROUNDED";
            _imageMask.cornerRadius = com.airtight.simpleviewer.config.Config.instance.imageCornerRadius;
            _imageMask.visible = loc1;
            _imageHolder.mask = loc1 ? _imageMask : null;
            _frameWidth = com.airtight.simpleviewer.config.Config.instance.frameWidth;
            if (com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "NONE") 
            {
                _frameWidth = 0;
            }
            _frame.color = com.airtight.simpleviewer.config.Config.instance.frameColor;
            _frame.rounded = com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "ROUNDED";
            _frame.cornerRadius = com.airtight.simpleviewer.config.Config.instance.imageCornerRadius;
            _frame.thickness = _frameWidth;
            _imageHolder.x = _frameWidth;
            _imageHolder.y = _frameWidth;
            return;
        }

        public function get loaded():Boolean
        {
            return _loaded;
        }

        public override function draw():void
        {
            if (!_loaded) 
            {
                return;
            }
            var loc1:*=new flash.geom.Rectangle(0, 0, width - _frameWidth * 2, height - _frameWidth * 2);
            var loc2:*=new flash.geom.Rectangle(0, 0, _jpgWidth, _jpgHeight);
            loc1.width = Math.max(loc1.width, 1);
            loc1.height = Math.max(loc1.height, 1);
            var loc3:*=_scaleMode;
            switch (loc3) 
            {
                case "NONE":
                {
                    break;
                }
                case "SCALE":
                {
                    if (_jpgWidth > loc1.width || _jpgHeight > loc1.height) 
                    {
                        loc2 = org.casalib.util.RatioUtil.scaleToFit(loc2, loc1);
                    }
                    break;
                }
                case "SCALE_UP":
                {
                    loc2 = org.casalib.util.RatioUtil.scaleToFit(loc2, loc1);
                    break;
                }
                case "FILL":
                {
                    loc2 = org.casalib.util.RatioUtil.scaleToFill(loc2, loc1);
                    break;
                }
                case "STRETCH":
                {
                    loc2.width = loc1.width;
                    loc2.height = loc1.height;
                    break;
                }
            }
            loc2 = alignToImageArea(loc2, loc1);
            _imageHolder.width = loc2.width;
            _imageHolder.height = loc2.height;
            _imageHolder.x = loc2.x + _frameWidth;
            _imageHolder.y = loc2.y + _frameWidth;
            if (_scaleMode == "NONE" || _scaleMode == "FILL") 
            {
                loc2.width = Math.min(loc2.width, loc1.width);
                loc2.height = Math.min(loc2.height, loc1.height);
                loc2 = alignToImageArea(loc2, loc1);
            }
            _frame.setSize(loc2.width + _frameWidth * 2, loc2.height + _frameWidth * 2);
            _frame.draw();
            _frame.move(loc2.x, loc2.y);
            loc2.x = loc2.x + _frameWidth;
            loc2.y = loc2.y + _frameWidth;
            _imageMask.setSize(loc2.width, loc2.height);
            _imageMask.move(loc2.x, loc2.y);
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, loc2));
            return;
        }

        public function set imageHolder(arg1:flash.display.Sprite):void
        {
            _imageHolder = arg1;
            return;
        }

        public function set loaded(arg1:Boolean):void
        {
            _loaded = arg1;
            return;
        }

        public function get index():int
        {
            return _index;
        }

        internal function onImageLoaded(arg1:flash.events.Event):void
        {
            _loaded = true;
            _loading = false;
            _jpgWidth = _imageLoader.contentLoaderInfo.width;
            _jpgHeight = _imageLoader.contentLoaderInfo.height;
            if (_useSmoothing) 
            {
                _imageBMP = new flash.display.Bitmap();
                _imageHolder.addChild(_imageBMP);
                _imageBMP.bitmapData = flash.display.Bitmap(_imageLoader.content).bitmapData;
                _imageBMP.smoothing = true;
            }
            if (_showing) 
            {
                resizeToImageArea();
            }
            dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_LOADED, _index));
            return;
        }

        internal function onImageProgress(arg1:flash.events.ProgressEvent):void
        {
            var loc1:*=arg1.bytesLoaded / arg1.bytesTotal;
            dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_PROGRESS, loc1));
            return;
        }

        public function get imageHolder():flash.display.Sprite
        {
            return _imageHolder;
        }

        internal function alignToImageArea(arg1:flash.geom.Rectangle, arg2:flash.geom.Rectangle):flash.geom.Rectangle
        {
            var loc1:*=arg1.clone();
            var loc2:*=com.airtight.simpleviewer.config.Config.instance.imageHAlign;
            switch (loc2) 
            {
                case "LEFT":
                {
                    loc1.x = 0;
                    break;
                }
                case "CENTER":
                {
                    loc1.x = Math.round((arg2.width - arg1.width) / 2);
                    break;
                }
                case "RIGHT":
                {
                    loc1.x = arg2.width - arg1.width;
                    break;
                }
            }
            loc2 = com.airtight.simpleviewer.config.Config.instance.imageVAlign;
            switch (loc2) 
            {
                case "TOP":
                {
                    loc1.y = 0;
                    break;
                }
                case "CENTER":
                {
                    loc1.y = Math.round((arg2.height - arg1.height) / 2);
                    break;
                }
                case "BOTTOM":
                {
                    loc1.y = arg2.height - arg1.height;
                    break;
                }
            }
            return loc1;
        }

        public override function dispose():void
        {
            super.dispose();
            unload();
            _imageHolder.removeChild(_imageLoader);
            removeChild(_imageHolder);
            return;
        }

        public function load():void
        {
            if (_loading) 
            {
                return;
            }
            if (_loaded) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_LOADED, _index));
                return;
            }
            _loaded = false;
            _loading = true;
            com.airtight.utils.NetUtils.loadImage(_imageLoader, _imageURL, onImageLoaded, onImageError, onImageProgress);
            com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[_index].loadFlickrCaption();
            return;
        }

        internal function resizeToImageArea():void
        {
            _width = com.airtight.simpleviewer.Shell.instance.imageArea.width;
            _height = com.airtight.simpleviewer.Shell.instance.imageArea.height;
            draw();
            visible = true;
            return;
        }

        public function set index(arg1:int):void
        {
            _index = arg1;
            return;
        }

        internal function onImageError(arg1:flash.events.Event):void
        {
            _loading = false;
            _loaded = false;
            com.airtight.simpleviewer.Logger.log("Image Load Error for URL: " + _imageURL, com.airtight.simpleviewer.Logger.WARN);
            _loadError = true;
            dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_ERROR, _index));
            return;
        }

        protected override function addChildren():void
        {
            _frame = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, false, com.airtight.simpleviewer.config.Config.instance.frameColor, 1, false, true);
            _imageHolder = new flash.display.Sprite();
            addChild(_imageHolder);
            _imageLoader = new flash.display.Loader();
            _imageHolder.addChild(_imageLoader);
            if (_useSmoothing) 
            {
                _imageLoader.visible = false;
            }
            _imageMask = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "ROUNDED");
            return;
        }

        public function get loadError():Boolean
        {
            return _loadError;
        }

        public function show(arg1:Boolean=true):void
        {
            _showing = arg1;
            if (arg1) 
            {
                if (_loaded) 
                {
                    resizeToImageArea();
                }
                else 
                {
                    load();
                }
            }
            else 
            {
                visible = false;
            }
            return;
        }

        public function unload():void
        {
            var loc1:*;
            if (_showing) 
            {
                return;
            }
            if (!_loaded && !_loading) 
            {
                return;
            }
            try 
            {
                if (_loading) 
                {
                    _imageLoader.close();
                }
            }
            catch (e:Error)
            {
                com.airtight.simpleviewer.Logger.log("Image.unload: Unable to close loader: " + _index, com.airtight.simpleviewer.Logger.DEBUG);
            }
            _imageLoader.unload();
            if (_useSmoothing && _loaded) 
            {
                try 
                {
                    _imageBMP.bitmapData.dispose();
                }
                catch (e:Error)
                {
                    com.airtight.simpleviewer.Logger.log("Image.unload: Unable to dispose bitmap: " + _index, com.airtight.simpleviewer.Logger.DEBUG);
                }
                _imageBMP = null;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_UNLOADED, _index));
            _loaded = false;
            _loading = false;
            return;
        }

        public static const IMAGE_PROGRESS:String="imageProgress";

        public static const IMAGE_HIDE_DONE:String="imageHideDone";

        public static const IMAGE_ERROR:String="imageError";

        public static const IMAGE_LOADED:String="imageLoaded";

        public static const IMAGE_UNLOADED:String="imageUnloaded";

        internal var _loading:Boolean;

        internal var _showing:Boolean;

        internal var _imageBMP:flash.display.Bitmap;

        internal var _scaleMode:String;

        internal var _imageLoader:flash.display.Loader;

        internal var _useSmoothing:Boolean;

        internal var _loaded:Boolean;

        internal var _imageHolder:flash.display.Sprite;

        internal var _loadError:Boolean;

        internal var _jpgWidth:int;

        internal var _frame:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _imageURL:String;

        internal var _frameWidth:Number;

        internal var _imageMask:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _jpgHeight:int;

        internal var _index:int;
    }
}
