package com.airtight.simpleviewer.display.image 
{
    import assets.*;
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.geom.*;
    
    public class ImageArea extends com.airtight.simpleviewer.display.components.Base
    {
        public function ImageArea(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            _transitionManager = new com.airtight.simpleviewer.display.image.TransitionManager();
            _imageRect = new flash.geom.Rectangle();
            return;
        }

        internal function isValidIndex(arg1:int):Boolean
        {
            if (arg1 < 0 || arg1 >= _imageCount) 
            {
                return false;
            }
            return true;
        }

        public function get overlay():com.airtight.simpleviewer.display.image.Overlay
        {
            return _overlay;
        }

        internal function onImageProgress(arg1:com.airtight.events.CustomEvent):void
        {
            _progress.value = Number(arg1.data);
            return;
        }

        public override function draw():void
        {
            _bkgndRect.setSize(width, height);
            if (_images[_imageIndex] == null) 
            {
                return;
            }
            _images[_imageIndex].setSize(width, height);
            _mask.setSize(width, height + 10);
            _progHolder.x = Math.round(width / 2);
            _progHolder.y = Math.round(height / 2);
            _imageNavigation.setSize(width, height);
            _bigPlayBtn.move((width - _bigPlayBtn.width) / 2, (height - _bigPlayBtn.height) / 2);
            return;
        }

        internal function onUserNavClick(arg1:com.airtight.events.CustomEvent):void
        {
            imageIndex = int(arg1.data);
            dispatchEvent(new com.airtight.events.CustomEvent(USER_NAVIGATION, imageIndex));
            _bigPlayBtn.visible = false;
            return;
        }

        public function get imageRect():flash.geom.Rectangle
        {
            return _imageRect;
        }

        protected override function addChildren():void
        {
            _bkgndRect = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, false, 0);
            _imageHolder = new flash.display.Sprite();
            addChild(_imageHolder);
            _imageHolder.mouseEnabled = false;
            _imageHolder.mouseChildren = false;
            _progHolder = new flash.display.Sprite();
            addChild(_progHolder);
            _progress = new com.airtight.simpleviewer.display.components.ProgressBar(_progHolder, 0, 0);
            _progress.setSize(106, 12);
            _progress.move((-_progress.width) / 2, (-_progress.height) / 2);
            _errorIcon = new assets.ErrorIcon();
            _progHolder.addChild(_errorIcon);
            _errorIcon.visible = false;
            _errorIcon.filters = com.airtight.simpleviewer.display.components.IconButton.getFilters();
            _mask = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0);
            _mask.visible = false;
            _imageNavigation = new com.airtight.simpleviewer.display.image.ImageNavigation(this, 0, 0);
            _overlay = new com.airtight.simpleviewer.display.image.Overlay(this, 0, 0);
            _watermark = new com.airtight.simpleviewer.display.image.Watermark(this, 0, 0);
            _autoPlayManager = new com.airtight.simpleviewer.display.image.AutoPlayManager();
            _bigPlayBtn = new com.airtight.simpleviewer.display.components.BigPlayButton(this, 0, 0, 0, "assets.BigPlayButtonAsset", false);
            _bigPlayBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onAutoPlayClick, false, 0, true);
            _autoPlayManager.addEventListener(flash.events.Event.CHANGE, onAutoPlayChange, false, 0, true);
            _bigPlayBtn.alpha = 0;
            return;
        }

        internal function onImageLoaded(arg1:com.airtight.events.CustomEvent):void
        {
            loadNextImageInQueue();
            if (int(arg1.data) == _imageIndex) 
            {
                _progress.visible = false;
            }
            return;
        }

        public function createImages():void
        {
            var loc2:*=null;
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onNavigateToThumbPage, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick, false, 0, true);
            _imageNavigation.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.stageManager.buttonBar.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick, false, 0, true);
            if (com.airtight.simpleviewer.config.Constants.IS_PRO) 
            {
                com.airtight.simpleviewer.Shell.instance.api.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick, false, 0, true);
            }
            _imageNavigation.initListeners();
            _watermark.initListeners();
            _transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            _imageCount = com.airtight.simpleviewer.data.DataManager.instance.galleryData.imageCount;
            _imagePreloading = com.airtight.simpleviewer.config.Config.instance.imagePreloading;
            _loadQueue = [];
            _images = [];
            var loc1:*=0;
            while (loc1 < _imageCount) 
            {
                loc2 = new com.airtight.simpleviewer.display.image.Image(_imageHolder, 0, 0, com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[loc1].imageURL, loc1);
                loc2.addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded, false, 0, true);
                loc2.addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_ERROR, onImageLoadError, false, 0, true);
                _images.push(loc2);
                ++loc1;
            }
            return;
        }

        public function get currentImage():com.airtight.simpleviewer.display.image.Image
        {
            return _images[_imageIndex];
        }

        internal function onImageLoadError(arg1:com.airtight.events.CustomEvent):void
        {
            if (int(arg1.data) == _imageIndex) 
            {
                _progress.visible = false;
                _errorIcon.visible = true;
                _errorIcon.alpha = 0;
                com.greensock.TweenLite.to(_errorIcon, 10, {"alpha":1, "ease":com.greensock.easing.Linear.easeNone, "useFrames":true});
            }
            loadNextImageInQueue();
            return;
        }

        public function useMask(arg1:Boolean):void
        {
            this.mask = arg1 ? _mask : null;
            return;
        }

        internal function set loadQueue(arg1:Array):void
        {
            _loadQueue = arg1.concat();
            loadNextImageInQueue();
            return;
        }

        public function get imageHolder():flash.display.Sprite
        {
            return _imageHolder;
        }

        public function get bigPlayBtn():com.airtight.simpleviewer.display.components.IconButton
        {
            return _bigPlayBtn;
        }

        public function getImage(arg1:int):com.airtight.simpleviewer.display.image.Image
        {
            return _images[arg1];
        }

        public function get transitionManager():com.airtight.simpleviewer.display.image.TransitionManager
        {
            return _transitionManager;
        }

        internal function onTransitionComplete(arg1:com.airtight.events.CustomEvent):void
        {
            var loc1:*=int(arg1.data);
            if (_imagePreloading == "NONE" || _imagePreloading == "NEXT") 
            {
                if (!(loc1 == imageIndex) && !(loc1 == imageIndex + 1) && isValidIndex(loc1)) 
                {
                    getImage(loc1).unload();
                }
            }
            if (_imagePreloading == "NEXT") 
            {
                ++loc1;
                if (!(loc1 == imageIndex) && !(loc1 == imageIndex + 1) && isValidIndex(loc1)) 
                {
                    getImage(loc1).unload();
                }
            }
            useMask(false);
            return;
        }

        public function get autoPlayManager():com.airtight.simpleviewer.display.image.AutoPlayManager
        {
            return _autoPlayManager;
        }

        public function get maxHeight():Number
        {
            return _maxHeight;
        }

        public function set imageIndex(arg1:int):void
        {
            var loc2:*=null;
            if (_enableLooping) 
            {
                if (arg1 < 0) 
                {
                    arg1 = (_imageCount - 1);
                }
                else if (arg1 >= _imageCount) 
                {
                    arg1 = 0;
                }
            }
            else if (arg1 < 0 || arg1 >= _imageCount) 
            {
                return;
            }
            _images[_imageIndex].removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_PROGRESS, onImageProgress);
            _images[_imageIndex].removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize);
            if (_images[arg1].loaded) 
            {
                _progress.visible = false;
            }
            else 
            {
                _images[arg1].addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_PROGRESS, onImageProgress, false, 0, true);
                _progress.visible = true;
                _progress.alpha = 0;
                _progress.value = 0;
                com.greensock.TweenLite.to(_progress, 10, {"alpha":1, "ease":com.greensock.easing.Linear.easeNone, "useFrames":true});
            }
            _errorIcon.visible = false;
            _images[arg1].load();
            var loc1:*=_imageIndex;
            _imageIndex = arg1;
            _images[arg1].addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize, false, 0, true);
            _transitionManager.doTransition(_images[loc1], _images[arg1]);
            dispatchEvent(new com.airtight.events.CustomEvent(IMAGE_SELECTED, arg1));
            if (_imagePreloading != "NONE") 
            {
                loc2 = _loadQueue.concat(arg1 + 1);
                loadQueue = loc2;
            }
            useMask(_transitionManager.transitionType == "SLIDE");
            return;
        }

        public function onAutoPlayClick(arg1:flash.events.Event):void
        {
            _autoPlayManager.play();
            return;
        }

        internal function loadNextImageInQueue():void
        {
            var loc1:*=0;
            if (_loadQueue.length > 0) 
            {
                loc1 = _loadQueue.pop();
                if (isValidIndex(loc1)) 
                {
                    getImage(loc1).load();
                }
            }
            return;
        }

        internal function onFirstImageLoaded(arg1:flash.events.Event):void
        {
            com.greensock.TweenLite.to(_bigPlayBtn, 15, {"alpha":1, "useFrames":true});
            dispatchEvent(new flash.events.Event(FIRST_IMAGE_LOADED));
            getImage(imageIndex).removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onFirstImageLoaded);
            return;
        }

        public function get imageIndex():int
        {
            return _imageIndex;
        }

        public function get imageCount():int
        {
            return _imageCount;
        }

        internal function onImageResize(arg1:com.airtight.events.CustomEvent):void
        {
            _imageRect = flash.geom.Rectangle(arg1.data);
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, arg1.data));
            return;
        }

        public function onNavigateToThumbPage(arg1:com.airtight.events.CustomEvent):void
        {
            var loc1:*=0;
            if (_imagePreloading == "PAGE") 
            {
                loc1 = 0;
                while (loc1 < _imageCount) 
                {
                    if (loc1 != _imageIndex) 
                    {
                        _images[loc1].unload();
                    }
                    ++loc1;
                }
            }
            if (_imagePreloading == "PAGE") 
            {
                loadQueue = arg1.data as Array;
            }
            return;
        }

        public function get images():Array
        {
            return _images;
        }

        public override function dispose():void
        {
            var i:int;
            var img:com.airtight.simpleviewer.display.image.Image;

            var loc1:*;
            i = 0;
            img = null;
            try 
            {
                super.dispose();
                _autoPlayManager.dispose();
                _transitionManager.dispose();
                _bigPlayBtn.removeEventListener(com.airtight.events.UIEvent.CLICK, onAutoPlayClick);
                _autoPlayManager.removeEventListener(flash.events.Event.CHANGE, onAutoPlayChange);
                _bigPlayBtn.dispose();
                removeChild(_bigPlayBtn);
                _bkgndRect.dispose();
                removeChild(_bkgndRect);
                _progress.dispose();
                _progHolder.removeChild(_progress);
                _progHolder.removeChild(_errorIcon);
                removeChild(_progHolder);
                _mask.dispose();
                removeChild(_mask);
                _watermark.dispose();
                removeChild(_watermark);
                _imageNavigation.dispose();
                removeChild(_imageNavigation);
                _overlay.dispose();
                removeChild(_overlay);
                com.airtight.simpleviewer.Shell.instance.thumbArea.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onNavigateToThumbPage);
                com.airtight.simpleviewer.Shell.instance.thumbArea.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick);
                _imageNavigation.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick);
                com.airtight.simpleviewer.Shell.instance.stageManager.buttonBar.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick);
                _transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete);
                if (com.airtight.simpleviewer.config.Constants.IS_PRO) 
                {
                    com.airtight.simpleviewer.Shell.instance.api.removeEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, onUserNavClick);
                }
                i = 0;
                while (i < _imageCount) 
                {
                    img = getImage(i);
                    img.removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded);
                    img.removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_ERROR, onImageLoadError);
                    img.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize);
                    getImage(i).dispose();
                    _imageHolder.removeChild(img);
                    ++i;
                }
                _images = [];
                removeChild(_imageHolder);
            }
            catch (e:Error)
            {
            };
            return;
        }

        public override function update():void
        {
            var loc1:*=com.airtight.simpleviewer.config.Config.instance.frameWidth;
            if (com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "NONE") 
            {
                loc1 = 0;
            }
            _maxWidth = loc1 * 2 + com.airtight.simpleviewer.config.Config.instance.maxImageWidth;
            _maxHeight = loc1 * 2 + com.airtight.simpleviewer.config.Config.instance.maxImageHeight;
            height = _maxHeight;
            width = _maxWidth;
            if (com.airtight.simpleviewer.config.Config.instance.imageDropShadow) 
            {
                _imageHolder.filters = [new flash.filters.DropShadowFilter(4, 45, 0, 0.4, 4, 4, com.airtight.simpleviewer.config.Config.instance.dropShadowStrength, 1)];
            }
            else 
            {
                _imageHolder.filters = [];
            }
            _progress.barColor = com.airtight.simpleviewer.config.Config.instance.frameColor;
            var loc2:*=new flash.geom.ColorTransform();
            loc2.color = com.airtight.simpleviewer.config.Config.instance.frameColor;
            _errorIcon.mcFace.transform.colorTransform = loc2;
            if (com.airtight.simpleviewer.config.Config.instance.imageClickMode == "NONE" || !(com.airtight.simpleviewer.config.Config.instance.imageClickMode == "NAVIGATE")) 
            {
                _imageNavigation.visible = false;
            }
            else 
            {
                _imageNavigation.visible = true;
            }
            _enableLooping = com.airtight.simpleviewer.config.Config.instance.enableLooping;
            _bigPlayBtn.visible = com.airtight.simpleviewer.config.Config.instance.showBigPlayButton;
            _bkgndRect.color = com.airtight.simpleviewer.config.Config.instance.imageBackColor;
            _bkgndRect.opacity = com.airtight.simpleviewer.config.Config.instance.imageBackOpacity;
            return;
        }

        public function set imageHolder(arg1:flash.display.Sprite):void
        {
            _imageHolder = arg1;
            return;
        }

        public function get maxWidth():Number
        {
            return _maxWidth;
        }

        public function onAutoPlayChange(arg1:flash.events.Event):void
        {
            _bigPlayBtn.visible = false;
            return;
        }

        public function startTheShow():void
        {
            var loc1:*=null;
            var loc2:*=0;
            if (com.airtight.simpleviewer.config.Config.instance.firstImageIndex > 0) 
            {
                imageIndex = com.airtight.simpleviewer.config.Config.instance.firstImageIndex;
            }
            else 
            {
                imageIndex = 0;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(USER_NAVIGATION, imageIndex));
            getImage(imageIndex).addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onFirstImageLoaded, false, 0, true);
            _autoPlayManager.initListeners();
            if (_imagePreloading == "ALL") 
            {
                loc1 = [];
                loc2 = _imageCount;
                while (loc2 >= 0) 
                {
                    loc1.push(loc2);
                    --loc2;
                }
                loadQueue = loc1;
            }
            return;
        }

        public static const IMAGE_SELECTED:String="imageSelected";

        public static const IMAGE_RESIZE:String="imageResize";

        public static const FIRST_IMAGE_LOADED:String="firstImageLoaded";

        public static const USER_NAVIGATION:String="userNavigation";

        internal var _bigPlayBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _progress:com.airtight.simpleviewer.display.components.ProgressBar;

        internal var _imageNavigation:com.airtight.simpleviewer.display.image.ImageNavigation;

        internal var _imageCount:int;

        internal var _images:Array;

        internal var _transitionManager:com.airtight.simpleviewer.display.image.TransitionManager;

        internal var _maxWidth:Number;

        internal var _errorIcon:assets.ErrorIcon;

        internal var _imageHolder:flash.display.Sprite;

        internal var _maxHeight:Number;

        internal var _imagePreloading:String;

        internal var _enableLooping:Boolean;

        internal var _progHolder:flash.display.Sprite;

        internal var _autoPlayManager:com.airtight.simpleviewer.display.image.AutoPlayManager;

        internal var _loadQueue:Array;

        internal var _watermark:com.airtight.simpleviewer.display.image.Watermark;

        internal var _imageIndex:int;

        internal var _overlay:com.airtight.simpleviewer.display.image.Overlay;

        internal var _imageRect:flash.geom.Rectangle;

        internal var _bkgndRect:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _mask:com.airtight.simpleviewer.display.components.BkgndRect;
    }
}
