package com.airtight.simpleviewer.display.image 
{
    import assets.*;
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    
    public class ImageNavigation extends com.airtight.simpleviewer.display.components.Base
    {
        public function ImageNavigation(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        internal function onNextOut(arg1:flash.events.MouseEvent):void
        {
            showNav(false, false, true);
            return;
        }

        internal function onBackOut(arg1:flash.events.MouseEvent):void
        {
            showNav(false, false, false);
            return;
        }

        public override function draw():void
        {
            _nextBtn.setSize(width / 2, height);
            _nextBtn.move(width / 2, 0);
            _backBtn.setSize(width / 2, height);
            if (!_useCursor) 
            {
                _nextIcon.move(_imageArea.imageRect.right - _nextIcon.width * _iconScale - _iconPadding, _imageArea.imageRect.top + (_imageArea.imageRect.height - _nextIcon.height * _iconScale) / 2);
                _backIcon.move(_imageArea.imageRect.left + _backIcon.width * _iconScale + _iconPadding, _imageArea.imageRect.top + (_imageArea.imageRect.height - _backIcon.height * _iconScale) / 2);
            }
            return;
        }

        internal function onImageResize(arg1:com.airtight.events.CustomEvent):void
        {
            invalidate();
            return;
        }

        public override function initListeners():void
        {
            _stageManager = com.airtight.simpleviewer.Shell.instance.stageManager;
            _imageArea = com.airtight.simpleviewer.Shell.instance.imageArea;
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected, false, 0, true);
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded, false, 0, true);
            stage.addEventListener(flash.events.Event.FULLSCREEN, onFullscreenChange, false, 0, true);
            _cursor = new assets.NextCursor();
            com.airtight.simpleviewer.Shell.instance.stageManager.addChild(_cursor);
            return;
        }

        internal function onIconResize(arg1:flash.events.Event):void
        {
            invalidate();
            return;
        }

        public function onMouseLeave(arg1:flash.events.Event):void
        {
            _cursor.visible = false;
            showNav(false, true, true);
            showNav(false, true, false);
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            _backBtn.removeEventListener(com.airtight.events.UIEvent.OVER, onBackOver);
            _backBtn.removeEventListener(com.airtight.events.UIEvent.OUT, onBackOut);
            _backBtn.removeEventListener(com.airtight.events.UIEvent.ACTIVATE, onActivate);
            _backBtn.removeEventListener(com.airtight.events.UIEvent.CLICK, onBackClick);
            _nextBtn.removeEventListener(com.airtight.events.UIEvent.OVER, onNextOver);
            _nextBtn.removeEventListener(com.airtight.events.UIEvent.OUT, onNextOut);
            _nextBtn.removeEventListener(com.airtight.events.UIEvent.ACTIVATE, onActivate);
            _nextBtn.removeEventListener(com.airtight.events.UIEvent.CLICK, onNextClick);
            stage.removeEventListener(flash.events.Event.MOUSE_LEAVE, onMouseLeave);
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected);
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize);
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded);
            stage.removeEventListener(flash.events.Event.FULLSCREEN, onFullscreenChange);
            _imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart);
            _imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete);
            if (_useCursor) 
            {
                removeEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove);
            }
            _nextIcon.dispose();
            _backIcon.dispose();
            _iconHolder.removeChild(_nextIcon);
            _iconHolder.removeChild(_backIcon);
            removeChild(_iconHolder);
            _backBtn.dispose();
            removeChild(_backBtn);
            _nextBtn.dispose();
            removeChild(_nextBtn);
            return;
        }

        internal function onBackOver(arg1:flash.events.MouseEvent):void
        {
            showNav(true, false, false);
            return;
        }

        internal function onNextOver(arg1:flash.events.MouseEvent):void
        {
            showNav(true, false, true);
            return;
        }

        internal function showNav(arg1:Boolean, arg2:Boolean=false, arg3:Boolean=true, arg4:Boolean=false):void
        {
            if (_showImageNav == "NEVER" && !arg4) 
            {
                return;
            }
            if (_useCursor) 
            {
                _cursor.visible = arg1;
                _cursor.scaleX = arg3 ? 1 : -1;
                return;
            }
            if (!(_showImageNav == "HOVER") && !arg4) 
            {
                return;
            }
            var loc1:*=arg3 ? _nextIcon : _backIcon;
            if (arg2) 
            {
                loc1.alpha = 1;
                loc1.visible = arg1;
                com.greensock.TweenLite.killTweensOf(loc1);
                return;
            }
            loc1.visible = true;
            if (arg1) 
            {
                loc1.alpha = 0;
                com.greensock.TweenLite.killTweensOf(loc1);
                com.greensock.TweenLite.to(loc1, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone});
            }
            else 
            {
                com.greensock.TweenLite.killTweensOf(loc1);
                com.greensock.TweenLite.to(loc1, _transFrames, {"alpha":0, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone});
            }
            invalidate();
            return;
        }

        internal function onFirstImageLoaded(arg1:flash.events.Event):void
        {
            if (!_fadeOverlayWithImage) 
            {
                _iconHolder.visible = true;
                com.greensock.TweenLite.to(_iconHolder, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone});
            }
            return;
        }

        internal function onTransitionStart(arg1:flash.events.Event):void
        {
            if (!_fadeOverlayWithImage) 
            {
                return;
            }
            _iconHolder.visible = false;
            return;
        }

        internal function onNextClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, _imageArea.imageIndex + 1));
            return;
        }

        internal function onActivate(arg1:com.airtight.events.UIEvent):void
        {
            var loc1:*=arg1.target == _nextBtn;
            if (arg1.data) 
            {
                if (loc1) 
                {
                    onNextOver(null);
                }
                else 
                {
                    onBackOver(null);
                }
            }
            else if (loc1) 
            {
                onNextOut(null);
            }
            else 
            {
                onBackOut(null);
            }
            return;
        }

        internal function onTransitionComplete(arg1:flash.events.Event):void
        {
            if (!_fadeOverlayWithImage) 
            {
                return;
            }
            _iconHolder.visible = true;
            _iconHolder.alpha = 0;
            com.greensock.TweenLite.to(_iconHolder, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone});
            if (_firstTime) 
            {
                _backBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onBackClick, false, 0, true);
                _nextBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onNextClick, false, 0, true);
                _firstTime = false;
            }
            return;
        }

        internal function onBackClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_CLICK, (_imageArea.imageIndex - 1)));
            return;
        }

        internal function onMouseMove(arg1:flash.events.MouseEvent):void
        {
            var loc1:*=_stageManager.globalToLocal(new flash.geom.Point(arg1.stageX, arg1.stageY));
            _cursor.x = loc1.x;
            _cursor.y = loc1.y;
            arg1.updateAfterEvent();
            return;
        }

        internal function onImageSelected(arg1:com.airtight.events.CustomEvent):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.enableLooping) 
            {
                return;
            }
            _nextBtn.active = !(arg1.data == (_imageArea.imageCount - 1));
            _backBtn.active = !(arg1.data == 0);
            invalidate();
            if (_showImageNav == "ALWAYS") 
            {
                showNav(!(arg1.data == (_imageArea.imageCount - 1)), false, true, true);
                showNav(!(arg1.data == 0), false, false, true);
            }
            return;
        }

        protected override function addChildren():void
        {
            _iconHolder = new flash.display.Sprite();
            addChild(_iconHolder);
            _nextIcon = new com.airtight.simpleviewer.display.components.Icon(_iconHolder, 0, 0, null);
            _nextIcon.mouseEnabled = false;
            _nextIcon.mouseChildren = false;
            _nextIcon.buttonMode = false;
            _nextIcon.visible = false;
            _backIcon = new com.airtight.simpleviewer.display.components.Icon(_iconHolder, 0, 0, null);
            _backIcon.mouseEnabled = false;
            _backIcon.mouseChildren = false;
            _backIcon.buttonMode = false;
            _backIcon.visible = false;
            _backIcon.flipped = true;
            _backBtn = new com.airtight.simpleviewer.display.components.BaseButton(this, 0, 0);
            _backBtn.addEventListener(com.airtight.events.UIEvent.OVER, onBackOver, false, 0, true);
            _backBtn.addEventListener(com.airtight.events.UIEvent.OUT, onBackOut, false, 0, true);
            _backBtn.addEventListener(com.airtight.events.UIEvent.ACTIVATE, onActivate, false, 0, true);
            _nextBtn = new com.airtight.simpleviewer.display.components.BaseButton(this, 0, 0);
            _nextBtn.addEventListener(com.airtight.events.UIEvent.OVER, onNextOver, false, 0, true);
            _nextBtn.addEventListener(com.airtight.events.UIEvent.OUT, onNextOut, false, 0, true);
            _nextBtn.addEventListener(com.airtight.events.UIEvent.ACTIVATE, onActivate, false, 0, true);
            stage.addEventListener(flash.events.Event.MOUSE_LEAVE, onMouseLeave, false, 0, true);
            _iconHolder.visible = false;
            _iconHolder.alpha = 0;
            _firstTime = true;
            return;
        }

        public override function update():void
        {
            var loc1:*=null;
            var loc2:*=null;
            _showImageNav = com.airtight.simpleviewer.config.Config.instance.showImageNav;
            _useCursor = com.airtight.simpleviewer.config.Config.instance.imageNavStyle == "CURSOR";
            _fadeOverlayWithImage = com.airtight.simpleviewer.config.Config.instance.hideOverlayOnTransition;
            _iconPadding = com.airtight.simpleviewer.config.Config.instance.imageNavPadding;
            if (_useCursor) 
            {
                addEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove, false, 0, true);
            }
            else 
            {
                removeEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove);
                var loc3:*=com.airtight.simpleviewer.config.Config.instance.imageNavStyle;
                switch (loc3) 
                {
                    case "BIG":
                    {
                        loc1 = "assets.BigArrow";
                        break;
                    }
                    case "CIRCLE":
                    {
                        loc1 = "assets.CircleArrow";
                        break;
                    }
                    case "SQUARE":
                    {
                        loc1 = "assets.ArrowSquare";
                        break;
                    }
                    case "TRIANGLE":
                    {
                        loc1 = "assets.TriangleArrow";
                        break;
                    }
                    default:
                    {
                        loc1 = "assets.InvertedArrow";
                        break;
                    }
                }
                _nextIcon.showDropShadow = !(com.airtight.simpleviewer.config.Config.instance.imageNavStyle == "CLASSIC");
                _backIcon.showDropShadow = !(com.airtight.simpleviewer.config.Config.instance.imageNavStyle == "CLASSIC");
                _nextIcon.clipPath = loc1;
                _backIcon.clipPath = loc1;
                loc2 = new flash.geom.ColorTransform();
                loc2.color = com.airtight.simpleviewer.config.Config.instance.imageNavColor;
                _nextIcon.face.transform.colorTransform = loc2;
                _backIcon.face.transform.colorTransform = loc2;
                _nextIcon.backColor = com.airtight.simpleviewer.config.Config.instance.imageNavBackColor;
                _nextIcon.backOpacity = com.airtight.simpleviewer.config.Config.instance.imageNavBackOpacity;
                _backIcon.backColor = com.airtight.simpleviewer.config.Config.instance.imageNavBackColor;
                _backIcon.backOpacity = com.airtight.simpleviewer.config.Config.instance.imageNavBackOpacity;
                _iconScale = com.airtight.simpleviewer.config.Config.instance.imageNavScale;
                _nextIcon.scaleX = _iconScale;
                _nextIcon.scaleY = _iconScale;
                _backIcon.scaleX = _iconScale;
                _backIcon.scaleY = _iconScale;
            }
            _cursor.visible = false;
            _cursor.x = 9999;
            _cursor.y = 9999;
            showNav(false, true, true, true);
            showNav(false, true, false, true);
            if (_showImageNav == "ALWAYS") 
            {
                showNav(true, true, true, true);
                showNav(true, true, false, true);
            }
            _transFrames = Math.round(com.airtight.simpleviewer.config.Config.instance.overlayFadeTime * stage.frameRate);
            return;
        }

        internal function onFullscreenChange(arg1:flash.events.Event):void
        {
            _cursor.x = 9999;
            _cursor.y = 9999;
            return;
        }

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _iconPadding:Number;

        internal var _firstTime:Boolean;

        internal var _iconHolder:flash.display.Sprite;

        internal var _nextBtn:com.airtight.simpleviewer.display.components.BaseButton;

        internal var _stageManager:com.airtight.simpleviewer.display.StageManager;

        internal var _transFrames:int;

        internal var _backBtn:com.airtight.simpleviewer.display.components.BaseButton;

        internal var _fadeOverlayWithImage:Boolean;

        internal var _showImageNav:String;

        internal var _nextIcon:com.airtight.simpleviewer.display.components.Icon;

        internal var _backIcon:com.airtight.simpleviewer.display.components.Icon;

        internal var _cursor:assets.NextCursor;

        internal var _iconScale:Number;

        internal var _useCursor:Boolean;
    }
}
