package com.airtight.simpleviewer.display.image 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    
    public class Overlay extends com.airtight.simpleviewer.display.components.Base
    {
        public function Overlay(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        internal function onMouseMove(arg1:flash.events.MouseEvent):void
        {
            var loc1:*=_imageArea.imageRect.contains(_imageArea.mouseX, _imageArea.mouseY);
            if (_imageArea.mouseX == 0 && _imageArea.mouseY == 0) 
            {
                loc1 = false;
            }
            if (loc1 != _mouseInsideImage) 
            {
                onMouseInside(loc1);
            }
            return;
        }

        internal function onFirstImageLoaded(arg1:flash.events.Event):void
        {
            onMouseMove(null);
            if (_showOverlay == "ALWAYS") 
            {
                _overlayHolder.visible = true;
                onFadeStart();
                com.greensock.TweenLite.to(_overlayHolder, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone, "onComplete":onFadeEnd});
            }
            return;
        }

        internal function onTransitionStart(arg1:flash.events.Event):void
        {
            showOnTrans(false, true);
            return;
        }

        public override function initListeners():void
        {
            _imageArea = com.airtight.simpleviewer.Shell.instance.imageArea;
            _stageManager = com.airtight.simpleviewer.Shell.instance.stageManager;
            _caption = com.airtight.simpleviewer.Shell.instance.stageManager.caption;
            _title = com.airtight.simpleviewer.Shell.instance.stageManager.title;
            _buttonBar = com.airtight.simpleviewer.Shell.instance.stageManager.buttonBar;
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize, false, 0, true);
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            stage.addEventListener(flash.events.Event.MOUSE_LEAVE, onMouseLeave, false, 0, true);
            _mouseInsideImage = false;
            return;
        }

        internal function onTransitionComplete(arg1:flash.events.Event):void
        {
            showOnTrans(true, false);
            return;
        }

        public function get overlayHolder():flash.display.Sprite
        {
            return _overlayHolder;
        }

        internal function showOnTrans(arg1:Boolean, arg2:Boolean):void
        {
            if (!_fadeOverlayWithImage) 
            {
                return;
            }
            if (arg2) 
            {
                this.alpha = 1;
                this.visible = arg1;
                return;
            }
            this.visible = true;
            if (arg1) 
            {
                this.alpha = 0;
                com.greensock.TweenLite.killTweensOf(this);
                onFadeStart();
                com.greensock.TweenLite.to(this, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone, "onComplete":onFadeEnd});
            }
            else 
            {
                com.greensock.TweenLite.killTweensOf(this);
                onFadeStart();
                com.greensock.TweenLite.to(this, _transFrames, {"alpha":0, "useFrames":true, "onComplete":onFadeEnd, "ease":com.greensock.easing.Linear.easeNone});
            }
            return;
        }

        internal function onMouseInside(arg1:Boolean):void
        {
            _mouseInsideImage = arg1;
            showOnHover(arg1, false);
            return;
        }

        public override function update():void
        {
            super.update();
            _imageClickMode = com.airtight.simpleviewer.config.Config.instance.imageClickMode;
            _showOverlay = com.airtight.simpleviewer.config.Config.instance.showOverlay;
            _bbPadding = com.airtight.simpleviewer.config.Config.instance.buttonBarPadding;
            _overlayButton.visible = _imageClickMode == "OPEN_URL";
            if (_showOverlay != "HOVER") 
            {
                stage.removeEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove);
            }
            else 
            {
                stage.addEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove, false, 0, true);
                onMouseMove(null);
            }
            _transFrames = Math.round(com.airtight.simpleviewer.config.Config.instance.overlayFadeTime * stage.frameRate);
            _fadeOverlayWithImage = com.airtight.simpleviewer.config.Config.instance.hideOverlayOnTransition;
            var loc1:*=com.airtight.simpleviewer.config.Config.instance.imageFrameStyle == "ROUNDED";
            _mask.cornerRadius = com.airtight.simpleviewer.config.Config.instance.imageCornerRadius;
            _mask.visible = loc1;
            _overlayHolder.mask = loc1 ? _mask : null;
            return;
        }

        internal function onMouseLeave(arg1:flash.events.Event):void
        {
            onMouseInside(false);
            showOnHover(false, false);
            return;
        }

        public override function draw():void
        {
            _overlayButton.setSize(width, height);
            if (_stageManager.captionIsOverlay) 
            {
                _caption.setSize(width, Math.min(com.airtight.simpleviewer.config.Config.instance.captionHeight, height));
            }
            if (_stageManager.titleIsOverlay) 
            {
                _title.width = width;
            }
            if (_stageManager.titlePosition == "OVERLAY_TOP") 
            {
                _title.y = 0;
            }
            if (_stageManager.captionPosition == "OVERLAY_TOP") 
            {
                _caption.y = 0;
                if (_stageManager.titlePosition == "OVERLAY_TOP") 
                {
                    _caption.y = _title.y + _title.height;
                }
            }
            if (_stageManager.captionPosition == "OVERLAY_BOTTOM") 
            {
                _caption.y = height - _caption.height;
            }
            if (_stageManager.titlePosition == "OVERLAY_BOTTOM") 
            {
                _title.y = height - _title.height;
                if (_stageManager.captionPosition == "OVERLAY_BOTTOM") 
                {
                    _title.y = height - _caption.captionTextAreaHeight - _title.height;
                }
            }
            if (_stageManager.buttonBarPosition == "OVERLAY") 
            {
                _buttonBar.alignInRect(new flash.geom.Rectangle(_bbPadding, _bbPadding, width - _bbPadding * 2, height - _bbPadding * 2));
            }
            _mask.setSize(width, height);
            return;
        }

        internal function showOnHover(arg1:Boolean, arg2:Boolean):void
        {
            if (_showOverlay != "HOVER") 
            {
                return;
            }
            if (arg2) 
            {
                _overlayHolder.alpha = 1;
                _overlayHolder.visible = arg1;
                return;
            }
            _overlayHolder.visible = true;
            if (arg1) 
            {
                _overlayHolder.alpha = 0;
                com.greensock.TweenLite.killTweensOf(_overlayHolder);
                onFadeStart();
                com.greensock.TweenLite.to(_overlayHolder, _transFrames, {"alpha":1, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone, "onComplete":onFadeEnd});
            }
            else 
            {
                com.greensock.TweenLite.killTweensOf(_overlayHolder);
                onFadeStart();
                com.greensock.TweenLite.to(_overlayHolder, _transFrames, {"alpha":0, "useFrames":true, "onComplete":onFadeEnd, "ease":com.greensock.easing.Linear.easeNone});
            }
            return;
        }

        internal function onImageResize(arg1:com.airtight.events.CustomEvent):void
        {
            setSize(_imageArea.imageRect.width, _imageArea.imageRect.height);
            move(_imageArea.imageRect.x, _imageArea.imageRect.y);
            draw();
            return;
        }

        protected override function addChildren():void
        {
            _overlayButton = new com.airtight.simpleviewer.display.components.BaseButton(this, 0, 0, null);
            _overlayButton.addEventListener(com.airtight.events.UIEvent.CLICK, com.airtight.simpleviewer.Shell.instance.onOpenClick, false, 0, true);
            _overlayHolder = new flash.display.Sprite();
            addChild(_overlayHolder);
            _overlayHolder.visible = false;
            _overlayHolder.alpha = 0;
            _mask = new com.airtight.simpleviewer.display.components.BkgndRect(this, 0, 0, true);
            _mask.visible = false;
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            stage.removeEventListener(flash.events.MouseEvent.MOUSE_MOVE, onMouseMove);
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onImageResize);
            _imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart);
            _imageArea.transitionManager.removeEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete);
            _imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.FIRST_IMAGE_LOADED, onFirstImageLoaded);
            stage.removeEventListener(flash.events.Event.MOUSE_LEAVE, onMouseLeave);
            _overlayButton.removeEventListener(com.airtight.events.UIEvent.CLICK, com.airtight.simpleviewer.Shell.instance.onOpenClick);
            _overlayButton.dispose();
            removeChild(_overlayButton);
            removeChild(_overlayHolder);
            return;
        }

        internal function onFadeEnd():void
        {
            this.blendMode = flash.display.BlendMode.NORMAL;
            if (_overlayHolder.alpha == 0) 
            {
                _overlayHolder.visible = false;
            }
            return;
        }

        internal function onFadeStart():void
        {
            this.blendMode = flash.display.BlendMode.LAYER;
            return;
        }

        public static const MOUSE_INSIDE:String="mouseInside";

        internal var _imageClickMode:String;

        internal var _overlayButton:com.airtight.simpleviewer.display.components.BaseButton;

        internal var _caption:com.airtight.simpleviewer.display.components.Caption;

        internal var _mask:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _stageManager:com.airtight.simpleviewer.display.StageManager;

        internal var _transFrames:int;

        internal var _mouseInsideImage:Boolean;

        internal var _buttonBar:com.airtight.simpleviewer.display.ButtonBar;

        internal var _bbPadding:int;

        internal var _fadeOverlayWithImage:Boolean;

        internal var _title:com.airtight.simpleviewer.display.components.Title;

        internal var _showOverlay:String;

        internal var _overlayHolder:flash.display.Sprite;
    }
}
