package com.airtight.simpleviewer.display.image 
{
    import assets.*;
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    
    public class TransitionManager extends flash.events.EventDispatcher
    {
        public function TransitionManager()
        {
            super();
            return;
        }

        public function doTransition(arg1:com.airtight.simpleviewer.display.image.Image, arg2:com.airtight.simpleviewer.display.image.Image):void
        {
            if (!_isFirstTransition) 
            {
                if (_doingTransition) 
                {
                    cleanUp(true);
                }
            }
            dispatchEvent(new com.airtight.events.CustomEvent(TRANSITION_START));
            _oldImage = arg1;
            _newImage = arg2;
            if (!_isFirstTransition) 
            {
                transOut();
            }
            if (_newImage.loaded) 
            {
                transIn();
            }
            else 
            {
                _newImage.addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded, false, 0, true);
            }
            _doingTransition = true;
            return;
        }

        internal function onTransitionComplete():void
        {
            cleanUp();
            return;
        }

        internal function cleanUp(arg1:Boolean=false):void
        {
            var loc1:*=null;
            if (!(_oldImage == null) && !_isFirstTransition) 
            {
                _oldImage.show(false);
            }
            com.greensock.TweenLite.killTweensOf(_newImage);
            com.greensock.TweenLite.killTweensOf(_oldImage);
            if (_transitionType == "FLASH") 
            {
                loc1 = new flash.geom.ColorTransform(1, 1, 1, 1, 0, 0, 0, 0);
                _newImage.transform.colorTransform = loc1;
            }
            _oldImage.alpha = 1;
            _newImage.alpha = 1;
            _newImage.x = 0;
            if (_transitionType == "HARDWIPE" || _transitionType == "SOFTWIPE") 
            {
                _oldImage.mask = null;
                _newImage.mask = null;
                _oldMask.visible = false;
                _newMask.visible = false;
                com.greensock.TweenLite.killTweensOf(_oldMask);
                com.greensock.TweenLite.killTweensOf(_newMask);
            }
            if (_transitionType != "SOFTWIPE") 
            {
            };
            _newImage.removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded);
            dispatchEvent(new com.airtight.events.CustomEvent(TRANSITION_COMPLETE, _oldImage.index));
            _doingTransition = false;
            _isFirstTransition = false;
            return;
        }

        internal function transIn():void
        {
            var loc2:*=NaN;
            _newImage.show(true);
            var loc1:*=_newImage.index < _oldImage.index;
            var loc3:*=_transitionType;
            switch (loc3) 
            {
                case "NONE":
                {
                    cleanUp();
                    break;
                }
                case "SLIDE":
                {
                    _newImage.x = loc1 ? -(_imageArea.width + IMAGE_GAP) : _imageArea.width + IMAGE_GAP;
                    com.greensock.TweenLite.to(_newImage, _transFrames, {"x":0, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true, "onComplete":cleanUp});
                    break;
                }
                case "CROSS_FADE":
                {
                    _newImage.alpha = 0;
                    com.greensock.TweenLite.to(_newImage, _transFrames, {"alpha":1, "useFrames":true, "onComplete":cleanUp, "ease":com.greensock.easing.Linear.easeNone});
                    break;
                }
                case "FADE":
                {
                    _newImage.alpha = 0;
                    com.greensock.TweenLite.to(_newImage, _transFrames / 2, {"alpha":1, "ease":com.greensock.easing.Linear.easeNone, "useFrames":true, "onComplete":cleanUp, "delay":_transFrames / 2});
                    break;
                }
                case "FLASH":
                {
                    com.greensock.TweenMax.from(_newImage, _transFrames, {"colorTransform":{"exposure":com.airtight.simpleviewer.config.Config.instance.flashBrightness}, "useFrames":true, "onComplete":cleanUp});
                    break;
                }
                case "HARDWIPE":
                {
                    _newImage.addChild(_newMask);
                    _newImage.mask = _newMask;
                    _newMask.width = _imageArea.width;
                    _newMask.height = _imageArea.height;
                    _newMask.x = loc1 ? _imageArea.width : -_imageArea.width;
                    com.greensock.TweenLite.to(_newMask, _transFrames, {"x":0, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true, "onComplete":cleanUp});
                    break;
                }
                case "SOFTWIPE":
                {
                    _newImage.cacheAsBitmap = true;
                    _newImage.addChild(_newMask);
                    _newImage.mask = _newMask;
                    _newMask.visible = true;
                    _newMask.width = _imageArea.width * 2;
                    _newMask.height = _imageArea.height;
                    _newMask.x = loc1 ? _imageArea.width * 2 : (-_imageArea.width) * 2;
                    loc2 = (-_imageArea.width) / 2;
                    com.greensock.TweenLite.to(_newMask, _transFrames, {"x":loc2, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true, "onComplete":cleanUp});
                    break;
                }
            }
            return;
        }

        internal function transOut():void
        {
            var loc1:*=false;
            var loc2:*=NaN;
            var loc3:*=NaN;
            var loc4:*=NaN;
            loc1 = _newImage.index < _oldImage.index;
            var loc5:*=_transitionType;
            switch (loc5) 
            {
                case "NONE":
                {
                    _oldImage.show(false);
                    break;
                }
                case "SLIDE":
                {
                    loc2 = loc1 ? _imageArea.width + IMAGE_GAP : -(_imageArea.width + IMAGE_GAP);
                    _oldImage.x = 0;
                    com.greensock.TweenLite.to(_oldImage, _transFrames, {"x":loc2, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true});
                    break;
                }
                case "CROSS_FADE":
                {
                    _imageArea.imageHolder.swapChildrenAt(_imageArea.imageHolder.getChildIndex(_newImage), (_imageArea.imageHolder.numChildren - 1));
                    _oldImage.alpha = 1;
                    com.greensock.TweenLite.to(_oldImage, _transFrames, {"alpha":0, "useFrames":true, "ease":com.greensock.easing.Linear.easeNone});
                    break;
                }
                case "FADE":
                {
                    _oldImage.alpha = 1;
                    _fadeOutTween = com.greensock.TweenMax.to(_oldImage, _transFrames / 2, {"alpha":0, "ease":com.greensock.easing.Linear.easeNone, "useFrames":true});
                    break;
                }
                case "FLASH":
                {
                    _oldImage.show(false);
                    break;
                }
                case "HARDWIPE":
                {
                    loc3 = loc1 ? -_imageArea.width : _imageArea.width;
                    _oldImage.addChild(_oldMask);
                    _oldImage.mask = _oldMask;
                    _oldMask.width = _imageArea.width;
                    _oldMask.height = _imageArea.height;
                    _oldMask.x = 0;
                    com.greensock.TweenLite.to(_oldMask, _transFrames, {"x":loc3, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true});
                    break;
                }
                case "SOFTWIPE":
                {
                    _oldImage.cacheAsBitmap = true;
                    _oldImage.addChild(_oldMask);
                    _oldImage.mask = _oldMask;
                    _oldMask.visible = true;
                    _oldMask.width = _imageArea.width * 2;
                    _oldMask.height = _imageArea.height;
                    _oldMask.x = (-_imageArea.width) / 2;
                    loc4 = _imageArea.width;
                    com.greensock.TweenLite.to(_oldMask, _transFrames, {"x":loc4, "useFrames":true, "ease":com.greensock.easing.Strong.easeOut});
                    break;
                }
            }
            return;
        }

        public function initListeners():void
        {
            com.airtight.simpleviewer.Shell.instance.addEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate, false, 0, true);
            _imageArea = com.airtight.simpleviewer.Shell.instance.imageArea;
            _isFirstTransition = true;
            doUpdate(null);
            return;
        }

        public function dispose():void
        {
            com.airtight.simpleviewer.Shell.instance.removeEventListener(com.airtight.simpleviewer.Shell.UPDATE, doUpdate);
            return;
        }

        public function doUpdate(arg1:flash.events.Event):void
        {
            _transitionType = com.airtight.simpleviewer.config.Config.instance.imageTransitionType;
            _transFrames = Math.round(com.airtight.simpleviewer.config.Config.instance.imageTransitionTime * _imageArea.stage.frameRate);
            if (_oldMask != null) 
            {
                _imageArea.removeChild(_oldMask);
            }
            if (_newMask != null) 
            {
                _imageArea.removeChild(_newMask);
            }
            if (_transitionType != "HARDWIPE") 
            {
                if (_transitionType == "SOFTWIPE") 
                {
                    _oldMask = new assets.SoftWipe();
                    _imageArea.addChild(_oldMask);
                    _oldMask.cacheAsBitmap = true;
                    _newMask = new assets.SoftWipe();
                    _imageArea.addChild(_newMask);
                    _newMask.cacheAsBitmap = true;
                }
            }
            else 
            {
                _oldMask = new com.airtight.simpleviewer.display.components.BkgndRect(_imageArea, 0, 0, false, 16711680);
                _newMask = new com.airtight.simpleviewer.display.components.BkgndRect(_imageArea, 0, 0, false, 65280);
            }
            return;
        }

        public function get transitionType():String
        {
            return _transitionType;
        }

        internal function onImageLoaded(arg1:com.airtight.events.CustomEvent):void
        {
            _newImage.removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded);
            transIn();
            return;
        }

        internal static const IMAGE_GAP:Number=20;

        public static const TRANSITION_COMPLETE:String="TransitionComplete";

        public static const TRANSITION_START:String="TransitionStart";

        internal var _oldMask:flash.display.Sprite;

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _transitionType:String;

        internal var _oldImage:com.airtight.simpleviewer.display.image.Image;

        internal var _isFirstTransition:Boolean;

        internal var _doingTransition:Boolean;

        internal var _transFrames:int;

        internal var _fadeOutTween:com.greensock.TweenMax;

        internal var _newImage:com.airtight.simpleviewer.display.image.Image;

        internal var _newMask:flash.display.Sprite;
    }
}
