package com.airtight.simpleviewer.display.image 
{
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class Watermark extends com.airtight.simpleviewer.display.components.Base
    {
        public function Watermark(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _mark = new com.airtight.simpleviewer.display.components.Icon(this, 0, 0, null, true);
            _mark.showDropShadow = false;
            _mark.addEventListener(flash.events.Event.RESIZE, onResize, false, 0, true);
            _mark.visible = false;
            return;
        }

        internal function onClick(arg1:flash.events.Event):void
        {
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.watermarkLinkURL)) 
            {
                org.casalib.util.NavigateUtil.openUrl(com.airtight.simpleviewer.config.Config.instance.watermarkLinkURL, com.airtight.simpleviewer.config.Config.instance.watermarkLinkTarget);
            }
            return;
        }

        internal function onTransitionComplete(arg1:flash.events.Event):void
        {
            _imageArea.addChild(_mark);
            invalidate();
            return;
        }

        internal function onTransitionStart(arg1:flash.events.Event):void
        {
            _imageArea.currentImage.addChild(_mark);
            _mark.visible = _enabled;
            return;
        }

        public override function initListeners():void
        {
            _imageArea = com.airtight.simpleviewer.Shell.instance.imageArea;
            _imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_RESIZE, onResize, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_START, onTransitionStart, false, 0, true);
            _imageArea.transitionManager.addEventListener(com.airtight.simpleviewer.display.image.TransitionManager.TRANSITION_COMPLETE, onTransitionComplete, false, 0, true);
            return;
        }

        public override function update():void
        {
            _enabled = com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.watermarkURL);
            if (_enabled) 
            {
                _mark.clipPath = com.airtight.simpleviewer.config.Config.instance.watermarkURL;
            }
            if (com.airtight.simpleviewer.config.Config.isValidString(com.airtight.simpleviewer.config.Config.instance.watermarkLinkURL)) 
            {
                _mark.mouseEnabled = true;
                _mark.buttonMode = true;
                _mark.useHandCursor = true;
                _mark.addEventListener(flash.events.MouseEvent.CLICK, onClick, false, 0, true);
            }
            else 
            {
                _mark.mouseEnabled = false;
                _mark.buttonMode = false;
                _mark.useHandCursor = false;
                _mark.removeEventListener(flash.events.MouseEvent.CLICK, onClick);
            }
            _mark.hAlign = com.airtight.simpleviewer.config.Config.instance.watermarkHAlign;
            _mark.vAlign = com.airtight.simpleviewer.config.Config.instance.watermarkVAlign;
            _padding = com.airtight.simpleviewer.config.Config.instance.watermarkPadding;
            return;
        }

        internal function onResize(arg1:flash.events.Event):void
        {
            invalidate();
            return;
        }

        public override function draw():void
        {
            if (!_enabled) 
            {
                return;
            }
            _mark.alignInRect(new flash.geom.Rectangle(_imageArea.imageRect.x + _padding, _imageArea.imageRect.y + _padding, _imageArea.imageRect.width - _padding * 2, _imageArea.imageRect.height - _padding * 2));
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            _mark.removeEventListener(flash.events.MouseEvent.CLICK, onClick);
            return;
        }

        internal var _enabled:Boolean;

        internal var _imageArea:com.airtight.simpleviewer.display.image.ImageArea;

        internal var _mark:com.airtight.simpleviewer.display.components.Icon;

        internal var _padding:int;
    }
}
