package com.airtight.simpleviewer.display.thumbs 
{
    import assets.*;
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.utils.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import org.casalib.util.*;
    
    public class Thumb extends com.airtight.simpleviewer.display.components.Base
    {
        public function Thumb(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0, arg4:String="", arg5:int=0)
        {
            _thumbURL = arg4;
            _index = arg5;
            _loading = false;
            super(arg1, arg2, arg3);
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_PROGRESS, onImageProgress, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).addEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_UNLOADED, onImageUnloaded, false, 0, true);
            if (com.airtight.simpleviewer.Shell.instance.imageArea.imageIndex == _index) 
            {
                update();
            }
            return;
        }

        public function show(arg1:Boolean):void
        {
            visible = arg1;
            return;
        }

        protected override function addChildren():void
        {
            _initIcon = new assets.InitialIcon();
            addChild(_initIcon);
            _base = new flash.display.Sprite();
            addChild(_base);
            _base.visible = false;
            _thumbHolder = new flash.display.Sprite();
            _base.addChild(_thumbHolder);
            _thumbLoader = new flash.display.Loader();
            _thumbHolder.addChild(_thumbLoader);
            _dogEar = new assets.DogEar();
            _base.addChild(_dogEar);
            _dogEar.visible = false;
            _progress = new com.airtight.simpleviewer.display.components.ProgressBar(_base, 0, 0);
            _frame = new com.airtight.simpleviewer.display.components.BkgndRect(_base, 0, 0, false, com.airtight.simpleviewer.config.Config.instance.thumbFrameColor, 1, false, true);
            _errorIcon = new assets.ErrorIcon();
            addChild(_errorIcon);
            _errorIcon.visible = false;
            _hit = new com.airtight.simpleviewer.display.components.BaseButton(this, 0, 0, _index);
            _hit.active = false;
            _hit.addEventListener(com.airtight.events.UIEvent.OVER, onOver, false, 0, true);
            _hit.addEventListener(com.airtight.events.UIEvent.OUT, onOut, false, 0, true);
            _hit.addEventListener(com.airtight.events.UIEvent.DOWN, onDown, false, 0, true);
            _hit.addEventListener(com.airtight.events.UIEvent.UP, onUp, false, 0, true);
            return;
        }

        internal function onOut(arg1:flash.events.MouseEvent):void
        {
            com.greensock.TweenLite.to(_frame, TWEEN_LENGTH, {"thickness":_frameThicknessUp, "tint":_frameColorUp, "useFrames":true});
            _progress.barColor = _frameColorUp;
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = _frameColorUp;
            _dogEar.transform.colorTransform = loc1;
            return;
        }

        public override function update():void
        {
            _frameThicknessUp = com.airtight.simpleviewer.config.Config.instance.thumbFrameWidth;
            _frameThicknessOver = com.airtight.simpleviewer.config.Config.instance.thumbHoverFrameWidth;
            _frameColorUp = com.airtight.simpleviewer.config.Config.instance.thumbFrameColor;
            _frameColorOver = com.airtight.simpleviewer.config.Config.instance.thumbFrameHoverColor;
            _loadingBrightness = com.airtight.simpleviewer.config.Config.instance.thumbLoadBrightness;
            _thumbShift = Math.min(com.airtight.simpleviewer.config.Config.instance.thumbClickShift, com.airtight.simpleviewer.config.Config.instance.thumbPadding);
            if (com.airtight.simpleviewer.config.Config.instance.thumbFrameStyle == "NONE") 
            {
                _frameThicknessUp = 0;
                _frameThicknessOver = 0;
            }
            _frame.rounded = com.airtight.simpleviewer.config.Config.instance.thumbFrameStyle == "ROUNDED";
            _frame.cornerRadius = com.airtight.simpleviewer.config.Config.instance.thumbCornerRadius;
            _frame.thickness = _frameThicknessUp;
            width = com.airtight.simpleviewer.config.Config.instance.thumbWidth;
            height = com.airtight.simpleviewer.config.Config.instance.thumbHeight;
            _hit.setSize(width, height);
            _frame.setSize(width, height);
            _progress.setSize(width - _frameThicknessUp * 2, com.airtight.simpleviewer.config.Config.instance.thumbLoadBarHeight);
            _progress.move(_frameThicknessUp, height - _frameThicknessUp - com.airtight.simpleviewer.config.Config.instance.thumbLoadBarHeight);
            _progress.barColor = _frameColorUp;
            _progress.visible = com.airtight.simpleviewer.config.Config.instance.showThumbLoadBar && !_loaded;
            _errorIcon.x = width / 2;
            _errorIcon.y = height / 2;
            _initIcon.x = Math.round(width / 2);
            _initIcon.y = Math.round(height / 2);
            _dogEar.x = (width - _frameThicknessUp - 1) - _dogEar.width;
            _dogEar.y = _frameThicknessUp + 1;
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = _frameColorUp;
            _errorIcon.mcFace.transform.colorTransform = loc1;
            _initIcon.mcFace.transform.colorTransform = loc1;
            _dogEar.transform.colorTransform = loc1;
            _frame.transform.colorTransform = loc1;
            if (_mask != null) 
            {
                _mask.setSize(width, height);
                _mask.rounded = com.airtight.simpleviewer.config.Config.instance.thumbFrameStyle == "ROUNDED";
                _mask.cornerRadius = com.airtight.simpleviewer.config.Config.instance.thumbCornerRadius;
            }
            if (_hit.selected) 
            {
                onOver(null);
            }
            return;
        }

        internal function onThumbLoaded(arg1:flash.events.Event):void
        {
            dispatchEvent(new flash.events.Event(THUMB_LOADED));
            _loaded = true;
            _loading = false;
            _initIcon.visible = false;
            _base.visible = true;
            _base.alpha = 0;
            if (com.airtight.simpleviewer.config.Config.instance.doThumbPopOut) 
            {
                _base.scaleX = 0.1;
                _base.scaleY = 0.1;
                _base.x = com.airtight.simpleviewer.config.Config.instance.thumbWidth / 2;
                _base.y = com.airtight.simpleviewer.config.Config.instance.thumbHeight / 2;
                com.greensock.TweenLite.to(_base, TWEEN_LENGTH, {"x":0, "y":0, "scaleX":1, "scaleY":1, "alpha":1, "ease":com.greensock.easing.Strong.easeOut, "useFrames":true});
            }
            else 
            {
                com.greensock.TweenLite.to(_base, TWEEN_LENGTH, {"alpha":1, "ease":com.greensock.easing.Linear.easeNone, "useFrames":true});
            }
            if (!_hit.selected) 
            {
                _hit.active = true;
            }
            if (!com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).loaded) 
            {
                com.greensock.TweenMax.to(_thumbHolder, 1, {"colorTransform":{"exposure":_loadingBrightness}, "useFrames":true});
            }
            resizeThumbToFit();
            return;
        }

        internal function onThumbError(arg1:flash.events.Event):void
        {
            _loading = false;
            _errorIcon.visible = true;
            dispatchEvent(new flash.events.Event(THUMB_LOADED));
            var loc1:*=com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[_index].imageURL;
            if (_thumbURL != loc1) 
            {
                com.airtight.simpleviewer.Logger.log("Thumb Load Error for: " + _thumbURL + " attempting to load main image as thumb", com.airtight.simpleviewer.Logger.WARN);
                _thumbURL = loc1;
                load();
            }
            return;
        }

        public function get index():int
        {
            return _index;
        }

        internal function onUp(arg1:flash.events.MouseEvent):void
        {
            _base.x = 0;
            _base.y = 0;
            return;
        }

        internal function onImageLoaded(arg1:com.airtight.events.CustomEvent):void
        {
            _progress.visible = false;
            com.greensock.TweenMax.killTweensOf(_thumbHolder);
            com.greensock.TweenMax.to(_thumbHolder, 10, {"colorTransform":{"exposure":1}, "useFrames":true});
            return;
        }

        internal function onOver(arg1:flash.events.MouseEvent):void
        {
            com.greensock.TweenLite.to(_frame, TWEEN_LENGTH, {"thickness":_frameThicknessOver, "tint":_frameColorOver, "useFrames":true});
            _progress.barColor = _frameColorOver;
            var loc1:*=new flash.geom.ColorTransform();
            loc1.color = _frameColorOver;
            _dogEar.transform.colorTransform = loc1;
            return;
        }

        internal function onImageProgress(arg1:com.airtight.events.CustomEvent):void
        {
            _progress.value = Number(arg1.data);
            return;
        }

        public function load():void
        {
            visible = true;
            _errorIcon.visible = false;
            if (_loading) 
            {
                return;
            }
            if (_loaded) 
            {
                dispatchEvent(new flash.events.Event(THUMB_LOADED));
                return;
            }
            _loading = true;
            com.airtight.utils.NetUtils.loadImage(_thumbLoader, _thumbURL, onThumbLoaded, onThumbError);
            return;
        }

        public override function draw():void
        {
            return;
        }

        public function unload():void
        {
            _thumbLoader.unload();
            return;
        }

        public function set selected(arg1:Boolean):void
        {
            _hit.selected = arg1;
            if (arg1 && com.airtight.simpleviewer.config.Config.instance.showThumbVisited) 
            {
                _dogEar.visible = true;
            }
            if (arg1) 
            {
                onOver(null);
            }
            else 
            {
                onOut(null);
            }
            return;
        }

        public override function dispose():void
        {
            super.dispose();
            unload();
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_PROGRESS, onImageProgress);
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_LOADED, onImageLoaded);
            com.airtight.simpleviewer.Shell.instance.imageArea.getImage(_index).removeEventListener(com.airtight.simpleviewer.display.image.Image.IMAGE_UNLOADED, onImageUnloaded);
            _hit.removeEventListener(com.airtight.events.UIEvent.OVER, onOver);
            _hit.removeEventListener(com.airtight.events.UIEvent.OUT, onOut);
            _hit.removeEventListener(com.airtight.events.UIEvent.DOWN, onDown);
            _hit.removeEventListener(com.airtight.events.UIEvent.UP, onUp);
            _hit.dispose();
            removeChild(_hit);
            _thumbHolder.removeChild(_thumbLoader);
            _base.removeChild(_thumbHolder);
            removeChild(_base);
            return;
        }

        internal function onDown(arg1:flash.events.MouseEvent):void
        {
            _base.x = _thumbShift;
            _base.y = _thumbShift;
            return;
        }

        internal function onImageUnloaded(arg1:com.airtight.events.CustomEvent):void
        {
            com.greensock.TweenMax.to(_thumbHolder, 1, {"colorTransform":{"exposure":_loadingBrightness}, "useFrames":true});
            _progress.visible = com.airtight.simpleviewer.config.Config.instance.showThumbLoadBar;
            _progress.value = 0;
            return;
        }

        internal function resizeThumbToFit():void
        {
            var loc2:*=NaN;
            var loc1:*=_thumbLoader.contentLoaderInfo.width;
            loc2 = _thumbLoader.contentLoaderInfo.height;
            if (loc1 == _width && loc2 == height && !(com.airtight.simpleviewer.config.Config.instance.thumbFrameStyle == "ROUNDED")) 
            {
                return;
            }
            _mask = new com.airtight.simpleviewer.display.components.BkgndRect(_base, 0, 0, com.airtight.simpleviewer.config.Config.instance.thumbFrameStyle == "ROUNDED");
            _mask.cornerRadius = com.airtight.simpleviewer.config.Config.instance.thumbCornerRadius;
            _mask.setSize(width, height);
            this.mask = _mask;
            _thumbLoader.visible = false;
            var loc3:*=new flash.display.Bitmap();
            _thumbHolder.addChild(loc3);
            loc3.bitmapData = flash.display.Bitmap(_thumbLoader.content).bitmapData;
            loc3.smoothing = true;
            var loc4:*=new flash.geom.Rectangle(0, 0, width, height);
            var loc5:*=new flash.geom.Rectangle(0, 0, loc1, loc2);
            loc5 = org.casalib.util.RatioUtil.scaleToFill(loc5, loc4);
            _thumbHolder.width = loc5.width;
            _thumbHolder.height = loc5.height;
            _thumbHolder.x = (width - loc5.width) / 2;
            _thumbHolder.y = (height - loc5.height) / 2;
            return;
        }

        internal static const TWEEN_LENGTH:Number=10;

        public static const THUMB_LOADED:String="thumbLoaded";

        internal var _initIcon:assets.InitialIcon;

        internal var _frameColorOver:Number;

        internal var _progress:com.airtight.simpleviewer.display.components.ProgressBar;

        internal var _thumbURL:String;

        internal var _dogEar:assets.DogEar;

        internal var _frameThicknessOver:Number;

        internal var _frameColorUp:Number;

        internal var _errorIcon:assets.ErrorIcon;

        internal var _loaded:Boolean;

        internal var _loadingBrightness:Number;

        internal var _index:int;

        internal var _hit:com.airtight.simpleviewer.display.components.BaseButton;

        internal var _frameThicknessUp:Number;

        internal var _thumbHolder:flash.display.Sprite;

        internal var _thumbShift:int;

        internal var _frame:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _base:flash.display.Sprite;

        internal var _mask:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _loading:Boolean;

        internal var _thumbLoader:flash.display.Loader;
    }
}
