package com.airtight.simpleviewer.display.thumbs 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.data.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.image.*;
    import com.airtight.simpleviewer.display.thumbs.thumbNav.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.ui.*;
    
    public class ThumbArea extends com.airtight.simpleviewer.display.components.Base
    {
        public function ThumbArea(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        public function get pageIndex():int
        {
            return _pageIndex;
        }

        public override function draw():void
        {
            _thumbMask.move((-com.airtight.simpleviewer.config.Config.instance.thumbPadding) / 2, 0);
            _thumbMask.setSize(_thumbsWidth + com.airtight.simpleviewer.config.Config.instance.thumbPadding, _thumbsHeight + com.airtight.simpleviewer.config.Config.instance.thumbClickShift);
            return;
        }

        public function get pageCount():int
        {
            return _pageCount;
        }

        public function set pageIndex(arg1:int):void
        {
            var loc3:*=0;
            if (arg1 < 0 || arg1 >= _pageCount || arg1 == _pageIndex) 
            {
                return;
            }
            _pageIndex = arg1;
            com.greensock.TweenLite.to(_thumbSlider, _transFrames, {"x":(-_pageIndex) * (_thumbsWidth + com.airtight.simpleviewer.config.Config.instance.thumbPadding), "ease":com.greensock.easing.Strong.easeOut, "onComplete":onPagingComplete, "useFrames":true});
            var loc1:*=[];
            var loc2:*=(_pageSize - 1);
            while (loc2 >= 0) 
            {
                if ((loc3 = loc2 + _pageIndex * _pageSize) < _thumbCount) 
                {
                    loc1.push(loc3);
                }
                --loc2;
            }
            if (com.airtight.simpleviewer.config.Config.instance.thumbPreloading == "PAGE") 
            {
                loadQueue = loc1;
            }
            dispatchEvent(new com.airtight.events.CustomEvent(THUMB_PAGE_NAV, loc1));
            _thumbHolder.visible = true;
            return;
        }

        public override function update():void
        {
            var loc1:*=null;
            if (com.airtight.simpleviewer.config.Config.instance.thumbNavStyle != "NONE") 
            {
                if (!(com.airtight.simpleviewer.config.Config.instance.thumbNavStyle == "NUMERIC") && com.airtight.simpleviewer.config.Config.instance.thumbNavPosition == "CENTER") 
                {
                    loc1 = Object(_thumbNav).navButton;
                    _thumbNav.move(0, (_thumbsHeight - loc1.height) / 2);
                    _thumbNav.width = _thumbsWidth + loc1.width * 2 + com.airtight.simpleviewer.config.Config.instance.thumbNavPadding * 2;
                    _thumbHolder.x = loc1.width + com.airtight.simpleviewer.config.Config.instance.thumbNavPadding;
                    width = _thumbNav.width;
                    height = _thumbsHeight;
                }
                else 
                {
                    _thumbNav.move(0, _thumbsHeight + com.airtight.simpleviewer.config.Config.instance.thumbNavPadding);
                    _thumbHolder.x = 0;
                    if (com.airtight.simpleviewer.config.Config.instance.thumbNavStyle != "NUMERIC") 
                    {
                        _thumbNav.width = _thumbsWidth;
                        width = _thumbsWidth;
                    }
                    else 
                    {
                        width = Math.max(_thumbsWidth, _thumbNav.width);
                    }
                    height = _thumbsHeight + _thumbNav.height + com.airtight.simpleviewer.config.Config.instance.thumbNavPadding;
                }
            }
            else 
            {
                width = _thumbsWidth;
                height = _thumbsHeight;
            }
            _transFrames = Math.round(com.airtight.simpleviewer.config.Config.instance.thumbNavSlideTime * stage.frameRate);
            if (com.airtight.simpleviewer.config.Config.instance.thumbDropShadow) 
            {
                _thumbSlider.filters = [new flash.filters.GlowFilter(0, 0.5, 5, 5, com.airtight.simpleviewer.config.Config.instance.dropShadowStrength, 1), new flash.filters.DropShadowFilter(4, 45, 0, 0.4, 4, 4, com.airtight.simpleviewer.config.Config.instance.dropShadowStrength, 1)];
            }
            else 
            {
                _thumbSlider.filters = [];
            }
            return;
        }

        internal function onThumbClick(arg1:com.airtight.events.UIEvent):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, arg1.data));
            return;
        }

        internal function set loadQueue(arg1:Array):void
        {
            _loadQueue = arg1.concat();
            onThumbLoaded(null);
            return;
        }

        internal function onThumbOut(arg1:com.airtight.events.UIEvent):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.changeCaptionOnHover) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_OVER, _selectedThumbIndex));
            }
            return;
        }

        internal function onThumbLoaded(arg1:flash.events.Event):void
        {
            var loc1:*=0;
            if (_loadQueue.length > 0) 
            {
                loc1 = _loadQueue.pop();
                if (loc1 < _thumbCount) 
                {
                    _thumbs[loc1].load();
                }
            }
            return;
        }

        public function getThumb(arg1:int):com.airtight.simpleviewer.display.thumbs.Thumb
        {
            return _thumbs[arg1];
        }

        public function onPagingComplete():void
        {
            return;
        }

        public override function dispose():void
        {
            var loc2:*=null;
            super.dispose();
            com.airtight.simpleviewer.Shell.instance.imageArea.removeEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected);
            _thumbNav.removeEventListener(THUMB_PAGE_NAV, onPageNav);
            var loc1:*=0;
            while (loc1 < _thumbCount) 
            {
                loc2 = _thumbs[loc1];
                if (loc2 == null) 
                {
                    return;
                }
                loc2.removeEventListener(com.airtight.simpleviewer.display.thumbs.Thumb.THUMB_LOADED, onThumbLoaded);
                loc2.removeEventListener(com.airtight.events.UIEvent.CLICK, onThumbClick);
                loc2.removeEventListener(com.airtight.events.UIEvent.OVER, onThumbOver);
                loc2.removeEventListener(com.airtight.events.UIEvent.OUT, onThumbOut);
                loc2.dispose();
                _thumbSlider.removeChild(loc2);
                ++loc1;
            }
            _thumbs = [];
            _thumbHolder.removeChild(_thumbSlider);
            removeChild(_thumbHolder);
            return;
        }

        internal function onUserImageSelected(arg1:com.airtight.events.CustomEvent):void
        {
            _selectedThumbIndex = int(arg1.data);
            pageIndex = Math.floor(_selectedThumbIndex / _pageSize);
            return;
        }

        internal function onThumbOver(arg1:com.airtight.events.UIEvent):void
        {
            if (com.airtight.simpleviewer.config.Config.instance.changeImageOnHover) 
            {
                onThumbClick(arg1);
            }
            else if (com.airtight.simpleviewer.config.Config.instance.changeCaptionOnHover) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_OVER, arg1.data));
            }
            return;
        }

        public function onMouseWheel(arg1:flash.events.MouseEvent):void
        {
            if (arg1.delta < 0) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex + 1));
            }
            if (arg1.delta > 0) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, (_selectedThumbIndex - 1)));
            }
            return;
        }

        public function get pageSize():int
        {
            return _pageSize;
        }

        internal function onPageNav(arg1:com.airtight.events.CustomEvent):void
        {
            pageIndex = int(arg1.data);
            return;
        }

        internal function onImageSelected(arg1:com.airtight.events.CustomEvent):void
        {
            if (_selectedThumbIndex != -1) 
            {
                _thumbs[_selectedThumbIndex].selected = false;
            }
            _selectedThumbIndex = int(arg1.data);
            _thumbs[_selectedThumbIndex].selected = true;
            if (com.airtight.simpleviewer.config.Config.instance.autoPlayThumbs) 
            {
                pageIndex = Math.floor(_selectedThumbIndex / _pageSize);
            }
            _thumbs[_selectedThumbIndex].load();
            return;
        }

        public function createThumbs():void
        {
            var loc2:*=null;
            var loc3:*=0;
            var loc4:*=0;
            var loc5:*=0;
            var loc6:*=null;
            var loc7:*=0;
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.IMAGE_SELECTED, onImageSelected, false, 0, true);
            com.airtight.simpleviewer.Shell.instance.imageArea.addEventListener(com.airtight.simpleviewer.display.image.ImageArea.USER_NAVIGATION, onUserImageSelected, false, 0, true);
            _thumbRows = com.airtight.simpleviewer.config.Config.instance.thumbRows;
            _thumbColumns = com.airtight.simpleviewer.config.Config.instance.thumbColumns;
            _pageSize = _thumbRows * _thumbColumns;
            _thumbCount = com.airtight.simpleviewer.data.DataManager.instance.galleryData.imageCount;
            _pageCount = Math.ceil(_thumbCount / _pageSize);
            _loadQueue = [];
            _thumbs = [];
            if (_pageCount < 2) 
            {
                _thumbNav.visible = false;
                com.airtight.simpleviewer.config.Config.instance.setOption("thumbNavStyle", "NONE", true);
            }
            _thumbsWidth = _thumbColumns * (com.airtight.simpleviewer.config.Config.instance.thumbWidth + com.airtight.simpleviewer.config.Config.instance.thumbPadding) - com.airtight.simpleviewer.config.Config.instance.thumbPadding;
            _thumbsHeight = _thumbRows * (com.airtight.simpleviewer.config.Config.instance.thumbHeight + com.airtight.simpleviewer.config.Config.instance.thumbPadding) - com.airtight.simpleviewer.config.Config.instance.thumbPadding;
            draw();
            var loc1:*=0;
            while (loc1 < _thumbCount) 
            {
                loc2 = new com.airtight.simpleviewer.display.thumbs.Thumb(_thumbSlider, 0, 0, com.airtight.simpleviewer.data.DataManager.instance.galleryData.images[loc1].thumbURL, loc1);
                loc2.addEventListener(com.airtight.simpleviewer.display.thumbs.Thumb.THUMB_LOADED, onThumbLoaded, false, 0, true);
                loc2.addEventListener(com.airtight.events.UIEvent.CLICK, onThumbClick, false, 0, true);
                loc2.addEventListener(com.airtight.events.UIEvent.OVER, onThumbOver, false, 0, true);
                loc2.addEventListener(com.airtight.events.UIEvent.OUT, onThumbOut, false, 0, true);
                loc3 = Math.floor(loc1 / _pageSize);
                loc4 = loc1 % _thumbColumns;
                loc5 = Math.floor((loc1 - loc3 * _pageSize) / _thumbColumns);
                loc2.move((com.airtight.simpleviewer.config.Config.instance.thumbWidth + com.airtight.simpleviewer.config.Config.instance.thumbPadding) * loc4 + (_thumbsWidth + com.airtight.simpleviewer.config.Config.instance.thumbPadding) * loc3, (com.airtight.simpleviewer.config.Config.instance.thumbHeight + com.airtight.simpleviewer.config.Config.instance.thumbPadding) * loc5);
                _thumbs.push(loc2);
                ++loc1;
            }
            if (com.airtight.simpleviewer.config.Config.instance.thumbPreloading == "ALL") 
            {
                loc6 = [];
                loc7 = _thumbCount;
                while (loc7 >= 0) 
                {
                    loc6.push(loc7);
                    --loc7;
                }
                loadQueue = loc6;
            }
            _selectedThumbIndex = -1;
            _pageIndex = -1;
            update();
            _thumbNav.initListeners();
            return;
        }

        protected override function addChildren():void
        {
            _thumbHolder = new flash.display.Sprite();
            addChild(_thumbHolder);
            _thumbHolder.visible = false;
            _thumbSlider = new flash.display.Sprite();
            _thumbHolder.addChild(_thumbSlider);
            _thumbMask = new com.airtight.simpleviewer.display.components.BkgndRect(_thumbHolder, 0, 0);
            _thumbSlider.mask = _thumbMask;
            _thumbSlider.mask.visible = false;
            if (com.airtight.simpleviewer.config.Config.instance.thumbNavStyle != "NUMERIC") 
            {
                _thumbNav = new com.airtight.simpleviewer.display.thumbs.thumbNav.ThumbNavArrows(this, 0, 0);
            }
            else 
            {
                _thumbNav = new com.airtight.simpleviewer.display.thumbs.thumbNav.ThumbNavNumeric(this, 0, 0);
            }
            if (com.airtight.simpleviewer.config.Config.instance.thumbNavStyle == "NONE") 
            {
                _thumbNav.visible = false;
            }
            _thumbNav.addEventListener(THUMB_PAGE_NAV, onPageNav, false, 0, true);
            return;
        }

        public function onKeyDown(arg1:flash.events.KeyboardEvent):void
        {
            if (!com.airtight.simpleviewer.config.Config.instance.enableKeyboardControls) 
            {
                return;
            }
            if (arg1.keyCode == flash.ui.Keyboard.DOWN) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex + _thumbColumns));
            }
            if (arg1.keyCode == flash.ui.Keyboard.UP) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex - _thumbColumns));
            }
            if (arg1.keyCode == flash.ui.Keyboard.RIGHT) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex + 1));
            }
            if (arg1.keyCode == flash.ui.Keyboard.LEFT) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, (_selectedThumbIndex - 1)));
            }
            if (arg1.keyCode == flash.ui.Keyboard.HOME) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, 0));
            }
            if (arg1.keyCode == flash.ui.Keyboard.END) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, (_thumbCount - 1)));
            }
            if (arg1.keyCode == flash.ui.Keyboard.PAGE_DOWN) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex + _pageSize));
            }
            if (arg1.keyCode == flash.ui.Keyboard.PAGE_UP) 
            {
                dispatchEvent(new com.airtight.events.CustomEvent(THUMB_CLICK, _selectedThumbIndex - _pageSize));
            }
            return;
        }

        public static const THUMB_PAGE_NAV:String="thumbPageNav";

        public static const THUMB_OVER:String="thumbOver";

        public static const THUMB_CLICK:String="thumbClick";

        internal var _pageIndex:int;

        internal var _thumbColumns:int;

        internal var _pageSize:int;

        internal var _thumbsWidth:Number;

        internal var _transFrames:int;

        internal var _selectedThumbIndex:int;

        internal var _thumbSlider:flash.display.Sprite;

        internal var _loadQueue:Array;

        internal var _thumbHolder:flash.display.Sprite;

        internal var _thumbMask:com.airtight.simpleviewer.display.components.BkgndRect;

        internal var _thumbsHeight:Number;

        internal var _pageCount:int;

        internal var _thumbNav:com.airtight.simpleviewer.display.components.Base;

        internal var _thumbCount:int;

        internal var _thumbRows:int;

        internal var _thumbs:Array;
    }
}
