package com.airtight.simpleviewer.display.thumbs.thumbNav 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.config.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import flash.display.*;
    import flash.events.*;
    
    public class ThumbNavArrows extends com.airtight.simpleviewer.display.components.Base
    {
        public function ThumbNavArrows(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            _nextBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.CircleArrow");
            _nextBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onNextClick, false, 0, true);
            _backBtn = new com.airtight.simpleviewer.display.components.IconButton(this, 0, 0, null, "assets.CircleArrow");
            _backBtn.flipped = true;
            _backBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onBackClick, false, 0, true);
            return;
        }

        internal function onBackClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, (_thumbArea.pageIndex - 1)));
            return;
        }

        public override function draw():void
        {
            if (com.airtight.simpleviewer.config.Config.instance.thumbNavPosition != "BOTTOM") 
            {
                _backBtn.move(0, 0);
                _nextBtn.move(width - _nextBtn.width, 0);
            }
            else if (com.airtight.simpleviewer.config.Config.instance.thumbColumns != 1) 
            {
                _backBtn.move((com.airtight.simpleviewer.config.Config.instance.thumbWidth - _backBtn.width) / 2, 0);
                _nextBtn.move(width - (com.airtight.simpleviewer.config.Config.instance.thumbWidth - _nextBtn.width) / 2 - _nextBtn.width, 0);
            }
            else 
            {
                _backBtn.move(com.airtight.simpleviewer.config.Config.instance.thumbWidth / 2 - _backBtn.width, 0);
                _nextBtn.move(com.airtight.simpleviewer.config.Config.instance.thumbWidth / 2, 0);
            }
            return;
        }

        public override function update():void
        {
            var loc1:*=null;
            var loc2:*=com.airtight.simpleviewer.config.Config.instance.thumbNavStyle;
            switch (loc2) 
            {
                case "BIG":
                {
                    loc1 = "assets.BigArrow";
                    break;
                }
                case "SQUARE":
                {
                    loc1 = "assets.ArrowSquare";
                    break;
                }
                case "TRIANGLE":
                {
                    loc1 = "assets.TriangleArrow";
                    break;
                }
                case "CLASSIC":
                {
                    loc1 = "assets.ClassicArrow";
                    break;
                }
                default:
                {
                    loc1 = "assets.CircleArrow";
                    break;
                }
            }
            _backBtn.colorUp = com.airtight.simpleviewer.config.Config.instance.thumbNavColor;
            _nextBtn.colorOver = com.airtight.simpleviewer.config.Config.instance.thumbNavHoverColor;
            _nextBtn.colorUp = com.airtight.simpleviewer.config.Config.instance.thumbNavColor;
            _backBtn.colorOver = com.airtight.simpleviewer.config.Config.instance.thumbNavHoverColor;
            _nextBtn.iconPath = loc1;
            _backBtn.iconPath = loc1;
            _backBtn.icon.backColor = com.airtight.simpleviewer.config.Config.instance.thumbNavBackColor;
            _backBtn.icon.backOpacity = com.airtight.simpleviewer.config.Config.instance.thumbNavBackOpacity;
            _nextBtn.icon.backColor = com.airtight.simpleviewer.config.Config.instance.thumbNavBackColor;
            _nextBtn.icon.backOpacity = com.airtight.simpleviewer.config.Config.instance.thumbNavBackOpacity;
            height = _nextBtn.height;
            return;
        }

        public override function initListeners():void
        {
            _thumbArea = com.airtight.simpleviewer.Shell.instance.thumbArea;
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onPageChange, false, 0, true);
            return;
        }

        public function get navButton():com.airtight.simpleviewer.display.components.IconButton
        {
            return _nextBtn;
        }

        internal function onNextClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, _thumbArea.pageIndex + 1));
            return;
        }

        internal function onPageChange(arg1:com.airtight.events.CustomEvent):void
        {
            _nextBtn.active = !(_thumbArea.pageIndex == (_thumbArea.pageCount - 1));
            _backBtn.active = !(_thumbArea.pageIndex == 0);
            return;
        }

        internal var _nextBtn:com.airtight.simpleviewer.display.components.IconButton;

        internal var _thumbArea:com.airtight.simpleviewer.display.thumbs.ThumbArea;

        internal var _backBtn:com.airtight.simpleviewer.display.components.IconButton;
    }
}
