package com.airtight.simpleviewer.display.thumbs.thumbNav 
{
    import com.airtight.events.*;
    import com.airtight.simpleviewer.*;
    import com.airtight.simpleviewer.display.components.*;
    import com.airtight.simpleviewer.display.thumbs.*;
    import flash.display.*;
    import flash.events.*;
    
    public class ThumbNavNumeric extends com.airtight.simpleviewer.display.components.Base
    {
        public function ThumbNavNumeric(arg1:flash.display.DisplayObjectContainer=null, arg2:Number=0, arg3:Number=0)
        {
            super(arg1, arg2, arg3);
            return;
        }

        protected override function addChildren():void
        {
            var loc2:*=null;
            _backBtn = new com.airtight.simpleviewer.display.components.NumericNavButton(this, 0, 0, "<", null);
            _backBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onBackClick, false, 0, true);
            _numericButtons = [];
            var loc1:*=0;
            while (loc1 < MAX_BUTTON_COUNT) 
            {
                loc2 = new com.airtight.simpleviewer.display.components.NumericNavButton(this, 0, 0, "", null);
                loc2.addEventListener(com.airtight.events.UIEvent.CLICK, onNumClick, false, 0, true);
                _numericButtons.push(loc2);
                ++loc1;
            }
            _nextBtn = new com.airtight.simpleviewer.display.components.NumericNavButton(this, 0, 0, ">", null);
            _nextBtn.addEventListener(com.airtight.events.UIEvent.CLICK, onNextClick, false, 0, true);
            return;
        }

        internal function onNumClick(arg1:com.airtight.events.UIEvent):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, arg1.data));
            return;
        }

        internal function onBackClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, (_thumbArea.pageIndex - 1)));
            return;
        }

        public override function update():void
        {
            height = com.airtight.simpleviewer.display.components.NumericNavButton.BUTTON_HEIGHT;
            return;
        }

        public override function draw():void
        {
            return;
        }

        public override function initListeners():void
        {
            _thumbArea = com.airtight.simpleviewer.Shell.instance.thumbArea;
            com.airtight.simpleviewer.Shell.instance.thumbArea.addEventListener(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, onPageChange, false, 0, true);
            alignButtons();
            return;
        }

        internal function alignButtons():void
        {
            var loc1:*=0;
            if (_thumbArea.pageCount < 10) 
            {
                loc1 = 15;
            }
            if (_thumbArea.pageCount >= 10 && _thumbArea.pageCount < 100) 
            {
                loc1 = 18;
            }
            if (_thumbArea.pageCount >= 100) 
            {
                loc1 = 25;
            }
            _nextBtn.setSize(loc1, com.airtight.simpleviewer.display.components.NumericNavButton.BUTTON_HEIGHT);
            _backBtn.setSize(loc1, com.airtight.simpleviewer.display.components.NumericNavButton.BUTTON_HEIGHT);
            var loc2:*=loc1 + BUTTON_PADDING;
            var loc3:*=0;
            while (loc3 < MAX_BUTTON_COUNT) 
            {
                _numericButtons[loc3].setSize(loc1, com.airtight.simpleviewer.display.components.NumericNavButton.BUTTON_HEIGHT);
                _numericButtons[loc3].x = loc2;
                if (loc3 >= _thumbArea.pageCount) 
                {
                    _numericButtons[loc3].visible = false;
                }
                else 
                {
                    loc2 = loc2 + loc1 + BUTTON_PADDING;
                }
                ++loc3;
            }
            _nextBtn.x = loc2;
            _width = loc2 + _nextBtn.width;
            return;
        }

        internal function onNextClick(arg1:flash.events.Event):void
        {
            dispatchEvent(new com.airtight.events.CustomEvent(com.airtight.simpleviewer.display.thumbs.ThumbArea.THUMB_PAGE_NAV, _thumbArea.pageIndex + 1));
            return;
        }

        internal function onPageChange(arg1:com.airtight.events.CustomEvent):void
        {
            var loc6:*=0;
            var loc7:*=0;
            var loc8:*=0;
            var loc9:*=null;
            var loc1:*=_thumbArea.pageIndex;
            var loc2:*=_thumbArea.pageCount;
            _nextBtn.active = !(loc1 == (loc2 - 1));
            _backBtn.active = !(loc1 == 0);
            var loc3:*=[];
            if (loc2 <= MAX_BUTTON_COUNT) 
            {
                loc6 = 0;
                while (loc6 < MAX_BUTTON_COUNT) 
                {
                    loc3.push(loc6);
                    ++loc6;
                }
            }
            else if (loc1 < MAX_BUTTON_COUNT - 3) 
            {
                loc7 = 0;
                while (loc7 < MAX_BUTTON_COUNT - 2) 
                {
                    loc3.push(loc7);
                    ++loc7;
                }
                loc3.push("...");
                loc3.push((loc2 - 1));
            }
            else if (loc1 > loc2 - (MAX_BUTTON_COUNT - 2)) 
            {
                loc3.push(0);
                loc3.push("...");
                loc8 = loc2 - (MAX_BUTTON_COUNT - 2);
                while (loc8 < loc2) 
                {
                    loc3.push(loc8);
                    ++loc8;
                }
            }
            else 
            {
                loc3.push(0);
                loc3.push("...");
                loc3.push((loc1 - 1));
                loc3.push(loc1);
                loc3.push(loc1 + 1);
                loc3.push("...");
                loc3.push((loc2 - 1));
            }
            var loc4:*=_backBtn.width + BUTTON_PADDING;
            var loc5:*=0;
            while (loc5 < MAX_BUTTON_COUNT) 
            {
                loc9 = _numericButtons[loc5];
                if (loc3[loc5] != "...") 
                {
                    loc9.active = true;
                    loc9.index = loc3[loc5];
                    loc9.selected = loc1 == loc3[loc5];
                }
                else 
                {
                    loc9.text = "...";
                    loc9.selected = false;
                    loc9.active = false;
                }
                ++loc5;
            }
            return;
        }

        internal static const BUTTON_PADDING:int=2;

        internal static const MAX_BUTTON_COUNT:int=7;

        internal var _thumbArea:com.airtight.simpleviewer.display.thumbs.ThumbArea;

        internal var _nextBtn:com.airtight.simpleviewer.display.components.NumericNavButton;

        internal var _backBtn:com.airtight.simpleviewer.display.components.NumericNavButton;

        internal var _numericButtons:Array;
    }
}
