package com.airtight.utils 
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.system.*;
    import flash.text.*;
    import flash.utils.*;
    
    public class Stats extends flash.display.Sprite
    {
        public function Stats(arg1:Object=null)
        {
            _theme = {"bg":51, "fps":16776960, "ms":65280, "mem":65535, "memmax":16711792};
            super();
            if (arg1) 
            {
                if (arg1.bg != null) 
                {
                    _theme.bg = arg1.bg;
                }
                if (arg1.fps != null) 
                {
                    _theme.fps = arg1.fps;
                }
                if (arg1.ms != null) 
                {
                    _theme.ms = arg1.ms;
                }
                if (arg1.mem != null) 
                {
                    _theme.mem = arg1.mem;
                }
                if (arg1.memmax != null) 
                {
                    _theme.memmax = arg1.memmax;
                }
            }
            addEventListener(flash.events.Event.ADDED_TO_STAGE, init, false, 0, true);
            return;
        }

        internal function hex2css(arg1:int):String
        {
            return "#" + arg1.toString(16);
        }

        internal function update(arg1:flash.events.Event):void
        {
            _timer = flash.utils.getTimer();
            if (_timer - 1000 > _ms_prev) 
            {
                _ms_prev = _timer;
                _mem = Number((flash.system.System.totalMemory * 9.54e-007).toFixed(3));
                _mem_max = _mem_max > _mem ? _mem_max : _mem;
                _fps_graph = Math.min(50, _fps / stage.frameRate * 50);
                _mem_graph = Math.min(50, Math.sqrt(Math.sqrt(_mem * 5000))) - 2;
                _mem_max_graph = Math.min(50, Math.sqrt(Math.sqrt(_mem_max * 5000))) - 2;
                _graph.scroll(1, 0);
                _graph.fillRect(_rectangle, _theme.bg);
                _graph.setPixel(0, _graph.height - _fps_graph, _theme.fps);
                _graph.setPixel(0, _graph.height - (_timer - _ms >> 1), _theme.ms);
                _graph.setPixel(0, _graph.height - _mem_graph, _theme.mem);
                _graph.setPixel(0, _graph.height - _mem_max_graph, _theme.memmax);
                _xml.fps = "FPS: " + _fps + " / " + stage.frameRate;
                _xml.mem = "MEM: " + _mem;
                _xml.memMax = "MAX: " + _mem_max;
                _fps = 0;
            }
            var loc1:*;
            _fps++;
            _xml.ms = "MS: " + _timer - _ms;
            _ms = _timer;
            _text.htmlText = _xml;
            return;
        }

        internal function init(arg1:flash.events.Event):void
        {
            removeEventListener(flash.events.Event.ADDED_TO_STAGE, init);
            graphics.beginFill(_theme.bg);
            graphics.drawRect(0, 0, 70, 50);
            graphics.endFill();
            _mem_max = 0;
            _xml = new XML("<xml><fps>FPS:</fps><ms>MS:</ms><mem>MEM:</mem><memMax>MAX:</memMax></xml>");
            _style = new flash.text.StyleSheet();
            _style.setStyle("xml", {"fontSize":"9px", "fontFamily":"_sans", "leading":"-2px"});
            _style.setStyle("fps", {"color":hex2css(_theme.fps)});
            _style.setStyle("ms", {"color":hex2css(_theme.ms)});
            _style.setStyle("mem", {"color":hex2css(_theme.mem)});
            _style.setStyle("memMax", {"color":hex2css(_theme.memmax)});
            _text = new flash.text.TextField();
            _text.width = 70;
            _text.height = 50;
            _text.styleSheet = _style;
            _text.condenseWhite = true;
            _text.selectable = false;
            _text.mouseEnabled = false;
            addChild(_text);
            var loc2:*;
            _graph = loc2 = new flash.display.BitmapData(70, 50, false, _theme.bg);
            var loc1:*=new flash.display.Bitmap(loc2);
            loc1.y = 50;
            addChild(loc1);
            _rectangle = new flash.geom.Rectangle(0, 0, 1, _graph.height);
            addEventListener(flash.events.MouseEvent.CLICK, onClick);
            addEventListener(flash.events.Event.ENTER_FRAME, update);
            return;
        }

        public function dispose():void
        {
            removeEventListener(flash.events.Event.ENTER_FRAME, update);
            return;
        }

        internal function onClick(arg1:flash.events.MouseEvent):void
        {
            if (mouseY / height > 0.5) 
            {
                var loc1:*;
                var loc2:*=((loc1 = stage).frameRate - 1);
                loc1.frameRate = loc2;
            }
            else 
            {
                loc2 = ((loc1 = stage).frameRate + 1);
                loc1.frameRate = loc2;
            }
            _xml.fps = "FPS: " + _fps + " / " + stage.frameRate;
            _text.htmlText = _xml;
            return;
        }

        internal var _fps_graph:uint;

        internal var _ms:uint;

        internal var _timer:uint;

        internal var _graph:flash.display.BitmapData;

        internal var _text:flash.text.TextField;

        internal var _mem:Number;

        internal var _xml:XML;

        internal var _mem_max_graph:uint;

        internal var _theme:Object;

        internal var _mem_graph:uint;

        internal var _fps:uint;

        internal var _ms_prev:uint;

        internal var _rectangle:flash.geom.Rectangle;

        internal var _style:flash.text.StyleSheet;

        internal var _mem_max:Number;
    }
}
