package com.greensock.core 
{
    import com.greensock.*;
    
    public class TweenCore extends Object
    {
        public function TweenCore(arg1:Number=0, arg2:Object=null)
        {
            super();
            this.vars = arg2 || {};
            var loc2:*;
            this.cachedTotalDuration = loc2 = arg1 || 0;
            this.cachedDuration = loc2;
            _delay = this.vars.delay || 0;
            this.cachedTimeScale = this.vars.timeScale || 1;
            this.active = Boolean(arg1 == 0 && _delay == 0 && !(this.vars.immediateRender == false));
            this.cachedTime = loc2 = 0;
            this.cachedTotalTime = loc2;
            this.data = this.vars.data;
            if (!_classInitted) 
            {
                if (isNaN(com.greensock.TweenLite.rootFrame)) 
                {
                    com.greensock.TweenLite.initClass();
                    _classInitted = true;
                }
                else 
                {
                    return;
                }
            }
            var loc1:*=this.vars.timeline is com.greensock.core.SimpleTimeline ? this.vars.timeline : this.vars.useFrames ? com.greensock.TweenLite.rootFramesTimeline : com.greensock.TweenLite.rootTimeline;
            this.cachedStartTime = loc1.cachedTotalTime + _delay;
            loc1.addChild(this);
            if (this.vars.reversed) 
            {
                this.cachedReversed = true;
            }
            if (this.vars.paused) 
            {
                this.paused = true;
            }
            return;
        }

        public function complete(arg1:Boolean=false, arg2:Boolean=false):void
        {
            if (!arg1) 
            {
                renderTime(this.cachedTotalDuration, arg2, false);
                return;
            }
            if (this.timeline.autoRemoveChildren) 
            {
                this.setEnabled(false, false);
            }
            else 
            {
                this.active = false;
            }
            if (!arg2) 
            {
                if (this.vars.onComplete && this.cachedTotalTime == this.cachedTotalDuration && !this.cachedReversed) 
                {
                    this.vars.onComplete.apply(null, this.vars.onCompleteParams);
                }
                else if (this.cachedReversed && this.cachedTotalTime == 0 && this.vars.onReverseComplete) 
                {
                    this.vars.onReverseComplete.apply(null, this.vars.onReverseCompleteParams);
                }
            }
            return;
        }

        public function invalidate():void
        {
            return;
        }

        public function resume():void
        {
            this.paused = false;
            return;
        }

        public function renderTime(arg1:Number, arg2:Boolean=false, arg3:Boolean=false):void
        {
            return;
        }

        public function get paused():Boolean
        {
            return this.cachedPaused;
        }

        public function set reversed(arg1:Boolean):void
        {
            if (arg1 != this.cachedReversed) 
            {
                this.cachedReversed = arg1;
                setTotalTime(this.cachedTotalTime, true);
            }
            return;
        }

        public function get delay():Number
        {
            return _delay;
        }

        public function get totalTime():Number
        {
            return this.cachedTotalTime;
        }

        public function get duration():Number
        {
            return this.cachedDuration;
        }

        public function play():void
        {
            this.reversed = false;
            this.paused = false;
            return;
        }

        public function restart(arg1:Boolean=false, arg2:Boolean=true):void
        {
            this.reversed = false;
            this.paused = false;
            this.setTotalTime(arg1 ? -_delay : 0, arg2);
            return;
        }

        public function set duration(arg1:Number):void
        {
            var loc1:*;
            this.cachedTotalDuration = loc1 = arg1;
            this.cachedDuration = loc1;
            setDirtyCache(false);
            return;
        }

        public function set startTime(arg1:Number):void
        {
            var loc1:*=Boolean(!(this.timeline == null) && (!(arg1 == this.cachedStartTime) || this.gc));
            this.cachedStartTime = arg1;
            if (loc1) 
            {
                this.timeline.addChild(this);
            }
            return;
        }

        public function set delay(arg1:Number):void
        {
            this.startTime = this.startTime + arg1 - _delay;
            _delay = arg1;
            return;
        }

        public function get reversed():Boolean
        {
            return this.cachedReversed;
        }

        public function get startTime():Number
        {
            return this.cachedStartTime;
        }

        public function set currentTime(arg1:Number):void
        {
            setTotalTime(arg1, false);
            return;
        }

        protected function setDirtyCache(arg1:Boolean=true):void
        {
            var loc1:*=arg1 ? this : this.timeline;
            while (loc1) 
            {
                loc1.cacheIsDirty = true;
                loc1 = loc1.timeline;
            }
            return;
        }

        public function reverse(arg1:Boolean=true):void
        {
            this.reversed = true;
            if (arg1) 
            {
                this.paused = false;
            }
            else if (this.gc) 
            {
                this.setEnabled(true, false);
            }
            return;
        }

        public function set paused(arg1:Boolean):void
        {
            if (!(arg1 == this.cachedPaused) && this.timeline) 
            {
                if (arg1) 
                {
                    _pauseTime = this.timeline.rawTime;
                }
                else 
                {
                    this.cachedStartTime = this.cachedStartTime + this.timeline.rawTime - _pauseTime;
                    _pauseTime = NaN;
                    setDirtyCache(false);
                }
                this.cachedPaused = arg1;
                this.active = Boolean(!this.cachedPaused && this.cachedTotalTime > 0 && this.cachedTotalTime < this.cachedTotalDuration);
            }
            if (!arg1 && this.gc) 
            {
                this.setTotalTime(this.cachedTotalTime, false);
                this.setEnabled(true, false);
            }
            return;
        }

        public function kill():void
        {
            setEnabled(false, false);
            return;
        }

        public function set totalDuration(arg1:Number):void
        {
            this.duration = arg1;
            return;
        }

        public function set totalTime(arg1:Number):void
        {
            setTotalTime(arg1, false);
            return;
        }

        public function get currentTime():Number
        {
            return this.cachedTime;
        }

        protected function setTotalTime(arg1:Number, arg2:Boolean=false):void
        {
            var loc1:*=NaN;
            var loc2:*=NaN;
            if (this.timeline) 
            {
                loc1 = _pauseTime || _pauseTime == 0 ? _pauseTime : this.timeline.cachedTotalTime;
                if (this.cachedReversed) 
                {
                    loc2 = this.cacheIsDirty ? this.totalDuration : this.cachedTotalDuration;
                    this.cachedStartTime = loc1 - (loc2 - arg1) / this.cachedTimeScale;
                }
                else 
                {
                    this.cachedStartTime = loc1 - arg1 / this.cachedTimeScale;
                }
                if (!this.timeline.cacheIsDirty) 
                {
                    setDirtyCache(false);
                }
                if (this.cachedTotalTime != arg1) 
                {
                    renderTime(arg1, arg2, false);
                }
            }
            return;
        }

        public function pause():void
        {
            this.paused = true;
            return;
        }

        public function get totalDuration():Number
        {
            return this.cachedTotalDuration;
        }

        public function setEnabled(arg1:Boolean, arg2:Boolean=false):Boolean
        {
            if (arg1) 
            {
                this.active = Boolean(!this.cachedPaused && this.cachedTotalTime > 0 && this.cachedTotalTime < this.cachedTotalDuration);
                if (!arg2 && this.gc) 
                {
                    this.timeline.addChild(this);
                }
            }
            else 
            {
                this.active = false;
                if (!arg2) 
                {
                    this.timeline.remove(this, true);
                }
            }
            this.gc = !arg1;
            return false;
        }

        public static const version:Number=1.13;

        public var active:Boolean;

        public var prevNode:com.greensock.core.TweenCore;

        public var cachedDuration:Number;

        protected var _delay:Number;

        public var gc:Boolean;

        public var cachedReversed:Boolean;

        public var nextNode:com.greensock.core.TweenCore;

        protected var _pauseTime:Number;

        public var cachedTime:Number;

        protected var _rawPrevTime:Number=-1;

        public var vars:Object;

        public var cachedTotalTime:Number;

        public var timeline:com.greensock.core.SimpleTimeline;

        public var cachedPaused:Boolean;

        public var data:*;

        public var cacheIsDirty:Boolean;

        public var initted:Boolean;

        public var cachedTimeScale:Number;

        public var cachedTotalDuration:Number;

        public var cachedStartTime:Number;

        protected var _hasUpdate:Boolean;

        protected static var _classInitted:Boolean;
    }
}
