package org.casalib.util 
{
    import flash.geom.*;
    import org.casalib.math.*;
    
    public class ColorUtil extends Object
    {
        public function ColorUtil()
        {
            super();
            return;
        }

        public static function getARGB(arg1:uint):Object
        {
            var loc1:*={};
            loc1.a = arg1 >> 24 & 255;
            loc1.r = arg1 >> 16 & 255;
            loc1.g = arg1 >> 8 & 255;
            loc1.b = arg1 & 255;
            return loc1;
        }

        public static function interpolateColor(arg1:flash.geom.ColorTransform, arg2:flash.geom.ColorTransform, arg3:org.casalib.math.Percent):flash.geom.ColorTransform
        {
            var loc1:*;
            (loc1 = new flash.geom.ColorTransform()).redMultiplier = org.casalib.util.NumberUtil.interpolate(arg3, arg1.redMultiplier, arg2.redMultiplier);
            loc1.greenMultiplier = org.casalib.util.NumberUtil.interpolate(arg3, arg1.greenMultiplier, arg2.greenMultiplier);
            loc1.blueMultiplier = org.casalib.util.NumberUtil.interpolate(arg3, arg1.blueMultiplier, arg2.blueMultiplier);
            loc1.alphaMultiplier = org.casalib.util.NumberUtil.interpolate(arg3, arg1.alphaMultiplier, arg2.alphaMultiplier);
            loc1.redOffset = org.casalib.util.NumberUtil.interpolate(arg3, arg1.redOffset, arg2.redOffset);
            loc1.greenOffset = org.casalib.util.NumberUtil.interpolate(arg3, arg1.greenOffset, arg2.greenOffset);
            loc1.blueOffset = org.casalib.util.NumberUtil.interpolate(arg3, arg1.blueOffset, arg2.blueOffset);
            loc1.alphaOffset = org.casalib.util.NumberUtil.interpolate(arg3, arg1.alphaOffset, arg2.alphaOffset);
            return loc1;
        }

        public static function getHexStringFromRGB(arg1:uint, arg2:uint, arg3:uint):String
        {
            var loc1:*=arg1.toString(16);
            var loc2:*=arg2.toString(16);
            var loc3:*=arg3.toString(16);
            loc1 = loc1.length != 1 ? loc1 : "0" + loc1;
            loc2 = loc2.length != 1 ? loc2 : "0" + loc2;
            loc3 = loc3.length != 1 ? loc3 : "0" + loc3;
            return (loc1 + loc2 + loc3).toUpperCase();
        }

        public static function getRGB(arg1:uint):Object
        {
            var loc1:*={};
            loc1.r = arg1 >> 16 & 255;
            loc1.g = arg1 >> 8 & 255;
            loc1.b = arg1 & 255;
            return loc1;
        }

        public static function getHexStringFromARGB(arg1:uint, arg2:uint, arg3:uint, arg4:uint):String
        {
            var loc1:*=arg1.toString(16);
            var loc2:*=arg2.toString(16);
            var loc3:*=arg3.toString(16);
            var loc4:*=arg4.toString(16);
            loc1 = loc1.length != 1 ? loc1 : "0" + loc1;
            loc2 = loc2.length != 1 ? loc2 : "0" + loc2;
            loc3 = loc3.length != 1 ? loc3 : "0" + loc3;
            loc4 = loc4.length != 1 ? loc4 : "0" + loc4;
            return (loc1 + loc2 + loc3 + loc4).toUpperCase();
        }

        public static function getColor(arg1:uint, arg2:uint, arg3:uint, arg4:uint=255):uint
        {
            return arg4 << 24 | arg1 << 16 | arg2 << 8 | arg3;
        }
    }
}
