package org.casalib.util 
{
    import org.casalib.math.*;
    
    public class NumberUtil extends Object
    {
        public function NumberUtil()
        {
            super();
            return;
        }

        public static function interpolate(arg1:org.casalib.math.Percent, arg2:Number, arg3:Number):Number
        {
            return arg2 + (arg3 - arg2) * arg1.decimalPercentage;
        }

        public static function max(arg1:*, arg2:*):Number
        {
            if (isNaN(arg1) && isNaN(arg2) || arg1 == null && arg2 == null) 
            {
                return NaN;
            }
            if (arg1 == null || arg2 == null) 
            {
                return arg2 != null ? arg2 : arg1;
            }
            if (isNaN(arg1) || isNaN(arg2)) 
            {
                return isNaN(arg2) ? arg1 : arg2;
            }
            return Math.max(arg1, arg2);
        }

        public static function isOdd(arg1:Number):Boolean
        {
            return !org.casalib.util.NumberUtil.isEven(arg1);
        }

        public static function constrain(arg1:Number, arg2:Number, arg3:Number):Number
        {
            return Math.min(Math.max(arg1, Math.min(arg2, arg3)), Math.max(arg2, arg3));
        }

        public static function roundDecimalToPlace(arg1:Number, arg2:uint):Number
        {
            var loc1:*=Math.pow(10, arg2);
            return Math.round(arg1 * loc1) / loc1;
        }

        public static function isEqual(arg1:Number, arg2:Number, arg3:Number=0):Boolean
        {
            return Math.abs(arg1 - arg2) <= Math.abs(arg3);
        }

        public static function isEven(arg1:Number):Boolean
        {
            return (arg1 & 1) == 0;
        }

        public static function getOrdinalSuffix(arg1:int):String
        {
            if (arg1 >= 10 && arg1 <= 20) 
            {
                return "th";
            }
            var loc1:*=arg1 % 10;
            switch (loc1) 
            {
                case 0:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                {
                    return "th";
                }
                case 3:
                {
                    return "rd";
                }
                case 2:
                {
                    return "nd";
                }
                case 1:
                {
                    return "st";
                }
                default:
                {
                    return "";
                }
            }
        }

        public static function normalize(arg1:Number, arg2:Number, arg3:Number):org.casalib.math.Percent
        {
            return new org.casalib.math.Percent((arg1 - arg2) / (arg3 - arg2));
        }

        public static function loopIndex(arg1:int, arg2:uint):uint
        {
            if (arg1 < 0) 
            {
                arg1 = arg2 + arg1 % arg2;
            }
            if (arg1 >= arg2) 
            {
                return arg1 % arg2;
            }
            return arg1;
        }

        public static function randomWithinRange(arg1:Number, arg2:Number):Number
        {
            return arg1 + Math.random() * (arg2 - arg1);
        }

        public static function getWeightedAverage(arg1:Number, arg2:Number, arg3:Number):Number
        {
            return arg1 + (arg2 - arg1) / arg3;
        }

        public static function min(arg1:*, arg2:*):Number
        {
            if (isNaN(arg1) && isNaN(arg2) || arg1 == null && arg2 == null) 
            {
                return NaN;
            }
            if (arg1 == null || arg2 == null) 
            {
                return arg2 != null ? arg2 : arg1;
            }
            if (isNaN(arg1) || isNaN(arg2)) 
            {
                return isNaN(arg2) ? arg1 : arg2;
            }
            return Math.min(arg1, arg2);
        }

        public static function isInteger(arg1:Number):Boolean
        {
            return arg1 % 1 == 0;
        }

        public static function isPrime(arg1:Number):Boolean
        {
            if (arg1 == 1 || arg1 == 2) 
            {
                return true;
            }
            if (org.casalib.util.NumberUtil.isEven(arg1)) 
            {
                return false;
            }
            var loc1:*=Math.sqrt(arg1);
            var loc2:*=3;
            while (loc2 <= loc1) 
            {
                if (arg1 % loc2 == 0) 
                {
                    return false;
                }
                ++loc2;
            }
            return true;
        }

        public static function randomIntegerWithinRange(arg1:int, arg2:int):int
        {
            return Math.round(org.casalib.util.NumberUtil.randomWithinRange(arg1, arg2));
        }

        public static function format(arg1:Number, arg2:uint, arg3:String=null, arg4:String=null):String
        {
            var loc3:*=null;
            var loc4:*=0;
            var loc5:*=0;
            var loc6:*=null;
            var loc1:*;
            var loc2:*=(loc1 = arg1.toString()).length;
            if (arg3 != null) 
            {
                loc3 = loc1.split("");
                loc4 = 3;
                loc5 = loc3.length;
                while (--loc5 > 0) 
                {
                    if (--loc4 != 0) 
                    {
                        continue;
                    }
                    loc4 = 3;
                    loc3.splice(loc5, 0, arg3);
                }
                loc1 = loc3.join("");
            }
            if (arg2 != 0) 
            {
                if (loc2 < arg2) 
                {
                    arg2 = arg2 - loc2;
                    loc6 = arg4 != null ? arg4 : "0";
                    while (arg2--) 
                    {
                        loc1 = loc6 + loc1;
                    }
                }
            }
            return loc1;
        }

        public static function addLeadingZero(arg1:Number):String
        {
            return arg1 < 10 ? "0" + arg1 : arg1.toString();
        }

        public static function map(arg1:Number, arg2:Number, arg3:Number, arg4:Number, arg5:Number):Number
        {
            return arg4 + (arg5 - arg4) * (arg1 - arg2) / (arg3 - arg2);
        }

        public static function createStepsBetween(arg1:Number, arg2:Number, arg3:Number):Array
        {
            ++arg3;
            var loc1:*=0;
            var loc2:*=new Array();
            var loc3:*=(arg2 - arg1) / arg3;
            while (++loc1 < arg3) 
            {
                loc2.push(loc1 * loc3 + arg1);
            }
            return loc2;
        }

        public static function isBetween(arg1:Number, arg2:Number, arg3:Number):Boolean
        {
            return !(arg1 < Math.min(arg2, arg3) || arg1 > Math.max(arg2, arg3));
        }
    }
}
